/*******************************************
*
*
*	dataColumnRec.h
*
*	A class that implements a column in an ANOVA table
*
*
************************************************/

#ifndef dataColumnRech
#define dataColumnRech = 1

#include "Element.h"
#include "aList.h"
#include "StringClass.h"
#include "StringList.h"
#include "StatList.h"
#include <iostream.h>
#include <fstream.h>
#include "aVector.h"
#include "aMatrix.h"
#include "MemoryManager.h"

enum dataColumnContentType  {numbers, wordStrings};
enum sampleRegimeType  {withReplacement, withoutReplacement};

//20070903	comment out MemoryLeakDebug code


class dataColumnRec{
	public:
		aString title_;
		dataColumnContentType content_;
		int source_;  //0=external, 1 = internally generated & not normally printed
		StringList levelsList_; // holds factor levels
		long pointerToDerivedSelf_;
	public:
		dataColumnRec(int source = 0);
//		dataColumnRec(dataColumnRec&);//no copying possible; use Clone instead
//		dataColumnRec(dataColumnRec*);//no copying possible; use Clone instead
		virtual ~dataColumnRec(void);
	virtual dataColumnRec*
			   Duplicate(void);//returns a duplicate copy of 'this'
//	virtual dataColumnRec& operator=(dataColumnRec& dcr);// define in derived classes
	virtual void SetPointerToDerivedSelf(void);
	virtual long GetPointerToDerivedSelf(void);

	virtual void Append(double x);
	virtual void Append(long double x);
	virtual void Append(float x);
	virtual void Append(int x);
	virtual void Append(long x);
	virtual void Append(aString* x);
	virtual void  CheckCategoryMembership (aString& value);
//	virtual dataColumnRec* Clone(void);//returns a duplicate copy of 'this'
	virtual void DeleteRow(long /*r*/){}//handled by derived classes
	virtual dataColumnContentType DetermineColumnContents (void);
	virtual dataColumnContentType DetermineColumnContents (aString& word);
	virtual StringList& GetFactorLevelList (void);
	virtual long len();
	virtual int MissingData(char );
	virtual int MissingData(long double );
	virtual aList<long>* 	
			MissingDataPos(char missingStrDataFlag, long double missingNumDataFlag);
	virtual aList<long>* 	
			MissingDataPos(long double missingNumDataFlag);
	virtual int NullDataCategories (void);
	virtual void PrintValue(ostream& , long ){}//handled in derived classes
	virtual void SetValue(aString& , long ){}//use in derived classes to put data into the string

	virtual int temporary(void);
	virtual void 		title(aString t);
	virtual aString& 		title(void);
//	virtual int operator[](long i){return 0;}

	friend int operator== (dataColumnRec& dataCol1, dataColumnRec& dataCol2);

	friend int operator!= (dataColumnRec& dataCol1, dataColumnRec& dataCol2);
	};//end class dataColumnRec

int operator== (dataColumnRec& dataCol1, dataColumnRec& dataCol2);

int operator!= (dataColumnRec& dataCol1, dataColumnRec& dataCol2);


#endif
