/*******************************************
*
*
*	dataColumnRecStr.h
*
*	A class that implements an aString data column in an ANOVA table
*
*
************************************************/

#ifndef dataColumnRecStrh
#define dataColumnRecStrh = 1

#include "Element.h"
#include "aList.h"
#include "StringClass.h"
#include "StatList.h"
#include <iostream.h>
#include <fstream.h>
#include "aVector.h"
#include "aMatrix.h"
#include "dataColumnRec.h"
#include "MemoryManager.h"


//	20070903	comment out MemoryLeakDebug code
//	20070903	move inlines to .cpp file

class dataColumnRecStr: public dataColumnRec{
	public:
		StringList dataList_;
	public:
		dataColumnRecStr(int source=0);
//		dataColumnRecStr(dataColumnRecStr&);//no copying possible; use Clone instead
//		dataColumnRecStr(dataColumnRecStr*);//no copying possible; use Clone instead
		~dataColumnRecStr(void);

	dataColumnRec* 
					Duplicate(void);//returns a duplicate copy of 'this'
	virtual dataColumnRecStr& operator=(dataColumnRecStr& dcr);
	virtual void	SetPointerToDerivedSelf(void);
	virtual long	GetPointerToDerivedSelf(void);


	aString& 		operator[](long i);

	//data column handling functions
	void 			Append(aString* x);
	StringList&		dataList(void);
	void 			DeleteRow(long r);
	StringList*  	GetResampledList (StringList& theList, sampleRegimeType sampleRegime, Ran3& ran);
	aString*  		GetResampleValue(StringList& theList, sampleRegimeType sampleRegime, Ran3& ran);
	long 			len();
	int 			MissingData(char missingDataFlag='\0');
	aList<long>* 	MissingDataPos(char missingDataFlag, long double /*dummy for numerical*/);
	 void 			PrintValue(ostream& outFile, long item);
	virtual long 	SampleSize(char missingDataFlag='\0');
	virtual long 	SampleSize(char* missingDataFlag);
	virtual long 	SampleSize(aString& missingDataFlag);
	virtual void SetValue(aString& str, long item);
	friend int operator== (dataColumnRecStr& dataCol1, dataColumnRecStr& dataCol2);

	friend int operator!= (dataColumnRecStr& dataCol1, dataColumnRecStr& dataCol2);


	};//end class dataColumnRecStr


	int operator== (dataColumnRecStr& dataCol1, dataColumnRecStr& dataCol2);


	int operator!= (dataColumnRecStr& dataCol1, dataColumnRecStr& dataCol2);


#endif

