// CumulativeNormalData.h

#ifndef CumulativeNormalDatah
#define CumulativeNormalDatah = 1


#include <fstream.h>
#include "MetropolisHastings.h"
#include "Element.cpp"
#include "aList.cpp"
#include "StatList.cpp"
#include "StringClass.h"
#include "StringList.h"

	class CumulativeNormalData: public MetropolisHastingsData{
#ifdef MemoryLeakDebug
	private:
		MemLeakIDType memID_;
	public:
		static memAllocList memIDList_;
		static  MemLeakIDType memIDCount_;
#endif
		public:
			StringList colHeadings;
			StatList<double> location;
			StatList<double> dose;
					//list of loci, each with list of all alleles that are diagnostic on 
					//the right side of the hybrid zone
		//NOTE that StringList rawLocusName will hold the diagnostic alleles as well
		
			StatList<double> alive;
			StatList<double> dead;
		
		public:
		CumulativeNormalData(void){
			#ifdef MemoryLeakDebug
				memID_=++memIDCount_;
				memIDList_.Append(memID_);
			#endif
			}


		CumulativeNormalData(CumulativeNormalData& parentData);//copy constructor

virtual	~CumulativeNormalData(void){
			#ifdef MemoryLeakDebug
				long i=memIDList_.Loc(memID_);
				memIDList_.Delete(i);
			#endif
			Clear();
			}

	void 		Clear(void);
	long		len();
	void 		PrintDataFile (aString& outFileName);
	void 		PrintDataFile (ostream& outFile);
	void 		ReadDataFile (aString& dataFileName);//input file assumed closed


#ifdef MemoryLeakDebug
	static void PrintIDList(ostream& outFile=cout);
	static void PrintIDListLen(ostream& outFile=cout);
#endif
		};//end class CumulativeNormalData
		
		
#endif

