/*****************************

	DataSetRecMCMC.h
	
	Combines the standard data set container class with the Metropolis-Hastings data container.
	This permits a data set to be sent to a likelihood function and run through the MCMC algorithm.
	
	
******************************/

#ifndef DataSetRecMCMCh
#define DataSetRecMCMCh = 1

#include <iostream.h>
#include <fstream.h>
#include "Element.h"
#include "aList.h"
#include "StringClass.h"
#include "StringList.h"
#include "Gamma.h"
#include "MetropolisHastings.h"
#include "dataColumnRec.h"
#include "dataSetRec.h"
//#include "DataSetRecNum.cpp"
//#include "DataSetRecStr.h"
#include "MemoryManager.h"


class DataSetRecMCMC: public dataSetRec, public MetropolisHastingsData{
	public:
		//no data members		
	public:
		DataSetRecMCMC(void);
		DataSetRecMCMC(DataSetRecMCMC& s);
		~DataSetRecMCMC(void);

	virtual DataSetRecMCMC* Duplicate(void);
	
	virtual DataSetRecMCMC& operator=(DataSetRecMCMC& dsrm);
	
	virtual void SetPointerToDerivedSelf(void);
	virtual long GetPointerToDerivedSelf(void);
	void Clear();
		
	friend int operator==(DataSetRecMCMC& a, DataSetRecMCMC& b);
	friend int operator!=(DataSetRecMCMC& a, DataSetRecMCMC& b);
	
	};//end class DataSetRecMCMC
	

#endif
