// DoseResponseClineData.h

#ifndef DoseResponseClineDatah
#define DoseResponseClineDatah = 1


#include <fstream.h>
#include "MetropolisHastings.h"
#include "Element.cpp"
#include "aList.cpp"
#include "StatList.cpp"
#include "StringClass.h"
#include "StringList.h"

	class DoseResponseClineData: public MetropolisHastingsData{
#ifdef MemoryLeakDebug
	private:
		MemLeakIDType memID_;
	public:
		static memAllocList memIDList_;
		static  MemLeakIDType memIDCount_;
#endif
		public:
			StringList colHeadings;
			StatList<double> location;
			ObjList<StatList<double> > dose;//indexed as dose[location][dosage]		
			ObjList<StatList<double> > alive;//indexed as alive[location][dosage]
			ObjList<StatList<double> > dead;//indexed as dead[location][dosage]
			
			aList<double> location_density;
			StatList<double> density;
		
		public:
		DoseResponseClineData(void){
			#ifdef MemoryLeakDebug
				memID_=++memIDCount_;
				memIDList_.Append(memID_);
			#endif
			}


		DoseResponseClineData(DoseResponseClineData& parentData);//copy constructor

virtual	~DoseResponseClineData(void){
			#ifdef MemoryLeakDebug
				long i=memIDList_.Loc(memID_);
				memIDList_.Delete(i);
			#endif
			Clear();
			}

	void 		Clear(void);
	long		len(int pop);
	long		pops(void);
	void 		PrintDataFile (aString& outFileName);
	void 		PrintDataFile (ostream& outFile);
	void 		ReadDataFile (aString& dataFileName);//input file assumed closed
	void 		ReadDensityDataFile (aString& dataFileName);//input file assumed closed
	long		sampleSize(int pop);


#ifdef MemoryLeakDebug
	static void PrintIDList(ostream& outFile=cout);
	static void PrintIDListLen(ostream& outFile=cout);
#endif
		};//end class DoseResponseClineData
		
		
#endif

