/************************************************

	FstatLandScapeInterface.h

************************************************/

#ifndef FstatLandScapeInterfaceh
#define FstatLandScapeInterfaceh = 1


#include "EvolutionaryGeneticsData.h"
#include "MultiformatMarkerData.h"
#include "HaploidMarkerData.h"
#include "CodominantMarkerData.h"
#include "DominantMarkerData2.h"
#include "SexLinkedData.h"
#include "SexLinkedCodomMarkerData.h"
#include "SexLinkedDomMarkerData2.h"
#include "CytoplasmicFemaleMarkerData.h"
#include "CytoplasmicMaleMarkerData.h"
#include "FstatisticAnalysisCore.h"
#include "FstatisticAnalysisHap.h"
#include "FstatisticAnalysisCodom.h"
#include "FstatisticAnalysisDom2.h"
#include "FstatisticAnalysisCodomSexLink.h"
#include "FstatisticAnalysisDomSexLink.h"
#include "FstatisticAnalysisCytoFemale.h"
#include "FstatisticAnalysisCytoMale.h"
#include "FstatisticAnalysisMultiFormat.h"
#include "GeljockLandScapeInterface.h"
#include "GeneticLandScape.h"
#include "GeneticGridCell.h"
#include "GeneticPopulation.h"
#include "Individual.h"
#include "GeneticIndividual.h"
#include "Phenotype.h"
#include "Genotype.h"
#include "StringClass.h"
#include "Element.cpp"
#include "aList.cpp"
#include "MemoryManager.h"


class FstatLandScapeInterface:
					public virtual FstatisticAnalysisMultiFormat,
					public virtual FstatisticAnalysisHap,
					public virtual FstatisticAnalysisCodom,
					public virtual FstatisticAnalysisDom2,
					public virtual FstatisticAnalysisCodomSexLink,
					public virtual FstatisticAnalysisDomSexLink,
					public virtual FstatisticAnalysisCytoFemale,
					public virtual FstatisticAnalysisCytoMale,
					public virtual FstatisticAnalysisCore,
					public virtual GelJockLandScapeInterface,
					public virtual MultiformatMarkerData,
					public virtual HaploidMarkerData,
					public virtual CodominantMarkerData,
					public virtual DominantMarkerData2,
					public virtual SexLinkedCodomMarkerData,
					public virtual SexLinkedDomMarkerData2,
					public virtual CytoplasmicFemaleMarkerData,
					public virtual CytoplasmicMaleMarkerData,
					public virtual SexLinkedData,
					public virtual EvolutionaryGeneticsData{
//  public:
//  	ObjList<StringList> actualAlleleNames_;
  public:
  	FstatLandScapeInterface(void){
  		}
 	~FstatLandScapeInterface(void){
 		GelJockLandScapeInterface::Clear();
 		}
 	
 	void 	Clear();
	void 	PrintAlleleFreqs (ostream& outFile, int ncols, char colSpacer = ' ');//outfile assumed open
/*	void 	PrintAlleleKey (ostream& outFile);//outfile assumed open

 	void ReadGeneticLandScape(GeneticLandScape& theLandScape, 
 						int species, aString& simTitle, aList<int>& skippedLocusNumbers);
 	void ReadGeneticLandScape(GeneticLandScape& theLandScape, //all species
 						aString& simTitle, aList<int>& skippedLocusNumbers);

 	void ReadGeneticLandScape(GeneticLandScape& theLandScape, 
 						int species, aString& simTitle, aList<int>& skippedLocusNumbers,
 						aList<int>& popNumbers);//selected sites on landscape
 	void ReadGeneticLandScape(GeneticLandScape& theLandScape, //all species
 						aString& simTitle, aList<int>& skippedLocusNumbers,
 						aList<int>& popNumbers);//selected sites on landscape

 	void SeedGeneticLandScape(GeneticLandScape& theLandScape, 
 						int species, Ran3List& ran, LandScapeInitializer01& init,
 						int useFileCoords);//fills a properly configured GeneticLandScape with stored genotypes
*/
};//end class FstatLandScapeInterface









#endif
