/************************************************

	GelJockLandScapeInterface.h

************************************************/

//20070129  Completely revamped to account for new genetic analysis data structures

#ifndef GelJockLandScapeInterfaceh
#define GelJockLandScapeInterfaceh = 1


//#include "ReadAndManageGelJock.h"
//#include "PopulationGeneticData.h"
#include "EvolutionaryGeneticsData.h"
#include "SexLinkedData.h"
#include "HaploidMarkerData.h"
#include "CodominantMarkerData.h"
#include "DominantMarkerData2.h"
#include "SexLinkedCodomMarkerData.h"
#include "CytoplasmicFemaleMarkerData.h"
#include "CytoplasmicMaleMarkerData.h"
#include "SexLinkedDomMarkerData2.h"
#include "MultiformatMarkerData.h"
#include "LandScape.h"
#include "GridCell.h"
#include "Population.h"
//#include "GeneticLandScape.h"
//#include "GeneticGridCell.h"
//#include "GeneticPopulation.h"
#include "Individual.h"
#include "GeneticIndividual.h"
#include "Phenotype.h"
#include "CoreGenome.h"
#include "Genotype.h"
#include "StringClass.h"
#include "Element.h"
#include "aList.h"
#include "CoordinateClass.h"
#include "InlineTemplates.h"
#include "MemoryManager.h"


class GelJockLandScapeInterface: public virtual MultiformatMarkerData,
								 public virtual HaploidMarkerData,
								 public virtual CodominantMarkerData,
								 public virtual DominantMarkerData2,
								 public virtual SexLinkedCodomMarkerData,
								 public virtual SexLinkedDomMarkerData2,
								 public virtual CytoplasmicFemaleMarkerData,
								 public virtual CytoplasmicMaleMarkerData,
								 public virtual SexLinkedData,
								 public virtual EvolutionaryGeneticsData
								 {
  public:
  	ObjList<StringList> actualAlleleNames_;
  public:
  	GelJockLandScapeInterface(void){
  		}
 	~GelJockLandScapeInterface(void){
 		actualAlleleNames_.Clear();
 		}
 	
 	void 	Clear();
	virtual void 	PrintAlleleFreqs (ostream& outFile, int ncols, char colSpacer = ' ');//outfile assumed open
	void 	PrintAlleleKey (ostream& outFile);//outfile assumed open

// 	void ReadGeneticLandScape(GeneticLandScape& theLandScape, 
 	void ReadGeneticLandScape(LandScape& theLandScape, 
 						int species, aString& simTitle, aList<int>& skippedLocusNumbers, 
 						int maxAlleleLen=1, bool expectMissingData=true);
 			//use expectMissingData if some individuals will be unscored for any locus 
 			//(e.g., y-chromosomes, species with different loci, etc.)
 			//otherwise set to 'false' for greater speed


// 	void ReadGeneticLandScape(GeneticLandScape& theLandScape, //all species
 	void ReadGeneticLandScape(LandScape& theLandScape, //all species
 						aString& simTitle, aList<int>& skippedLocusNumbers,
 						int maxAlleleLen=1, bool expectMissingData=true);

// 	void ReadGeneticLandScape(GeneticLandScape& theLandScape, 
 	void ReadGeneticLandScape(LandScape& theLandScape, 
 						int species, aString& simTitle, aList<int>& skippedLocusNumbers,
 						aList<int>& popNumbers, int maxAlleleLen=1, bool expectMissingData=true);
 						//selected sites on landscape

// 	void ReadGeneticLandScape(GeneticLandScape& theLandScape, //all species
 	void ReadGeneticLandScape(LandScape& theLandScape, //all species
 						aString& simTitle, aList<int>& skippedLocusNumbers,
 						aList<int>& popNumbers, int maxAlleleLen=1, bool expectMissingData=true);
 						//selected sites on landscape

// 	void SeedGeneticLandScape(GeneticLandScape& theLandScape, 
 	void SeedGeneticLandScape(LandScape& theLandScape, 
 						int species, Ran3List& ran, LandScapeInitializer01& init,
 						int useFileCoords);//fills a properly configured GeneticLandScape with stored genotypes

// 	void SeedLandScape(GeneticLandScape& theLandScape, //generic version for specialized Individual-based classes
 	void SeedLandScape(LandScape& theLandScape, //generic version for specialized Individual-based classes
 						int species, Ran3List& ran, LandScapeInitializer01& init,
 						int useFileCoords);//fills a properly configured LandScape with stored genotypes


};//end class GelJockLandScapeInterface









#endif
