//GeneFrequencyDistribution.h

#ifndef GeneFrequencyDistributionh
#define GeneFrequencyDistributionh = 1


#include <iostream.h>
#include <math.h>
#include "InlineTemplates.h"
#include "aError.h"
#include "Element.h"
#include "aList.h"
#include "StatList.h"
#include "Gamma.h"
//#include "Gamma2.h"
#include "cdflib.h"
#include "Randomness.h"
#include "MemoryManager.h"


//20081229  added note that ploidy should be set to 0.5 when creating distributions for cytoplasmically inherited loci


class GeneFrequencyDistribution{
	public:
	 long double Fst_, pBar_;
	 const long double ploidy_;
	 
	 public:

	 GeneFrequencyDistribution(const long double ploidy=(long double)2.0):
	 	//ploidy should be set to 0.5 when creating distributions for cytoplasmically inherited loci
	 			ploidy_(ploidy){
				 Fst_ = pBar_ = zero;
	 				}
	 GeneFrequencyDistribution(const long double Fst, const long double pBar, const long double ploidy=(long double)2.0):
	 	//ploidy should be set to 0.5 when creating distributions for cytoplasmically inherited loci
	 			Fst_(Fst), pBar_(pBar), ploidy_(ploidy){
	 			if(pBar< zero || pBar > one){
	 				aError("pBar out of range when constructing GeneFrequencyDistribution2 object");}
	 			if(Fst< zero || Fst > one){
	 				aError("Fst out of range when constructing GeneFrequencyDistribution2 object");}
	 				}
	 GeneFrequencyDistribution(GeneFrequencyDistribution& d):
	 			Fst_(d.Fst_), pBar_(d.pBar_), ploidy_(d.ploidy_){
	 				}
	 GeneFrequencyDistribution(GeneFrequencyDistribution* d):
	 			Fst_(d->Fst_), pBar_(d->pBar_),ploidy_(d->ploidy_){
	 				}
	 			
	 ~GeneFrequencyDistribution(){
	 	}

	virtual void Initialize(const long double Fst, const long double pBar){
				Fst_ = Fst;  pBar_ = pBar;}
	virtual void Initialize(GeneFrequencyDistribution& d){
				Fst_ = d.Fst_;  pBar_ = d.pBar_;}

			long double FreqP_AtProb_x(long double x);
	virtual int fixed(void){return (pBar_ == zero || pBar_ == one);}
	virtual long double Nm();
			long double ProbabilityAtFrequencyP(long double p);
	virtual long double		RandomFrequency(Ran3& ran);
	
	
};//end class GeneFrequencyDistribution


#endif


