// ClineGeneticData.h

#ifndef ClineGeneticDatah
#define ClineGeneticDatah = 1


//#include "ReadAndManageGeljock.h"
#include "MultiformatMarkerData.h"
#include "HybridIndexByLocation.h"
#include "HybridIndexByLocus.h"
#include "MetropolisHastings.h"
#include "Element.h"
#include "aList.h"
#include "String.h"
#include "StringList.h"
#include "TextDatum.h"
#include "TextDataList.h"
#include <iostream.h>
#include <fstream.h>
#include "aError.h"
#include "MemoryManager.h"

	class ClineGeneticData: public MultiformatMarkerData, public MetropolisHastingsData{
		public:
			aList<int> diagnosticTraitNum_;//holds places in (=indices of) EvolutionaryGeneticsData::traitNum_[]
			ObjList<StringList> diagnosticAllelesR_;
					//list of loci, each with list of all alleles that are diagnostic on 
					//the right side of the hybrid zone
					//indexed according to elements of diagnosticTraitNum
			long pointerToDerivedSelf_;
		
			ObjList<HybridIndexByLocation> hybridIndices_;
			ObjList<HybridIndexByLocus> HybridIndicesByLocus_;//indexed according to elements of diagnosticTraitNum
		
		public:
		ClineGeneticData(void){}
		ClineGeneticData(aString& s);
		ClineGeneticData(ClineGeneticData& parentData);
		ClineGeneticData(ClineGeneticData& parentdata, aList<int>& popSubsetNums);
virtual	~ClineGeneticData(void){
			Clear();
			}
			//makes a copy of the original data using a subset of populations
			//useful for separate analyses of data subsets

	void 		SetPointerToDerivedSelf(void){
					pointerToDerivedSelf_ = (long) this;}
	long  		GetPointerToDerivedSelf(void){
					return (long) this;}
//	virtual MetropolisHastingsData* Duplicate(void){//use for virtual copying of derived classes
//			return _Duplicate();}

	ClineGeneticData* _Duplicate(void){//use for virtual copying of derived classes
			return NEW ClineGeneticData(*this);}


	void 		AddDiagnosticAlleles(aString& aLocusName);//attaches list of diagnistic alleles to aString
	void 		CalculateHybridIndex(aList<long double>& popLocation);
	void 		Clear(void);
	void 		CullLoci (aList<int>& lociToCull);
//	void 		CullSkippedLoci (void);
	void		FitAllozymeCline(aString& dataFileName);
	virtual void Initialize(void);
	virtual void Initialize(aString& a);
	void 		Initialize(ClineGeneticData& cgd);
	ClineGeneticData* PoolDiagnosticAlleles (void);
	void 		PrintGelJockFile (aString& outFileName);
	void 		PrintGelJockFile (ostream& outFile);
	virtual	int 	PrintHybridIndexFile(aString& outFileName);
	int 		ReadGelJockDataFile (aString* dataFileName);//input file assumed closed
	void 		RestoreLoci (StringList& lociToRestore);
	void 		StoreDiagnosticAlleles(void);
	void 		StripDiagnosticAlleles(aString& aLocusName);//strips list of diagnistic alleles to aString


		};//end class ClineGeneticData
		
		
#endif

