/*****
GenotypeFreqDistDom.h

dominant markers: p_ is the (dominant) allele frequency, but the class holds marker frequencies in the
order {dominant,recessive}. 

*****/

#ifndef GenotypeFreqDistDomh
#define GenotypeFreqDistDomh = 1


#include "aError.h"
#include "Element.h"
#include "aList.h"
#include "StatList.h"
#include "StringClass.h"
#include "StringList.h"
#include "RandomList.h"
#include "InlineTemplates.h"
#include "GenotypeFreqDistribution.h"
#include <iostream.h>
#include "MemoryManager.h"


class GenotypeFreqDistDom: public GenotypeFreqDistribution{
	public:
	long double beta_;//dominant marker frequency over both sexes
	
	public:
	GenotypeFreqDistDom(const long double beta, const long double Fis=(long double)0.0):
			GenotypeFreqDistribution(), beta_(beta){
					Fis_=Fis;
					CreateDistributionDominantMarker();
					}//ctr
			
	GenotypeFreqDistDom(void):GenotypeFreqDistribution(){
			beta_ = (long double)0.0;
			}

	GenotypeFreqDistDom(GenotypeFreqDistDom& d):
					GenotypeFreqDistribution(d),beta_(d.beta_){
			}	
	GenotypeFreqDistDom(GenotypeFreqDistDom* d):
					GenotypeFreqDistribution(*d),beta_(d->beta_){
			}
					
	
	~GenotypeFreqDistDom(void){}

	virtual GenotypeFreqDistribution* Duplicate(void){
		return NEW GenotypeFreqDistDom(*this);
		}

	virtual void Initialize(long double beta, long double Fis=(long double)0.0){
		Clear();
		beta_=beta;
		Fis_ = Fis;
		CreateDistributionDominantMarker();
		}


	void CreateDistribution2(void){
				CreateDistributionDominantMarker();}
	void CreateDistributionDominantMarker(void);//0-1 data, sampled from Fis, sex ratio & marker freq
	virtual long double markerFrequency(int markerDom0recessive1){//returns marker frequency for dominant/recessive markers
			if(markerDom0recessive1==0){
					return beta_;}
			return (long double)1.0 - beta_;
			}
	virtual long double markerFrequency(int markerDom0recessive1, bool /*homogametic*/){
				return markerFrequency(markerDom0recessive1);}
	virtual long double markerFrequency(int markerDom0recessive1, int /*sexFemale0male1*/){
				return markerFrequency(markerDom0recessive1);}
//	void PrintToScreen(void);
	
};//end GenotypeFreqDistSexLinkDom




#endif
