//GenotypeFreqMultiAlleleDist.h

#ifndef GenotypeFreqMultiAlleleDisth
#define GenotypeFreqMultiAlleleDisth = 1


#include "StatList.h"
#include "Element.h"
#include "aList.h"
#include "RandomList.h"
#include "StringList.h"
#include <iostream.h>
#include "MemoryManager.h"


class GenotypeFreqMultiAlleleDist: public StatList<long double>{
	public:
	aList<long double> p_;
	long double Fis_;
	StringList gTypes_;
	public:
	GenotypeFreqMultiAlleleDist(aList<long double>& p, const long double Fis=(long double)0.0):
					p_(p), Fis_(Fis){
//			CreateDistribution();
			CreateDistribution2();
			}
	GenotypeFreqMultiAlleleDist(GenotypeFreqMultiAlleleDist& d):
					StatList<long double>(d), p_(d.p_), Fis_(d.Fis_){
			}	
	GenotypeFreqMultiAlleleDist(GenotypeFreqMultiAlleleDist* d):
					StatList<long double>(d), p_(d->p_), Fis_(d->Fis_){
			}
					
	~GenotypeFreqMultiAlleleDist(void){
			p_.Clear();
			gTypes_.Clear();
			}


	int			Alleles(void){return p_.len();}
	void 		CreateDistribution(void);
	void 		CreateDistribution2(void);//corrects for boundary conditions when Fis<0
	void 		PrintToScreen(void);
	int 		RandomGenotype(Ran3List& ran){
						return ran.weighted(*this);}
	aString* 	RandomGenotypeString(Ran3List& ran);
	

};//end GenotypeFreqMultiAlleleDist


#endif
