/*****************************************************
*
*	Fis_Fit_Q_Likelihood.h
*
*	These functions calculate the ln-likelihood of a Fst & Nm
*	from allele frequencies of codominant markers, 
*	by applying a modified form of Wright's beta distribution.
*
******************************************************/

#ifndef Fis_Fit_Q_Likelihoodh
#define Fis_Fit_Q_Likelihoodh = 1

#include <math.h>
#include "Element.h"
#include "aList.h"
#include "Randomness.h"
#include "InlineTemplates.h"
#include "Gamma.h"
#include "ParamRec.h"
#include "MetropolisHastings.h"
#include "CodominantMarkerMCMCData.h"
#include "SexLinkedCodominantMarkerMCMCData.h"
#include "DominantMarkerMCMCData.h"
#include "SexLinkedDominantMarkerMCMCData.h"
#include "Fis_Fit_Q_ParamRec.h"
#include "Fis_Fit_Q_DomParamRec.h"

long double Fis_Fit_Q_Likelihood_Codominant(ParamRec& p, MetropolisHastingsData* data);
long double Fis_Fit_Q_Likelihood_SexLinkedCodominant(ParamRec& p, MetropolisHastingsData* data);
long double Fis_Fit_Q_Likelihood_Dominant(ParamRec& p, MetropolisHastingsData* data);
long double Fis_Fit_Q_Likelihood_SexLinkedDominant(ParamRec& p, MetropolisHastingsData* data);



#endif
