/*****************************************

	PopPhenoLandScapeInterface.h

******************************************/

#ifndef PopPhenoLandScapeInterfaceh
#define PopPhenoLandScapeInterfaceh = 1


#include "PopulationPhenotypicData.h"
#include "GeneticLandScape.h"
#include "StringClass.h"
#include "StringList.h"
#include "Element.h"
#include "aList.h"
#include "MemoryManager.h"


class PopPhenoLandScapeInterface: public PopulationPhenotypicData {
  public:
	StringList indivStateNames;//id, sex, age, etc. traits not stored in Phenotype class
	ObjList<ObjList<StringList> > indivStateScores;//listed for each population, then for each trait


  public:
  	PopPhenoLandScapeInterface(void){
  		}
 	~PopPhenoLandScapeInterface(void){
 		}
 	
	void DeleteIndividualsWithStates(StringList& undesirableStateNames, 
									  ObjList<StringList> & undesirableStates);
			//removes individuals with the listed state values
			//Uses AND as sorting criterion when multiple state names given
			//states are attributes (id, age, sex, etc.) of Individual and derived classes,
			//not traits stored in class Phenotype

	void KeepIndividualsWithStates(StringList& desirableStateNames,
									ObjList<StringList> & desirableStates);
			//removes individuals EXCEPT those with the listed state values
			//Uses AND as sorting criterion when multiple state names given
			//states are attributes (id, age, sex, etc.) of Individual and derived classes,
			//not traits stored in class Phenotype

 	void ReadGeneticLandScape(GeneticLandScape& theLandScape, 
 						int species, aString& simTitle, aList<int>& skippedTraitNumbers, 
 						int includeGenotype = 0);
 	
 	void ReadGeneticLandScape(GeneticLandScape& theLandScape, //all species
 						aString& simTitle, aList<int>& skippedTraitNumbers, 
 						int includeGenotype = 0);

	void ReadListOfIndividuals(ObjList<Individual>& indivList, 
				aString& simTitle, aList<int>& skippedTraitNumbers, int includeGenotype);
 	
};//end class PopPhenoLandScapeInterface









#endif
