// AllozymeClineShapeData9.h

//This class calculates cline shape by fitting data in the form (x,y) to
//a 9-parameter tanh function.  The theory is in Szymura & Barton 1986.
//The program reads in a data set of allozymes and calculates the hybrid
//index and gametic disequilibria for each population.

//derived classes implement the appropriate cline shape functions
#ifndef AllozymeClineShapeData9h
#define AllozymeClineShapeData9h = 1

//#include <iostream.h>
#include <Shape9ParamRec.h>
//#include <AllozymeClineShapeData3.h>
#include <AllozymeClineShapePlus.h>


class AllozymeClineShapeData9: public AllozymeClineShapePlus<Shape9ParamRec>{
		public:
			AllozymeClineShapeData9(double harmonicMeanRecomb):
				AllozymeClineShapePlus<Shape9ParamRec>(harmonicMeanRecomb){
						harMeanRecomb = harmonicMeanRecomb;
						params = 9;}
			AllozymeClineShapeData9(aString& s, double harmonicMeanRecomb): 
				AllozymeClineShapePlus<Shape9ParamRec>(s, harmonicMeanRecomb){
						harMeanRecomb = harmonicMeanRecomb;
						params = 9;}
			AllozymeClineShapeData9(double numChromosomes, double mapDistBetweenLoci):
				AllozymeClineShapePlus<Shape9ParamRec>(numChromosomes, mapDistBetweenLoci){
						params = 9;}
			AllozymeClineShapeData9(aString& s, double numChromosomes, double mapDistBetweenLoci): 
				AllozymeClineShapePlus<Shape9ParamRec>(s, numChromosomes, mapDistBetweenLoci){
						params = 9;}
			~AllozymeClineShapeData9(void){}
			
		};//end class AllozymeClineShapeData9





/*

class AllozymeClineShapeData9: virtual public AllozymeClineShapeData3{
		public:
			AllozymeClineShapeData9(void): AllozymeClineShapeData3(){
				IShapeData();}
			AllozymeClineShapeData9(String& s): AllozymeClineShapeData3(s){
				IShapeData();}
			~AllozymeClineShapeData9(void){}

	virtual void 		IShapeData(void ){
						params = 9;					
						delete bestParams; bestParams= new Shape9ParamRec();
						delete paramsInUse; paramsInUse= new Shape9ParamRec();
						delete paramDeviations; paramDeviations= new Shape9ParamRec();
						delete paramsToTry; paramsToTry= new Shape9ParamRec();
						}//end IShapeData		
	virtual void		SetCurrentAsBest(void){
						delete bestParams; bestParams = 0;
						bestParams = new Shape9ParamRec(*paramsInUse);
						}//end SetCurrentAsBest
						


		};//end class AllozymeClineShapeData9

*/
#endif
