//LikelihoodListTotal.cp


#include <LikelihoodListTotal.h>


template<class T> double LikelihoodListTotal<T>::bestL(ClinePopList& popCombList){
	T* bestParam = best(popCombList);
	if (bestParam == 0){ return 0.0;}
		else{ return bestParam->Ltotal();}
	}//end LikelihoodListTotal<T>::bestL(ClinePopList&)



template<class T> void LikelihoodListTotal<T>::PrintBestParameters(long& allTries,
									aList<long>& acceptedChanges, 
									aList<long>& totalTries,
									ostream& outFile){
	long sumA = 0, sumN = 0; 
	aList<double> successRate; double overallSuccessRate = 0.0;
	for (int i=0;i<totalTries.len();++i){
		successRate.Append(0.0);}
	for (i=0;i<successRate.len();++i){
		if (totalTries[i] > 0){				
			successRate.Replace((double) acceptedChanges[i] / (double) totalTries[i], i);
			sumA += acceptedChanges[i];
			sumN += totalTries[i];
			}//end if totalTries
		}//end for i
	if (sumN > 0){
		overallSuccessRate = (double) sumA / (double) sumN;}

	if(compare==cline){
			overallBest.PrintShapeWithCI(allTries, overallSuccessRate, successRate, 
						lowerCI, upperCI, bestDerived, lowerDerivedCI, upperDerivedCI, outFile);}
		else if(compare==disequilibrium){
			double diseqSuccess = overallBest.GetDiseqSuccess(successRate);
			overallBest.PrintDiseqWithCI(diseqSuccess,lowerCI, upperCI, outFile);}
		else if(compare==total){
			overallBest.PrintDerivedWithCI(lowerCI, upperCI, bestDerived, lowerDerivedCI, upperDerivedCI, outFile);}
						
	}//end  LikelihoodListTotal<T>::PrintBestParameters

/*
template <class T> void LikelihoodListTotal<T>::SetCurrentTotal(T& param, ClinePopList& popCombList){
	T* Tparam = current(popCombList);
	param.D(Tparam->D());
	param.LtoLmaxDiseq(Tparam->LtoLmaxDiseq());
	param.LmaxMinusLDiseq(Tparam->LmaxMinusLDiseq());
	param.SetTotal();
	doubleLmaxTotal = 
	param.SetTotalLikelihoodRatiosl(LmaxTotal);
	param.LmaxMinusLTotal(Dparam->LmaxMinusLDiseq());
	}//end LikelihoodListDiseq<T>::SetCurrentDiseq
*/




