//Shape4ParamRec.cp


#pragma once
#include <Shape4ParamRec.h>
#include <ClinePopList.h>
#include <FitMultilocusCline.h>




Shape4ParamRec* Shape4ParamRec::ChangeParams(Shape2ParamRec& paramDeviations,
						  Ran3& ran, int& thisOne, const double t, const int annealingShape){
	int OK=True;
	thisOne = ChooseParameter(ran, annealingShape);
	Shape4ParamRec* paramToChange = new Shape4ParamRec(*this);//calls copy constructor
	do	{
		OK = True;
		if (thisOne == 1){//change center point by a random amount
				paramToChange->c_ = ran.NormDev(center(), paramDeviations.center() * t);}
			else if (thisOne == 2){//change width by random amount
				paramToChange->w_ = ran.NormDev(w(), paramDeviations.w() * t);}
			else if (thisOne == 3){//change bottomL by random amount
				paramToChange->bottomL_ = ran.NormDev(bottomL(), paramDeviations.bottomL() * t);}
			else if (thisOne == 4){//change topR by random amount
				paramToChange->topR_ = ran.NormDev(topR(), paramDeviations.topR() * t);}
		OK = paramToChange->SetShape();
		}while (! OK);
	return paramToChange;
	}//	end Shape4ParamRec::ChangeParams



	int Shape4ParamRec::ChooseParameter(Ran3& ran, const int annealingShape){
		//randomly chooses a parameter to vary
		return ran.longBetween(1,4);//randomly choose center (1), width (2), bottomL (3), or topR(4)
		}//end Shape4ParamRec::ChooseParameter



int Shape4ParamRec::FindCenterPopulations(ClinePopList& centerPopList, ClinePopList& popLocation){
	return centerPopList.FindCenterPopulations(*this, popLocation);}



int Shape4ParamRec:: MeetsParamCriteria (void){
	int OK = Shape2ParamRec:: MeetsParamCriteria();
	if ((bottomL() < minScoreAtL) || (bottomL() > (minScoreAtL + maxScoreAtR) / 2.0)) {
			OK = False;}
		else if ((topR() > maxScoreAtR) || (topR() < (minScoreAtL + maxScoreAtR) / 2.0)) {
			OK = False;}
	return OK;
	}//end  Shape4ParamRec:: MeetsParamCriteria



void	 Shape4ParamRec::SetStartingValues(void){
	// plausible arbitrary values that start the iteration process
	// these are now constants defined in AllozymeClineGlobals.h
	Shape2ParamRec::SetStartingValues();
	bottomL_ = minScoreAtL;
	topR_ = maxScoreAtR;
	}//end Shape4ParamRec::SetStartingValues

	
	
	
void	 Shape4ParamRec::SetDeviationValues(void){
	//set initial parameter deviation values (standard deviations)
	//parameters deviated by random variables with these standard deviations
	// these are now constants defined in AllozymeClineGlobals.h
	Shape2ParamRec::SetDeviationValues();
	bottomL_ = bottomTopDev;
	topR_ = bottomTopDev;
	}//end Shape4ParamRec::SetDeviationValues




