// Shape7ParamRec.h



#ifndef Shape7ParamRech
#define Shape7ParamRech = 1

#include "AllozymeClineGlobals.h"

class ClinePopList;
class Shape7ParamRec;

class Shape7ParamRec
//			public virtual Shape2ParamRec,
//			public virtual Shape3ParamRec,
//			public virtual Shape6ParamRec
			{
				//a set of cline shape parameters and their derived parameters
		//for width, center location, bottom and top allele frequencies, thetas, asymptotes, and disequilibrium
	    public:
		double c_;//when fitting, these are randomly chosen
		double w_;		//width
		double thetaL_;		//decay on left side
		double thetaR_;		//decay on right side
		double asymptoteL_;	//asymptote of right side, which is left of center
		double asymptoteR_;	//asymptote of left side, which is right of center
		double xL_;	//these are calculated values
		double xR_;
		double betaL_;	
		double betaR_;
		double Lcline_;	//likelihood of this parameter set
		double LtoLmaxCline_;
		double LmaxMinusLcline_;
		double D_;//disequilibrium
		double Ldiseq_;	//likelihood of this disequilibrium value
		double LtoLmaxDiseq_;
		double LmaxMinusLDiseq_;
		double Ltotal_;	//likelihood of this parameter set
		double LtoLmaxTotal_;
		double LmaxMinusLTotal_;
	public:
		Shape7ParamRec(void): Lcline_(0.0), LtoLmaxCline_(0.0), LmaxMinusLcline_(0.0),
			c_(0.0), w_(0.0), Ldiseq_(0.0), LtoLmaxDiseq_(0.0), LmaxMinusLDiseq_(0.0), D_(0.0),
			Ltotal_(0.0), LtoLmaxTotal_(0.0), LmaxMinusLTotal_(0.0), thetaL_(0.0), thetaR_(0.0),
			asymptoteL_(0.0), asymptoteR_(0.0), xL_(0.0), xR_(0.0), betaL_(0.0), betaR_(0.0)
			{}
		Shape7ParamRec(Shape7ParamRec& x):	//copy constructor
					c_(x.center()),
					w_(x.w()),
					thetaL_(x.thetaL()),
					thetaR_(x.thetaR()),
					asymptoteL_(x.asymptoteL()),
					asymptoteR_(x.asymptoteR()),
					xL_(x.xL()),
					xR_(x.xR()),
					betaL_(x.betaL()),
					betaR_(x.betaR()),
					D_(x.D()),
					Lcline_(x.Lcline()),
					LtoLmaxCline_(x.LtoLmaxCline()),
					LmaxMinusLcline_(x.LmaxMinusLcline()),
					Ldiseq_(x.Ldiseq()),
					LtoLmaxDiseq_(x.LtoLmaxDiseq()),
					LmaxMinusLDiseq_(x.LmaxMinusLDiseq()),
					Ltotal_(x.Ltotal()),
					LtoLmaxTotal_(x.LtoLmaxTotal()),
					LmaxMinusLTotal_(x.LmaxMinusLTotal())
					{}
		Shape7ParamRec(Shape7ParamRec* x):	//copy constructor
					c_(x->center()),
					w_(x->w()),
					thetaL_(x->thetaL()),
					thetaR_(x->thetaR()),
					asymptoteL_(x->asymptoteL()),
					asymptoteR_(x->asymptoteR()),
					xL_(x->xL()),
					xR_(x->xR()),
					betaL_(x->betaL()),
					betaR_(x->betaR()),
					D_(x->D()),
					Lcline_(x->Lcline()),
					LtoLmaxCline_(x->LtoLmaxCline()),
					LmaxMinusLcline_(x->LmaxMinusLcline()),
					Ldiseq_(x->Ldiseq()),
					LtoLmaxDiseq_(x->LtoLmaxDiseq()),
					LmaxMinusLDiseq_(x->LmaxMinusLDiseq()),
					Ltotal_(x->Ltotal()),
					LtoLmaxTotal_(x->LtoLmaxTotal()),
					LmaxMinusLTotal_(x->LmaxMinusLTotal())
					{}
		virtual ~Shape7ParamRec(void){}

	virtual double 	center(void){return c_;}
	virtual double 	w(void) {return w_;}	
	virtual double 	bottomL(void){return 0.0;}//average allele freq on left side
	virtual double 	topR(void){return 1.0;} //average allele freq on right side
	virtual double 	Lcline(void){return Lcline_;}
	virtual double 	LtoLmaxCline(void) {return LtoLmaxCline_;}	
	virtual double 	LmaxMinusLcline(void){return LmaxMinusLcline_;}
	virtual double 	D(void){return D_;}
	virtual double 	Ldiseq(void){return Ldiseq_;}
	virtual double 	LtoLmaxDiseq(void){return LtoLmaxDiseq_;}
	virtual double 	LmaxMinusLDiseq(void){return LmaxMinusLDiseq_;}
	virtual double 	Ltotal(void){return Ltotal_;}
	virtual double 	LtoLmaxTotal(void) {return LtoLmaxTotal_;}	
	virtual double 	LmaxMinusLTotal(void){return LmaxMinusLTotal_;}
	virtual double 	thetaL(void){return thetaL_;}//decay on left side
	virtual double 	thetaR(void){return thetaR_;}//decay on right side
	virtual double 	asymptoteL(void){return asymptoteL_;}//asymptote of right side, which is left of center
	virtual double 	asymptoteR(void){return asymptoteR_;}//asymptote of left side, which is right of center
	virtual double 	xL(void){return xL_;}
	virtual double 	xR(void){return xR_;}
	virtual double 	betaL(void){return betaL_;}
	virtual double 	betaR(void){return betaR_;}
	virtual void	 	center(double c){c_ = c;}
	virtual void	 	w(double w) {w_ = w;}	
	virtual void	 	Lcline(double L){Lcline_ = L;}
	virtual void	 	LtoLmaxCline(double ratio) {LtoLmaxCline_ = ratio;}	
	virtual void	 	LmaxMinusLcline(double diff){LmaxMinusLcline_ = diff;}
	virtual void	 	D(double d){D_ = d;}
	virtual void	 	Ldiseq(double L){Ldiseq_ = L;}
	virtual void	 	LtoLmaxDiseq(double ratio){LtoLmaxDiseq_ = ratio;}
	virtual void	 	LmaxMinusLDiseq(double diff){LmaxMinusLDiseq_ = diff;}
	virtual void	 	Ltotal(double L){Ltotal_ = L;}
	virtual void	 	LtoLmaxTotal(double ratio) {LtoLmaxTotal_ = ratio;}	
	virtual void	 	LmaxMinusLTotal(double diff){LmaxMinusLTotal_ = diff;}
	virtual void	 	thetaL(double t){thetaL_ = t;}
	virtual void	 	thetaR(double t){thetaR_ = t;}
	virtual void	 	asymptoteL(double x){asymptoteL_ = x;}
	virtual void 	 	asymptoteR(double x){asymptoteR_ = x;}
	virtual void	 	xL(double x){xL_ = x;}
	virtual void	 	xR(double x){xR_ = x;}
	virtual void	 	betaL(double b){betaL_ = b;}
	virtual void	 	betaR(double b){betaR_ = b;}

	//derived variables from the analysis
	virtual double sigma (const double recombinationRate){		
					if (D() < 0.0) {
							return 0.0;}
						else{
							return sqrt((D() * recombinationRate * w() * w()) / (1.0 + recombinationRate));}
					}//end sigma
	virtual double sVsHets (const double recombinationRate){
						double s = sigma(recombinationRate);
						return (2.0*s / w())*(2.0*s / w());}
	virtual double sStarEcotone (const double recombinationRate){	//selection in an ecotone, =(1.732*sigma/w)^2
						double s = sigma(recombinationRate);
						return (1.732*s / w())*(1.732*s / w());}
	virtual double sStarDomEcotone (const double recombinationRate){//selection in an ecotone vs dominant locus, =(1.782*sigma/w)^2
						double s = sigma(recombinationRate);
						return (1.782*s / w())*(1.782*s / w());}
	virtual double nLocSel (const double recombinationRate);//number of loci under selection
	virtual double sPerMarkerL (const double recombinationRate){
					return thetaL() * sVsHets(recombinationRate);}
	virtual double sPerMarkerR (const double recombinationRate){
					return thetaR() * sVsHets(recombinationRate);}
	virtual double sVsHetsRI (const double recombinationRate);//mean selection on each reproductive isolating locus
	virtual double timeL (const double recombinationRate);
	virtual double timeR (const double recombinationRate);
	virtual double WhybridOverWpure (const double recombinationRate);
	virtual double bigS (const double recombinationRate);




	virtual Shape7ParamRec* 	
					ChangeDiseqParam(Shape7ParamRec& paramDeviations,
						  Ran3& ran, int& thisOne, const double t);
	virtual Shape7ParamRec* 	
					ChangeParams(Shape7ParamRec& paramDeviations,
						  Ran3& ran, int& thisOne, const double t, const int annealingShape);
	virtual int		ChooseParameter(Ran3& ran, const int annealingShape=0);
	virtual void		Clear(void){
						c_=w_=Lcline_=LtoLmaxCline_=LmaxMinusLcline_=0.0;
						D_=Ldiseq_=LtoLmaxDiseq_=LmaxMinusLDiseq_=0.0;
						Ltotal_=LtoLmaxTotal_=LmaxMinusLTotal_=0.0;
						thetaL_=thetaR_=asymptoteL_=asymptoteR_=xL_=xR_=betaL_=betaR_=0.0;
						}
	virtual Shape7ParamRec* 	Copy(void){//must be deleted elsewhere
						return new Shape7ParamRec(*this);}
	virtual void		DerivedValues(aList<double>& derivedList, double recombinationRate);//listed in order of calls above
	virtual int 		FindCenterPopulations(ClinePopList& centerPopList, ClinePopList& popLocation);
	virtual double 	GetDiseqSuccess(aList<double>& successRate){
						return successRate[7];}//D is seventh parameter varied in ChangeParams
	virtual int		HasHigherLikelihood(Shape7ParamRec& param, likelihoodType compare, const double ci = 0.0);
						//boolean;  always greater if param.Lcline == 0
	virtual int 		LJunction (const double score);
	virtual void		max(Shape7ParamRec& param){//sets parameters to the maximum of this & param
							if(param.center()>center()){c_=param.center();}
							if(param.w()>w()){w_=param.w();}
							Lcline_=LtoLmaxCline_=LmaxMinusLcline_=0.0;
							if(param.D()>D()){D_=param.D();}
							Ldiseq_=LtoLmaxDiseq_=LmaxMinusLDiseq_=0.0;
							Ltotal_=LtoLmaxTotal_=LmaxMinusLTotal_=0.0;
							if(param.thetaL()>thetaL()){thetaL_=param.thetaL();}
							if(param.thetaR()>thetaR()){thetaR_=param.thetaR();}
							if(param.asymptoteL()>asymptoteL()){asymptoteL_=param.asymptoteL();}
							if(param.asymptoteR()>asymptoteR()){asymptoteR_=param.asymptoteR();}
							if(param.xL()>xL()){xL_=param.xL();}
							if(param.xR()>xR()){xR_=param.xR();}
							if(param.betaL()>betaL()){betaL_=param.betaL();}
							if(param.betaR()>betaR()){betaR_=param.betaR();}
							}
	virtual int 		MeetsParamCriteria (void);//boolean for legal parameters
	virtual void		min(Shape7ParamRec& param){//sets parameters to the minimum of this & param
							if(param.center()<center()){c_=param.center();}
							if(param.w()<w()){w_=param.w();}
							Lcline_=LtoLmaxCline_=LmaxMinusLcline_=0.0;
							if(param.D()<D()){D_=param.D();}
							Ldiseq_=LtoLmaxDiseq_=LmaxMinusLDiseq_=0.0;
							Ltotal_=LtoLmaxTotal_=LmaxMinusLTotal_=0.0;
							if(param.thetaL()<thetaL()){thetaL_=param.thetaL();}
							if(param.thetaR()<thetaR()){thetaR_=param.thetaR();}
							if(param.asymptoteL()<asymptoteL()){asymptoteL_=param.asymptoteL();}
							if(param.asymptoteR()<asymptoteR()){asymptoteR_=param.asymptoteR();}
							if(param.xL()<xL()){xL_=param.xL();}
							if(param.xR()<xR()){xR_=param.xR();}
							if(param.betaL()<betaL()){betaL_=param.betaL();}
							if(param.betaR()<betaR()){betaR_=param.betaR();}
							}
	virtual double 	PonCline(const double x, const double score);
	virtual void 		PrintDerivedWithCI(Shape7ParamRec& lowerCI, 
								   Shape7ParamRec& upperCI, 
								   aList<double>& bestDerived,
								   aList<double>& lowerDerivedCI, 
								   aList<double>& upperDerivedCI, 
								   ostream& outFile);//called by the best total parameter set only
	virtual void 		PrintDiseqWithCI(const double successRate, 
							Shape7ParamRec& lowerCI, 
							Shape7ParamRec& upperCI, 
							ostream& outFile);//called by the best parameter set only		
	virtual void 		PrintShapeWithCI(const long allTries, 
							const double overallSuccessRate, 
							aList<double>& successRate,
							Shape7ParamRec& lowerCI, 
							Shape7ParamRec& upperCI, 
							aList<double>& bestDerived, 
							aList<double>& lowerDerivedCI, 
							aList<double>& upperDerivedCI, 
							ostream& outFile);//called by the best parameter set only
	virtual void		PrintToScreen(const long tries, const double recombinationRate);
	virtual int 		RJunction (const double score);
	virtual void		SetBarrierStrength(void);
	virtual void 		SetClineLikelihoodRatios(double LmaxCline);
	virtual void		SetDeviationValues(void);
	virtual void 		SetDiseqLikelihoodRatios(const double LmaxDiseq);
	virtual void 		SetNewBest(void){LtoLmaxCline_ = 1.0; LmaxMinusLcline_ = 0.0;}
	virtual void 		SetNewBestDiseq(void){LtoLmaxDiseq_ = 1.0; LmaxMinusLDiseq_ = 0.0;}
	virtual void 		SetNewBestTotal(void){LtoLmaxTotal_ = 1.0; LmaxMinusLTotal_ = 0.0;}
	virtual int    		SetShape(void);//returns boolean false if illegal shape
	virtual void		SetStartingValues(void);
	virtual void 		SetTotal(void);
	virtual void 		SetTotalLikelihoodRatios(const double LmaxTotal);
	virtual void 		operator=(Shape7ParamRec& x){
						c_= x.center();
						w_= x.w();
						thetaL_ = x.thetaL();
						thetaR_ = x.thetaR();
						asymptoteL_ = x.asymptoteL();
						asymptoteR_ = x.asymptoteR();
						xL_ = x.xL();
						xR_ = x.xR();
						betaL_ = x.betaL();
						betaR_ = x.betaR();
						D_= x.D();
						Lcline_= x.Lcline();
						LtoLmaxCline_= x.LtoLmaxCline();
						LmaxMinusLcline_= x.LmaxMinusLcline();
						Ldiseq_= x.Ldiseq();
						LtoLmaxDiseq_= x.LtoLmaxDiseq();
						LmaxMinusLDiseq_= x.LmaxMinusLDiseq();
						Ltotal_ = x.Ltotal();
						LtoLmaxTotal_ = x.LtoLmaxTotal();
						LmaxMinusLTotal_ = x.LmaxMinusLTotal();
						}

	friend int 		operator== (Shape7ParamRec& a, Shape7ParamRec& b);

	friend int 		operator!= (Shape7ParamRec& a, Shape7ParamRec& b){
							return (!(a==b));}

	};//end class Shape7ParamRec

#endif

