//Shape8ParamRec.cp


//#pragma once
#include <Shape8ParamRec.h>
#include <ClinePopList.h>
//#include <FitMultilocusCline.h>




Shape8ParamRec* Shape8ParamRec::ChangeParams(Shape8ParamRec& paramDeviations,
						  Ran3& ran, int& thisOne, const double t, const int annealingShape){
	int OK=True;
	thisOne = ChooseParameter(ran, annealingShape);
	Shape8ParamRec* paramToChange = new Shape8ParamRec(*this);//calls copy constructor
	do	{
		OK = True;
		if (thisOne == 1){//change center point by a random amount
				paramToChange->c_ = ran.NormDev(center(), paramDeviations.center() * t);}
			else if (thisOne == 2){//change width by random amount
				paramToChange->w_ = ran.NormDev(w(), paramDeviations.w() * t);}
			else if (thisOne == 3){//change thetaL by random amount
				paramToChange->thetaL_ = ran.NormDev(thetaL(), paramDeviations.thetaL() * t);}
			else if (thisOne == 4){//change thetaR by random amount
				paramToChange->thetaR_ = ran.NormDev(thetaR(), paramDeviations.thetaR() * t);}
			else if (thisOne == 5){//change asymptoteL by random amount
				paramToChange->asymptoteL_ = ran.NormDev(asymptoteL(), paramDeviations.asymptoteL() * t);}
			else if (thisOne == 6){//change asymptoteR by random amount
				paramToChange->asymptoteR_ = ran.NormDev(asymptoteR(), paramDeviations.asymptoteR() * t);}
			else if (thisOne == 7){//change bottomL by random amount
				paramToChange->bottomL_ = ran.NormDev(bottomL(), paramDeviations.bottomL() * t);}
			else if (thisOne == 8){//change topR by random amount
				paramToChange->topR_ = ran.NormDev(topR(), paramDeviations.topR() * t);}
		OK = paramToChange->SetShape();
		}while (! OK);
	return paramToChange;
	}//	end Shape8ParamRec::ChangeParams



int Shape8ParamRec::ChooseParameter(Ran3& ran, const int annealingShape){ 
	//randomly choose center (1), width (2), thetaL (3), thetaR(4), 
	//asymptoteL (5), asymptoteR (6), bottomL (7), or topR (8)
	return ran.longBetween(1,8);
	}//end Shape8ParamRec::ChooseParameter


int Shape8ParamRec::FindCenterPopulations(ClinePopList& centerPopList, ClinePopList& popLocation){
	return centerPopList.FindCenterPopulations(*this, popLocation);}



int Shape8ParamRec:: MeetsParamCriteria (void){
	int OK = Shape6ParamRec:: MeetsParamCriteria();
	if ((bottomL() < minScoreAtL) || (bottomL() > (minScoreAtL + maxScoreAtR) / 2.0)) {
			OK = False;}
		else if ((topR() > maxScoreAtR) || (topR() < (minScoreAtL + maxScoreAtR) / 2.0)) {
			OK = False;}
	return OK;
	}//end  Shape8ParamRec:: MeetsParamCriteria



void	 Shape8ParamRec::SetDeviationValues(void){
	//set initial parameter deviation values (standard deviations)
	//parameters deviated by random variables with these standard deviations
	// these are now constants defined in AllozymeClineGlobals.h
	Shape6ParamRec::SetDeviationValues();
	bottomL_ = bottomTopDev;
	topR_ = bottomTopDev;
	}//end Shape8ParamRec::SetDeviationValues



void	 Shape8ParamRec::SetStartingValues(void){
	// plausible arbitrary values that start the iteration process
	// these are now constants defined in AllozymeClineGlobals.h
	Shape6ParamRec::SetStartingValues();
	bottomL_ = minScoreAtL;
	topR_ = maxScoreAtR;
	LJunction(maxScore);
	RJunction(maxScore);
	}//end Shape8ParamRec::SetStartingValues

	
int operator== (Shape8ParamRec& a, Shape8ParamRec& b){
	if(	((Shape6ParamRec) a == (Shape6ParamRec) b)  &&
		 (a.bottomL()==b.bottomL())  &&			
		 (a.topR()==b.topR())
	    )		 {return 1;}else{ return 0;}
	}//end operator ==


