// Shape8ParamRec.h

#ifndef Shape8ParamRech
#define Shape8ParamRech = 1

//#include <Shape4ParamRec.h>
#include <Shape6ParamRec.h>

class ClinePopList;
class Shape8ParamRec;

class Shape8ParamRec:
//		public virtual Shape2ParamRec,
//		public virtual Shape4ParamRec, 
//		public virtual Shape6ParamRec
		public Shape6ParamRec
		{
	//a set of cline shape parameters and their derived parameters
	//for width, center location, theta, top, bottom,and  the asymptotic edges of the single-locus clines on the ends
	    public:
		double bottomL_;	//average allele freq on left side
		double topR_;		//average allele freq on right side
	public:
		Shape8ParamRec(void): Shape6ParamRec(), bottomL_(0.0),topR_(0.0) {}
		Shape8ParamRec(Shape8ParamRec& x): //copy constructor
				 Shape6ParamRec(x), 
				 bottomL_(x.bottomL()),
				 topR_(x.topR())
				{}
		Shape8ParamRec(Shape8ParamRec* x): //copy constructor
				 Shape6ParamRec(x), 
				 bottomL_(x->bottomL()),
				 topR_(x->topR())
				{}
		virtual ~Shape8ParamRec(void){}

		virtual double bottomL(void){return bottomL_;}//average allele freq on left side
		virtual double topR(void){return topR_;} //average allele freq on right side
		virtual void	 bottomL(double p){bottomL_ = p;}//average allele freq on left side
		virtual void	 topR(double p){topR_ = p;} //average allele freq on right side


	virtual Shape8ParamRec* 	
					ChangeParams(Shape8ParamRec& paramDeviations,
						  Ran3& ran, int& thisOne, const double t, const int annealingShape);
	virtual int		ChooseParameter(Ran3& ran, const int annealingShape=0);
	virtual void		Clear(void){
						Shape6ParamRec::Clear();
						bottomL_=topR_=0.0;}
	virtual Shape8ParamRec* 	Copy(void){//must be deleted elsewhere
						return new Shape8ParamRec(*this);}
	virtual void		DerivedValues(aList<double>& derivedList, double recombinationRate){
						Shape6ParamRec::DerivedValues(derivedList, recombinationRate);}
	virtual int 		FindCenterPopulations(ClinePopList& centerPopList, ClinePopList& popLocation);
	virtual void		max(Shape8ParamRec& param){//sets parameters to the maximum of this & param
							Shape6ParamRec::max(param);
							if(param.bottomL()>bottomL()){bottomL_=param.bottomL();}
							if(param.topR()>topR()){topR_=param.topR();}
							}
	virtual int 		MeetsParamCriteria (void);//boolean for legal parameters
	virtual void		min(Shape8ParamRec& param){//sets parameters to the minimum of this & param
							Shape6ParamRec::min(param);
							if(param.bottomL()<bottomL()){bottomL_=param.bottomL();}
							if(param.topR()<topR()){topR_=param.topR();}
							}
	virtual double 	PonCline(const double x, const double score){
								return Shape6ParamRec::PonCline(x, score);}
	virtual void 		PrintShapeWithCI(const long allTries, 
							const double overallSuccessRate, 
							aList<double>& successRate,
							Shape8ParamRec& lowerCI, 
							Shape8ParamRec& upperCI, 
							aList<double>& bestDerived, 
							aList<double>& lowerDerivedCI, 
							aList<double>& upperDerivedCI, 
							ostream& outFile){//called by the best parameter set only
								Shape6ParamRec::PrintShapeWithCI(allTries, overallSuccessRate,
															successRate, lowerCI, upperCI, 
															bestDerived, lowerDerivedCI, 
															upperDerivedCI, outFile);}
	virtual void		SetDeviationValues(void);
	virtual void		SetStartingValues(void);
	virtual void 		operator=(Shape8ParamRec& x){
						c_= x.center();
						w_= x.w();
						thetaL_ = x.thetaL();
						thetaR_ = x.thetaR();
						asymptoteL_ = x.asymptoteL();
						asymptoteR_ = x.asymptoteR();
						bottomL_ = x.bottomL();
						topR_ = x.topR(); 
						xL_ = x.xL();
						xR_ = x.xR();
						betaL_ = x.betaL();
						betaR_ = x.betaR();
						Lcline_= x.Lcline();
						LtoLmaxCline_= x.LtoLmaxCline();
						LmaxMinusLcline_= x.LmaxMinusLcline();
						}

	friend int operator== (Shape8ParamRec& a, Shape8ParamRec& b);
	

	friend int operator!= (Shape8ParamRec& a, Shape8ParamRec& b){
		return (!(a==b));}

	};//end class Shape8ParamRec

#endif
