// Shape9ParamRec.h

#ifndef Shape9ParamRech
#define Shape9ParamRech = 1

//#include <Shape2ParamRec.h>
//#include <Shape6ParamRec.h>
#include <Shape7ParamRec.h>
//#include <Shape8ParamRec.h>
#include "AllozymeClineGlobals.h"

class ClinePopList;
class Shape9ParamRec;

class Shape9ParamRec: 
//			public virtual Shape2ParamRec,
//			public virtual Shape6ParamRec,
//			public virtual Shape7ParamRec,
//			public virtual Shape8ParamRec
			public Shape7ParamRec
			{
				//a set of cline shape parameters and their derived parameters
		//for width, center location, bottom and top allele frequencies, thetas, asymptotes, and disequilibrium
	    public:
		double bottomL_;	//average allele freq on left side
		double topR_;		//average allele freq on right side
	public:
		Shape9ParamRec(void): Shape7ParamRec(), bottomL_(0.0),topR_(0.0) {}
		Shape9ParamRec(Shape9ParamRec& x)://copy constructor
					Shape7ParamRec(x), 
					bottomL_(x.bottomL()),
					topR_(x.topR()) 
					{}
		Shape9ParamRec(Shape9ParamRec* x)://copy constructor
					Shape7ParamRec(x), 
					bottomL_(x->bottomL()),
					topR_(x->topR()) 
					{}
		virtual ~Shape9ParamRec(void){}


		virtual double bottomL(void){return bottomL_;}//average allele freq on left side
		virtual double topR(void){return topR_;} //average allele freq on right side
		virtual void	 bottomL(double p){bottomL_ = p;}//average allele freq on left side
		virtual void	 topR(double p){topR_ = p;} //average allele freq on right side


	virtual Shape9ParamRec* 	
					ChangeDiseqParam (Shape9ParamRec& paramDeviations,
						  	     Ran3& ran, int& thisOne, const double t);
	virtual Shape9ParamRec* 	
					ChangeParams (Shape9ParamRec& paramDeviations,
						  	     Ran3& ran, int& thisOne, const double t, const int annealingShape);
	virtual int		ChooseParameter(Ran3& ran, const int annealingShape=0);
	virtual void		Clear(void){
						Shape7ParamRec::Clear();
						bottomL_=topR_=0.0;
						}
	virtual Shape9ParamRec* 		Copy(void);
	virtual void		DerivedValues(aList<double>& derivedList, double recombinationRate);
	virtual double 	GetDiseqSuccess(aList<double>& successRate){
						return successRate[8];}//D is ninth parameter varied in ChangeParams
	virtual int 		FindCenterPopulations(ClinePopList& centerPopList, ClinePopList& popLocation);
	virtual int		HasHigherLikelihood(Shape9ParamRec& param, likelihoodType compare, const double ci = 0.0){//boolean
						//always greater if param.L == 0
						if (compare == cline){
								return ((param.Lcline() == 0.0) ||  (Lcline() > param.Lcline() - ci ));}
							else if (compare ==disequilibrium){
								return ((param.Ldiseq() == 0.0) ||  (Ldiseq() > param.Ldiseq() - ci ));}
							else {// (compare ==total)
								return ((param.Ltotal() == 0.0) ||  (Ltotal() > param.Ltotal() - ci ));}
						}//end HasHigherLikelihood
	virtual void		max(Shape9ParamRec& param){//sets parameters to the maximum of this & param
							Shape7ParamRec::max(param);
							if(param.bottomL()>bottomL()){bottomL_=param.bottomL();}
							if(param.topR()>topR()){topR_=param.topR();}
							}
	virtual int 		MeetsParamCriteria (void);//boolean for legal parameters
	virtual void		min(Shape9ParamRec& param){//sets parameters to the minimum of this & param
							Shape7ParamRec::min(param);
							if(param.bottomL()<bottomL()){bottomL_=param.bottomL();}
							if(param.topR()<topR()){topR_=param.topR();}
							}
	virtual void 		PrintDerivedWithCI(Shape9ParamRec& lowerCI, 
							Shape9ParamRec& upperCI, 
							aList<double>& bestDerived,
							aList<double>& lowerDerivedCI, 
							aList<double>& upperDerivedCI, 
							ostream& outFile){//called by the best total parameter set only
								Shape7ParamRec::PrintDerivedWithCI(lowerCI, 
								   			upperCI, bestDerived, lowerDerivedCI, 
								   			upperDerivedCI,  outFile);}
	virtual void 		PrintShapeWithCI(const long allTries, 
							const double overallSuccessRate, 
							aList<double>& successRate,
							Shape9ParamRec& lowerCI, 
							Shape9ParamRec& upperCI, 
							aList<double>& bestDerived, 
							aList<double>& lowerDerivedCI, 
							aList<double>& upperDerivedCI, 
							ostream& outFile){//called by the best parameter set only
								Shape7ParamRec::PrintShapeWithCI(allTries, overallSuccessRate,
															successRate, lowerCI, upperCI, 
															bestDerived, lowerDerivedCI, 
															upperDerivedCI, outFile);}
	virtual void 		PrintToScreen (const long tries, const double recombinationRate);
	virtual void		SetDeviationValues(void);
	virtual void 		SetNewBest(void){Shape7ParamRec::SetNewBest();}
	virtual int    		SetShape(void){//returns boolean false if illegal shape
						return Shape7ParamRec::SetShape();}
	virtual void		SetStartingValues(void);
	virtual void 		operator=(Shape9ParamRec& x);

	friend int 		operator== (Shape9ParamRec& a, Shape9ParamRec& b);

	friend int 		operator!= (Shape9ParamRec& a, Shape9ParamRec& b){
							return (!(a==b));}

	};//end class Shape9ParamRec

#endif
