/***************************************************
*																														}
*	DioeciousIndividual.h																				}
*													
*	This class has to mate with the opposite sex before reproducing,
*		but the genetic details are otherwise ignored.
*	All individuals are classed a males or females upon construction.
*	Genetic stuff done by class DioeciousGeneticIndividual.
*	Collect data (dispersal etc.) using derived classes.
*
****************************************************/

#ifndef DioeciousIndividualh
#define DioeciousIndividualh = 1

//#include <iostream.h>
#include "Element.h"
#include "aList.h"
#include "Randomness.h"
#include "RandomList.h"
#include "PopulationIntf.h"
//#include "Individual.h"
#include "SexualIndividual.h"
//#include "Population.h"


class DioeciousIndividual: public SexualIndividual{
	public:
			DioeciousIndividual(void);
			DioeciousIndividual(genderSet gender, long id=0, 
							    Population* site=NULL);
			DioeciousIndividual(long id, Population* site=NULL);
			DioeciousIndividual(DioeciousIndividual& indiv);
			DioeciousIndividual(DioeciousIndividual* indiv);
virtual 	 ~DioeciousIndividual(void){}
virtual Individual* 		Duplicate(genderSet gender,long id,Population* site=NULL);//VIRTUAL COPY CONSTRUCTOR
virtual Individual* 		Duplicate(long id,Population* site=NULL);//VIRTUAL COPY CONSTRUCTOR
virtual Individual* 		Duplicate(void);//VIRTUAL COPY CONSTRUCTOR


//THESE OVERRIDE FUNCTIONS IN THE BASE CLASS SexualIndividual

virtual void	Clone (long& idCount);


virtual void	IIndividual (genderSet gender, lifeStageType lifeStage, 
								double rate, Ran3List& ran);
								
virtual void	IIndividual (genderSet gender, lifeStageType lifeStage, 
								double rate, Ran3List& ran, LandScapeInitializer01& init, aList<double>& extraInfo);

virtual void	MakeABaby (long& idCount, Ran3List& ran);

virtual genderSet 		RealizedSexOfClassMember(double sexRatio, Ran3& ran){
							return (ran.next()<sexRatio) ? F:M;}
						//returns any one of the possible sexes of this class

virtual void	SetMate (Individual* mate, int propagate=1){
							mated();
							if(propagate){mate->SetMate(this,0);}
							}
	};		//end DioeciousIndividual

#endif
