/******************************************
*
*	SexualLandScape
*
*   This header defines the derived LandScape class
*	that forms the basis for individuals that must mate to reproduce.
*	It seeds the landscape with base-class hermaphroditic individuals,
*	and presumes constant habitat quality.  Derived
*	classes add features and/or take data.
******************************************/


#ifndef SexualLandScapeh
#define SexualLandScapeh = 1

#include <iostream.h>
#include "Element.h"
#include "aList.h"
#include "Randomness.h"
#include "StatList.h"
#include "RandomList.h"
#include "GridCell.h"
#include "LandScape.h"
#include "SexualPopulation.h"
#include "SexualIndividual.h"
#include "MemoryManager.h"


class SexualLandScape: public LandScape {
	

  public:
	// CONSTRUCTORS
	SexualLandScape(LandScapeInitializer01& init):/*general purpose initializer*/
			LandScape(init){}
	SexualLandScape(int len, //ONE SPECIES
					 int w, 	//default habitat=0, override ILandScape otherwise
					 migrationModelSet migrationModel,
					 long initSize, 
					 long maxCapacity, 
					 int maxage, 
					 double fSurvivalRate, //CONSTANT THROUGH LIFE
  					 double fFecundityRate, //CONSTANT THROUGH LIFE
  					 double femaleMovementRate//,
//  					 selectionSourceSet sSource
					 ):
			LandScape(len,w,migrationModel,initSize,maxCapacity, 
					  maxage,fSurvivalRate,
					  fFecundityRate,femaleMovementRate//,sSource
					  ) {}
	
	SexualLandScape(int len, //ONE SPECIES
					 int w, 	//default habitat=0, override ILandScape otherwise
					 migrationModelSet migrationModel,
					 long initSize, 
					 long maxCapacity, 
					 int maxage, 
					 aList<double>* fSurvivalSchedule, //VARIABLE SURVIVAL
  					 aList<double>* fFecunditySchedule, //VARIABLE FECUNDITY
 					 ObjList<aList<double> >* femaleMovementRate//,
//  					 selectionSourceSet sSource 
 					 ):
			LandScape(len,w,migrationModel,initSize,maxCapacity, 
					  maxage,fSurvivalSchedule,
					  fFecunditySchedule,femaleMovementRate//,sSource
					  ) {}
	
	SexualLandScape(int len, //ONE OR MORE SPECIES
					 int w, 	//default habitat=0, override ILandScape otherwise
					 migrationModelSet migrationModel,
					 int species, 
					 aList<long>* initSize,
					 aList<long>* maxCapacity, 
					 aList<int>* maxage, 
					 ObjList<aList<double> >* fSurvivalSchedule,
  					 ObjList<aList<double> >* fFecunditySchedule,
 					 ObjList<ObjList<aList<double> > >* femaleMovementRate//,
  			//		 selectionSourceSet sSource 
					 ):
			LandScape(len,w,migrationModel,species,initSize,maxCapacity, 
					  maxage,fSurvivalSchedule,
					  fFecunditySchedule,femaleMovementRate//,sSource
					  ) {}



virtual ~SexualLandScape(void){}

//	THESE ARE FUNCTIONS OVERRIDDEN FROM THE BASE LANDSCAPE CLASS
virtual void 		ILandScape(Ran3List& ran,int seeded = true);
virtual void 		ILandScape(LandScapeInitializer01& init, Ran3List& ran,int seeded = true);
virtual double		intrinsicSexRatio(int){return 0.5;}
virtual void 		SeedLandScape (int species, long initSize, Ran3List& ran);
virtual void 		SeedLandScape (LandScapeInitializer01& init, int species, 
									long initSize, Ran3List& ran);


	};//end SexualLandScape

#endif
