/*******************************************
*
*
*	MatrixList.h
*
*	A class that implements a list of matrices of long doubles
*
*
*
************************************************/

#ifndef MatrixListh
#define MatrixListh = 1

#include "Element.h"
#include "aList.h"
#include "aVector.h"
#include "aMatrix.h"
#include "MemoryManager.h"
#include "InlineTemplates.h"


class MatrixList: public ObjList<aMatrix<long double> >{
	public:
	MatrixList(void):ObjList<aMatrix<long double> >(){
		}
	MatrixList(MatrixList& m):ObjList<aMatrix<long double> >(m){
		}
	MatrixList(MatrixList* m):ObjList<aMatrix<long double> >(m){
		}
	~MatrixList(void){
		Clear();
		}
	
	aMatrix<long double>* ConcatCols (void);
			//returns new matrix concatenated by adding columns
			//rows must all match or null matrix returned
	aMatrix<long double>* ConcatRows (void);
			//returns new matrix concatenated by adding rows
			//columns must all match or null matrix returned
	aMatrix<long double>* DirectSum (void);//returns new direct sum of listed components
	aMatrix<long double>* Sum(void);//sums the matrices in the list

	friend int operator== (MatrixList& mx1, MatrixList& mx2);

	friend int operator!= (MatrixList& mx1,  MatrixList& mx2);
	};//end class MatrixList



#endif
