/***************************************************************
*
*
*	BootList.h
*
*	base class:   StatList<T>
*
*	Does sorts a distribution and finds approximate P values
*
***************************************************************/


#ifndef BootListh
#define BootListh = 1


#include "Element.h"
#include "aList.h"
#include "StatList.h"
#include "InlineTemplates.h"
#include <iostream.h>
#include <math.h>
#include "MemoryManager.h"


template <class T>  class BootList: public StatList<T> {
	protected:
		int sorted_;//boolean
	public:
		BootList(void):StatList<T>(),sorted_(0){
			}
		BootList(aList<T>& a):StatList<T>(a),sorted_(0){
			}
		BootList(aList<T>* a):StatList<T>(a),sorted_(0){
			}
		BootList(StatList<T>& s):StatList<T>(s),sorted_(0){
			}
		BootList(StatList<T>* s):StatList<T>(s),sorted_(0){
			}
		BootList(BootList<T>& b):StatList<T>(b),sorted_(b.sorted_){
			}
		BootList(BootList<T>* b):StatList<T>(b),sorted_(b->sorted_){
			}
		~BootList(void){
			}
	
	public:	
virtual aList<T>* 		Duplicate(void){return NEW BootList(*this);}

	long double Get1TailP (T obsValue, int tailEnd);//tailEnd=0 is low tail, tailEnd=1 is high tail
	long double Get2TailP (T obsValue);
	T Percentile (double percent);//returns value at list location nearest to percent
			//example:
			//	BootList<int> theList;  
			//	etc...
			//	int the5thPercentileValue = theList.Percentile(5.0);


	void Append(T x){
		aList<T>::Append(x);
		sorted_=0;}
	void Clear(){
		aList<T>::Clear();
		sorted_=0;}
	void Decrement(long loc){
		aList<T>::Decrement(loc);
		sorted_=0;}
	void Increment(long loc){
		aList<T>::Increment(loc);
		sorted_=0;}
	void Insert (T x, long loc){
		aList<T>::Insert(x,loc);
		sorted_=0;}
	void Sort(void){
		if (sorted_){return;}
		aList<T>::Sort();
		sorted_=1;}
	void Prepend(T x){
		aList<T>::Prepend(x);
		sorted_=0;}
	void Replace (T x, long loc){
		aList<T>::Replace(x,loc);
		sorted_=0;}

	friend int operator== (BootList< T >& list1, BootList< T >& list2);

	friend int operator!= (BootList< T >& list1, BootList< T >& list2);
	
	};//end class BootList<T>
	
template <class T > int operator== (BootList< T >& list1, BootList< T >& list2){
	return ((StatList<T>) list1==(StatList<T>) list2);}

template <class T > int operator!= (BootList< T >& list1, BootList< T >& list2){
	return !(list1 == list2);}


		
		




















#endif
