/******************************************
*
*	SortList.h
*
*	Base class:  ObjList<T>
*
*	User-defined objects that can be sorted
*	i.e., they have definitions for operators <, >, =
*
*******************************************/

#ifndef SortListh
#define SortListh=1

#include "Element.h"
#include "aList.h"
#include "MemoryManager.h"
#include <iostream.h>


template<class T> class SortList : public ObjList<T> {
		//User-defined objects that can be sorted
  protected:
  	int sorted_;
  public:
    SortList(void);//empty list
	SortList(SortList<T>& toCopy);
				//constucts a new copy
	SortList(SortList<T>* toCopy);
				//constructs a new copy
	SortList(ObjList<T>& toCopy);
				//copies from basic ObjList
	SortList(ObjList<T>* toCopy);
				//copies from basic ObjList
    		
virtual ~SortList(void){}

virtual void 		Append (T* x);
virtual void		Clear(void);
						//frees memory of all contents
virtual void 		Delete (long loc);
						//range of loc=0 (=first) to len()-1 (=last)
virtual void 		Detach (long loc);
						//range of loc=0 (=first) to len()-1 (=last)
virtual void 		Detach (void);
						//releases but does not delete contents
virtual ObjList<T>* Duplicate(void);
virtual void 		Insert (T* x, long loc);
						//range of loc=0 (=first) to len()-1 (=last)
virtual void 		Prepend (T* x);
virtual void 		Replace (T* x, long loc);
						//range of loc=0 (=first) to len()-1 (=last)
virtual void 		Sort (void);//ascending order
						//sorts entire list using Sort(long,long)
virtual void 		Sort (long start, long finish);
						//a QuickSort algorithm
virtual void 		SortDescending (void);
						//sorts entire list using Sort(long,long)
virtual void 		SortDescending (long start, long finish);
						//a QuickSort algorithm
SortList<T>&		operator= (SortList<T>& z);

	friend int operator== (SortList< T >& list1, SortList< T >& list2);

	friend int operator!= (SortList< T >& list1, SortList< T >& list2);

	
    };//end class SortList<T>







#endif

