/*********************************************
*
*
*		ChiSqDistribution.h
*
*
*		Functions for calculating Chi-squared-distribution statistics
*
*
**********************************************/


#ifndef ChiSqDistributionh
#define ChiSqDistributionh = 1

#include "InlineTemplates.h"
#include "aError.h"
#include "MemoryManager.h"
#include "Gamma.h"
#include "Randomness.h"


long double ChiSqDistribution(const int df, const long double x);
	//height of distyribution at x


long double ChiSqCumDensityFunction(const int df, const long double x);
	//integral from 0 to x



long double ChiSqDistributionPvalue(const int df, const long double x);
	//integral from x to infinity


long double ChiSquareRandomValue(const int df, Ran3& ran);
	//random number from ChiSq distribution


long double gsGamma(const long double alpha, const long double r, Ran3& ran);
	//used for calculating random number
        

long double gkm1Gamma(const long double b, const long double c, Ran3& ran);
	//used for calculating random number
   

long double gkm2Gamma(const long double k, const long double b, const long double c, Ran3& ran);
	//used for calculating random number


#endif

