/***********************************************************************************
*
*	CoordinateClass.h
*
*	Template class holding up to 3-D coordinates in Cartesian space
*
************************************************************************************/

#ifndef CoordinateClassh
#define CoordinateClassh = 1

#include "MemoryManager.h"
#include "InlineTemplates.h"
#include "Randomness.h"
//#include "Element.h"
//#include "aList.h"



template <class T> class CoordinateClass {
  public:
 	CoordinateClass<T>(void);
 	CoordinateClass<T>(T x, T y=(T)0.0, T z=(T)0.0);
 	CoordinateClass<T>(CoordinateClass<T>& c);
 	CoordinateClass<T>(CoordinateClass<T>* c);
 	~CoordinateClass<T>(void) {}
  public:
  	CoordinateClass<T>* Duplicate(void);
	virtual long GetPointerToDerivedSelf(void){
				return (long) this;}
  	T& operator[] (int i);
  	void set (T x, T y=(T)0.0,T z=(T)0.0);
  	void set_x (T x);
  	void set_y (T y);
  	void set_z (T z);
  	void RandomLoc(T minX, T maxX, T minY, T maxY, Ran3& ran);
  	void RandomLoc(T minX, T maxX, T minY, T maxY, T minZ, T maxZ, Ran3& ran);

friend int operator== (CoordinateClass<T>& a, CoordinateClass<T>& b);
friend int operator!= (CoordinateClass<T>& a, CoordinateClass<T>& b);

  protected:
  	T data_[3];

  	};/*end class CoordinateClass<T>*/
  	

#endif
