/**************************************************
*
*	Correlation.h
*
*	This class computes correlation coefficients on pairs of numbers.
*
**************************************************/

#ifndef Correlationh
#define Correlationh = 1

#include "Element.h"
#include "aList.h"
#include "StatList.h"
#include "InlineTemplates.h"
#include <iostream.h>



class Correlation{
   public:
   	StatList<long double> x_, y_;
   	double rPearson_;//rPearson_=2.0 if r is undefined
   	int rFlag_;//=1 if rPearson is calculated, 0 otherwise
   public:
   	Correlation(void);
   	Correlation(StatList<long double> a, StatList<long double> b);
   	Correlation(Correlation& c);
   	Correlation(Correlation* c);
   	~Correlation(void);
   	
   	void Append(long double x, long double y);//appends {x,y} to x_ & y_ respectively
    	
    	void CalcrPearson(void);//sets rPearson_=2.0 if r is undefined
    	
    	long n(){return x_.len();}//sample size
   	
   	long double rPearson(void);
   	
   	long double xCoord(long loc){return x_[loc];}
    long double yCoord(long loc){return y_[loc];}
 	
   	};//end class Correlation




#endif

