//Gamma.h

#ifndef Gammah
#define Gammah=1

#include "InlineTemplates.h"
#include <math.h>
#include "MemoryManager.h"
#include "aError.h"
#include "Randomness.h"


long double gammaln(const long double xx);
	
	
long double Gamma(const long double xx);

long double Gamma(const long double a, const long double x);

long double Gamma(const long double a, const long double x0, const long double x1);

long double Erf(const long double x);
		//error function -- integral 0 to x 
		//used to compute cumulative density function of the 
		//standard normal distribution from -infinity to z

long double Erfc(const long double x);
		//complement of the error function -- integral x to infinity


long double gammaInc(const long double a, const long double x);
	//incomplete gamma function -- integral 0 to x with shape parameter a 

long double gammaGeneralizedInc(const long double a, const long double x0, const long double x1);
	//incomplete gamma function -- integral x0 to x1 with shape parameter a 

long double gammaIncComp(const long double a, const long double x);
	//complement of incomplete gamma function -- integral x to infinity with shape parameter a 

long double gammaSer(const long double a, const long double x, long double gammalna);
	//series method for evaluating incomplete gamma function 

long double gammaCF(const long double a, const long double x, long double gammalna);
	//continued-fraction method for evaluating incomplete gamma function 


long double GammaRegularized(const long double a, const long double x);
	
long double GammaRegularized(const long double a, const long double x0, const long double x1);

//already supplied in class Randomness
//long double RandomGamma(const long double a, const long double x, Ran3& ran);

//these used in calculationg RandomGamma
//long double gsGamma(const long double a, const long double r, Ran3& ran);
//long double gkm1Gamma(const long double b, const long double c, Ran3& ran);
//long double gkm2Gamma(const long double k, const long double b, const long double c, Ran3& ran);



#endif

