/*****************************************************
*
*	CumulativeNormalLikelihood.h
*
*	This function calculates the ln-likelihood of data point x
*	on a cumulative normal distribution with mean mu and 
*	standard deviation sigma.
*
******************************************************/

#ifndef CumulativeNormalLikelihoodh
#define CumulativeNormalLikelihoodh = 1

#include <math.h>
#include "InlineTemplates.h"
#include "Element.h"
#include "aList.h"
#include "NormalDistrib.h"
#include "ParamRec.h"
#include "MetropolisHastings.h"


long double CumulativeNormalLikelihood(long double x, long double mu, long double sigma);


long double CumulativeNormalLikelihood(ParamRec& p, MetropolisHastingsData* theData);












#endif
