/***************************************************
																							
	DioeciousGeneticPopulation.h																	
																							
	SuperClass:  SexualGeneticPopulation
	
	Handles sexual reproduction with genetics
	Data analysis handled using derived classes			

***************************************************/

#ifndef DioeciousGeneticPopulationh
#define DioeciousGeneticPopulationh = 1

#include "Element.h"
#include "aList.h"
#include "Randomness.h"
#include "RandomList.h"
#include "SexualGeneticPopulation.h"
#include "MemoryManager.h"


class DioeciousGeneticPopulation: public SexualGeneticPopulation {
	public:
		
		DioeciousGeneticPopulation(long id, int species, GridCell* g, long k):
				SexualGeneticPopulation(id,species,g,k){}
				
		DioeciousGeneticPopulation(long id): SexualGeneticPopulation(id) {}
		DioeciousGeneticPopulation(DioeciousGeneticPopulation& p);
		DioeciousGeneticPopulation(DioeciousGeneticPopulation* p);
virtual ~DioeciousGeneticPopulation(void){}
virtual  Population* Duplicate(long id, int species, GridCell* g, long k){/*virtual constructor*/
				return NEW DioeciousGeneticPopulation(id,species,g,k);}
virtual  Population* Duplicate(long id){/*virtual constructor*/
				return NEW DioeciousGeneticPopulation(id);}

/*THESE ARE DIOECIOUS FUNCTIONS*/
		/*override if you need sex ratios to include hermaphrodites in mixed-population cases*/
		double 	sexRatio(void){/*observed  F/(F+M) for all dioecious individuals*/
							return ((double)(females()+femaleBabies())/
								((double)(females()+males()+femaleBabies()+maleBabies())));}
		double 	adultSexRatio(void){/*= observed F/(F+M) of dioecious adults*/
							return ((double)females()/
								((double)(females()+males())));}
		double 	offspringSexRatio(void){/*= observed F/(F+M) of dioecious babies*/
							return ((double)femaleBabies()/
								((double)(femaleBabies()+maleBabies())));}
		

/*THESE ARE OVERRIDDEN FROM CLASS SexualGeneticPopulation<T>*/
virtual void			Reproduce (long& idCount, Ran3List& ran);

	};	/*end DioeciousGeneticPopulation*/

#endif
