/***************************************************
																							
	DioeciousPopulation																	
																							
	SuperClass:  SexualPopulation
	
	Handles sexual reproduction with dioecy
	Data analysis handled using derived classes			
																							
***************************************************/

#ifndef DioeciousPopulationh
#define DioeciousPopulationh = 1



#include "Element.h"
#include "aList.h"
#include "RandomList.h"
#include "Randomness.h"
#include "SexualPopulation.h"
#include "Individual.h"
#include "GridCell.h"
#include "DioeciousIndividual.h"
#include "MemoryManager.h"


class DioeciousPopulation: public SexualPopulation{
	public:
		DioeciousPopulation(long id, int species, GridCell* g, long k):
				SexualPopulation(id,species,g,k){}
				
		DioeciousPopulation(long id): 
			SexualPopulation(id){}

		DioeciousPopulation(DioeciousPopulation& p): 
			SexualPopulation(p)  {}

		DioeciousPopulation(DioeciousPopulation* p):
			SexualPopulation(p){}

virtual ~DioeciousPopulation(void){}

virtual  Population* Duplicate(long id, int species, GridCell* g, long k){/*virtual constructor*/
				return NEW DioeciousPopulation(id,species,g,k);}
virtual  Population* Duplicate(long id){/*virtual constructor*/
				return NEW DioeciousPopulation(id);}

//THESE ARE DIOECIOUS FUNCTIONS
		//override if you need sex ratios to include hermaphrodites in mixed-population cases
		double 	sexRatio(void){//observed  F/(F+M) for all dioecious individuals
							return ((double)(females()+femaleBabies())/
								((double)(females()+males()+
											femaleBabies()+maleBabies())));}
		double 	adultSexRatio(void){//= observed F/(F+M) of dioecious adults
							return ((double)females()/
								((double)(females()+males())));}
		double 	offspringSexRatio(void){//= observed F/(F+M) of dioecious babies
							return ((double)femaleBabies()/
								((double)(femaleBabies()+maleBabies())));}
		


//THESE ARE OVERRIDDEN FROM CLASS SexualPopulation
virtual void			Reproduce (long& idCount, Ran3List& ran);

	};	//end DioeciousPopulation

#endif
