/***************************************************
																							
	SexualGeneticPopulation																		
																							
	Base Class:  GeneticPopulation
	
	Handles sexual reproduction with genetics
	Data analysis handled using derived classes			

***************************************************/

#ifndef SexGenPopulationh
#define SexGenPopulationh = 1

#include "Randomness.h"
#include "RandomList.h"
#include "Element.h"
#include "aList.h"
#include "Population.h"
#include "GeneticPopulation.h"
#include "Individual.h"
#include "SexualGeneticIndividual.h"
#include <iostream.h>
#include "InlineTemplates.h"
#include "MemoryManager.h"


class SexualGeneticPopulation: public GeneticPopulation {
	public:
		
		SexualGeneticPopulation(long id, int species, GridCell* g, long k):
				GeneticPopulation(id,species,g,k){
			}
				
		SexualGeneticPopulation(long id): GeneticPopulation(id) {
			}
		SexualGeneticPopulation(SexualGeneticPopulation& p):
			GeneticPopulation(p){
			}
		SexualGeneticPopulation(SexualGeneticPopulation* p):
			GeneticPopulation(p){
			}
virtual ~SexualGeneticPopulation(void){
	}
virtual  Population* Duplicate(long id, int species, GridCell* g, long k){/*virtual constructor*/
				return NEW SexualGeneticPopulation(id,species,g,k);}
virtual  Population* Duplicate(long id){/*virtual constructor*/
				return NEW SexualGeneticPopulation(id);}
virtual  Population* Duplicate(void){/*virtual constructor*/
				return NEW SexualGeneticPopulation(*this);}
virtual ObjList<Individual>* /*samples babies from matings with otherPop*/
					 SampleNBabies(int nBabies, Ran3List& ran,SexualGeneticPopulation& theOtherPop);

/*THESE ARE OVERRIDDEN FROM CLASS GeneticPopulation*/
virtual void			AssignMates (Ran3List& ran, aList<long double>& reproductionInfo, int tries=1, int maxThisAgeClass=1);
virtual void			Reproduce (long& idCount, Ran3List& ran, aList<long double>& specialInfo);

	};	/*end SexualGeneticPopulation*/

#endif
