/******************************************
*
*	RandomList.h
*
*	includes sampling from lists and weighted lists
*	base class: Ran3
*
******************************************/


#ifndef RandomListh
#define RandomListh = 1


#include <math.h>
#include "InlineTemplates.h"
#include "Randomness.h"
#include "Element.h"
#include "aList.h"
#include "aVector.h"
#include "MemoryManager.h"

class Ran3List: public Ran3 {
  public:
  	Ran3List(int idum=(-1001)) :Ran3(idum){
  		}
virtual ~Ran3List(void){
	}
	
	//returns an index of a place in their lists 
	long	weighted(aList<int>& weights);
	long	weighted(aList<double>& weights);
				//calls floatBetween, so use weights in float range
	long	weighted(aList<long double>& weights);
				//calls floatBetween, so use weights in float range
	long	weighted(aList<long>& weights);
				//be sure sum of list <max long value
	long	weighted(aList<float>& weights);
	

	long	weighted(aVector<int>& weights);
	long	weighted(aVector<double>& weights);
				//calls floatBetween, so use weights in float range
	long	weighted(aVector<long double>& weights);
				//calls floatBetween, so use weights in float range
	long	weighted(aVector<long>& weights);
				//be sure sum of list <max long value
	long	weighted(aVector<float>& weights);
	
	double operator() (void) {return next();}

  	};//end Ran3List
  	

#endif
