/******************************************
*
*	Randomness2bit.h
*
*	handles random number classes
*
******************************************/


#ifndef Randomness2bith
#define Randomness2bith = 1


#include <math.h>
#include "InlineTemplates.h"
#include "MemoryManager.h"

class Ran3 {
	//2-bit pseudorandom number generator based on Pascal Recipes p. 221
	//0.0  result  1.0
  	//default constructor always yields the same sequence
  private:
  	const float mbig_;	
  	const float mseed_;	
  	const float mz_;	
  	const float fac_;	
  	float* ran3ma_;	
  	int idum_;				
  	int ran3Inext_, ran3Inextp_, gasdevIset_;  //int
  	float gasdevGset_;		//2-bit:  float 
  public:
  	Ran3(int idum=(-1001)) :idum_(idum),
  						 mbig_(4.0e6),		
  						 mseed_(1618033.0), 
  						 mz_(0.0),
  						 fac_(2.5e-7),		
  						 ran3ma_(NEW float[55]),	
  						 gasdevIset_(0),
  						 gasdevGset_(0.0) {IRan3();}
virtual ~Ran3(void){delete [] ran3ma_;ran3ma_=0;}
	float 	floatBetween (float bottom, float top);
	float 	GasDev (void);
  	void 	IRan3(void);
	long 	longBetween (long bottom, long top);
  	float 	next(void);
	float 	NormDev (float mu, float sigma); 
			//returns a random normal deviate 
			//from dist. of mean=mu and st.dev=sigma}
	float	RandomProb(void) {return next();}
	
	
	float operator() (void) {return next();}

  	};//end Ran3
  	

#endif
