/**********
*
*	SelectionIntf.h
*	
*	This is the interface for handling natural selection
*	in the LandScape library.
*
***********/


#ifndef SelectionIntfh
#define SelectionIntfh = 1

#include "Element.h"
#include "aList.h"
#include "Randomness.h"
#include "Individual.h"
#include "InlineTemplates.h"
#include "MemoryManager.h"

class Individual;

typedef int (*ViabilitySelectionFunc)(aList<long double>&, Individual&, Ran3&, long double&);
	/* returns boolean dead 0 or alive 1 */
	/* aList carries any needed coefficients */
	/* called by Individual, which first formats the parameter list*/
	/* Individual sends itself too, in case more info is needed by function*/
	/* THE LAST VARIABLE HOLDS THE INDIVIDUAL'S FITNESS VALUE */



/*default selection function*/
int NeutralToSelection(aList<long double>&, Individual&, Ran3&, long double&);


#endif
