/***********************************
*
*
*	TextDataList.h
*
*	Implements a variable-length list of TextDatum objects
*	Default missing data string for output is "?"
*
******************************************/


#ifndef TextDataListh
#define TextDataListh = 1

#include "Element.h"
#include "aList.h"
#include "Stringclass.h"
#include "StringList.h"
#include "InlineTemplates.h"
#include "TextDatum.h"
#include "MemoryManager.h"



class TextDataList : public StringList {
	public:
		aString missingDataStr_;
	public:
		TextDataList(void):missingDataStr_("?"){}
		TextDataList(aString& missing):missingDataStr_(missing){}
		TextDataList(char* missing):missingDataStr_(missing){}
		TextDataList(char& missing):missingDataStr_(missing){}
		TextDataList(TextDataList& toCopy);
		TextDataList(TextDataList* toCopy);
		virtual ~TextDataList(void){}
virtual ObjList<aString>* Duplicate(void);//returns list as a base-class object

		void Print(ostream& outFile);//file assumed open
			//primitive debugging output, one string per line
void 	SetMissingStr(aString& missing){
			missingDataStr_=missing;}
void 	Sort(void){//missing data at end of list
			if(len()<2){return;}
			Sort(0,len()-1);}
void 	Sort(long start, long finish);//missing data at end of list

TextDatum& First(void){
		TextDatum *t = (TextDatum*) &(StringList::First());
		return *t;}

TextDatum& Last(void){
		TextDatum *t = (TextDatum*) &(StringList::Last());
		return *t;}

TextDatum& Nth(long loc){
		TextDatum *t = (TextDatum*) &(StringList::Nth(loc));
		return *t;}

TextDatum& operator[](long loc){
		TextDatum *t = (TextDatum*) &(StringList::operator[](loc));
		return *t;}

TextDataList&	operator= (TextDataList& z){			
			StringList::operator=(z);
			missingDataStr_=z.missingDataStr_;
			return *this;
			}
friend int operator== (TextDataList& a, TextDataList& b){
		StringList& aa = a;
		StringList& bb = b;
  		return ((aa == bb) && (a.missingDataStr_ == b.missingDataStr_));}
friend int operator!= (TextDataList& a, TextDataList& b){
  		return !(a==b);}
  		
  		
	};


#endif
