/******************


aTime.h

This class handles time calculations

*******************/


#ifndef aTimeh
#define aTimeh = 1

#include <time.h>
#include "StringClass.h"
#include "InlineTemplates.h"
#include "MemoryManager.h"

class aTime{
	public:
		time_t firstTime_;//when class created
		time_t mostRecentTime_;//last call
		time_t elapsedSinceLast_;//when last call is replaced
		
	public:
		aTime(void);//sets to current time
		
		aTime(aTime& t);//copies

virtual aTime* Duplicate(void);//virtual copies
		
	public:
		time_t first(void);//returns firstTime_
		time_t recent(void);//returns mostRecentTime_
		time_t elapsedSinceLast(void);//returns elapsedSinceLast_
		long double elapsed(void);//mostRecentTime_ to now, in seconds
		
		void mark(void);//sets new most recent time

		aString* HMS(long double timediff);//returns a string with hours:mins:secs only
			//used mostly to display differences in time
		aString* HMS_elapsed(void);//returns a string with hours:mins:secs only
			//used for time since most recent marked time
		
		aString* HMS_totalElapsed(void);//returns a string with hours:mins:secs only
			//used for time since first time
		
		int daysInMonth(int m, int yr);//4-digit years only; months 1-12 not 0-11

		long double totalElapsed(void);//firstTime_ to now, in seconds

		friend int operator==(aTime& t1, aTime& t2);
			//true if all data equal
		
		friend int operator!=(aTime& t1, aTime& t2);
		
		};//end class aTime


















#endif













