/*******************************************
*
*
*	dataColumnRec.cpp
*
*	A class that implements a column in an ANOVA table
*
*
************************************************/

#ifndef dataColumnReccpp
#define dataColumnReccpp = 1


#include "dataColumnRec.h"
#include "Element.cpp"
#include "aList.cpp"
#include "StatList.cpp"
#include "aVector.cpp"
#include "aMatrix.cpp"

/******* class dataColumnRec ***********************/




dataColumnRec::dataColumnRec(int source): source_(source){
	SetPointerToDerivedSelf();
	}


dataColumnRec::~dataColumnRec(void){
			levelsList_.Clear();
			pointerToDerivedSelf_=NULL;
			}//end ~dataColumnRec


void  dataColumnRec::Append(double){
	}//these are defined in derived classes
void  dataColumnRec::Append(long double){
	}//these are defined in derived classes
void  dataColumnRec::Append(float){
	}//these are defined in derived classes
void  dataColumnRec::Append(int){
	}//these are defined in derived classes
void  dataColumnRec::Append(long){
	}//these are defined in derived classes
void  dataColumnRec::Append(aString*){
	}//these are defined in derived classes

dataColumnRec*   dataColumnRec::Duplicate(void){
	//returns a duplicate copy of 'this'
	dataColumnRec* dup = NEW dataColumnRec();
	dup->title_ = title_;
	dup->content_ = content_;
	dup->source_ = source_;
	dup->levelsList_ = levelsList_;//this copies each value separately
	return dup;
	}//end dataColumnRec::Duplicate 


void dataColumnRec::SetPointerToDerivedSelf(void){
	pointerToDerivedSelf_ = (long)this;
	}


long dataColumnRec::GetPointerToDerivedSelf(void){
	long psdf = (long)this;
	return psdf;
	}



void  dataColumnRec::CheckCategoryMembership (aString& value){
//	procedure CheckCategoryMembership (value: stringType; var theStrList: ListStrStructureRecType);
	// used to accumulate the factor levels for a column of data
	if ((levelsList_.len() == 0) || (!( levelsList_.Includes(&value)))){
			aString* a = NEW aString(value);
			levelsList_.Append(a);}
	}//end dataColumnRec::CheckCategoryMembership 


dataColumnContentType dataColumnRec::DetermineColumnContents (void){
	return content_;}


dataColumnContentType dataColumnRec::DetermineColumnContents (aString& word){
	char stringVarSymbol = '$';
	int len =word.len();
	char lastLetter = word[len-1];
	if (lastLetter == stringVarSymbol){
			content_ = wordStrings;}
		else{content_ = numbers;}
	return content_;
	}//	end dataColumnRec::DetermineColumnContents


StringList& dataColumnRec::GetFactorLevelList (void){
	return levelsList_;}

aList<long>* dataColumnRec::MissingDataPos(char missingStrDataFlag, long double missingNumDataFlag){
	aList<long> *theList;
	if (DetermineColumnContents()==numbers){
			theList = MissingDataPos(missingNumDataFlag, missingNumDataFlag);}
		else{
			theList = MissingDataPos(missingStrDataFlag,missingNumDataFlag);}
	return theList;
	}//	end dataColumnRec::MissingDataPos


aList<long>* dataColumnRec::MissingDataPos(long double missingNumDataFlag){
	aList<long> *theList;
	if (DetermineColumnContents()==numbers){
			theList = MissingDataPos(missingNumDataFlag);}
		else{
			theList = NEW aList<long>();}
	return theList;
	}//	end dataColumnRec::MissingDataPos


long dataColumnRec::len(){
	return 0;
	}

int dataColumnRec::MissingData(char ){
	return 0;
	}
		
int dataColumnRec::MissingData(long double ){
	return 0;
	}



int dataColumnRec::NullDataCategories (void){
	//counts null data entries in theStrList and chops them off the list
	aString nullData(".");
	int i, sum = 0;
	long z = levelsList_.len();
	for (i=z-1;i>=0;--i){
		aString theString = levelsList_[i] ;		
		if(theString == nullData){
			++sum;
			levelsList_.Delete(i);}
		}//end for i
	return sum;
	}//end  dataColumnRec::NullDataCategories


int dataColumnRec::temporary(void){
	return source_;
	}


void dataColumnRec::title(aString t){
	title_ = t;}
	
aString& 	dataColumnRec::title(void){
	return title_;}


int operator== (dataColumnRec& dataCol1, dataColumnRec& dataCol2){
		return (dataCol1.title() == dataCol2.title());}

int operator!= (dataColumnRec& dataCol1, dataColumnRec& dataCol2){
		return !(dataCol1 == dataCol2);}



#endif
