/*******************************************
*
*
*	dataColumnRecStr.cpp
*
*	A class that implements a numerical data column in an ANOVA table
*
*
************************************************/

#ifndef dataColumnRecStrcp
#define dataColumnRecStrcp = 1


#include "dataColumnRecStr.h"
#include "Element.cpp"
#include "aList.cpp"
#include "StatList.cpp"
#include "aVector.cpp"
#include "aMatrix.cpp"
//#include "dataColumnRec.cpp"


dataColumnRecStr::dataColumnRecStr(int source): dataColumnRec(source){
	content_ = wordStrings;
	SetPointerToDerivedSelf();
	}


//		dataColumnRecStr(dataColumnRecStr&);//no copying possible; use Clone instead
//		dataColumnRecStr(dataColumnRecStr*);//no copying possible; use Clone instead


dataColumnRecStr::~dataColumnRecStr(void){
			dataList_.Clear();
			pointerToDerivedSelf_=NULL;
	}//end ~dataColumnRec



dataColumnRecStr& dataColumnRecStr::operator=(dataColumnRecStr& dcrs){
	dataList_ = dcrs.dataList_;
	return *this;
	}//operator=


void dataColumnRecStr::SetPointerToDerivedSelf(void){
	pointerToDerivedSelf_ = (long)this;
	}



long dataColumnRecStr::GetPointerToDerivedSelf(void){
	long pdsf = (long)this;
	return pdsf;
	}



aString& dataColumnRecStr::operator[](long i){
	return dataList_[i];
	}


dataColumnRec*   dataColumnRecStr::Duplicate(void){
	//returns a duplicate copy of 'this'
	dataColumnRecStr* dup = NEW dataColumnRecStr();
	dup->title_ = title_;
	dup->content_ = content_;
	dup->source_ = source_;
	dup->levelsList_ = levelsList_;//this copies each value separately
	dup->dataList_ = dataList_;//this copies each value separately
	return dup;
	}//end dataColumnRecStr::Duplicate 



void dataColumnRecStr::Append(aString* x){
	dataList_.Append(x);
	}


StringList&	dataColumnRecStr::dataList(void){
	return dataList_;
	}


void dataColumnRecStr::DeleteRow(long r){
	dataList_.Delete(r);
	}


StringList*  dataColumnRecStr::GetResampledList (StringList& theList, sampleRegimeType sampleRegime, Ran3& ran){
	StringList* newList = NEW StringList();
	long i;
	for (i=0;i<theList.len();++i){ 
		aString* value = GetResampleValue(theList, sampleRegime, ran);
		newList->Append(value);
		}//end for i
	return newList;
	}//end  dataColumnRecStr::GetResampledList


aString*   dataColumnRecStr::GetResampleValue(StringList& theList, sampleRegimeType sampleRegime, Ran3& ran){
	//if w/o replacement, then be sure to send a copy of theList if you want the original list intact
		long loc = ran.longBetween(0, theList.len());
		aString *val = NEW aString( theList[loc]);
		if (sampleRegime == withoutReplacement){
			theList.Delete(loc);}
		return val;
	}//end dataColumnRecStr::GetResampleValue


long dataColumnRecStr::len(){
	return dataList_.len();
	}


int dataColumnRecStr::MissingData(char missingDataFlag){
	int rval=0;
	if(len()>SampleSize(missingDataFlag)){
			rval = 1;}
	return rval;
	}


aList<long>* dataColumnRecStr::MissingDataPos(char missingDataFlag, long double /*dummy for numerical*/){
	aList<long>* nulldataList = NEW aList<long>();
	long i;
	for(i=0;i<dataList_.len();++i){
		if(dataList_[i] == missingDataFlag){
			nulldataList->Append(i);}
		}//end for i
	return nulldataList;
	}//end dataColumnRecStr::MissingDataPos



void dataColumnRecStr::PrintValue(ostream& outFile, long item){
	if (dataList_.len()>0){
			outFile<<dataList_[item];}
		else{outFile<<".";}
		}


long dataColumnRecStr::SampleSize(char missingDataFlag){
	aString m(missingDataFlag);
	return SampleSize(m);
	}


long dataColumnRecStr::SampleSize(char* missingDataFlag){
	aString m(missingDataFlag);
	return SampleSize(m);
	}

	
long dataColumnRecStr::SampleSize(aString& missingDataFlag){
	long nullRows = 0;
	long i;
	for(i=0;i<dataList_.len();++i){
		if(dataList_[i] == missingDataFlag){
			nullRows++;}
		}//end for i
	return dataList_.len() - nullRows;
	}//end dataColumnRecStr::SampleSize



void dataColumnRecStr::SetValue(aString& str, long item){
	if (dataList_.len()>0){
		str.cat(dataList_[item]);}
	}


int operator== (dataColumnRecStr& dataCol1, dataColumnRecStr& dataCol2){
		dataColumnRec& dc1 = dataCol1;
		dataColumnRec& dc2 = dataCol2;
		return (dc1 == dc2);}


int operator!= (dataColumnRecStr& dataCol1, dataColumnRecStr& dataCol2){
		dataColumnRec& dc1 = dataCol1;
		dataColumnRec& dc2 = dataCol2;
		return (dc1 != dc2);}



#endif

