/*******************************************
*
*
*	dataSetRec.cpp
*
*	A class that implements a data set held by an ANOVA table
*
*
************************************************/

#ifndef dataSetReccp
#define dataSetReccp = 1


#include "dataSetRec.h"
#include "Element.cpp"
#include "aList.cpp"
//#include "MatrixList.cpp"
#include "aVector.cpp"
#include "aMatrix.cpp"
#include "StatList.cpp"



	dataSetRec::dataSetRec(void){
		}

	dataSetRec::dataSetRec(dataSetRec& d): ObjList<dataColumnRec> (d){
		}



	dataSetRec::~dataSetRec(void){
	}



void dataSetRec::ClearNullFactorLevels (void){
	int i;
	for(i=0;i<len();++i){
		dataColumnRec&  dataColumn = Nth(i);
		dataColumn. NullDataCategories();
		}//end for i
	}//end dataSetRec::ClearNullFactorLevels 



aList<int>* dataSetRec::ColumnsWithMissingData(char missingStrDataFlag, long double missingNumDataFlag){
		//returns columns numbers with missing data
		//returned list must be disposed elsewhere
		//missingStrDataFlag & missingNumDataFlag are how missing data are coded in the dataset
	aList<int>* shortCols = NEW aList<int>();
	int i;
	for(i=0;i<len();++i){
		dataColumnRec& theColumn = Nth(i);
		if(theColumn.DetermineColumnContents()==numbers){
				if(theColumn.MissingData(missingNumDataFlag)==1){
					shortCols->Append(i);}}
			else{
				if(theColumn.MissingData(missingStrDataFlag)==1){
					shortCols->Append(i);}}
		}//end for i
	return shortCols;	
	}//dataSetRec::ColumnsWithMissingData


aList<int>* dataSetRec::ColumnsWithOutMissingData(char missingStrDataFlag, long double missingNumDataFlag){
		//returns columns numbers without missing data
		//returned list must be disposed elsewhere
	aList<int>* fullCols = NEW aList<int>();
	int i;
	for(i=0;i<len();++i){
		dataColumnRec& theColumn = Nth(i);
		if(theColumn.DetermineColumnContents()==numbers){
				if(theColumn.MissingData(missingNumDataFlag)==0){
					fullCols->Append(i);}}
			else{
				if(theColumn.MissingData(missingStrDataFlag)==0){
					fullCols->Append(i);}}
		}//end for i
	return fullCols;	
	}//dataSetRec::ColumnsWithOutMissingData


dataSetRec* dataSetRec::CopyIndependentColumns(StringList& dependentColNames){
	dataSetRec* indepOnlyDataSet = NEW dataSetRec();
	int c;
	for (c=0;c<len_;++c){
		dataColumnRec& dCol1 = (*this)[c];
		aString& dCol1title = dCol1.title_;
		if(! (dependentColNames.Includes(&dCol1title))){
//			dataColumnRec* dcolCopy = dCol1.Clone();
			dataColumnRec* dcolCopy = dCol1.Duplicate();
			indepOnlyDataSet->Append(dcolCopy);}
		}
	return indepOnlyDataSet;
	}//end  dataSetRec::CopyIndependentColumns



void dataSetRec::CullMissingData(char missingStrDataFlag, long double missingNumDataFlag){
	//deletes rows with missing data
	int c;
	for (c=0;c<len_;++c){
		dataColumnRec& col = (*this)[c];
		aList<long>* missingRows = col.MissingDataPos(missingStrDataFlag, missingNumDataFlag);
		for(long r=missingRows->len()-1;r>=0;--r){
			for(int cc=0;cc<len();++cc){
				dataColumnRec& col1 = (*this)[cc];
				col1.DeleteRow((*missingRows)[r]);}}
		delete missingRows; missingRows=NULL;
		}
	}//end  dataSetRec::CullMissingData


void dataSetRec::DeleteRow(long rownum){
	int col;
	for(col=0;col<len();++col){
		Nth(col).DeleteRow(rownum);
		}
	}//dataSetRec::DeleteRow(long

dataColumnContentType dataSetRec::DetermineColumnContents (aString& word){
	char stringVarSymbol = '$';
	int len =word.len();
	char lastLetter = word[len-1];
	if (lastLetter == stringVarSymbol){
			return wordStrings;}
		else{return numbers;}
	}//	end dataSetRec::DetermineColumnContents


dataColumnRec& dataSetRec::GetDataColumn (int loc){
	return Nth(loc);
	}//end dataSetRec::GetDataColumn(int)



dataColumnRec& dataSetRec::GetDataColumn (aString& colTitle){
	int i;
	for (i=0;i<len();++i){
		dataColumnRec& columnPtr = Nth(i);
		if (columnPtr.title() == colTitle){
			return columnPtr;}
		}//end for i
	//if no match found
	cout<<"There are no data columns named "<<colTitle<<" in the data set.";
	return First();
	}//end dataSetRec::GetDataColumn (aString&)


StringList&  dataSetRec::GetFactorLevelList (aString& colTitle){
	dataColumnRec& theColumn = GetDataColumn(colTitle);
	return theColumn.GetFactorLevelList();
	}////end dataSetRec::GetFactorLevelList (aString&)
	


void dataSetRec::GetResampledData(aMatrix<long double>& Ymatrix,int sampleWithReplacement, Ran3& ran){
	Ymatrix.Clear();
	if (len() == 0) return;
	aList<int> itemSequence;
	long i,j,loc,item, c;
	long double val;
	for(i=0;i<First().len();++i) itemSequence.Append(i);
	for(j=0;j<First().len();++j){
		loc = ran.longBetween(0, itemSequence.len()-1);
		item = itemSequence[loc];
		if (! sampleWithReplacement){
			itemSequence.Delete(loc);}
		aVector<long double> newrow;
		for(c=0;c<len();++c){
			dataColumnRec& dataCol = GetDataColumn(c);
			dataColumnRecNum<long double> *dataColLD = (dataColumnRecNum<long double>*) &dataCol;
			val = (*dataColLD)[loc];
			newrow.Append(val);
			}//c
		Ymatrix.ConcatRow(newrow);
		}//j
	}//end dataSetRec::GetResampledDataLongDouble



int dataSetRec::IncludesCol (aString& colTitle){
	int i, retval=0;
	for (i=0;i<len();++i){
		dataColumnRec& columnPtr = Nth(i);
		if (columnPtr.title() == colTitle){
			retval=1;}
		}//end for i
	//if no match found
	return retval;
	}//end dataSetRec::Includes (aString&)



int  dataSetRec::MissingData(char missingStrDataFlag, long double missingNumDataFlag){
	///returns 0 if no missing data, 1 otherwise
	int i, retval=0;
	for(i=0;i<len();++i){
		dataColumnRec& theColumn = Nth(i);
		if(theColumn.DetermineColumnContents()==numbers){
				if(theColumn.MissingData(missingNumDataFlag)==1){retval=1;}}
			else{
				if(theColumn.MissingData(missingStrDataFlag)==1){retval=11;}}
		}//end for i
	return retval;	
	}//dataSetRec::MissingData


ObjList<dataSetRec>* dataSetRec::ParseMissingDataIntoSets(StringList& dependentColNames, char missingStrDataFlag , long double missingNumDataFlag){
	ObjList<dataSetRec>* dataSetListPtr = NEW ObjList<dataSetRec>();
	ObjList<dataSetRec>& dataSetList = *dataSetListPtr;	
	if ( ! MissingData(missingStrDataFlag,missingNumDataFlag)){
		dataSetRec* d = NEW dataSetRec(*this);//returns a copy of itself
		dataSetList.Append(d);
		return dataSetListPtr;}
	ObjList<aList<long> > missingDataPosList;
	int c;
	for(c=0;c<dependentColNames.len();++c){
		aString& colName = dependentColNames[c];
		dataColumnRec& dCol1 = GetDataColumn(colName);
		aList<long>* missingDataPos = dCol1.MissingDataPos(missingStrDataFlag, missingNumDataFlag);
		if(missingDataPosList.Includes(missingDataPos)){
				int dataSetNum1 = missingDataPosList.Loc(missingDataPos);
//				dataSetList[dataSetNum1].Append(dCol1.Clone());
				dataSetList[dataSetNum1].Append(dCol1.Duplicate());
				delete missingDataPos; missingDataPos=NULL;
				}
			else{
				missingDataPosList.Append(missingDataPos);
				missingDataPos = NULL;//forget
				dataSetRec* dataConfig = CopyIndependentColumns(dependentColNames);
				dataSetList.Append(dataConfig);
//				dataConfig->Append(dCol1.Clone());
				dataConfig->Append(dCol1.Duplicate());
				}
		}//end for c
	return dataSetListPtr;
	}//end dataSetRec::ParseMissingDataIntoSets()


void dataSetRec::Print(int printTempData){
	Print(cout, ' ', printTempData);
	}			


void  dataSetRec::Print(aString& outFileName, char separator, int printTempData){
	char* filename = outFileName.raw();
	fstream outFile;
	outFile.open(filename,  ios::out /*,filebuf::openprot*/);
	Print(outFile, separator, printTempData);//blanks for separators
	outFile.close();
	delete[] filename; filename= NULL;
	}//end dataSetRec::Print(aString&)



void  dataSetRec::Print(ostream& outFile, char separator, int printTempData){
	long i, row, rows = 0;
	for(i=0; i<len();++i){//print headings
		dataColumnRec& theColumn0 = Nth(i);
		if(i==0) rows = theColumn0.len();
		if(!(theColumn0.temporary()) || printTempData){
			outFile<<theColumn0.title();
			if (i<len()-1){outFile<<separator;}
			}
		}//end for i
	outFile<<endl;
	for(row=0;row<rows;++row){
		for(i=0; i<len();++i){
			dataColumnRec& theColumn1 = Nth(i);
			if(!(theColumn1.temporary()) || printTempData){
				theColumn1.PrintValue(outFile, row);
				if (i<len()-1){outFile<<separator;}
				}
			}//end for i
		outFile<<endl;
		}//end for row
	outFile<<endl;
	}//end dataSetRec::Print(ostream&, char)
		


void  dataSetRec::PrintMathematicaFormat(aString& outFileName, bool printHeadings, bool printTempData){
	char* filename = outFileName.raw();
	fstream outFile;
	outFile.open(filename,  ios::out /*,filebuf::openprot*/);
	PrintMathematicaFormat(outFile, printHeadings, printTempData);//blanks for separators
	outFile.close();
	delete[] filename; filename= NULL;
	}//end dataSetRec::PrintMathematicFormat(aString&, bool)



void  dataSetRec::PrintMathematicaFormat(ostream& outFile, bool printHeadings, bool printTempData){
	long i, row, extraRows=0, rows = 0;
	StringList mathOut;
	mathOut.Append(NEW aString("{"));
	++extraRows;
	if(len()>0) {rows = First().len();}
	if(printHeadings){
		++extraRows;
		mathOut.Append(NEW aString("{"));
		for(i=0; i<len();++i){//print headings
			dataColumnRec& theColumn0 = Nth(i);
			if(i==0) rows = theColumn0.len();
			if(!(theColumn0.temporary()) || printTempData){
				mathOut.Append(NEW aString(theColumn0.title()));
				if (i<len()-1){
					mathOut[extraRows].cat(",");}
				}
			}//end for i
		mathOut[0].cat("},");
		}
//	mathOut.Append(NEW aString("{"));
	for(row=0;row<rows;++row){
		mathOut.Append(NEW aString("{"));
		for(i=0; i<len();++i){//columns
			dataColumnRec& theColumn1 = Nth(i);
			if(!(theColumn1.temporary()) || printTempData){
//				mathOut[row+extraRow].cat("{");
				theColumn1.SetValue(mathOut[row+extraRows],row);
				if (i<len()-1){
					mathOut[row+extraRows].cat(",");}
				}
			}//end for i
		mathOut[row+extraRows].cat("}");
		if(row<rows-1){
			mathOut[row+extraRows].cat(",");}
		}//end for row
	mathOut.Append(NEW aString("}"));
	mathOut.Print(outFile);
	}//end dataSetRec::PrintMathematicFormat(ostream&, bool)
		




void  dataSetRec::ReadDataFile (aString& dataFileName){
	Clear();// empty any old data
	aString endCharList(" \t,;:\"(){}[]!?");
	//loads the variable-array data set variables
	char* filename = dataFileName.raw();
	fstream dataFile;
	dataFile.open(filename,ios::in);
	
	char *dataLine=NEW char[10001];dataLine[0]='\0';
	dataFile.getline(dataLine, 10000);	//the first line is just column headings
	aString indivDataLine(dataLine);
	while(indivDataLine.len()>0){
		//use the column headings to define the number and order of columns
		aString *word = indivDataLine.ChopOffFirstWord(endCharList);
		dataColumnContentType a = DetermineColumnContents(*word);
		dataColumnRec* columnPtr;
		if(a==numbers){
				columnPtr = NEW dataColumnRecNum<long double>();}
			else{//a==wordStrings
				columnPtr = NEW dataColumnRecStr();}
		columnPtr->title(*word);
		Append(columnPtr);
		delete word; word=NULL;
		}//end while

	while (! dataFile.eof()){//read until the end of the file
		dataLine[0]='\0';
		dataFile.getline(dataLine, 10000);	
		indivDataLine=dataLine;
		indivDataLine.CullLeadingSpaces();
		if(indivDataLine.len()>0){
			for(int col=0;col<len();++col){
				dataColumnRec& columnPtr = Nth(col);
				aString* word = indivDataLine.ChopOffFirstWord(endCharList);
				if (columnPtr.DetermineColumnContents ()==numbers){
						long double score = word->toLongDouble();
						columnPtr.Append(score);
						delete word; word = NULL;
						}
					else{//DetermineColumnContents ()==wordStrings
						columnPtr.CheckCategoryMembership(*word);
						columnPtr.Append(word);
						word = NULL;
						}
				}//end for col
			}//end if len()>0
		}//end while ! eof
	ClearNullFactorLevels();
	dataFile.close();
	delete [] dataLine; dataLine=NULL;
	delete [] filename; filename=NULL;
	}// end dataSetRec::ReadDataFile 


aString* dataSetRec::SynthesizeNewStrDataCol(StringList& colTitles){	
	//combines the factor levels of the columns to make an interaction column 
	//returns new data column name
	if(colTitles.len()<2)return NEW aString(colTitles[0]);//don't do this with only a single column
	aString newColTitle;
	for(int i=0;i<colTitles.len();++i){
		newColTitle.cat(colTitles[i]);
		if(i<colTitles.len()-1){newColTitle.cat("_x_");}
		}
	newColTitle.CullChar('$');
	newColTitle.cat('$');
	if(IncludesCol(newColTitle)){return NEW aString(newColTitle);}//already present
	
	dataColumnRecStr* newCol = NEW dataColumnRecStr(1);
	newCol->title(newColTitle);
	Prepend(newCol);
	dataColumnRec& firstOldCol = GetDataColumn(colTitles[0]);
	int colSize = firstOldCol.len();
	for(int d=0;d<colSize;++d){
		aString* newData = NEW aString();
		for(int di=0;di<colTitles.len();++di){
			dataColumnRec& oldCol =  GetDataColumn(colTitles[di]);
			if(oldCol.DetermineColumnContents()==wordStrings){
//					dataColumnRecStr& oldColStr= (dataColumnRecStr) oldCol;
					dataColumnRecStr* oldColStr= (dataColumnRecStr*) &oldCol;
					newData->cat((*oldColStr)[d]);}
				else{
//					dataColumnRecNum<double>& oldColNum = (dataColumnRecNum<double>) oldCol;
					dataColumnRecNum<long double>* oldColNum = (dataColumnRecNum<long double>*) &oldCol;
					newData->cat((*oldColNum)[d]);}
					
			if(di<colTitles.len()-1){newData->cat('_');}
			}//end for di
		newCol->CheckCategoryMembership(*newData);
		newCol->Append(newData);
		newData = NULL;}
	
	return NEW aString(newColTitle);	
	}//end dataSetRec::SynthesizeNewStrDataCol




#endif

