// CumulativeNormalData.cpp

#ifndef CumulativeNormalDatacpp
#define CumulativeNormalDatacpp = 1

#include "CumulativeNormalData.h"


#ifdef MemoryLeakDebug
MemLeakIDType  CumulativeNormalData::memIDCount_ = (MemLeakIDType) 0;//initialized here in file scope
memAllocList  CumulativeNormalData::memIDList_ =  memAllocList();//initialized here in file scope
void  CumulativeNormalData::PrintIDList(ostream& outFile){
	memIDList_.Print(outFile);}
void  CumulativeNormalData::PrintIDListLen(ostream& outFile){
	memIDList_.PrintLen(outFile);}
#endif



CumulativeNormalData::CumulativeNormalData(CumulativeNormalData& parentData):
			colHeadings(parentData.colHeadings),
			location(parentData.location),
			dose(parentData.dose),
			alive(parentData.alive),
			dead(parentData.dead)
			{	
		}//end ctor CumulativeNormalData(CumulativeNormalData&)




void CumulativeNormalData::Clear(void){
	colHeadings.Clear();
	location.Clear();
	dose.Clear();
	alive.Clear();
	dead.Clear();
	}//end CumulativeNormalData::Clear()


long CumulativeNormalData::len(void){
	return dose.len();
	}//end CumulativeNormalData::len()


void CumulativeNormalData::PrintDataFile(aString& outFileName){
	fstream dataFile;
	char* fileName = outFileName.raw();
	dataFile.open(fileName, ios::out /*,filebuf::openprot*/);
	PrintDataFile(dataFile);
	dataFile.close();
	delete [] fileName;fileName=0;
	}//end CumulativeNormalData::PrintDataFile (aString&)



void CumulativeNormalData::PrintDataFile(ostream& outFile){
	aString headingLine;
	for(int c=0;c<colHeadings.len();++c){
		headingLine.cat(colHeadings[c]);
		if(c<colHeadings.len()-1){headingLine.cat('\t');}
		}//end for c
	outFile<<headingLine<<endl;
	for(int i=0;i<len();++i){
		aString	dataLine(location[i]); dataLine.cat('\t');
		dataLine.cat(dose[i],6,9); dataLine.cat('\t');
		dataLine.cat(alive[i]); dataLine.cat('\t');
		dataLine.cat(dead[i]);
		outFile<<dataLine<<endl;
		}//end for i
	}//end CumulativeNormalData::PrintDataFile




void CumulativeNormalData::ReadDataFile (aString& dataFileName){
	Clear();
	fstream dataFile;	
	char *dataLine=new char[1001];dataLine[0]='\0';
	aString endCharList(" \t,:\"{}[]!?");
	char* filename=dataFileName.raw();
	dataFile.open(filename,ios::in);

	dataFile.getline(dataLine, 1000); 
	aString headingLine(dataLine);
	while(headingLine.len()>0){
		aString *heading = headingLine.ChopOffFirstWord(endCharList);
		colHeadings.Append(heading);
		}//end while
	while( ! dataFile.eof()){
		dataFile.getline(dataLine, 1000); 
		aString parameterLine(dataLine);
		if(parameterLine.len()>0){
			aString *datumStr = parameterLine.ChopOffFirstWord(endCharList);
			double datum = datumStr->toDouble();
			location.Append(datum);
			delete datumStr;datumStr=0;
			datumStr = parameterLine.ChopOffFirstWord(endCharList);
			datum = datumStr->toDouble();
			dose.Append(datum);
			delete datumStr;datumStr=0;
			datumStr = parameterLine.ChopOffFirstWord(endCharList);
			datum = datumStr->toDouble();
			alive.Append(datum);
			delete datumStr;datumStr=0;
			datumStr = parameterLine.ChopOffFirstWord(endCharList);
			datum = datumStr->toDouble();
			dead.Append(datum);
			delete datumStr;datumStr=0;
			}//end if data exist
		}//end while
	dataFile.close();
	}//end CumulativeNormalData::ReadDataFile(aString&)



#endif



