/*****************************

	DataSetRecMCMC.cpp
	
	Combines the standard data set container class with the Metropolis-Hastings data container.
	This permits a data set to be sent to a likelihood function and run through the MCMC algorithm.
	Assuames the relevant likelihood function 'knows' how to find the appropriate data columns.
	
	
******************************/

#ifndef DataSetRecMCMCcpp
#define DataSetRecMCMCcpp = 1

#include "DataSetRecMCMC.h"
#include "Element.cpp"
#include "aList.cpp"


DataSetRecMCMC::DataSetRecMCMC(void){
	SetPointerToDerivedSelf();
	}

	
DataSetRecMCMC::DataSetRecMCMC(DataSetRecMCMC& s){
	dataSetRec::operator=(s);
	SetPointerToDerivedSelf();
	}


DataSetRecMCMC::~DataSetRecMCMC(void){}
	

DataSetRecMCMC* DataSetRecMCMC::Duplicate(void){
	DataSetRecMCMC *ndsrm = NEW DataSetRecMCMC(*this);
	return ndsrm;
	}


	
DataSetRecMCMC& DataSetRecMCMC::operator=(DataSetRecMCMC& dsrm){
	dataSetRec::operator=(dsrm);
	return *this;
	}
		
void DataSetRecMCMC::SetPointerToDerivedSelf(void){
//	pointerToDerivedSelf_ = (long) this;
	}

long DataSetRecMCMC::GetPointerToDerivedSelf(void){
	long pdsf = (long) this;
	return pdsf;
	}


void DataSetRecMCMC::Clear(void){
	dataSetRec::Clear();
	MetropolisHastingsData::Clear();
	}



int operator==(DataSetRecMCMC& a, DataSetRecMCMC& b){
	dataSetRec *c = (dataSetRec*) &a;
	dataSetRec *d = (dataSetRec*) &b;
	return (*c == *d);
	}


int operator!=(DataSetRecMCMC& a, DataSetRecMCMC& b){
	return !(a==b);
	}

#endif
