// DoseResponseClineData.cpp

#ifndef DoseResponseClineDatacpp
#define DoseResponseClineDatacpp = 1

#include "DoseResponseClineData.h"


#ifdef MemoryLeakDebug
MemLeakIDType  DoseResponseClineData::memIDCount_ = (MemLeakIDType) 0;//initialized here in file scope
memAllocList  DoseResponseClineData::memIDList_ =  memAllocList();//initialized here in file scope
void  DoseResponseClineData::PrintIDList(ostream& outFile){
	memIDList_.Print(outFile);}
void  DoseResponseClineData::PrintIDListLen(ostream& outFile){
	memIDList_.PrintLen(outFile);}
#endif



DoseResponseClineData::DoseResponseClineData(DoseResponseClineData& parentData):
			colHeadings(parentData.colHeadings),
			location(parentData.location),
			dose(parentData.dose),
			alive(parentData.alive),
			dead(parentData.dead)
			{	
		}//end ctor DoseResponseClineData(DoseResponseClineData&)




void DoseResponseClineData::Clear(void){
	colHeadings.Clear();
	location.Clear();
	dose.Clear();
	alive.Clear();
	dead.Clear();
	location_density.Clear();
	density.Clear();
	}//end DoseResponseClineData::Clear()


long DoseResponseClineData::len(int pop){
	if (dose.len()==0){return 0;}
	return dose[pop].len();
	}//end DoseResponseClineData::len(int)


long DoseResponseClineData::pops(void){
	return location.len();
	}//end DoseResponseClineData::pops()


void DoseResponseClineData::PrintDataFile(aString& outFileName){
	fstream dataFile;
	char* fileName = outFileName.raw();
	dataFile.open(fileName, ios::out /*,filebuf::openprot*/);
	PrintDataFile(dataFile);
	dataFile.close();
	delete [] fileName;fileName=0;
	}//end DoseResponseClineData::PrintDataFile (aString&)



void DoseResponseClineData::PrintDataFile(ostream& outFile){
	aString headingLine;
	for(int c=0;c<colHeadings.len();++c){
		headingLine.cat(colHeadings[c]);
		if(c<colHeadings.len()-1){headingLine.cat('\t');}
		}//end for c
	outFile<<headingLine<<endl;
	for(int pop=0;pop<pops();++pop){
		for(int i=0;i<len(pop);++i){
			aString	dataLine(location[pop]); dataLine.cat('\t');
			dataLine.cat(dose[pop][i],6,9); dataLine.cat('\t');
			dataLine.cat(alive[pop][i]); dataLine.cat('\t');
			dataLine.cat(dead[pop][i]);
			outFile<<dataLine<<endl;
			}//end for i
		}//end for pop
	}//end DoseResponseClineData::PrintDataFile




void DoseResponseClineData::ReadDataFile (aString& dataFileName){
	colHeadings.Clear();
	location.Clear();
	dose.Clear();
	alive.Clear();
	dead.Clear();
	fstream dataFile;	
	char *dataLine=new char[1001];dataLine[0]='\0';
	aString endCharList(" \t,:\"{}[]!?");
	char* filename=dataFileName.raw();
	dataFile.open(filename,ios::in);

	dataFile.getline(dataLine, 1000); 
	aString headingLine(dataLine);
	while(headingLine.len()>0){
		aString *heading = headingLine.ChopOffFirstWord(endCharList);
		colHeadings.Append(heading);
		}//end while
	while( ! dataFile.eof()){
		dataFile.getline(dataLine, 1000); 
		aString parameterLine(dataLine);
		if(parameterLine.len()>0){
			aString *datumStr = parameterLine.ChopOffFirstWord(endCharList);
			double loc = datumStr->toDouble();
			delete datumStr;datumStr=0;
			datumStr = parameterLine.ChopOffFirstWord(endCharList);
			double dosage = datumStr->toDouble();
			delete datumStr;datumStr=0;
			datumStr = parameterLine.ChopOffFirstWord(endCharList);
			double nAlive = datumStr->toDouble();
			delete datumStr;datumStr=0;
			datumStr = parameterLine.ChopOffFirstWord(endCharList);
			double nDead = datumStr->toDouble();
			delete datumStr;datumStr=0;

			if(!(location.Includes(loc))){
				location.Append(loc);
				dose.Append(new StatList<double>());
				alive.Append(new StatList<double>());
				dead.Append(new StatList<double>());
				}//end if new location
			dose.Last().Append(dosage);
			alive.Last().Append(nAlive);
			dead.Last().Append(nDead);
			}//end if data exist
		}//end while
	dataFile.close();
	}//end DoseResponseClineData::ReadDataFile(aString&)


void DoseResponseClineData::ReadDensityDataFile (aString& dataFileName){
	location_density.Clear();
	density.Clear();
	fstream dataFile;	
	char *dataLine=new char[1001];dataLine[0]='\0';
	aString endCharList(" \t,:\"{}[]!?");
	char* filename=dataFileName.raw();
	dataFile.open(filename,ios::in);

	while( ! dataFile.eof()){
		dataFile.getline(dataLine, 1000); 
		aString parameterLine(dataLine);
		if(parameterLine.len()>0){
			aString *datumStr = parameterLine.ChopOffFirstWord(endCharList);
			double loc = datumStr->toDouble();
			delete datumStr;datumStr=0;
			datumStr = parameterLine.ChopOffFirstWord(endCharList);
			double dens = datumStr->toDouble();
			delete datumStr;datumStr=0;
			location_density.Append(loc);
			density.Append(dens);
			}//end if data exist
		}//end while
	dataFile.close();
	}//end DoseResponseClineData::ReadDensityDataFile(aString&)


long DoseResponseClineData::sampleSize(int pop){
	long a = alive[pop].sum();
	long d = dead[pop].sum();
	return a + d;
	}//end DoseResponseClineData::sampleSize(int)



#endif



