//FstatisticAnalysisCytoMale.cpp

#ifndef FstatisticAnalysisCytoMalecpp
#define FstatisticAnalysisCytoMalecpp=1

#include "FstatisticAnalysisCytoMale.h"
#include "Element.cpp"
#include "aList.cpp"
#include "StatList.cpp"



//20081229	fixed bug in NmFromCytoMaleFst(long double, int)


FstatisticAnalysisCytoMale::FstatisticAnalysisCytoMale(aString& s){
	FstatisticAnalysisCore::Initialize(); 
	CytoplasmicMaleMarkerData::Initialize();
	EvolutionaryGeneticsData::Initialize(s); 
	}


FstatisticAnalysisCytoMale::FstatisticAnalysisCytoMale(EvolutionaryGeneticsData& egd){
	CytoplasmicMaleMarkerData::Initialize();
	EvolutionaryGeneticsData::Initialize(egd);//do this second to overwrite blank initialization
	FstatisticAnalysisCore::Initialize();
	}//FstatisticAnalysisCytoMale::FstatisticAnalysisCytoMale(EvolutionaryGeneticsData&)



FstatisticAnalysisCytoMale::FstatisticAnalysisCytoMale(CytoplasmicMaleMarkerData& cymd){
	CytoplasmicMaleMarkerData::Initialize(cymd);
	FstatisticAnalysisCore::Initialize();
	}//FstatisticAnalysisCytoMale::FstatisticAnalysisCytoMale(CytoplasmicMaleMarkerData&)




FstatisticAnalysisCytoMale::FstatisticAnalysisCytoMale(FstatisticAnalysisCytoMale& cymd){//copy constructor
	CytoplasmicMaleMarkerData::Initialize(cymd);
	FstatisticAnalysisCore::Initialize(cymd);
	}//FstatisticAnalysisCytoMale::FstatisticAnalysisCytoMale(FstatisticAnalysisCytoMale&)





FstatisticAnalysisCytoMale::FstatisticAnalysisCytoMale(FstatisticAnalysisCytoMale& parentData, aList<int>& popSubsetNums) {
	//makes a copy of the original data using a subset of populations
	//useful for separate analyses of data subsets
	CytoplasmicMaleMarkerData::Initialize(parentData, popSubsetNums);//copies
	}//end ctor FstatisticAnalysisCytoMale(FstatisticAnalysisCytoMale&, aList<int>&)


FstatisticAnalysisCytoMale::FstatisticAnalysisCytoMale(CytoplasmicMaleMarkerData& parentData, aList<int>& popSubsetNums) {
	//makes a copy of the original data using a subset of populations
	//useful for separate analyses of data subsets
	CytoplasmicMaleMarkerData::Initialize(parentData, popSubsetNums);//copies
	}//end ctor FstatisticAnalysisCytoMale(CytoplasmicMaleMarkerData&, aList<int>&)





void FstatisticAnalysisCytoMale::Clear(){
	FstatisticAnalysisCore::Clear();
	CytoplasmicMaleMarkerData::Clear();
	}


void FstatisticAnalysisCytoMale::Initialize(FstatisticAnalysisCytoMale& cymd){//copy constructor
	CytoplasmicMaleMarkerData::Initialize(cymd);
	FstatisticAnalysisCore::Initialize(cymd);
	}//FstatisticAnalysisCytoMale::FstatisticAnalysisCytoMale(FstatisticAnalysisCytoMale&)



void FstatisticAnalysisCytoMale::CalculateIBDestimates(Ran3& ran,int sampleSize){//sampled with replacement, per locus
	if(! IBDcurrent_){
			ClearIBDs();}
		else if(IBDmethod_.Includes((int)IBDestimCytoMale)) {return;}
		else{}
	CalculateGenotypeFreqs();
	if(nlociCYmale_==0){
		IBDcurrent_=true;
		return;}

	long double IBD_betwIndivInPop_, IBD_betwIndivBetwPops_;
	aList<long double> 	IBD_betwIndivInPop_ByLoc_, IBD_betwIndivBetwPops_ByLoc_;
	StatList<long double> 	IBD_inIndiv_ByLoc_Num, IBD_betwIndivInPop_ByLoc_Num, IBD_betwIndivBetwPops_ByLoc_Num;

	long pop,pop1,pop2,loc,i1,i2,rep;
	long double IBDval;
	jackIBDvalsLoc_.Append(NEW ObjList<aList<long double> >());
	for(loc=0;loc<nlociCYmale_;++loc){
		jackIBDvalsLoc_.Last().Append(NEW aList<long double>());
		jackIBDvalsLoc_.Last().Last().Append(zero);//IBD within pop
		jackIBDvalsLoc_.Last().Last().Append(zero);//IBD betw pops
		IBD_betwIndivInPop_ByLoc_.Append(zero);
		IBD_betwIndivBetwPops_ByLoc_.Append(zero);
		IBD_betwIndivInPop_ByLoc_Num.Append(zero);
		IBD_betwIndivBetwPops_ByLoc_Num.Append(zero);
		}//loc
	
	//between individuals
	StatList<int> IBDbetwIndivInPopByLocCounter;
	for(loc=0;loc<nlociCYmale_;++loc){
		IBDbetwIndivInPopByLocCounter.Append(0);
		}//loc

	for(loc=0;loc<nlociCYmale_;++loc){
		for(rep=0;rep<sampleSize;++rep){
			do{
				pop = ran.longBetween(0,npop_-1);
				}while(popSize(pop)<2);
			i1=ran.longBetween(0,popSize(pop)-1);
			do{
				i2=ran.longBetween(0,popSize(pop)-1);
				}while(i1==i2);
			TextDatum& g0_2 = GenotypicVal(pop, i1, locusNumCYmale_[loc],0);
			TextDatum& g1_2 = GenotypicVal(pop, i2, locusNumCYmale_[loc],0);
			if(g0_2 == g1_2 && g0_2.OK()){
				IBDbetwIndivInPopByLocCounter[loc]++;}
			}//rep
		IBDval = (long double)IBDbetwIndivInPopByLocCounter[loc] /(long double) sampleSize;
//		IBD_betwIndivInPop_ByLoc_[loc]=IBDval;
		IBD_betwIndivInPop_ByLoc_.Append(IBDval);
		IBD_betwIndivInPop_ByLoc_Num[loc] = (long double)IBDbetwIndivInPopByLocCounter[loc];
		}//loc
	IBDval = (long double)IBDbetwIndivInPopByLocCounter.sum() /(long double) (sampleSize * nlociCYmale_);
	IBD_betwIndivInPop_ = IBDval;
	
	StatList<int> IBDbetwIndivBetwPopsByLocCounter;
	for(loc=0;loc<nlociCYmale_;++loc){
		IBDbetwIndivBetwPopsByLocCounter.Append(0);
		}//loc

	for(loc=0;loc<nlociCYmale_;++loc){
		for(rep=0;rep<sampleSize;++rep){
			do{
				pop1 = ran.longBetween(0,npop_-1);
				pop2 = ran.longBetween(0,npop_-1);
				}while(pop1==pop2 || popSize(pop1)<2 || popSize(pop2)<2);
			i1=ran.longBetween(0,popSize(pop1)-1);
			i2=ran.longBetween(0,popSize(pop2)-1);
			TextDatum& g0_3 = GenotypicVal(pop1, i1, locusNumCYmale_[loc],0);
			TextDatum& g1_3 = GenotypicVal(pop2, i2, locusNumCYmale_[loc],0);
			if(g0_3 == g1_3 && g0_3.OK()){
				IBDbetwIndivBetwPopsByLocCounter[loc]++;
				}
			}//rep
		IBDval = (long double)IBDbetwIndivBetwPopsByLocCounter[loc] /(long double) sampleSize;
		IBD_betwIndivBetwPops_ByLoc_[loc]=IBDval;
		IBD_betwIndivBetwPops_ByLoc_Num[loc] = (long double)IBDbetwIndivBetwPopsByLocCounter[loc];
		}//loc
	IBDval = (long double)IBDbetwIndivBetwPopsByLocCounter.sum() /(long double) (sampleSize * nlociCYmale_);
	IBD_betwIndivBetwPops_ = IBDval;			
	
	//transfer to general data structures
	IBDmethod_.Append(IBDestimCytoMale);
	IBDlevels_.Append( NEW StringList());
	IBDlevels_.Last().Append(NEW aString("betwIndivsInPops"));
	IBDlevels_.Last().Append(NEW aString("betwIndivsBetwPops"));
	IBDvals_.Append(NEW aList<long double>());
	IBDvals_.Last().Append(IBD_betwIndivInPop_);
	IBDvals_.Last().Append(IBD_betwIndivBetwPops_);
	IBDvalsByLoc_.Append(NEW ObjList<aList<long double> >());
	ObjList<aList<long double> >& IBDByLoc = IBDvalsByLoc_.Last();
	ObjList<aList<long double> >& jackIBDByLoc = jackIBDvalsLoc_.Last();
	for(loc=0;loc<nlociCYmale_;++loc){
		IBDByLoc.Append(NEW aList<long double>());
		IBDByLoc[loc].Append(IBD_betwIndivInPop_ByLoc_[loc]);
		IBDByLoc[loc].Append(IBD_betwIndivBetwPops_ByLoc_[loc]);
		if(nlociCYmale_>1){
			jackIBDByLoc[loc][0] = (IBD_inIndiv_ByLoc_Num.sum()-IBD_inIndiv_ByLoc_Num[loc]) / (long double)((nlociCYmale_-1)*sampleSize);
			jackIBDByLoc[loc][1] = (IBD_betwIndivInPop_ByLoc_Num.sum()-IBD_betwIndivInPop_ByLoc_Num[loc]) / (long double)((nlociCYmale_-1)*sampleSize);
			jackIBDByLoc[loc][2] = (IBD_betwIndivBetwPops_ByLoc_Num.sum()-IBD_betwIndivBetwPops_ByLoc_Num[loc]) / (long double)((nlociCYmale_-1)*sampleSize);
			}
		}//loc
	IBDcurrent_=true;

	//update F-stats
	long double Fstval, Fitval;
	if(! FstatsCurrent_){
		ClearFstats();}
	Fmethod_.Append(IBDestimCytoMale);
	Flevels_.Append( NEW StringList());
	Flevels_.Last().Append(NEW aString("Fst"));
	Flevels_.Last().Append(NEW aString("Fit"));
	Fstats_.Append(NEW aList<long double>());
	Fstval=Fitval=zero;
	if(IBD_betwIndivBetwPops_ != one){
		Fstval = (IBD_betwIndivInPop_ - IBD_betwIndivBetwPops_) / (one - IBD_betwIndivBetwPops_);
		Fitval = Fstval;
		}
	Fstats_.Last().Append(Fstval);
	Fstats_.Last().Append(Fitval);
	FstatsLoc_.Append(NEW ObjList<aList<long double> >());
	jackFstatsLoc_.Append(NEW ObjList<aList<long double> >());//[Fmethod][loc][Flevel]
	ObjList<aList<long double> >& FByLoc = FstatsLoc_.Last();
	ObjList<aList<long double> >& jackFByLoc = jackFstatsLoc_.Last();
	StatList<long double> jackFstByLocNum, jackFitByLocNum, jackFstByLocDenom;
	long double FstNum, FstDenom;
	for(loc=0;loc<nlociCYmale_;++loc){
		FByLoc.Append(NEW aList<long double>());
		Fstval=Fitval=FstNum=FstDenom=zero;
		if(IBD_betwIndivBetwPops_ByLoc_[loc] != one){
			FstNum = (IBD_betwIndivInPop_ByLoc_[loc] - IBD_betwIndivBetwPops_ByLoc_[loc]);
			FstDenom = (one - IBD_betwIndivBetwPops_ByLoc_[loc]);
			Fstval = Fitval = FstNum/FstDenom;
			}
		FByLoc[loc].Append(Fstval);
		FByLoc[loc].Append(Fitval);
		jackFstByLocNum.Append(FstNum);
		jackFstByLocDenom.Append(FstDenom);
		}//loc
	for(loc=0;loc<nlociCYmale_;++loc){
		Fstval=Fitval=FstNum=FstDenom=zero;
		jackFByLoc.Append(NEW aList<long double>());
		FstDenom = jackFstByLocDenom.sum()-jackFstByLocDenom[loc];
		if(FstDenom != zero){
			Fstval = Fitval = (jackFstByLocNum.sum()-jackFstByLocNum[loc])/FstDenom;
			}
		jackFByLoc[loc].Append(Fstval);//Fst
		jackFByLoc[loc].Append(Fitval);//Fit
		}//loc
	FstatsCurrent_=true;
	}//FstatisticAnalysisCytoMale::CalculateIBDestimates(Ran3&,int)




void FstatisticAnalysisCytoMale::CalculateIBDexhaustive(void){//only do this for very small population samples
	if(! IBDcurrent_){
			ClearIBDs();}
		else if(IBDmethod_.Includes((int)IBDexhaustCytoMale)) {return;}
		else{}
	CalculateGenotypeFreqs();
	if(nlociCYmale_==0){
		IBDcurrent_=true;
		return;}

	long double IBD_inIndiv_, IBD_betwIndivInPop_, IBD_betwIndivBetwPops_;
	aList<long double> 	IBD_inIndiv_ByLoc_, IBD_betwIndivInPop_ByLoc_, IBD_betwIndivBetwPops_ByLoc_;
	StatList<long double> 	IBD_betwIndivInPop_ByLoc_Num, IBD_betwIndivBetwPops_ByLoc_Num, IBD_Denom;

	jackIBDvalsLoc_.Append(NEW ObjList<aList<long double> >());
	//within individuals
	long pop,pop1,pop2,loc,i1,i2;
	long double IBDval,IBDdenom;
	StatList<int> allIndivsByLoc;
	for(loc=0;loc<nlociCYmale_;++loc){
		jackIBDvalsLoc_.Last().Append(NEW aList<long double>());
		jackIBDvalsLoc_.Last().Last().Append(zero);//IBD within pop
		jackIBDvalsLoc_.Last().Last().Append(zero);//IBD betw pops
//		IBD_inIndiv_ByLoc_.Append(zero);
		allIndivsByLoc.Append(0);
		IBD_betwIndivInPop_ByLoc_.Append(zero);
		IBD_betwIndivBetwPops_ByLoc_.Append(zero);
		IBD_betwIndivInPop_ByLoc_Num.Append(zero);
		IBD_betwIndivBetwPops_ByLoc_Num.Append(zero);
		IBD_Denom.Append(zero);
		for(pop=0;pop<npop_;++pop){
			allIndivsByLoc[loc] += nByLocusCYmale_[pop][loc];}
		}//loc
	IBD_inIndiv_ = zero;//accounts for sample size diffs among loci
	
	//between individuals
	StatList<int> IBDbetwIndivInPopByLocCounter;
	for(loc=0;loc<nlociCYmale_;++loc){
		IBDbetwIndivInPopByLocCounter.Append(0);
		}//loc

	for(loc=0;loc<nlociCYmale_;++loc){
		for(pop=0;pop<npop_;++pop){
			for(i1=0;i1<popSize(pop)-1;++i1){
				for(i2=i1+1;i2<popSize(pop);++i2){
					TextDatum& g0_2 = GenotypicVal(pop, i1, locusNumCYmale_[loc],0);
					TextDatum& g1_2 = GenotypicVal(pop, i2, locusNumCYmale_[loc],0);
					if(g0_2 == g1_2 && g0_2.OK()){
						IBDbetwIndivInPopByLocCounter[loc]++;
						}
					}//i2
				}//i1
			}//pop
		IBDval = (long double)IBDbetwIndivInPopByLocCounter[loc];
		IBDdenom = (long double) allIndivsByLoc[loc] * (long double) (allIndivsByLoc[loc] - 1) / two;
		IBD_betwIndivInPop_ByLoc_[loc]=IBDval/IBDdenom;
		IBD_betwIndivInPop_ByLoc_Num[loc]=IBDval;
		IBD_Denom[loc] = IBDdenom;
		}//loc
	IBDval = (long double)IBDbetwIndivInPopByLocCounter.sum();
	IBDdenom = (long double) allIndivsByLoc.sum() * (long double) (allIndivsByLoc.sum() - 1) / two;
	IBD_betwIndivInPop_ = IBDval/IBDdenom;
	
	StatList<int> IBDbetwIndivBetwPopsByLocCounter;
	for(loc=0;loc<nlociCYmale_;++loc){
		IBDbetwIndivBetwPopsByLocCounter.Append(0);
		}//loc

	for(loc=0;loc<nlociCYmale_;++loc){
		for(pop1=0;pop1<npop_-1;++pop1){
			for(pop2=pop1+1;pop2<npop_;++pop2){
				for(i1=0;i1<popSize(pop1)-1;++i1){
					for(i2=0;i2<popSize(pop2);++i2){
						TextDatum& g0_3 = GenotypicVal(pop1, i1, locusNumCYmale_[loc],0);
						TextDatum& g1_3 = GenotypicVal(pop2, i2, locusNumCYmale_[loc],0);
						if(g0_3 == g1_3 && g0_3.OK()){
							IBDbetwIndivBetwPopsByLocCounter[loc]++;
							}
						}//i2
					}//i1
				}//pop2
			}//pop1
		IBDval = (long double)IBDbetwIndivBetwPopsByLocCounter[loc];
		IBDdenom = (long double) allIndivsByLoc[loc] * (long double) (allIndivsByLoc[loc] - 1) / two;
		IBD_betwIndivBetwPops_ByLoc_[loc]=IBDval/IBDdenom;
		IBD_betwIndivBetwPops_ByLoc_Num[loc] = IBDval;
		}//loc
	IBDval = (long double)IBDbetwIndivBetwPopsByLocCounter.sum();
	IBDdenom = (long double) allIndivsByLoc.sum() * (long double) (allIndivsByLoc.sum() - 1) / two;
	IBD_betwIndivBetwPops_ = IBDval/IBDdenom;			

	//transfer to general data structures
	IBDmethod_.Append(IBDexhaustCytoMale);
	IBDlevels_.Append( NEW StringList());
	IBDlevels_.Last().Append(NEW aString("betwIndivsInPops"));
	IBDlevels_.Last().Append(NEW aString("betwIndivsBetwPops"));
	IBDvals_.Append(NEW aList<long double>());
	IBDvals_.Last().Append(IBD_betwIndivInPop_);
	IBDvals_.Last().Append(IBD_betwIndivBetwPops_);
	IBDvalsByLoc_.Append(NEW ObjList<aList<long double> >());
	ObjList<aList<long double> >& IBDByLoc = IBDvalsByLoc_.Last();
	ObjList<aList<long double> >& jackIBDByLoc = jackIBDvalsLoc_.Last();
	for(loc=0;loc<nlociCYmale_;++loc){
		IBDByLoc.Append(NEW aList<long double>());
		IBDByLoc[loc].Append(IBD_betwIndivInPop_ByLoc_[loc]);
		IBDByLoc[loc].Append(IBD_betwIndivBetwPops_ByLoc_[loc]);
		if(IBD_Denom.sum()>IBD_Denom[loc]){
			jackIBDByLoc[loc][0] = (IBD_betwIndivInPop_ByLoc_Num.sum() - IBD_betwIndivInPop_ByLoc_Num[loc]) / (IBD_Denom.sum()-IBD_Denom[loc]);
			jackIBDByLoc[loc][1] = (IBD_betwIndivBetwPops_ByLoc_Num.sum() - IBD_betwIndivBetwPops_ByLoc_Num[loc]) / (IBD_Denom.sum()-IBD_Denom[loc]);
			}
		}//loc
	
	IBDcurrent_=true;

	//update F-stats
	long double Fstval, Fitval;
	if(! FstatsCurrent_){
		ClearFstats();}
	Fmethod_.Append(IBDexhaustCytoMale);
	Flevels_.Append( NEW StringList());
	Flevels_.Last().Append(NEW aString("Fst"));
	Flevels_.Last().Append(NEW aString("Fit"));
	Fstats_.Append(NEW aList<long double>());
	Fstval=Fitval=zero;
	if(IBD_betwIndivBetwPops_ != one){
		Fstval = (IBD_betwIndivInPop_ - IBD_betwIndivBetwPops_) / (one - IBD_betwIndivBetwPops_);
		Fitval = Fstval;
		}
	Fstats_.Last().Append(Fstval);
	Fstats_.Last().Append(Fitval);
	FstatsLoc_.Append(NEW ObjList<aList<long double> >());
	jackFstatsLoc_.Append(NEW ObjList<aList<long double> >());//[Fmethod][loc][Flevel]
	ObjList<aList<long double> >& FByLoc = FstatsLoc_.Last();
	ObjList<aList<long double> >& jackFByLoc = jackFstatsLoc_.Last();
	StatList<long double> jackFstByLocNum, jackFstByLocDenom;
	long double FstNum, FstDenom;
	for(loc=0;loc<nlociCYmale_;++loc){
		FByLoc.Append(NEW aList<long double>());
		Fstval=Fitval=FstNum=FstDenom=zero;
		if(IBD_betwIndivBetwPops_ByLoc_[loc] != one){
			FstNum = (IBD_betwIndivInPop_ByLoc_[loc] - IBD_betwIndivBetwPops_ByLoc_[loc]);
			FstDenom = (one - IBD_betwIndivBetwPops_ByLoc_[loc]);
			Fstval = Fitval = FstNum/FstDenom;
			}
		FByLoc[loc].Append(Fstval);
		FByLoc[loc].Append(Fitval);
		jackFstByLocNum.Append(FstNum);
		jackFstByLocDenom.Append(FstDenom);
		}//loc
	for(loc=0;loc<nlociCYmale_;++loc){
		Fstval=Fitval=FstNum=FstDenom=zero;
		jackFByLoc.Append(NEW aList<long double>());
		FstDenom = jackFstByLocDenom.sum()-jackFstByLocDenom[loc];
		if(FstDenom != zero){
			Fstval = Fitval = (jackFstByLocNum.sum()-jackFstByLocNum[loc])/FstDenom;
			}
		jackFByLoc[loc].Append(Fstval);//Fst
		jackFByLoc[loc].Append(Fitval);//Fit
		}//loc
	FstatsCurrent_=true;
	}//FstatisticAnalysisCytoMale::CalculateIBDexhaustive()



void FstatisticAnalysisCytoMale::ClearIBDs(void){
		//derived classes pick and delete Fstats calculated from IBD
	FstatisticAnalysisCore::ClearIBDs();
	if(IBDmethod_.Includes((int)IBDexhaustCytoMale)){
		int m = IBDmethod_.Loc((int)IBDexhaustCytoMale);
		IBDlevels_.Delete(m);
		IBDvalsByLoc_.Delete(m);
		IBDmethod_.Delete(m);
		}
	if(IBDmethod_.Includes((int)IBDexhaustCytoMale)){
		int m = IBDmethod_.Loc((int)IBDexhaustCytoMale);
		IBDlevels_.Delete(m);
		IBDvalsByLoc_.Delete(m);
		IBDmethod_.Delete(m);
		}
	}//end FstatisticAnalysisCytoMale::ClearIBDs()



long double FstatisticAnalysisCytoMale::CytoplasmicFstFromNm(long double Nm, int numTrueDemes){
	long double scale=two, msr = one - primarySexRatio_;//male sex ratio
	scale *= msr;
	if(numTrueDemes<2){numTrueDemes=0;}
		else{numTrueDemes=MAX((int)npop_,numTrueDemes);}
	if(numTrueDemes>1){
		long double d = (long double)numTrueDemes;
		scale *= d*d/((d-one)*(d-one));}
	return one/(scale*Nm + one);
	}//FstatisticAnalysisCytoMale::CytoplasmicFstFromNm(long double, bool)




void FstatisticAnalysisCytoMale::CytoMaleMarkerFstats (int numTrueDemes){
	//calculates F-statistics among populations using haploid markers,
	//to be used when there is only one group of pops.

	//clear out any previous calculations if necessary
  	if(! FstatsCurrent_){
  		ClearFstats();}
	if(nlociCYmale_==0){return;}
	if((Fmethod_.Includes((int) CYmale))){return;}
	int j,pop,loc,mEff,Flevel,vclevel,m,a;
	FstatsCurrent_=vcCurrent_=0;
	Fmethod_.Append((int) CYmale);
	m = Fmethod_.len()-1;
	FstatsLoc_.Append(NEW ObjList<aList<long double> >());//loc, F-level
	FstatsAll_.Append(NEW ObjList<ObjList<aList<long double> > >());//loc,allele, F-level
	Fstats_.Append(NEW aList<long double>());//F-level
	jackFstatsLoc_.Append(NEW ObjList<aList<long double> >());//loc, F-level
	Flevels_.Append(NEW StringList());//F-level

	vcMethod_.Append((int) CYmale);
	vcLoc_.Append(NEW ObjList<aList<long double> >());//loc, vc-level
	vcAll_.Append(NEW ObjList<ObjList<aList<long double> > >());//loc,allele, vc-level
	vc_.Append(NEW aList<long double>());//vc-level
	vcLevels_.Append(NEW StringList());//vc-level

	Fmethod_.Append((int) CYmaleEffective);
	mEff = Fmethod_.len()-1;
	FstatsLoc_.Append(NEW ObjList<aList<long double> >());//loc, F-level
	FstatsAll_.Append(NEW ObjList<ObjList<aList<long double> > >());//loc,allele, F-level
	Fstats_.Append(NEW aList<long double>());//F-level
	jackFstatsLoc_.Append(NEW ObjList<aList<long double> >());//loc, F-level
	Flevels_.Append(NEW StringList());//F-level

	vcMethod_.Append((int) CYmaleEffective);
	vcLoc_.Append(NEW ObjList<aList<long double> >());//loc, vc-level
	vcAll_.Append(NEW ObjList<ObjList<aList<long double> > >());//loc,allele, vc-level
	vc_.Append(NEW aList<long double>());//vc-level
	vcLevels_.Append(NEW StringList());//vc-level


	//set up all the F-stat arrays
	// first the array describing the Fstat structure:
	aString* FWord=NEW aString("Fst");
	Flevels_[m].Append(FWord);
	Flevels_[mEff].Append(NEW aString(*FWord));

	aString* vcWord=NEW aString("var(p)");
	vcLevels_[m].Append(vcWord);
	vcLevels_[mEff].Append(NEW aString(*vcWord));
	vcWord=NEW aString("var(i)");
	vcLevels_[m].Append(vcWord);
	vcLevels_[mEff].Append(NEW aString(*vcWord));
	vcWord=NEW aString("var(t)");
	vcLevels_[m].Append(vcWord);
	vcLevels_[mEff].Append(NEW aString(*vcWord));
	//make and initialize the jackknife & by-locus Fstat lists
	for (Flevel=0;Flevel<1;++Flevel){
		Fstats_[m].Append(zero);
		Fstats_[mEff].Append(zero);
		}
	for (vclevel=0;vclevel<3;++vclevel){
		vc_[m].Append(zero);
		vc_[mEff].Append(zero);
		}
	//some intermediate variables
	aList<long double> sumILoc;
	aList<long double> sumSLoc;
	aList<long double> sumISLoc;

	CytoplasmicMaleMarkerData::CheckForNewAlleles();
	CytoplasmicMaleMarkerData::CalculateGenotypeFreqs();
	CytoplasmicMaleMarkerData::UpdateVariableLociCYmale();
	aList<long double> Q;//global freqs for each marker
	for (j=0;j<nlociCYmale_;++j){
		//make and initialize the jackknife & by-locus Fstat lists for this locus 
		FstatsLoc_[m].Append(NEW aList<long double>());
		jackFstatsLoc_[m].Append(NEW aList<long double>());
		FstatsLoc_[mEff].Append(NEW aList<long double>());
		jackFstatsLoc_[mEff].Append(NEW aList<long double>());
		for (Flevel=0;Flevel<1;++Flevel){
			FstatsLoc_[m][j].Append(zero);
			jackFstatsLoc_[m][j].Append(zero);
			FstatsLoc_[mEff][j].Append(zero);
			jackFstatsLoc_[mEff][j].Append(zero);
			}
		//make and initialize the jackknife & by-allele Fstat lists for this locus 
		FstatsAll_[m].Append(NEW ObjList<aList<long double> >());
		FstatsAll_[mEff].Append(NEW ObjList<aList<long double> >());
		//initialize variables
		sumILoc.Append(zero);
		sumSLoc.Append(zero);
		sumISLoc.Append(zero);

		//make and initialize the by-allele F-stat list for each allele and append to this locus list
		StringList& locAlleleList = allelesPresentCYmale_[j];
		for (a=0;a<locAlleleList.len();++a){
			FstatsAll_[m][j].Append(NEW aList<long double>());
			FstatsAll_[mEff][j].Append(NEW aList<long double>());
			for (Flevel=0;Flevel<1;++Flevel){
				FstatsAll_[m][j][a].Append(zero);
				FstatsAll_[mEff][j][a].Append(zero);
				}
			}//end for a							

		//make and initialize the by-allele var comp list
		vcLoc_[m].Append(NEW aList<long double>());
		vcLoc_[mEff].Append(NEW aList<long double>());
		for (vclevel=0;vclevel<3;++vclevel){
			vcLoc_[m][j].Append(zero);
			vcLoc_[mEff][j].Append(zero);
			}
		vcAll_[m].Append(NEW ObjList<aList<long double> >());
		vcAll_[mEff].Append(NEW ObjList<aList<long double> >());
		for (a=0;a<locAlleleList.len();++a){
			vcAll_[m][j].Append(NEW aList<long double>());
			vcAll_[mEff][j].Append(NEW aList<long double>());
			for (vclevel=0;vclevel<3;++vclevel){
				vcAll_[m][j][a].Append(zero);
				vcAll_[mEff][j][a].Append(zero);
				}
			}//end for a							
		Q.Append(zero);
		}//end for j

	//the main body of the calculations	
//	long double sr = primarySexRatio();
	long double r = (long double) (npop_);
	long double dfS = r - one;
	long double Isum,Ssum,ISsum,fstVal,NmfromFst,FstEffFromNm;
	long double n,n0,nbar,nsq,dfI,ssqI,ssqS,MSI,MSS,vcI,vcS;
	Isum=Ssum=ISsum=zero;
	aString levelName;
	for (j=0;j<variableLocusNumCYmale_.len();++j){
		loc = variableLocusNumCYmale_[j];//the actual locus
//		StringList& locAlleleList = allelesPresentHap[loc];
		n=n0=nbar=nsq=dfI=ssqI=ssqS=MSI=MSS=vcI=vcS=zero;
		StatList<long double> q;//marker frequencies for this locus at each pop
		StatList<long double> nn;//sample sizes for this locus at each pop
		
		//Calculate for the whole population set:
		for (pop=0;pop<npop_;++pop){
			q.Append(CytoplasmicMaleMarkerData::GetFreqCYmale(pop,loc, 0));
			nn.Append((long double) (CytoplasmicMaleMarkerData::GetLocusSampleSizeCYmale(pop,loc)) );
			//average sample size among pops:
			nsq += nn[pop] * nn[pop];//running total
			// Average marker frequency (=Q)
			Q[loc] += nn[pop] * q[pop];
			}//pop
		n = nn.sum();//total sample size
		if ((r>one)&&(n>zero)) {//this weeds out zero denominators
			nbar = n/r;
			n0 = (n - nsq/n) / dfS;
			Q[loc] /=n;

			//Now get the term accounting for variance among allelic frequencies
			for (pop=0;pop<npop_;++pop){
				ssqI += nn[pop] * q[pop]*(one - q[pop]);
				ssqS += nn[pop] * (q[pop] - Q[loc]) * (q[pop] - Q[loc]);
				}//end for pop
			dfI = n - r;
			
			MSI = ssqI/dfI;
			MSS = ssqS/dfS;
			
			//variance components
			vcI = MSI;
			if (n0 != zero){
				vcS = (MSS - MSI)/n0;
				}
			}//end if r>1, n>0

		for(a=0;a<allelesPresentCYmale_[loc].len();++a){//same for both marker phenotypes
			vcAll_[m][loc][a][0] = vcS;
			vcAll_[m][loc][a][1] = vcI;
			vcAll_[m][loc][a][2] = vcS+vcI;
			vcAll_[mEff][loc][a][0] = vcS;
			vcAll_[mEff][loc][a][1] = vcI;
			vcAll_[mEff][loc][a][2] = vcS+vcI;
			//A, B, &C remain zero if their components have any zero denominators
			if ((vcS+vcI) != zero) {
				levelName="Fst";
				Flevel = Flevels_[m].Loc(&levelName);
				fstVal = FstatsAll_[m][loc][a][Flevel] = vcS / (vcS+vcI);
//				FstatsAll_[mEff][loc][a][Flevel] = ((one - sr)*vcS) / (two*(vcS+vcI) - (one + sr)*vcS);
				NmfromFst = NmFromCytoMaleFst(fstVal,numTrueDemes);
				FstEffFromNm = EffectiveFstFromNm(NmfromFst,numTrueDemes);
				FstatsAll_[mEff][loc][a][Flevel] = FstEffFromNm;
				}//end if vcS+vcI
			}//a
		//save these in an array for a quicker calculation of the jackknife variance estimates
		sumILoc[loc] = vcI;
		sumSLoc[loc] = vcS;
		sumISLoc[loc] = vcI+vcS;

		Isum += vcI;
		Ssum += vcS;
		ISsum += vcI+vcS;
			
		vcLoc_[m][loc][0] = sumSLoc[loc];
		vcLoc_[m][loc][1] = sumILoc[loc];
		vcLoc_[m][loc][2] = sumISLoc[loc];
		vcLoc_[mEff][loc][0] = sumSLoc[loc];
		vcLoc_[mEff][loc][1] = sumILoc[loc];
		vcLoc_[mEff][loc][2] = sumISLoc[loc];
//		aList<long double>& locFstat = FstatsLoc_[m][loc];
		long double temp = sumISLoc[loc];
		if (sumISLoc[loc] != zero) {
			levelName="Fst";
			Flevel = Flevels_[m].Loc(&levelName);
			fstVal = FstatsLoc_[m][loc][Flevel]=sumSLoc[loc] / sumISLoc[loc];
//			FstatsLoc_[mEff][loc][Flevel]=((one - sr)*sumSLoc[loc]) / (two * sumISLoc[loc] - (one + sr)*sumISLoc[loc]);
			NmfromFst = NmFromCytoMaleFst(fstVal,numTrueDemes);
			FstEffFromNm = EffectiveFstFromNm(NmfromFst,numTrueDemes);
			FstatsLoc_[mEff][loc][Flevel] = FstEffFromNm;
			}
		}//end for j

	vc_[m][0] = Ssum;
	vc_[m][1] = Isum;
	vc_[m][2] = ISsum;
	vc_[mEff][0] = Ssum;
	vc_[mEff][1] = Isum;
	vc_[mEff][2] = ISsum;
	if (ISsum != zero){
		levelName="Fst";
		Flevel = Flevels_[m].Loc(&levelName);
		fstVal = Fstats_[m][Flevel] = Ssum/ISsum;
//		Fstats_[mEff][Flevel] = ((one - sr)*Ssum)/(two*ISsum - (one + sr)*Ssum);
		NmfromFst = NmFromCytoMaleFst(fstVal,numTrueDemes);
		FstEffFromNm = EffectiveFstFromNm(NmfromFst,numTrueDemes);
		Fstats_[mEff][Flevel] = FstEffFromNm;
		}//end if ISsum

	//now do the jackknife calculations, over loci
	for (j=0;j<variableLocusNumCYmale_.len();++j){
		loc = variableLocusNumCYmale_[j];//the actual locus		
		if (ISsum != sumISLoc[loc]) {
			levelName="Fst";
			Flevel = Flevels_[m].Loc(&levelName);
			fstVal = jackFstatsLoc_[m][loc][Flevel] = (Ssum-sumSLoc[loc]) / (ISsum - sumISLoc[loc]);
//			jackFstatsLoc_[mEff][loc][Flevel] = ((one - sr)*(Ssum-sumSLoc[loc])) / (two*(ISsum - sumISLoc[loc])-(one + sr)*(Ssum-sumSLoc[loc]));
			NmfromFst = NmFromCytoMaleFst(fstVal,numTrueDemes);
			FstEffFromNm = EffectiveFstFromNm(NmfromFst,numTrueDemes);
			jackFstatsLoc_[mEff][loc][Flevel] = FstEffFromNm;
			}//end if 
		}//end for j

	FstatsCurrent_=vcCurrent_=1;
	}//end FstatisticAnalysisCytoMale::CYmaleMarkerFstats






void FstatisticAnalysisCytoMale::HierarchicalCytoMaleMarkerFstats(void){}


long double FstatisticAnalysisCytoMale::Nm(long double FstVal,int Fmethod, int numTrueDemes, bool /*zygoteMigration*/){
	long double Nmval = zero;
	if(Fmethod==CYmaleEffective){
			if(FstVal<=zero) return (long double)1.0e6;
			if(FstVal>=one) return zero;
			long double scale=two,msr=one-primarySexRatio_;
			scale *= msr;
			if(numTrueDemes<2){numTrueDemes=0;}
				else{numTrueDemes=MAX((int)npop_,numTrueDemes);}
			if(numTrueDemes>1){
				long double d=(long double)numTrueDemes;
				scale *= d*d/(d-one)*(d-one);}
			Nmval = (one - FstVal)/(scale*FstVal);
			}
		else{
			Nmval = NmFromCytoMaleFst(FstVal,numTrueDemes);}
	return Nmval;
	}//FstatisticAnalysisCytoMale::Nm(long double,int, int, bool)



long double FstatisticAnalysisCytoMale::NmFromCytoMaleFst(long double FstCYM, int numTrueDemes){
	if(FstCYM<=zero) return (long double)1.0e6;
	if(FstCYM>=one) return zero;
	long double msr = one - primarySexRatio_;
	long double scale=two*msr;
	if(numTrueDemes<2){numTrueDemes=0;}
		else{numTrueDemes=MAX((int)npop_,numTrueDemes);}
	if(numTrueDemes>1){
		long double d=(long double)numTrueDemes;
		scale *= d*d/((d-one)*(d-one));}
	long double Nmval = (one - FstCYM)/(scale*FstCYM);
	return Nmval;
	}//FstatisticAnalysisCytoMale::NmFromCytoMaleFst(long double,int )


int  FstatisticAnalysisCytoMale::PrintFMethodHeading(ostream& outFile, const int Fmethod){
	if(Fmethod==CYmale){
			outFile<<"Least-squares estimators of Wright's F-statistics for cytoplasmic markers passed through males only."<<endl;}
		else if(Fmethod ==hierCYmale){
			outFile<<"Least-squares estimators of Wright's hierarchical F-statistics for cytoplasmic markers passed through males only."<<endl;}
		else {
			return FstatisticAnalysisCore::PrintFMethodHeading(outFile, Fmethod);}
	return 1;//no error
	}//end FstatisticAnalysisCytoMale::PrintFMethodHeading


void FstatisticAnalysisCytoMale::PrintFStatisticsByLocus(ostream& outFile, const int Fmethod, aString& titleStr, char colSpacer){
	StringList namesOfLoci;
	CytoplasmicMaleMarkerData::GetLocusNames(namesOfLoci);
	FstatisticAnalysisCore::PrintFStatisticsByLocus(outFile, Fmethod, titleStr, namesOfLoci, colSpacer);
	}
	
	
void FstatisticAnalysisCytoMale::PrintFStatisticsByAllele(ostream& outFile, const int Fmethod, aString& titleStr, char colSpacer){
	StringList namesOfLoci;
	CytoplasmicMaleMarkerData::GetLocusNames(namesOfLoci);
	FstatisticAnalysisCore::PrintFStatisticsByAllele(outFile, Fmethod, titleStr, namesOfLoci, allelesPresentCYmale_, colSpacer);
	}





void FstatisticAnalysisCytoMale::PrintNEXUSFile(aString& outFileName, StringList& textToAppend){
	CytoplasmicMaleMarkerData::PrintNEXUSFile(outFileName, textToAppend);
	}//end FstatisticAnalysisCytoMale::PrintNEXUSFile(aString&, StringList&)



void FstatisticAnalysisCytoMale::PrintNEXUSFile (ostream& outFile, StringList& textToAppend){
	CytoplasmicMaleMarkerData::PrintNEXUSFile(outFile, textToAppend);
	}//end FstatisticAnalysisCytoMale::PrintNEXUSFile(ostream&,StringList&)




void FstatisticAnalysisCytoMale::ResetFlags(void){
	FstatisticAnalysisCore::ResetFlags();
	CytoplasmicMaleMarkerData::ResetFlags();
	}


FstatisticAnalysisCytoMale& FstatisticAnalysisCytoMale::operator=(EvolutionaryGeneticsData& egd){
	Clear();
	EvolutionaryGeneticsData::Initialize(egd);
	return *this;
	}//FstatisticAnalysisCytoMale::operator=(EvolutionaryGeneticsData&)


FstatisticAnalysisCytoMale& FstatisticAnalysisCytoMale::operator=(CytoplasmicMaleMarkerData& cymd){
	Clear();
	CytoplasmicMaleMarkerData::Initialize(cymd);
	return *this;
	}//FstatisticAnalysisCytoMale::operator=(CytoplasmicMaleMarkerData&)



FstatisticAnalysisCytoMale& FstatisticAnalysisCytoMale::operator=(FstatisticAnalysisCytoMale& cymd){
	Clear();
	CytoplasmicMaleMarkerData::Initialize(cymd);
	FstatisticAnalysisCore::Initialize(cymd);
	return *this;
	}//FstatisticAnalysisCytoMale::operator=(FstatisticAnalysisCytoMale&)


#endif
