//FstatisticAnalysisDom.cpp

#ifndef FstatisticAnalysisDomcpp
#define FstatisticAnalysisDomcpp=1

#include "FstatisticAnalysisDom.h"
#include "Element.cpp"
#include "aList.cpp"
#include "StatList.cpp"






FstatisticAnalysisDom::FstatisticAnalysisDom(aString& s){
	PopulationGeneticData::title_=s; 
	ngroups=npop_=nloci=maxall=nlociDom=0; 
	variableLoci=varLociCurrent_=allelesCurrent_=lociSkipped=0; 
	alleleFreqCurrent_=HetObsCurrent_=varLociCurrentDom_=0;
	FstatsCurrent_=vcCurrent_=allelesCurrentDom_=phenotypeFreqsCurrent_=0; 
	}


FstatisticAnalysisDom::FstatisticAnalysisDom(PopulationGeneticData& pgd){
	title_=pgd.title_; 
	npop_=pgd.npop_;
	nloci=pgd.nloci;
	maxall=pgd.maxall;
	ngroups=pgd.ngroups;
	variableLoci=pgd.variableLoci;
	popSize=pgd.popSize;
	groupName=pgd.groupName;
	popName=pgd.popName;
	localityName=pgd.localityName;
	rawLocusName=pgd.rawLocusName;
	locusName=pgd.locusName;
	skippedLocusName=pgd.skippedLocusName;
	groupHierarchy=pgd.groupHierarchy;
	popsByLocality=pgd.popsByLocality;
	varLociCurrent_=pgd.varLociCurrent_;
	skippedLocusNum=pgd.skippedLocusNum;
	variableLoci_=pgd.variableLoci_;
	lociSkipped=pgd.lociSkipped;
	rawGtypes=pgd.rawGtypes;
	gtypes=pgd.gtypes;
	allelesCurrent_=pgd.allelesCurrent_;
	allelesPresent=pgd.allelesPresent;
	alleleFreqCurrent_=pgd.alleleFreqCurrent_;
	alleleFreq=pgd.alleleFreq;
	twoN=pgd.twoN;
	HetObsCurrent_=pgd.HetObsCurrent_;
	HetObsByAllele=pgd.HetObsByAllele;
	HetObsByLocus=pgd.HetObsByLocus;
	diseqD=pgd.diseqD;
	locusD=pgd.locusD;

	varLociCurrentDom_=allelesCurrentDom_=phenotypeFreqsCurrent_=0;

	FstatsCurrent_=vcCurrent_=0; 
	}//FstatisticAnalysisDom::FstatisticAnalysisDom(PopulationGeneticData&)



FstatisticAnalysisDom::FstatisticAnalysisDom(DominantMarkerData& pgd){
	title_=pgd.title_; 
	npop_=pgd.npop_;
	nloci=pgd.nloci;
	maxall=pgd.maxall;
	ngroups=pgd.ngroups;
	variableLoci=pgd.variableLoci;
	popSize=pgd.popSize;
	groupName=pgd.groupName;
	popName=pgd.popName;
	localityName=pgd.localityName;
	rawLocusName=pgd.rawLocusName;
	locusName=pgd.locusName;
	skippedLocusName=pgd.skippedLocusName;
	groupHierarchy=pgd.groupHierarchy;
	popsByLocality=pgd.popsByLocality;
	varLociCurrent_=pgd.varLociCurrent_;
	skippedLocusNum=pgd.skippedLocusNum;
	variableLoci_=pgd.variableLoci_;
	lociSkipped=pgd.lociSkipped;
	rawGtypes=pgd.rawGtypes;
	gtypes=pgd.gtypes;
	allelesCurrent_=pgd.allelesCurrent_;
	allelesPresent=pgd.allelesPresent;
	alleleFreqCurrent_=pgd.alleleFreqCurrent_;
	alleleFreq=pgd.alleleFreq;
	twoN=pgd.twoN;
	HetObsCurrent_=pgd.HetObsCurrent_;
	HetObsByAllele=pgd.HetObsByAllele;
	HetObsByLocus=pgd.HetObsByLocus;
	diseqD=pgd.diseqD;
	locusD=pgd.locusD;

	nlociDom=pgd.nlociDom;
	variableLociDom=pgd.variableLociDom;
	varLociCurrentDom_=pgd.varLociCurrentDom_;
	rawLocusNameDom=pgd.rawLocusNameDom;
	locusNameDom=pgd.locusNameDom;
	skippedLocusNameDom=pgd.skippedLocusNameDom;
	lociSkippedDom=pgd.lociSkippedDom;
	skippedLocusNumDom=pgd.skippedLocusNumDom;
	rawPhenotypes=pgd.rawPhenotypes;
	phenotypes=pgd.phenotypes;
	allelesCurrentDom_=pgd.allelesCurrentDom_;
	allelesPresentDom=pgd.allelesPresentDom;
	phenotypeFreqsCurrent_=pgd.phenotypeFreqsCurrent_;
	phenotypeFreq=pgd.phenotypeFreq;
	nByLocusDom=pgd.nByLocusDom;
	
	FstatsCurrent_=vcCurrent_=0; 
	}//FstatisticAnalysisDom::FstatisticAnalysisDom(DominantMarkerData&)



FstatisticAnalysisDom::FstatisticAnalysisDom(FstatisticAnalysis& pgd){
	title_=pgd.title_; 
	npop_=pgd.npop_;
	nloci=pgd.nloci;
	maxall=pgd.maxall;
	ngroups=pgd.ngroups;
	variableLoci=pgd.variableLoci;
	popSize=pgd.popSize;
	groupName=pgd.groupName;
	popName=pgd.popName;
	localityName=pgd.localityName;
	rawLocusName=pgd.rawLocusName;
	locusName=pgd.locusName;
	skippedLocusName=pgd.skippedLocusName;
	groupHierarchy=pgd.groupHierarchy;
	popsByLocality=pgd.popsByLocality;
	varLociCurrent_=pgd.varLociCurrent_;
	skippedLocusNum=pgd.skippedLocusNum;
	variableLoci_=pgd.variableLoci_;
	lociSkipped=pgd.lociSkipped;
	rawGtypes=pgd.rawGtypes;
	gtypes=pgd.gtypes;
	allelesCurrent_=pgd.allelesCurrent_;
	allelesPresent=pgd.allelesPresent;
	alleleFreqCurrent_=pgd.alleleFreqCurrent_;
	alleleFreq=pgd.alleleFreq;
	twoN=pgd.twoN;
	HetObsCurrent_=pgd.HetObsCurrent_;
	HetObsByAllele=pgd.HetObsByAllele;
	HetObsByLocus=pgd.HetObsByLocus;
	diseqD=pgd.diseqD;
	locusD=pgd.locusD;

	varLociCurrentDom_=allelesCurrentDom_=phenotypeFreqsCurrent_=0;

	FstatsCurrent_=pgd.FstatsCurrent_;
	Fmethod_=pgd.Fmethod_;
	Flevels_=pgd.Flevels_;
	Fstats_=pgd.Fstats_;
	FstatsLoc_=pgd.FstatsLoc_;
	jackFstatsLoc_=pgd.jackFstatsLoc_;
	FstatsAll_=pgd.FstatsAll_;
	vcCurrent_=pgd.vcCurrent_;
	vcMethod_=pgd.vcMethod_;
	vcLevels_=pgd.vcLevels_;
	vc_=pgd.vc_;
	vcLoc_=pgd.vcLoc_;
	vcAll_=pgd.vcAll_;
	}//FstatisticAnalysisDom::FstatisticAnalysisDom(FstatisticAnalysis&)



FstatisticAnalysisDom::FstatisticAnalysisDom(FstatisticAnalysisDom& pgd){//copy constructor
	title_=pgd.title_; 
	npop_=pgd.npop_;
	nloci=pgd.nloci;
	maxall=pgd.maxall;
	ngroups=pgd.ngroups;
	variableLoci=pgd.variableLoci;
	popSize=pgd.popSize;
	groupName=pgd.groupName;
	popName=pgd.popName;
	localityName=pgd.localityName;
	rawLocusName=pgd.rawLocusName;
	locusName=pgd.locusName;
	skippedLocusName=pgd.skippedLocusName;
	groupHierarchy=pgd.groupHierarchy;
	popsByLocality=pgd.popsByLocality;
	varLociCurrent_=pgd.varLociCurrent_;
	skippedLocusNum=pgd.skippedLocusNum;
	variableLoci_=pgd.variableLoci_;
	lociSkipped=pgd.lociSkipped;
	rawGtypes=pgd.rawGtypes;
	gtypes=pgd.gtypes;
	allelesCurrent_=pgd.allelesCurrent_;
	allelesPresent=pgd.allelesPresent;
	alleleFreqCurrent_=pgd.alleleFreqCurrent_;
	alleleFreq=pgd.alleleFreq;
	twoN=pgd.twoN;
	HetObsCurrent_=pgd.HetObsCurrent_;
	HetObsByAllele=pgd.HetObsByAllele;
	HetObsByLocus=pgd.HetObsByLocus;
	diseqD=pgd.diseqD;
	locusD=pgd.locusD;

	nlociDom=pgd.nlociDom;
	variableLociDom=pgd.variableLociDom;
	varLociCurrentDom_=pgd.varLociCurrentDom_;
	rawLocusNameDom=pgd.rawLocusNameDom;
	locusNameDom=pgd.locusNameDom;
	skippedLocusNameDom=pgd.skippedLocusNameDom;
	lociSkippedDom=pgd.lociSkippedDom;
	skippedLocusNumDom=pgd.skippedLocusNumDom;
	rawPhenotypes=pgd.rawPhenotypes;
	phenotypes=pgd.phenotypes;
	allelesCurrentDom_=pgd.allelesCurrentDom_;
	allelesPresentDom=pgd.allelesPresentDom;
	phenotypeFreqsCurrent_=pgd.phenotypeFreqsCurrent_;
	phenotypeFreq=pgd.phenotypeFreq;
	nByLocusDom=pgd.nByLocusDom;

	FstatsCurrent_=pgd.FstatsCurrent_;
	Fmethod_=pgd.Fmethod_;
	Flevels_=pgd.Flevels_;
	Fstats_=pgd.Fstats_;
	FstatsLoc_=pgd.FstatsLoc_;
	jackFstatsLoc_=pgd.jackFstatsLoc_;
	FstatsAll_=pgd.FstatsAll_;
	vcCurrent_=pgd.vcCurrent_;
	vcMethod_=pgd.vcMethod_;
	vcLevels_=pgd.vcLevels_;
	vc_=pgd.vc_;
	vcLoc_=pgd.vcLoc_;
	vcAll_=pgd.vcAll_;
	}//FstatisticAnalysisDom::FstatisticAnalysisDom(FstatisticAnalysisDom&)





FstatisticAnalysisDom::FstatisticAnalysisDom(FstatisticAnalysisDom& parentData, aList<int>& popSubsetNums) {
	//makes a copy of the original data using a subset of populations
	//useful for separate analyses of data subsets
	(*this) = parentData;//copies

	npop_=popSubsetNums.len();
	popSubsetNums.Sort();
	ResetFlags();
	for(int p=0;p<popSubsetNums.len();++p){
		int pp = popSubsetNums[p];//population num in parentData
		aString* pn = NEW aString(parentData.popName[pp]);
		popName.Append(pn);
		popSize.Append(parentData.popSize[pp]);
		if(parentData.rawGtypes.len()>0){//if codominant data present
			StringList* rawG = NEW StringList(parentData.rawGtypes[pp]);
			rawGtypes.Append(rawG);
			StringList* newgtype = NEW StringList(parentData.gtypes[pp]);
			gtypes.Append(newgtype);
			}
		if(parentData.rawPhenotypes.len()>0){//if dominant data present
			StringList* rawP = NEW StringList(parentData.rawPhenotypes[pp]);
			rawPhenotypes.Append(rawP);
			StringList* newptype = NEW StringList(parentData.phenotypes[pp]);
			phenotypes.Append(newptype);
			}
		}//end for p
	GroupMembership();
	LocalityMembership();
	CheckForNewAlleles();
	}//end ctor FstatisticAnalysisDom(FstatisticAnalysisDom&, aList<int>&)


FstatisticAnalysisDom::FstatisticAnalysisDom(DominantMarkerData& parentData, aList<int>& popSubsetNums) {
	//makes a copy of the original data using a subset of populations
	//useful for separate analyses of data subsets
	(*this) = parentData;//copies

	npop_=popSubsetNums.len();
	popSubsetNums.Sort();
	ResetFlags();
	for(int p=0;p<popSubsetNums.len();++p){
		int pp = popSubsetNums[p];//population num in parentData
		aString* pn = NEW aString(parentData.popName[pp]);
		popName.Append(pn);
		popSize.Append(parentData.popSize[pp]);
		if(parentData.rawGtypes.len()>0){//if codominant data present
			StringList* rawG = NEW StringList(parentData.rawGtypes[pp]);
			rawGtypes.Append(rawG);
			StringList* newgtype = NEW StringList(parentData.gtypes[pp]);
			gtypes.Append(newgtype);
			}
		if(parentData.rawPhenotypes.len()>0){//if dominant data present
			StringList* rawP = NEW StringList(parentData.rawPhenotypes[pp]);
			rawPhenotypes.Append(rawP);
			StringList* newptype = NEW StringList(parentData.phenotypes[pp]);
			phenotypes.Append(newptype);
			}
		}//end for p
	GroupMembership();
	LocalityMembership();
	CheckForNewAlleles();
	}//end ctor FstatisticAnalysisDom(DominantMarkerData&, aList<int>&)





void FstatisticAnalysisDom::Clear(){
	FstatisticAnalysis::Clear();
	DominantMarkerData::Clear();
	}


void FstatisticAnalysisDom::DomMarkerFstats (void){
	//calculates F-statistics among populations using dominant markers,
	//to be used when there is only one group of pops.
	//Notation follows Porter MS in prep

	//clear out any previous calculations if necessary
  	if(! FstatsCurrent_){
  		ClearFstats();}
	if((Fmethod_.Includes((int) domStd))){return;}
	FstatsCurrent_=vcCurrent_=0;
	Fmethod_.Append((int) domStd);
	int m = Fmethod_.len()-1;
	FstatsLoc_.Append(NEW ObjList<aList<long double> >());//loc, F-level
	FstatsAll_.Append(NEW ObjList<ObjList<aList<long double> > >());//loc,allele, F-level
	Fstats_.Append(NEW aList<long double>());//F-level
	jackFstatsLoc_.Append(NEW ObjList<aList<long double> >());//loc, F-level
	Flevels_.Append(NEW StringList());//F-level

	vcMethod_.Append((int) domStd);
	vcLoc_.Append(NEW ObjList<aList<long double> >());//loc, vc-level
	vcAll_.Append(NEW ObjList<ObjList<aList<long double> > >());//loc,allele, vc-level
	vc_.Append(NEW aList<long double>());//vc-level
	vcLevels_.Append(NEW StringList());//vc-level

	//set up all the F-stat arrays
	// first the array describing the Fstat structure:
	aString* FWord=NEW aString("Fst");
	Flevels_[m].Append(FWord);

	aString* vcWord=NEW aString("var(p)");
	vcLevels_[m].Append(vcWord);
	vcWord=NEW aString("var(i)");
	vcLevels_[m].Append(vcWord);
	vcWord=NEW aString("var(t)");
	vcLevels_[m].Append(vcWord);
	//make and initialize the jackknife & by-locus Fstat lists
	for (int Flevel=0;Flevel<1;++Flevel){Fstats_[m].Append((long double)0.0);}
	for (int vclevel=0;vclevel<3;++vclevel){vc_[m].Append((long double)0.0);}
	//some intermediate variables
	aList<long double> sumILoc;
	aList<long double> sumSLoc;
	aList<long double> sumISLoc;

	DominantMarkerData::CheckForNewAlleles();
	DominantMarkerData::CalculatePhenotypeFreqs();
	DominantMarkerData::UpdateVariableLociDom();
	aList<long double> Q;//global freqs for each marker
	for (int j=0;j<nlociDom;++j){
		//make and initialize the jackknife & by-locus Fstat lists for this locus 
		aList<long double>* locFstat = NEW aList<long double>();
		FstatsLoc_[m].Append(locFstat);
		aList<long double>* locJackFstat = NEW aList<long double>();
		jackFstatsLoc_[m].Append(locJackFstat);
		for (int Flevel=0;Flevel<1;++Flevel){
			locFstat->Append((long double)0.0);
			locJackFstat->Append((long double)0.0);
			}
		//make and initialize the jackknife & by-allele Fstat lists for this locus 
		ObjList<aList<long double> >* locAlleleFstat = NEW ObjList<aList<long double> >();
		FstatsAll_[m].Append(locAlleleFstat);
		//initialize variables
		sumILoc.Append((long double)0.0);
		sumSLoc.Append((long double)0.0);
		sumISLoc.Append((long double)0.0);

		//make and initialize the by-allele F-stat list for each allele and append to this locus list
		StringList& locAlleleList = allelesPresentDom[j];
		for (int a=0;a<locAlleleList.len();++a){
			aList<long double>* alleleFstat =NEW aList<long double>();
			locAlleleFstat->Append(alleleFstat);
			for (int Flevel=0;Flevel<1;++Flevel){alleleFstat->Append((long double)0.0);}
			}//end for a							

		//make and initialize the by-allele var comp list
		vcLoc_[m].Append(NEW aList<long double>());
		for (int vclevel=0;vclevel<3;++vclevel){vcLoc_[m][j].Append((long double)0.0);}
		vcAll_[m].Append(NEW ObjList<aList<long double> >());
		for (int a=0;a<locAlleleList.len();++a){
			vcAll_[m][j].Append(NEW aList<long double>());
			for (int vclevel=0;vclevel<3;++vclevel){vcAll_[m][j][a].Append((long double)0.0);}
			}//end for a							
		Q.Append((long double)0.0);
		}//end for j

	//the main body of the calculations	
	long double r = (long double) (npop_);
	long double dfS = r - (long double)1.0;
	long double Isum,Ssum,ISsum;
	Isum=Ssum=ISsum=(long double)0.0;
	for (int j=0;j<variableLociDom.len();++j){
		int loc = variableLociDom[j];//the actual locus
//		StringList& locAlleleList = allelesPresentDom[loc];
		long double n,n0,nbar,nsq,dfI,ssqI,ssqS,MSI,MSS,vcI,vcS;
		n=n0=nbar=nsq=dfI=ssqI=ssqS=MSI=MSS=vcI=vcS=(long double)0.0;
		StatList<long double> q;//marker frequencies for this locus at each pop
		StatList<long double> nn;//sample sizes for this locus at each pop
		
		//Calculate for the whole population set:
		for (int pop=0;pop<npop_;++pop){
			q.Append(DominantMarkerData::GetFreqDom(pop,loc, 0));
			nn.Append((double) (DominantMarkerData::GetLocusSampleSizeDom(pop,loc)) );
			//average sample size among pops:
			nsq += nn[pop] * nn[pop];//running total
			// Average marker frequency (=Q)
			Q[loc] += nn[pop] * q[pop];
			}//pop
		n = nn.sum();//total sample size
		if ((r>(long double)1.0)&&(n>(long double)0.0)) {//this weeds out zero denominators
			nbar = n/r;
			n0 = (n - nsq/n) / dfS;
			Q[loc] /=n;

			//Now get the term accounting for variance among allelic frequencies
			for (int pop=0;pop<npop_;++pop){
				ssqI += nn[pop] * q[pop]*((long double)1.0 - q[pop]);
				ssqS += nn[pop] * (q[pop] - Q[loc]) * (q[pop] - Q[loc]);
				}//end for pop
			dfI = n - r;
			
			MSI = ssqI/dfI;
			MSS = ssqS/dfS;
			
			//variance components
			vcI = MSI;
			if (n0 != (long double)0.0){
				vcS = (MSS - MSI)/n0;
				}
			}//end if r>1, n>0

		for(int a=0;a<allelesPresentDom[loc].len();++a){//same for both marker phenotypes
			vcAll_[m][loc][a][0] = vcS;
			vcAll_[m][loc][a][1] = vcI;
			vcAll_[m][loc][a][2] = vcS+vcI;
			//A, B, &C remain zero if their components have any zero denominators
			if ((vcS+vcI) != 0.0) {
				aString levelName="Fst";
				int Flevel = Flevels_[m].Loc(&levelName);
//				FstatsAll_[m][loc][a].Replace(vcS / (vcS+vcI), Flevel);
				FstatsAll_[m][loc][a][Flevel] = vcS / (vcS+vcI);
				}//end if vcS+vcI
			}//a
		//save these in an array for a quicker calculation of the jackknife variance estimates
		sumILoc[loc] = vcI;
		sumSLoc[loc] = vcS;
		sumISLoc[loc] = vcI+vcS;

		Isum += vcI;
		Ssum += vcS;
		ISsum += vcI+vcS;
			
		vcLoc_[m][loc][0] = sumSLoc[loc];
		vcLoc_[m][loc][1] = sumILoc[loc];
		vcLoc_[m][loc][2] = sumISLoc[loc];
		aList<long double>& locFstat = FstatsLoc_[m][loc];
		long double temp = sumISLoc[loc];
		if (sumISLoc[loc] != (long double)0.0) {
			aString levelName="Fst";
			int Flevel = Flevels_[m].Loc(&levelName);
			FstatsLoc_[m][loc][Flevel]=sumSLoc[loc] / sumISLoc[loc];
			}
		}//end for j

	vc_[m][0] = Ssum;
	vc_[m][1] = Isum;
	vc_[m][2] = ISsum;
	if (ISsum != 0.0){
		aString levelName="Fst";
		int Flevel = Flevels_[m].Loc(&levelName);
		Fstats_[m][Flevel] = Ssum/ISsum;
		}//end if ISsum

	//now do the jackknife calculations, over loci
	for (int j=0;j<variableLociDom.len();++j){
		int loc = variableLociDom[j];//the actual locus		
		if (ISsum != sumISLoc[loc]) {
			aString levelName="Fst";
			int Flevel = Flevels_[m].Loc(&levelName);
			jackFstatsLoc_[m][loc][Flevel] = (Ssum-sumSLoc[loc]) / (ISsum - sumISLoc[loc]);
			}//end if 
		}//end for j

	FstatsCurrent_=vcCurrent_=1;
	}//end FstatisticAnalysisDom::DomMarkerFstats






void FstatisticAnalysisDom::HierarchicalDomMarkerFstats(void){}



int  FstatisticAnalysisDom::PrintFMethodHeading(ostream& outFile, const int Fmethod){
	if(Fmethod==domStd){
			outFile<<"Estimators of Wright's F-statistics using dominant markers."<<endl;}
		else if(Fmethod ==hierDom ){
			outFile<<"Estimators of Wright's hierarchical F-statistics using dominant markers."<<endl;}
		else{
			return FstatisticAnalysis::PrintFMethodHeading(outFile,Fmethod);}
	return 1;//no error
	}//end FstatisticAnalysis::PrintFMethodHeading




void  FstatisticAnalysisDom::PrintFStatisticsByLocus(ostream& outFile, const int Fmethod, char colSpacer){
	if(! Fmethod_.Includes((int)Fmethod)){
		aError("ERROR:  the F-method requested hasn't been calculated.");
		return ;}
	int m = Fmethod_.Loc((int) Fmethod);

	int asciiFormat = 1;//default: align columns with font of constant width
	if (colSpacer != ' '){
		asciiFormat = 0;}//separate columns using the spacer supplied

	outFile<<title_<<endl<<endl;
	if(PrintFMethodHeading(outFile, Fmethod)==0){return;}//returns if error found

	aString tableHeadingLine("Locus");
	for(int f0=0;f0<Flevels_[m].len();++f0){
		if(asciiFormat){tableHeadingLine.separator(11*(f0+1)-tableHeadingLine.len(), '\0');}//each 11 characters
			else{tableHeadingLine.cat(colSpacer);}
		tableHeadingLine.cat(Flevels_[m][f0]);
		}
	outFile<<endl<<tableHeadingLine<<endl;
	for(int loc=0;loc<nlociDom;++loc){
		aString line(locusNameDom[loc]); if(asciiFormat){line.separator(8-line.len());}else{line.cat(colSpacer);}
		for(int f1=0;f1<Flevels_[m].len();++f1){
			aString& fword = Flevels_[m][f1];
			double Fval = F(fword, loc, Fmethod);
			if(Fval>=0.0) {line.separator(1);}//space for negative sign
			line.cat(Fval,1,6); if(asciiFormat){line.separator(11*(f1+1)+8-line.len());}else{line.cat(colSpacer);}
			}
		outFile<<line<<endl;
		}//end for loc
	outFile<<endl<<endl;
	}//end FstatisticAnalysisDom::PrintFStatisticsByLocus



void  FstatisticAnalysisDom::PrintFStatisticsByAllele(ostream& outFile, const int Fmethod, char colSpacer){
	if(! Fmethod_.Includes((int)Fmethod)){
		aError("ERROR:  the F-method requested hasn't been calculated.");
		return ;}
	int m = Fmethod_.Loc((int) Fmethod);

	int asciiFormat = 1;//default: align columns with font of constant width
	if (colSpacer != ' '){
		asciiFormat = 0;}//separate columns using the spacer supplied

	outFile<<title_<<endl<<endl;
	if(PrintFMethodHeading(outFile, Fmethod)==0){return;}//returns if error found

	aString tableHeadingLine("Locus");
	for(int f0=0;f0<Flevels_[m].len();++f0){
		if(asciiFormat){tableHeadingLine.separator(11*(f0+1)-tableHeadingLine.len(), '\0');}//each 11 characters
			else{tableHeadingLine.cat(colSpacer);}
		tableHeadingLine.cat(Flevels_[m][f0]);
		}
	outFile<<endl<<tableHeadingLine<<endl;
	for(int loc=0;loc<nlociDom;++loc){
		aString locLine(locusNameDom[loc]);  locLine.cat(":");
		outFile<<locLine<<endl;
		for(int allele=0;allele<GetNumAllelesDom(loc);++allele){  
			aString line(allelesPresentDom[loc][allele]);  
			line.prepend("  ");  if(asciiFormat){line.separator(8-line.len());}else{line.cat(colSpacer);}
			for(int f1=0;f1<Flevels_[m].len();++f1){
				aString& fword = Flevels_[m][f1];
				double Fval = F(fword, loc, allele, Fmethod);
				if(Fval>=0.0) {line.separator(1);}//space for negative sign
				line.cat(Fval,1,6); if(asciiFormat){line.separator(11*(f1+1)+8-line.len());}else{line.cat(colSpacer);}
				}
			outFile<<line<<endl;
			}//end for allele		
		}//end for loc
	outFile<<endl<<endl;
	}//end FstatisticAnalysisDom::PrintFStatisticsByAllele




void FstatisticAnalysisDom::PrintNEXUSFile(aString& outFileName, StringList& textToAppend){
	DominantMarkerData::PrintNEXUSFile(outFileName, textToAppend);
	}//end FstatisticAnalysisDom::PrintNEXUSFile(aString&, StringList&)



void FstatisticAnalysisDom::PrintNEXUSFile (ostream& outFile, StringList& textToAppend){
	DominantMarkerData::PrintNEXUSFile(outFile, textToAppend);
	}//end FstatisticAnalysisDom::PrintNEXUSFile(ostream&,StringList&)




void FstatisticAnalysisDom::ResetFlags(void){
	FstatisticAnalysis::ResetFlags();
	DominantMarkerData::ResetFlags();
	}


FstatisticAnalysisDom& FstatisticAnalysisDom::operator=(PopulationGeneticData& pgd){
	Clear();
	title_=pgd.title_; 
	npop_=pgd.npop_;
	nloci=pgd.nloci;
	maxall=pgd.maxall;
	ngroups=pgd.ngroups;
	variableLoci=pgd.variableLoci;
	popSize=pgd.popSize;
	groupName=pgd.groupName;
	popName=pgd.popName;
	localityName=pgd.localityName;
	rawLocusName=pgd.rawLocusName;
	locusName=pgd.locusName;
	skippedLocusName=pgd.skippedLocusName;
	groupHierarchy=pgd.groupHierarchy;
	popsByLocality=pgd.popsByLocality;
	varLociCurrent_=pgd.varLociCurrent_;
	skippedLocusNum=pgd.skippedLocusNum;
	variableLoci_=pgd.variableLoci_;
	lociSkipped=pgd.lociSkipped;
	rawGtypes=pgd.rawGtypes;
	gtypes=pgd.gtypes;
	allelesCurrent_=pgd.allelesCurrent_;
	allelesPresent=pgd.allelesPresent;
	alleleFreqCurrent_=pgd.alleleFreqCurrent_;
	alleleFreq=pgd.alleleFreq;
	twoN=pgd.twoN;
	HetObsCurrent_=pgd.HetObsCurrent_;
	HetObsByAllele=pgd.HetObsByAllele;
	HetObsByLocus=pgd.HetObsByLocus;
	diseqD=pgd.diseqD;
	locusD=pgd.locusD;

	varLociCurrentDom_=allelesCurrentDom_=phenotypeFreqsCurrent_=0;

	FstatsCurrent_=vcCurrent_=0;
	
	return *this;
	}//FstatisticAnalysisDom::operator=(PopulationGeneticData&)


FstatisticAnalysisDom& FstatisticAnalysisDom::operator=(DominantMarkerData& pgd){
	Clear();
	title_=pgd.title_; 
	npop_=pgd.npop_;
	nloci=pgd.nloci;
	maxall=pgd.maxall;
	ngroups=pgd.ngroups;
	variableLoci=pgd.variableLoci;
	popSize=pgd.popSize;
	groupName=pgd.groupName;
	popName=pgd.popName;
	localityName=pgd.localityName;
	rawLocusName=pgd.rawLocusName;
	locusName=pgd.locusName;
	skippedLocusName=pgd.skippedLocusName;
	groupHierarchy=pgd.groupHierarchy;
	popsByLocality=pgd.popsByLocality;
	varLociCurrent_=pgd.varLociCurrent_;
	skippedLocusNum=pgd.skippedLocusNum;
	variableLoci_=pgd.variableLoci_;
	lociSkipped=pgd.lociSkipped;
	rawGtypes=pgd.rawGtypes;
	gtypes=pgd.gtypes;
	allelesCurrent_=pgd.allelesCurrent_;
	allelesPresent=pgd.allelesPresent;
	alleleFreqCurrent_=pgd.alleleFreqCurrent_;
	alleleFreq=pgd.alleleFreq;
	twoN=pgd.twoN;
	HetObsCurrent_=pgd.HetObsCurrent_;
	HetObsByAllele=pgd.HetObsByAllele;
	HetObsByLocus=pgd.HetObsByLocus;
	diseqD=pgd.diseqD;
	locusD=pgd.locusD;

	nlociDom=pgd.nlociDom;
	variableLociDom=pgd.variableLociDom;
	varLociCurrentDom_=pgd.varLociCurrentDom_;
	rawLocusNameDom=pgd.rawLocusNameDom;
	locusNameDom=pgd.locusNameDom;
	skippedLocusNameDom=pgd.skippedLocusNameDom;
	lociSkippedDom=pgd.lociSkippedDom;
	skippedLocusNumDom=pgd.skippedLocusNumDom;
	rawPhenotypes=pgd.rawPhenotypes;
	phenotypes=pgd.phenotypes;
	allelesCurrentDom_=pgd.allelesCurrentDom_;
	allelesPresentDom=pgd.allelesPresentDom;
	phenotypeFreqsCurrent_=pgd.phenotypeFreqsCurrent_;
	phenotypeFreq=pgd.phenotypeFreq;
	nByLocusDom=pgd.nByLocusDom;

	FstatsCurrent_=vcCurrent_=0;
	
	return *this;
	}//FstatisticAnalysisDom::operator=(DominantMarkerData&)


FstatisticAnalysisDom& FstatisticAnalysisDom::operator=(FstatisticAnalysis& pgd){
	Clear();
	title_=pgd.title_; 
	npop_=pgd.npop_;
	nloci=pgd.nloci;
	maxall=pgd.maxall;
	ngroups=pgd.ngroups;
	variableLoci=pgd.variableLoci;
	popSize=pgd.popSize;
	groupName=pgd.groupName;
	popName=pgd.popName;
	localityName=pgd.localityName;
	rawLocusName=pgd.rawLocusName;
	locusName=pgd.locusName;
	skippedLocusName=pgd.skippedLocusName;
	groupHierarchy=pgd.groupHierarchy;
	popsByLocality=pgd.popsByLocality;
	varLociCurrent_=pgd.varLociCurrent_;
	skippedLocusNum=pgd.skippedLocusNum;
	variableLoci_=pgd.variableLoci_;
	lociSkipped=pgd.lociSkipped;
	rawGtypes=pgd.rawGtypes;
	gtypes=pgd.gtypes;
	allelesCurrent_=pgd.allelesCurrent_;
	allelesPresent=pgd.allelesPresent;
	alleleFreqCurrent_=pgd.alleleFreqCurrent_;
	alleleFreq=pgd.alleleFreq;
	twoN=pgd.twoN;
	HetObsCurrent_=pgd.HetObsCurrent_;
	HetObsByAllele=pgd.HetObsByAllele;
	HetObsByLocus=pgd.HetObsByLocus;
	diseqD=pgd.diseqD;
	locusD=pgd.locusD;

	varLociCurrentDom_=allelesCurrentDom_=phenotypeFreqsCurrent_=0;

	FstatsCurrent_=pgd.FstatsCurrent_;
	Fmethod_=pgd.Fmethod_;
	Flevels_=pgd.Flevels_;
	Fstats_=pgd.Fstats_;
	FstatsLoc_=pgd.FstatsLoc_;
	jackFstatsLoc_=pgd.jackFstatsLoc_;
	FstatsAll_=pgd.FstatsAll_;
	vcCurrent_=pgd.vcCurrent_;
	vcMethod_=pgd.vcMethod_;
	vcLevels_=pgd.vcLevels_;
	vc_=pgd.vc_;
	vcLoc_=pgd.vcLoc_;
	vcAll_=pgd.vcAll_;
	
	return *this;
	}//FstatisticAnalysisDom::operator=(FstatisticAnalysis&)


FstatisticAnalysisDom& FstatisticAnalysisDom::operator=(FstatisticAnalysisDom& pgd){
	Clear();
	title_=pgd.title_; 
	npop_=pgd.npop_;
	nloci=pgd.nloci;
	maxall=pgd.maxall;
	ngroups=pgd.ngroups;
	variableLoci=pgd.variableLoci;
	popSize=pgd.popSize;
	groupName=pgd.groupName;
	popName=pgd.popName;
	localityName=pgd.localityName;
	rawLocusName=pgd.rawLocusName;
	locusName=pgd.locusName;
	skippedLocusName=pgd.skippedLocusName;
	groupHierarchy=pgd.groupHierarchy;
	popsByLocality=pgd.popsByLocality;
	varLociCurrent_=pgd.varLociCurrent_;
	skippedLocusNum=pgd.skippedLocusNum;
	variableLoci_=pgd.variableLoci_;
	lociSkipped=pgd.lociSkipped;
	rawGtypes=pgd.rawGtypes;
	gtypes=pgd.gtypes;
	allelesCurrent_=pgd.allelesCurrent_;
	allelesPresent=pgd.allelesPresent;
	alleleFreqCurrent_=pgd.alleleFreqCurrent_;
	alleleFreq=pgd.alleleFreq;
	twoN=pgd.twoN;
	HetObsCurrent_=pgd.HetObsCurrent_;
	HetObsByAllele=pgd.HetObsByAllele;
	HetObsByLocus=pgd.HetObsByLocus;
	diseqD=pgd.diseqD;
	locusD=pgd.locusD;

	nlociDom=pgd.nlociDom;
	variableLociDom=pgd.variableLociDom;
	varLociCurrentDom_=pgd.varLociCurrentDom_;
	rawLocusNameDom=pgd.rawLocusNameDom;
	locusNameDom=pgd.locusNameDom;
	skippedLocusNameDom=pgd.skippedLocusNameDom;
	lociSkippedDom=pgd.lociSkippedDom;
	skippedLocusNumDom=pgd.skippedLocusNumDom;
	rawPhenotypes=pgd.rawPhenotypes;
	phenotypes=pgd.phenotypes;
	allelesCurrentDom_=pgd.allelesCurrentDom_;
	allelesPresentDom=pgd.allelesPresentDom;
	phenotypeFreqsCurrent_=pgd.phenotypeFreqsCurrent_;
	phenotypeFreq=pgd.phenotypeFreq;
	nByLocusDom=pgd.nByLocusDom;

	FstatsCurrent_=pgd.FstatsCurrent_;
	Fmethod_=pgd.Fmethod_;
	Flevels_=pgd.Flevels_;
	Fstats_=pgd.Fstats_;
	FstatsLoc_=pgd.FstatsLoc_;
	jackFstatsLoc_=pgd.jackFstatsLoc_;
	FstatsAll_=pgd.FstatsAll_;
	vcCurrent_=pgd.vcCurrent_;
	vcMethod_=pgd.vcMethod_;
	vcLevels_=pgd.vcLevels_;
	vc_=pgd.vc_;
	vcLoc_=pgd.vcLoc_;
	vcAll_=pgd.vcAll_;
	
	return *this;
	}//FstatisticAnalysisDom::operator=(FstatisticAnalysisDom&)


#endif
