//SexLinkedData.cpp

#ifndef SexLinkedDatacpp
#define SexLinkedDatacpp = 1

#include "SexLinkedData.h"
#include "Element.cpp"
#include "aList.cpp"
//#include "TextDataList.cpp"
#include "StatList.cpp"
#include "aVector.cpp"
#include "aMatrix.cpp"
//#include "MatrixList.cpp"
//#include "PartitionedMatrix.cpp"




void  SexLinkedData::Initialize(void){
	Clear();
	}//Initialize()
	
	
void  SexLinkedData::Initialize(aString& s){
	Clear();
	EvolutionaryGeneticsData::Initialize(s); 
	}//SexLinkedData::Initialize(aString&)
	
	
void  SexLinkedData::Initialize(SexLinkedData& cmd){
	EvolutionaryGeneticsData::Initialize(cmd); 
	heterogameticSex_=cmd.heterogameticSex_;
	sexTrait_=cmd.sexTrait_;
	primarySexRatio_=cmd.primarySexRatio_;
	heterogameticIndivs_=cmd.heterogameticIndivs_;
	homogameticIndivs_=cmd.homogameticIndivs_;
	Nheterogametic_=cmd.Nheterogametic_;
	Nhomogametic_=cmd.Nhomogametic_;
	sortedBySex_=cmd.sortedBySex_;
	}//Initialize(SexLinkedData& )
	
	
	
void  SexLinkedData::Initialize(SexLinkedData& parentData, aList<int>& popSubsetNums){
	Clear();
	EvolutionaryGeneticsData::Initialize(parentData,popSubsetNums);
	heterogameticSex_=parentData.heterogameticSex_;
	sexTrait_=parentData.sexTrait_;
	primarySexRatio_=parentData.primarySexRatio_;
	Nheterogametic_=Nhomogametic_=0;
	for(int p=0;p<popSubsetNums.len();++p){
		int pp = popSubsetNums[p];//population num in parentData
		heterogameticIndivs_.Append(parentData.heterogameticIndivs_[pp].Duplicate());
		homogameticIndivs_.Append(parentData.homogameticIndivs_[pp].Duplicate());
		Nheterogametic_ += parentData.heterogameticIndivs_[pp].len();
		Nhomogametic_ += parentData.homogameticIndivs_[pp].len();
		}//end for p
	sortedBySex_=false;
	if(Nheterogametic_+Nhomogametic_>0){
		sortedBySex_=true;}
	}//SexLinkedData::Initialize(SexLinkedData&, aList<int>&)


	
	
	
SexLinkedData&  SexLinkedData::operator=(SexLinkedData& cmd){
	EvolutionaryGeneticsData::operator=(cmd); 
	heterogameticSex_=cmd.heterogameticSex_;
	sexTrait_=cmd.sexTrait_;
	primarySexRatio_=cmd.primarySexRatio_;
	heterogameticIndivs_=cmd.heterogameticIndivs_;
	homogameticIndivs_=cmd.homogameticIndivs_;
	Nheterogametic_=cmd.Nheterogametic_;
	Nhomogametic_=cmd.Nhomogametic_;
	sortedBySex_=cmd.sortedBySex_;
	return *this;
	}//operator=(SexLinkedData&)



void SexLinkedData::CullToOneGroup (EvolutionaryGeneticsData& parentData,int groupNum){
	//makes a subset data structure from the specified group
	//individuals resampled
	EvolutionaryGeneticsData::CullToOneGroup(parentData,groupNum);
	SortBySex();
	}//end SexLinkedData::CullToOneGroup (EvolutionaryGeneticsData&, int)



void SexLinkedData::CullToOneSex (SexLinkedData& parentData,genderSet sexVal){
	aList<int> sexValList;
	sexValList.Append((int)sexVal);
	CullToTheseSexes(parentData,sexValList);
	}//SexLinkedData::CullToOneSex(SexLinkedData&,genderSet){
	
	
	
void SexLinkedData::CullToTheseSexes (SexLinkedData& parentData,aList<int>& sexValList){
	//makes a subset data structure from the specified sex
	Clear();
	if(sexValList.len()==0) return;
	title_ = parentData.title_;
	title_.cat(" -- ");
	for(int s=0;s<sexValList.len();++s){
		genderSet sexVal = (genderSet) sexValList[s];
		switch(sexVal){
			case A:
				title_.cat("asexuals"); break;
			case B:
				title_.cat("hermaphrodites"); break;
			case F:
				title_.cat("females"); break;
			case M:
				title_.cat("males"); break;
			default: break;
			}
		if(s<sexValList.len()-2){
				title_.cat(", ");}
			else if (s == sexValList.len()-2){
				title_.cat(" & ");}
			else{}
		}
	title_.cat(" only");


	npop_ = parentData.npop_;
	ngroups_ = parentData.ngroups_;
	ntraits_ = parentData.ntraits_;
	groupName_ = parentData.groupName_;
	localityName_ = parentData.localityName_;
	traitName_ = parentData.traitName_;
	traitNum_ = parentData.traitNum_;
	skippedTraitNum_ = parentData.skippedTraitNum_;
	missing_ = parentData.missing_;
	popName_ = parentData.popName_;
	localityCoordinates_ = parentData.localityCoordinates_;
	missing_ = parentData.missing_;
	
	heterogameticSex_ = parentData.heterogameticSex_;
	sexTrait_ = parentData.sexTrait_;
	primarySexRatio_ = parentData.primarySexRatio_;
	
	genderSet thisSexVal=B;
	int pop, i, thisSexValInt;
	for(pop=0;pop<parentData.npop_;++pop){
		popSize_.Append(0);
		rawTraits_.Append(NEW ObjList<TextDataList>());
		for(i=0;i<parentData.popSize(pop);++i){
			TextDatum& thisSex = parentData.rawTraits_[pop][i][sexTrait_];
			thisSexVal = genderCode(thisSex);
			thisSexValInt = (int)thisSexVal;
			if(sexValList.Includes(thisSexValInt)){
				rawTraits_[pop].Append((TextDataList*)parentData.rawTraits_[pop][i].Duplicate());
				popSize_[pop]++;}
			}//i
		}//pop
	
	//cull empty populations from data
	for(pop=npop_-1;pop>=0;--pop){
		if(parentData.rawTraits_[pop].len()==0){
			parentData.rawTraits_.Delete(pop);
			popName_.Delete(pop);
			popSize_.Delete(pop);
			}
		}//pop
	npop_ = rawTraits_.len();
		
	ResetFlags();
	GroupMembership();
	LocalityMembership();
	}//end SexLinkedData::CullToTheseSexes (SexLinkedData&, aList<int>&)



void SexLinkedData::GetGenome(GeneContainerCore& gc, int pop, int indiv, bool setID){
	//uploads data to MultiInheritanceModeContainer<int>[locus]
	MultiInheritanceModeContainer<int>* mimc = (MultiInheritanceModeContainer<int>*) &gc;
	if(setID){
		mimc->SetID(1+GetIndivNumInDataSequence(pop,indiv));}
	TextDatum& sexValStr = rawTraits_[pop][indiv][sexTrait_];
	char sxval = sexValStr[0];
	mimc->SetSex(sxval);
	}//SexLinkedData::GetGenome(GeneContainerCore&, int, int)



bool SexLinkedData::heterogametic(int pop, int indiv){
	if(rawTraits_[pop][indiv][sexTrait_] == heterogameticSex_){
		return true;}
	return false;
	}//SexLinkedData::heterogametic(int, int)


long double SexLinkedData::PloidyEffective(void){
	long double sr = primarySexRatio();
	if(heterogameticSex_==M){//take the complement for calculation purposes
		sr = (long double)1.0 - sr;}
	long double pp=ploidy();//returns autosomal ploidy
	return sr*pp + ((long double)1.0 - sr)*(pp/(long double)2.0);
	}// SexLinkedData::PloidyEffective()


void SexLinkedData::SetGenome(GeneContainerCore& gc, int pop, int indiv){
	//records data from MultiInheritanceModeContainer<int>
	//assumes blank data records already created in EvolutionaryGeneticsData
	MultiInheritanceModeContainer<int>* mimc = (MultiInheritanceModeContainer<int>*) &gc;
	ResetFlags();
	rawTraits_[pop][indiv][0] = mimc->ID();
	genderSet sexVal = mimc->sex_;
	if(sexVal == (genderSet)M){
			rawTraits_[pop][indiv][sexTrait_] = "M";}
		else{		
			rawTraits_[pop][indiv][sexTrait_] = "F";}
	}//SexLinkedData::SetGenome(GeneContainerCore&, int, int)



void SexLinkedData::SetHeterogametic(char hetChar){
	if(hetChar == '\0' || (const static char)hetChar == M || (const static char) hetChar == F){
		heterogameticSex_ = hetChar;
		return;}
	aString err("ERROR: can\'t set the heterogametic to ");
	err+hetChar+"; use M or F only";
	aError(err);
	}//SexLinkedData::SetHeterogametic(char)



int SexLinkedData::SetSexTrait(void){//the trait that contains sex information
	//returns 0 if successful, error code 1 otherwise
	aString sex("sex"), SEX("SEX"), Sex("Sex");//spellings
	sexTrait_=-1;
	for(int tr=0;tr<traitName_.len();++tr){
		aString& trname = traitName_[tr];
		if(trname==sex || trname == SEX || trname==Sex){
			sexTrait_=tr;
			return 0;}
		}//tr
	//get here only if no sex trait found
	aString err("ERROR: no sex character found.  To analyze sex-linked data, you need to specify the sex of each individual ");
	err+"in a separate data column.  Label the column \'sex\' and label the sexes \'F\' and \'M\'.";
	aError(err);
	return 1;
	}//SexLinkedData::SetSexTrait()




void SexLinkedData::SortBySex(void){
	if(sortedBySex_==true) return;
	heterogameticIndivs_.Clear();
	homogameticIndivs_.Clear();
	int pop, i;
	Nheterogametic_=Nhomogametic_=0;
	for(pop=0;pop<npop_;++pop){
		heterogameticIndivs_.Append(NEW aList<int>());
		homogameticIndivs_.Append(NEW aList<int>());
		for(i=0;i<individuals(pop);++i){
			if(heterogametic(pop,i)){
					heterogameticIndivs_[pop].Append(i);
					++Nheterogametic_;}
				else{
					homogameticIndivs_[pop].Append(i);
					++Nhomogametic_;}
			}	}
	sortedBySex_=true;
	}//SexLinkedData::SortBySex()


#endif
