//unit SexLinkedDomMarkerData2.cpp

#ifndef SexLinkedDomMarkerData2cpp
#define SexLinkedDomMarkerData2cpp = 1

#include "SexLinkedDomMarkerData2.h"
#include "SexLinkedCodomMarkerData.h"
#include "Element.cpp"
#include "aList.cpp"
#include "SortList.cpp"




SexLinkedDomMarkerData2::SexLinkedDomMarkerData2(SexLinkedDomMarkerData2& parentData):
			SexLinkedData(parentData),
			nlociSLDom_(parentData.nlociSLDom_),
			ploidy_(parentData.ploidy_),
			alleleLen_(parentData.alleleLen_),
			allSLDomLoci_(parentData.allSLDomLoci_),
			locusNumSLDom_(parentData.locusNumSLDom_),
			skippedLocusNumSLDom_(parentData.skippedLocusNumSLDom_),
			variableLocusNumSLDom_(parentData.variableLocusNumSLDom_), 
			allelesPresentSLDom_(parentData.allelesPresentSLDom_),

			phenotypeCountSLDom_(parentData.phenotypeCountSLDom_),
			phenotypeCountSLDomGlobal_(parentData.phenotypeCountSLDomGlobal_),
			phenotypeCountSLHeterogametic_(parentData.phenotypeCountSLHeterogametic_),
			phenotypeCountSLHeterogameticGlobal_(parentData.phenotypeCountSLHeterogameticGlobal_),
			phenotypeCountSLHomogametic_(parentData.phenotypeCountSLHomogametic_),
			phenotypeCountSLHomogameticGlobal_(parentData.phenotypeCountSLHomogameticGlobal_),

			phenotypeFreqSLDom_(parentData.phenotypeFreqSLDom_),
			phenotypeFreqSLDomGlobal_(parentData.phenotypeFreqSLDomGlobal_),
			phenotypeFreqSLHeterogametic_(parentData.phenotypeFreqSLHeterogametic_),
			phenotypeFreqSLHomogametic_(parentData.phenotypeFreqSLHomogametic_),
			phenotypeFreqSLHeterogameticGlobal_(parentData.phenotypeFreqSLHeterogameticGlobal_),
			phenotypeFreqSLHomogameticGlobal_(parentData.phenotypeFreqSLHomogameticGlobal_),
			nByLocusSLDom_(parentData.nByLocusSLDom_),
			allelesCurrentSLDom_(parentData.allelesCurrentSLDom_),
			varLociCurrentSLDom_(parentData.varLociCurrentSLDom_),
			phenotypeFreqsCurrentSLDom_(parentData.phenotypeFreqsCurrentSLDom_)
			{	
		}//end ctor SexLinkedDomMarkerData2(SexLinkedDomMarkerData2&)


SexLinkedDomMarkerData2::SexLinkedDomMarkerData2(SexLinkedDomMarkerData2& parentData, 
						aList<int>& popSubsetNums):
			nlociSLDom_(parentData.nlociSLDom_),
			ploidy_(parentData.ploidy_),
			alleleLen_(parentData.alleleLen_),
			allSLDomLoci_(parentData.allSLDomLoci_),
			locusNumSLDom_(parentData.locusNumSLDom_),
			skippedLocusNumSLDom_(parentData.skippedLocusNumSLDom_)
			{
	//makes a copy of the original data using a subset of populations
	//useful for separate analyses of data subsets
	Initialize(parentData,popSubsetNums);
	title_.prepend("subset of dataset: ");
	ResetFlags();
	SortBySex();
	CheckForNewAlleles();
	UpdateVariableLociDom();
	}//end ctor SexLinkedDomMarkerData2(SexLinkedDomMarkerData2&, aList<int>&)


void  SexLinkedDomMarkerData2::Initialize(void){
	SexLinkedDomMarkerData2::Clear();
	}//Initialize()
	
	
void  SexLinkedDomMarkerData2::Initialize(aString& s){
	SexLinkedDomMarkerData2::Clear();
	title_=s; 
	}//Initialize(aString&)
	
	
void  SexLinkedDomMarkerData2::Initialize(SexLinkedDomMarkerData2& dmd){
	SexLinkedData::Initialize(dmd);
	nlociSLDom_=dmd.nlociSLDom_;
	ploidy_=dmd.ploidy_;
	alleleLen_=dmd.alleleLen_;
	allSLDomLoci_=dmd.allSLDomLoci_;
	locusNumSLDom_=dmd.locusNumSLDom_; 
	skippedLocusNumSLDom_=dmd.skippedLocusNumSLDom_;
	variableLocusNumSLDom_=dmd.variableLocusNumSLDom_;
	allelesPresentSLDom_=dmd.allelesPresentSLDom_;

	phenotypeCountSLDom_=dmd.phenotypeCountSLDom_;
	phenotypeCountSLDomGlobal_=dmd.phenotypeCountSLDomGlobal_;
	phenotypeCountSLHeterogametic_=dmd.phenotypeCountSLHeterogametic_;
	phenotypeCountSLHomogametic_=dmd.phenotypeCountSLHomogametic_;
	phenotypeCountSLHeterogameticGlobal_=dmd.phenotypeCountSLHeterogameticGlobal_;
	phenotypeCountSLHomogameticGlobal_=dmd.phenotypeCountSLHomogameticGlobal_;

	phenotypeFreqSLDom_=dmd.phenotypeFreqSLDom_;
	phenotypeFreqSLDomGlobal_=dmd.phenotypeFreqSLDomGlobal_;
	phenotypeFreqSLHeterogametic_=dmd.phenotypeFreqSLHeterogametic_;
	phenotypeFreqSLHomogametic_=dmd.phenotypeFreqSLHomogametic_;
	phenotypeFreqSLHeterogameticGlobal_=dmd.phenotypeFreqSLHeterogameticGlobal_;
	phenotypeFreqSLHomogameticGlobal_=dmd.phenotypeFreqSLHomogameticGlobal_;

	nByLocusSLDom_=dmd.nByLocusSLDom_;
	nByLocusSLHeterogametic_=dmd.nByLocusSLHeterogametic_;
	nByLocusSLHomogametic_=dmd.nByLocusSLHomogametic_;
	allelesCurrentSLDom_=dmd.allelesCurrentSLDom_;
	varLociCurrentSLDom_=dmd.varLociCurrentSLDom_;
	phenotypeFreqsCurrentSLDom_=dmd.phenotypeFreqsCurrentSLDom_;
	}//Initialize(SexLinkedDomMarkerData2&)
	

void  SexLinkedDomMarkerData2::Initialize(SexLinkedDomMarkerData2& parentData, aList<int>& popSubsetNums){
	SexLinkedData::Initialize(parentData,popSubsetNums);
	nlociSLDom_=parentData.nlociSLDom_;
	ploidy_=parentData.ploidy_;
	alleleLen_=parentData.alleleLen_;
	allSLDomLoci_=parentData.allSLDomLoci_;
	locusNumSLDom_=parentData.locusNumSLDom_;
	skippedLocusNumSLDom_=parentData.skippedLocusNumSLDom_;
	SortBySex();
	CheckForNewAlleles();
	UpdateVariableLociDom();
	}//end Initialize(SexLinkedDomMarkerData2&, aList<int>&)


	
SexLinkedDomMarkerData2&  SexLinkedDomMarkerData2::operator=(SexLinkedDomMarkerData2& dmd){
	Initialize(dmd);
	return *this;
	}//operator=(SexLinkedDomMarkerData2&)




void SexLinkedDomMarkerData2::CalculatePhenotypeFreqs (void){
	//This routine counts marker frequencies, taking into account
	//markers left blank in the data set.
	if (phenotypeFreqsCurrentSLDom_){return;}
	SortBySex();
	CheckForNewAlleles();
	long pop, i, loc, marker;
	long double freq;
//	char blank = ' ', tab='\t';	//don't count these
	aString missingDataFlags = ".?-*";//characters used to signify missing data
	aString endCharList = " \t,";//characters used to separate data fields
	phenotypeCountSLDom_.Clear();
	phenotypeCountSLHeterogametic_.Clear();
	phenotypeCountSLHomogametic_.Clear();
	phenotypeFreqSLDom_.Clear();
	phenotypeFreqSLHeterogametic_.Clear();
	phenotypeFreqSLHomogametic_.Clear();
	nByLocusSLDom_.Clear();
	nByLocusSLHeterogametic_.Clear();
	nByLocusSLHomogametic_.Clear();
	for (pop=0;pop< npop_;++pop){ 
		//set up a frequency list for this population
		phenotypeCountSLDom_.Append( NEW ObjList<aList<int> >());
		phenotypeCountSLHeterogametic_.Append( NEW ObjList<aList<int> >());
		phenotypeCountSLHomogametic_.Append( NEW ObjList<aList<int> >());
		phenotypeFreqSLDom_.Append( NEW ObjList<aList<long double> >());
		phenotypeFreqSLHeterogametic_.Append( NEW ObjList<aList<long double> >());
		phenotypeFreqSLHomogametic_.Append( NEW ObjList<aList<long double> >());
		nByLocusSLDom_.Append(NEW aList<int>());
		nByLocusSLHeterogametic_.Append(NEW aList<int>());
		nByLocusSLHomogametic_.Append(NEW aList<int>());
		for (loc=0;loc<nlociSLDom_;++loc){//loops through dominant loci
			//first set up a blank array of frequencies for each possible phenotype
			phenotypeCountSLDom_[pop].Append(NEW aList<int>());
			phenotypeCountSLHeterogametic_[pop].Append(NEW aList<int>());
			phenotypeCountSLHomogametic_[pop].Append(NEW aList<int>());
			phenotypeFreqSLDom_[pop].Append(NEW aList<long double>());
			phenotypeFreqSLHeterogametic_[pop].Append(NEW aList<long double>());
			phenotypeFreqSLHomogametic_[pop].Append(NEW aList<long double>());
			StringList& markerNamesList = allelesPresentSLDom_[loc];
			freq = (long double) 0.0;
			for (marker=0;marker<markerNamesList.len();++marker){//initialize
				phenotypeCountSLDom_[pop][loc].Append(0);
				phenotypeCountSLHeterogametic_[pop][loc].Append(0);
				phenotypeCountSLHomogametic_[pop][loc].Append(0);
				phenotypeFreqSLDom_[pop][loc].Append(freq);
				phenotypeFreqSLHeterogametic_[pop][loc].Append(freq);
				phenotypeFreqSLHomogametic_[pop][loc].Append(freq);
				}

			//next look at the phenotype of each individual and tally the frequency
			long nSampled=0, nSampledHet=0, nSampledHom=0;	//the number of individuals
			ObjList<TextDataList>& phenotypesList = rawTraits_[pop];
			for (i=0;i< phenotypesList.len();++i){
				TextDatum& phene = phenotypesList[i][locusNumSLDom_[loc]];
				if (phene.OK()) {//if not, it's missing data
					//increment the frequency & sample size -- divide later
					marker = markerNamesList.Loc(&phene);
					phenotypeCountSLDom_[pop][loc][marker]++;
					phenotypeFreqSLDom_[pop][loc][marker]++;
					nSampled++;
					if(heterogametic(pop,i)){
							phenotypeCountSLHeterogametic_[pop][loc][marker]++;
							phenotypeFreqSLHeterogametic_[pop][loc][marker]++;
							nSampledHet++;}
						else{//homogametic
							phenotypeCountSLHomogametic_[pop][loc][marker]++;
							phenotypeFreqSLHomogametic_[pop][loc][marker]++;
							nSampledHom++;}
					}//end if legal data
				}//end for i


			//now go through and divide by the sample size to restore the frequencies
			if(nSampled>0){
				for (marker=0;marker<markerNamesList.len();++marker){
					phenotypeFreqSLDom_[pop][loc][marker] /= (long double) nSampled;
					}}
			if(nSampledHet>0){
				for (marker=0;marker<markerNamesList.len();++marker){
					phenotypeFreqSLHeterogametic_[pop][loc][marker] /= (long double) nSampledHet;
					}}
			if(nSampledHom>0){
				for (marker=0;marker<markerNamesList.len();++marker){
					phenotypeFreqSLHomogametic_[pop][loc][marker] /= (long double) nSampledHom;
					}}
			//store the sample size for this locus
			nByLocusSLDom_[pop].Append((int)nSampled);
			nByLocusSLHeterogametic_[pop].Append((int)nSampledHet);
			nByLocusSLHomogametic_[pop].Append((int)nSampledHom);
			}//end for loc
		}//end for pop
	phenotypeCountSLDomGlobal_.Clear();
	phenotypeCountSLHeterogameticGlobal_.Clear();
	phenotypeCountSLHomogameticGlobal_.Clear();
	phenotypeFreqSLDomGlobal_.Clear();
	phenotypeFreqSLHeterogameticGlobal_.Clear();
	phenotypeFreqSLHomogameticGlobal_.Clear();
	int summ=0;
	for(loc=0;loc<nlociSLDom_;++loc){
		phenotypeCountSLDomGlobal_.Append(NEW aList<int>());
		phenotypeCountSLHeterogameticGlobal_.Append(NEW aList<int>());
		phenotypeCountSLHomogameticGlobal_.Append(NEW aList<int>());
		phenotypeFreqSLDomGlobal_.Append(NEW aList<long double>());
		phenotypeFreqSLHeterogameticGlobal_.Append(NEW aList<long double>());
		phenotypeFreqSLHomogameticGlobal_.Append(NEW aList<long double>());
		for(marker=0;marker<allelesPresentSLDom_[loc].len();++marker){
			freq=(long double)0.0;summ=0;
			for(pop=0;pop<npop_;++pop){
				summ += phenotypeCountSLDom_[pop][loc][marker];
				freq += phenotypeFreqSLDom_[pop][loc][marker];
				}
			phenotypeCountSLDomGlobal_[loc].Append(summ);
			phenotypeFreqSLDomGlobal_[loc].Append(freq/(long double)npop_);

			freq=(long double)0.0;summ=0;
			for(pop=0;pop<npop_;++pop){
				summ += phenotypeCountSLHeterogametic_[pop][loc][marker];
				freq += phenotypeFreqSLHeterogametic_[pop][loc][marker];
				}
			phenotypeCountSLHeterogameticGlobal_[loc].Append(summ);
			phenotypeFreqSLHeterogameticGlobal_[loc].Append(freq/(long double)npop_);

			freq=(long double)0.0;summ=0;
			for(pop=0;pop<npop_;++pop){
				summ += phenotypeCountSLHomogametic_[pop][loc][marker];
				freq += phenotypeFreqSLHomogametic_[pop][loc][marker];
				}
			phenotypeCountSLHomogameticGlobal_[loc].Append(summ);
			phenotypeFreqSLHomogameticGlobal_[loc].Append(freq/(long double)npop_);
			}}		
	phenotypeFreqsCurrentSLDom_=1;
	}//end SexLinkedDomMarkerData2::CalculatePhenotypeFreqs



ObjList<aList<long double> >* SexLinkedDomMarkerData2::CalculatePhenotypeFreqsByPopSet(aList<int>& popSet, aList<long double>& nList){
 	//returns list of loci, each with list of marker freqs, using total marker set
 	CalculatePhenotypeFreqs();
 	nList.Clear();
 	ObjList<aList<long double> >* popSetFreqsPtr = NEW ObjList<aList<long double> >(phenotypeFreqSLDom_[0]);//copies structure
 	ObjList<aList<long double> >& popSetFreqs = *popSetFreqsPtr;//notational convenience
 	for(int loc=0;loc<nlociSLDom_;++loc){
 		int markers = GetNumAllelesDom(loc);
 		long double samSizeSet = (long double) 0.0;
 		for(int m=0;m<markers;++m){
 			long double nCopies = (long double) 0.0;
 			for(int popSetPop=0;popSetPop<popSet.len();++popSetPop){
 				int pop = popSet[popSetPop];
 				long double nSample = (long double) (nByLocusSLDom_[pop][loc]);
 				if(m==0){samSizeSet += nSample;}
 				nCopies += nSample * GetFreqDom(pop,loc,m);
 				}
 			if(m==0){nList.Append(samSizeSet);}
 			if(nCopies==0.0){
 					popSetFreqs[loc][m]=(long double) 0.0;}
 				else if(nCopies==samSizeSet){
 					popSetFreqs[loc][m]=(long double) 1.0;}
 				else{
 					popSetFreqs[loc][m] = nCopies / samSizeSet;
 					}
 			}//end for m
 		}//end for loc
 	return popSetFreqsPtr;
	}//end SexLinkedDomMarkerData2::CalculateAlleleFreqsByPopSet



void SexLinkedDomMarkerData2::CheckForNewAlleles (void){
	if (allelesCurrentSLDom_){return;}
	allelesPresentSLDom_.Clear();
	for (int loc=0;loc<nlociSLDom_;++loc){//initialize
		allelesPresentSLDom_.Append(NEW StringList());}
	for (int pop=0;pop<npop_;++pop){
		ObjList<TextDataList>& ptypeList = rawTraits_[pop];
		for(int i=0;i<ptypeList.len();++i){
			for (int loc=0;loc<nlociSLDom_;++loc){
				TextDatum& phene = ptypeList[i][locusNumSLDom_[loc]];
				if(phene.OK()){//ignore missing data
					StringList& alleleList = allelesPresentSLDom_[loc];
					if(!(alleleList.Includes(&phene))){
						alleleList.Append(NEW aString(phene));}
					}//OK
				}//end for loc
			}//end for i
		}//end for pop
	for (int loc=0;loc<nlociSLDom_;++loc){
		allelesPresentSLDom_[loc].Sort();}
	allelesCurrentSLDom_=true;
	SexLinkedDomMarkerData2::UpdateVariableLociDom();
	}//end SexLinkedDomMarkerData2::CheckForNewAlleles



void SexLinkedDomMarkerData2::Clear(void){
	EvolutionaryGeneticsData::Clear();
	allSLDomLoci_.Clear();
	locusNumSLDom_.Clear();
	skippedLocusNumSLDom_.Clear();
	variableLocusNumSLDom_.Clear();
	heterogameticIndivs_.Clear();
	homogameticIndivs_.Clear();
	allelesPresentSLDom_.Clear();
	phenotypeCountSLDom_.Clear();
	phenotypeCountSLHeterogametic_.Clear();
	phenotypeCountSLHomogametic_.Clear();
	phenotypeCountSLDomGlobal_.Clear();
	phenotypeCountSLHeterogameticGlobal_.Clear();
	phenotypeCountSLHomogameticGlobal_.Clear();

	phenotypeFreqSLDom_.Clear();
	phenotypeFreqSLHeterogametic_.Clear();
	phenotypeFreqSLHomogametic_.Clear();
	phenotypeFreqSLDomGlobal_.Clear();
	phenotypeFreqSLHeterogameticGlobal_.Clear();
	phenotypeFreqSLHomogameticGlobal_.Clear();
	nByLocusSLDom_.Clear();
	nByLocusSLHeterogametic_.Clear();
	nByLocusSLHomogametic_.Clear();
	nlociSLDom_=allelesCurrentSLDom_=varLociCurrentSLDom_=phenotypeFreqsCurrentSLDom_=0;
	}//end SexLinkedDomMarkerData2::Clear()




void SexLinkedDomMarkerData2::ConvertCodominantData(SexLinkedCodomMarkerData& codomData){
	//converts extant codominant data into dominant marker phenotypes; skipped loci omitted
	//first allele is recessive to second allele; missing data treated as unscored
	//don't let codomData be part of the same data object in derived classes
	codomData.CheckForNewAlleles();	
	int cloc;
	bool tooManyAlleles=false;
	for(cloc=0;cloc<codomData.nlociSLCodom_;++cloc){
		if(codomData.allelesPresentSLCodom_[cloc].len() >2){
			tooManyAlleles=true; break;}}
	if(tooManyAlleles){
		aError("ERROR: SexLinkedDomMarkerData2::ConvertCodominantData only works when there are 1-2 allele copies/locus in the data");
		return;}
	Clear();
	title_=codomData.title_ + "--converted from codominant data";
	npop_=codomData.npop_;
	ngroups_=codomData.ngroups_;
	popSize_=codomData.popSize_;
	popName_=codomData.popName_;
	groupName_=codomData.groupName_;
	localityName_=codomData.localityName_;
	groupHierarchy_=codomData.groupHierarchy_;
	popsByLocality_=codomData.popsByLocality_;
	localityCoordinates_=codomData.localityCoordinates_;
	ploidy_=codomData.ploidy_;
	alleleLen_=codomData.alleleLen_;
	heterogameticSex_=codomData.heterogameticSex_;
	sexTrait_=codomData.sexTrait_;
	nlociSLDom_ = codomData.nlociSLCodom_;
	ntraits_ = codomData.ntraits_;
	int pop,i,p;
	traitName_.Append(NEW aString(codomData.traitName_[0]));//ID
	traitName_.Append(NEW aString(codomData.traitName_[codomData.sexTrait_]));//ID
	traitNum_.Append(0);
	traitNum_.Append(1);
	for(cloc=0;cloc<codomData.nlociSLCodom_;++cloc){
		traitName_.Append(NEW aString(codomData.traitName_[codomData.locusNumSLCodom_[cloc]]));
		traitNum_.Append(cloc+2);
//		locusNumSLDom_.Append(cloc);//last one created
		locusNumSLDom_.Append(cloc+2);//last one created
		allSLDomLoci_.Append(cloc+2);//ID & sexTrait_ & last one created
		}
	for(pop=0;pop<npop_;++pop){
		rawTraits_.Append(NEW ObjList<TextDataList>());//{0,1} presence-absence data as read from data file
		nByLocusSLDom_.Append(NEW aList<int>());
		for(int loc=0;loc<nlociSLDom_;++loc){
			nByLocusSLDom_[pop].Append(0);}//initialize		
		for(i=0;i<codomData.individuals(pop);++i){
			rawTraits_[pop].Append(NEW TextDataList());
			rawTraits_[pop][i].Append(NEW TextDatum(codomData.Trait(pop,i,0)));//ID code
			rawTraits_[pop][i].Append(NEW TextDatum(codomData.Trait(pop,i,sexTrait_)));//ID code
			for(cloc=0;cloc<codomData.nlociSLCodom_;++cloc){
//				TextDataList codomGenes(codomData.rawSLCodomGtypes_[pop][i][codomData.locusNumSLCodom_[cloc]]);//a copy
				TextDataList codomGenes(codomData.rawSLCodomGtypes_[pop][i][cloc]);//a copy
				bool missingflag=false;
				for(p=0;p<codomData.ploidy(pop,i);++p){
					if(codomGenes[p].missing()){missingflag=true;break;}}
				if(missingflag){//treat as unscored data
					rawTraits_[pop][i].Append(NEW TextDatum());//store as missing
					continue;
					}
				codomGenes.Sort();//to order of codomData.allelesPresent_
				bool recessive=true;
				for(p=0;p<codomGenes.len();++p){//ploidy of this individual at this locus
					if(codomGenes[p] != codomData.allelesPresentSLCodom_[cloc][0]){//recessive allele A present
						recessive=false;
						break;
						}}
				if (recessive){
						rawTraits_[pop][i].Append(NEW TextDatum("0"));}
					else {
						rawTraits_[pop][i].Append(NEW TextDatum("1"));}
				nByLocusSLDom_[pop][cloc]++;
				}//end for cloc
			}//end for i
		}//end for pop
	CheckForNewAlleles();	
	}//end SexLinkedDomMarkerData2::ConvertCodominantData()



void  SexLinkedDomMarkerData2::CreateBootstrapData(SexLinkedDomMarkerData2& origData, Ran3& ran){
	EvolutionaryGeneticsData::CreateBootstrapData(origData,ran);
	SortBySex();
	CheckForNewAlleles();	
	}//end  SexLinkedDomMarkerData2::CreateBootstrapData(EvolutionaryGeneticsData&)



void  SexLinkedDomMarkerData2::CreateBootstrapDataConstPop(SexLinkedDomMarkerData2& origData, Ran3& ran){
	EvolutionaryGeneticsData::CreateBootstrapDataConstPop(origData,ran);
	SortBySex();
	CheckForNewAlleles();	
	}//end  SexLinkedDomMarkerData2::CreateBootstrapDataConstPop(EvolutionaryGeneticsData&)




void SexLinkedDomMarkerData2::CreateRandomData(
							const long double Fst, 
							const long double Fis,
							const long double betaBar, 
							const int numPopsSampled,
							const int numIndivsPerPop,
							const int numLociSampled,
							Ran3List& ran){
	//	first do this using codominant data, then convert
	//	those data to dominant marker phenotypes
	//first convert from phenotypeto allele frequencies
	//assume first allele (pBar) is the recessive one
	long double recessiveAlleleFreq = sexLinkedRecessiveAlleleFreqFromFisBeta (betaBar, Fis);
	SexLinkedCodomMarkerData codomData;
	codomData.SetPrimarySexRatio(primarySexRatio());
	codomData.CreateRandomData(Fst,Fis,recessiveAlleleFreq,numPopsSampled,
											numIndivsPerPop,numLociSampled,ran);
	ConvertCodominantData(codomData);
	}//end SexLinkedDomMarkerData2::CreateRandomData(...)


void SexLinkedDomMarkerData2::CreateRandomData(
							const long double Fst, 
							const long double Fis,
							ObjList<aList<long double> >& betaBar, //loci by alleles
							ObjList<aList<int> >& numIndivsPerPopLoc,
							Ran3List& ran){
	//multiple alleles per locus, variable sample sizes per pop
	//first convert from phenotype to allele frequencies
	//assume first allele (pBar) is the recessive one
	ObjList<aList<long double> > recessiveAlleleFreqs(betaBar);
	for(long loc=0;loc<recessiveAlleleFreqs.len();++loc){
		long double freq = sexLinkedRecessiveAlleleFreqFromFisBeta(recessiveAlleleFreqs[loc][0],Fis);
		recessiveAlleleFreqs[loc][0] = (long double)1.0 - freq;
		if(recessiveAlleleFreqs[loc].len()>1){			
			recessiveAlleleFreqs[loc][1] = freq;}
		}
	SexLinkedCodomMarkerData codomData;
	codomData.SetPrimarySexRatio(primarySexRatio());
	codomData.CreateRandomData(Fst,Fis,recessiveAlleleFreqs,
											numIndivsPerPopLoc,ran);
	ConvertCodominantData(codomData);
	}//end SexLinkedDomMarkerData2::CreateRandomData(...)



void SexLinkedDomMarkerData2::CreateRandomData(const long double Fspt,//differentation among species
							const long double Flt, //differentiation among localities
							const long double Fis,
							const long double Flspt, //differentiation among subpops after means accounted for
							const long double betaBar, //grand mean
							const int numSpeciesSampled,
							const int numLocalitiesSampled,
							const int numIndivsPerPop,
							const int numLociSampled,
							Ran3List& ran){
	long double recessiveAlleleFreq = sexLinkedRecessiveAlleleFreqFromFisBeta(betaBar,Fis);
	SexLinkedCodomMarkerData codomData;
	codomData.SetPrimarySexRatio(primarySexRatio());
	codomData.CreateRandomData(Fspt,Flt,Fis,Flspt,recessiveAlleleFreq,numSpeciesSampled,numLocalitiesSampled,
											numIndivsPerPop,numLociSampled,ran);
	ConvertCodominantData(codomData);
	}//



void SexLinkedDomMarkerData2::CreateRandomData(const long double Fspt,//differentation among species
							const long double Flt, //differentiation among localities
							const long double Fis,
							const long double betaBar, //grand mean
							const int numSpeciesSampled,
							const int numLocalitiesSampled,
							const int numIndivsPerPop,
							const int numLociSampled,
							Ran3List& ran){
	long double recessiveAlleleFreq = sexLinkedRecessiveAlleleFreqFromFisBeta(Fis,betaBar);
	SexLinkedCodomMarkerData codomData;
	codomData.SetPrimarySexRatio(primarySexRatio());
	codomData.CreateRandomData(Fspt,Flt,Fis,recessiveAlleleFreq,numSpeciesSampled,numLocalitiesSampled,
											numIndivsPerPop,numLociSampled,ran);
	ConvertCodominantData(codomData);
	}//



void SexLinkedDomMarkerData2::CreateRandomDataLocFirst(const long double Fspt,//differentation among species
							const long double Flt, //differentiation among localities
							const long double Fis,
							const long double betaBar, //grand mean
							const int numSpeciesSampled,
							const int numLocalitiesSampled,
							const int numIndivsPerPop,
							const int numLociSampled,
							Ran3List& ran){
	long double recessiveAlleleFreq = sexLinkedRecessiveAlleleFreqFromFisBeta(betaBar,Fis);
	SexLinkedCodomMarkerData codomData;
	codomData.SetPrimarySexRatio(primarySexRatio());
	codomData.CreateRandomDataLocFirst(Fspt,Flt,Fis,recessiveAlleleFreq,numSpeciesSampled,numLocalitiesSampled,
											numIndivsPerPop,numLociSampled,ran);
	ConvertCodominantData(codomData);
	}//


void SexLinkedDomMarkerData2::CullDomLoci (StringList& lociToCull){
	//This function culls the designated loci from each dominant phenotype data string
	//and includes them among the skipped loci
	if(lociToCull.len()==0){return;}//none to cull
	aList<int> cullListByNum;
	for(int tr=0;tr<lociToCull.len();++tr){
		aString cTraitname = lociToCull[tr];
		int item = traitName_.Loc(&cTraitname);
		if((item>=0)&&(!(skippedTraitNum_.Includes(item)))){
			//the trait exists in the rawlist && isn't already skipped
			cullListByNum.Append(item);
			}//if item exists
		}//tr
	CullDomLoci(cullListByNum);
	}//end procedure SexLinkedDomMarkerData2::CullDomLoci(StringList&)


void SexLinkedDomMarkerData2::CullDomLoci (aList<int>& lociToCull){
	//This function shifts trait numbers from from traitNums_ to the skippedTraitNums_ list
	if(lociToCull.len()==0){return;}//none to cull
	for(int tr=0;tr<lociToCull.len();++tr){
		int cLoc = lociToCull[tr];//make sure it's a valid cull step
		if(traitNum_.Includes(cLoc) && cLoc>=0 && cLoc<traitName_.len()){
			long item = traitNum_.Loc(cLoc);
			skippedTraitNum_.Append(cLoc);
			skippedLocusNumSLDom_.Append(cLoc);
			traitNum_.Delete(item);
			item = locusNumSLDom_.Loc(cLoc);
			locusNumSLDom_.Delete(item);
			}//if item not skipped already
		}//tr
	nlociSLDom_ = locusNumSLDom_.len();
	skippedTraitNum_.Sort();
	skippedLocusNumSLDom_.Sort();
	ResetFlags();
	CheckForNewAlleles();
	}//SexLinkedDomMarkerData2::CullDomLoci (aList<int>&)



void SexLinkedDomMarkerData2::CullDomLocus (char* locusToCull){
	aString locToCull(locusToCull);
	CullDomLocus(locToCull);
	}//end SexLinkedDomMarkerData2::CullLocus (char* )


void SexLinkedDomMarkerData2::CullDomLocus (aString& locusToCull){
	StringList lociToCull;
	lociToCull.Append(NEW aString(locusToCull));
	CullDomLoci(lociToCull);
	}//end SexLinkedDomMarkerData2::CullLocus (aString& )


void SexLinkedDomMarkerData2::CullMonomorphicLociDom (void){	
	//This function culls the monomorphic loci from each genotype data string
	//and includes them among the skipped loci
	UpdateVariableLociDom();
	if(variableLocusNumSLDom_.len()==locusNumSLDom_.len()){return;}//none monomorphic
	aList<int> monomorphicLoci(locusNumSLDom_);
	for(int vLoc=0; vLoc<variableLocusNumSLDom_.len();++vLoc){
		if(monomorphicLoci.Includes(variableLocusNumSLDom_[vLoc])){//polymorphic
			int item = monomorphicLoci.Loc(variableLocusNumSLDom_[vLoc]);
			monomorphicLoci.Delete(item);}
		}//vLoc
	CullDomLoci(monomorphicLoci);
	}//end procedure SexLinkedDomMarkerData2::CullMonomorphicLociDom


void SexLinkedDomMarkerData2::CullToOneSex (SexLinkedDomMarkerData2& parentData,genderSet sexVal){
	//makes a subset data structure from the specified group
	aList<int> sexValList;
	sexValList.Append((int)sexVal);
	CullToTheseSexes(parentData,sexValList);
	}//end SexLinkedDomMarkerData2::CullToOneSex (SexLinkedDomMarkerData2& , genderSet )


void SexLinkedDomMarkerData2::CullToTheseSexes (SexLinkedDomMarkerData2& parentData,aList<int>& sexValList){
	//makes a subset data structure from the specified group
	Clear();
	if(sexValList.len()==0) return;
	title_ = parentData.title_;
	title_.cat(" -- ");
	for(int s=0;s<sexValList.len();++s){
		genderSet sexVal = (genderSet) sexValList[s];
		switch(sexVal){
			case A:
				title_.cat("asexuals"); break;
			case B:
				title_.cat("hermaphrodites"); break;
			case F:
				title_.cat("females"); break;
			case M:
				title_.cat("males"); break;
			default: break;
			}
		if(s<sexValList.len()-2){
				title_.cat(", ");}
			else if (s == sexValList.len()-2){
				title_.cat(" & ");}
			else{}
		}
	title_.cat(" only");


	npop_ = parentData.npop_;
	ngroups_ = parentData.ngroups_;
	ntraits_ = parentData.ntraits_;
	groupName_ = parentData.groupName_;
	localityName_ = parentData.localityName_;
	traitName_ = parentData.traitName_;
	traitNum_ = parentData.traitNum_;
	skippedTraitNum_ = parentData.skippedTraitNum_;
	missing_ = parentData.missing_;
	popName_ = parentData.popName_;
	localityCoordinates_ = parentData.localityCoordinates_;
	missing_ = parentData.missing_;
	
	heterogameticSex_ = parentData.heterogameticSex_;
	sexTrait_ = parentData.sexTrait_;
	primarySexRatio_ = parentData.primarySexRatio_;
	
	nlociSLDom_ = parentData.nlociSLDom_;
	locusNumSLDom_ = parentData.locusNumSLDom_;
	allSLDomLoci_ = parentData.allSLDomLoci_;
	skippedLocusNumSLDom_ = parentData.skippedLocusNumSLDom_;
	
	genderSet thisSexVal=B;
	int pop, i, thisSexValInt;
	for(pop=0;pop<parentData.npop_;++pop){
		popSize_.Append(0);
		rawTraits_.Append(NEW ObjList<TextDataList>());
		for(i=0;i<parentData.popSize(pop);++i){
			TextDatum& thisSex = parentData.rawTraits_[pop][i][sexTrait_];
			thisSexVal = genderCode(thisSex);
			thisSexValInt = (int)thisSexVal;
			if(sexValList.Includes(thisSexValInt)){
				rawTraits_[pop].Append((TextDataList*)parentData.rawTraits_[pop][i].Duplicate());
				popSize_[pop]++;}
			}//i
		}//pop
	
	//cull empty populations from data
	for(pop=npop_-1;pop>=0;--pop){
		if(parentData.rawTraits_[pop].len()==0){
			parentData.rawTraits_.Delete(pop);
			popName_.Delete(pop);
			popSize_.Delete(pop);
			}
		}//pop
	npop_ = rawTraits_.len();
		
	ResetFlags();
	GroupMembership();
	LocalityMembership();
	CheckForNewAlleles();
	}//end SexLinkedDomMarkerData2::CullToTheseSexes (SexLinkedDomMarkerData2& ,aList<int>& )



long double SexLinkedDomMarkerData2::sexLinkedDominantAlleleFreqFromFisBeta (long double beta, long double FisVal){
	long double one = (long double)1.0;
	long double two = one + one;
	long double four = two * two;
	long double sr = primarySexRatio();
	long double dominantAlleleFreq = - sqrt((one+sr*(one-FisVal))*(one+sr*(one-FisVal)) - four * beta * sr *(one-FisVal) );
	dominantAlleleFreq += one + sr *(one + FisVal);
	dominantAlleleFreq /= two * sr * (one - FisVal);
	return dominantAlleleFreq;
	}//SexLinkedDomMarkerData2::sexLinkedDominantAlleleFreqFromFisBeta (long double, long double) 



void SexLinkedDomMarkerData2::ExpungeLoci (StringList& lociToCull){
	if(lociToCull.len()==0){return;}//none to cull
	aList<int> cullListByNum;
	for(int tr=0;tr<lociToCull.len();++tr){
		aString cTraitname = lociToCull[tr];
		int item = traitName_.Loc(&cTraitname);
		if(item>=0){//the trait exists in the rawlist
			cullListByNum.Append(item);
			}//if item exists
		}//tr
	ExpungeLoci(cullListByNum);
	}//end procedure SexLinkedDomMarkerData2::ExpungeLoci(StringList&)


void SexLinkedDomMarkerData2::ExpungeLoci (aList<int>& lociToCull){
	//This function removes trait numbers from the haploid data set; called during reclassification
	if(lociToCull.len()==0){return;}//none to cull
	long item;
	for(int tr=0;tr<lociToCull.len();++tr){
		int cLoc = lociToCull[tr];//make sure it's a valid cull step
		if(allSLDomLoci_.Includes(cLoc)){
			item = allSLDomLoci_.Loc(cLoc);
			allSLDomLoci_.Delete(item);}
		if(locusNumSLDom_.Includes(cLoc)){
			item = locusNumSLDom_.Loc(cLoc);
			locusNumSLDom_.Delete(item);}
		if(skippedLocusNumSLDom_.Includes(cLoc)){
			item = skippedLocusNumSLDom_.Loc(cLoc);
			skippedLocusNumSLDom_.Delete(item);}
		}//tr
	nlociSLDom_ = locusNumSLDom_.len();
	ResetFlags();
	SexLinkedDomMarkerData2::CheckForNewAlleles();
	}//SexLinkedDomMarkerData2::ExpungeLoci (aList<int>&)



void SexLinkedDomMarkerData2::ExpungeLocus (char* locusToCull){
	aString locToCull(locusToCull);
	ExpungeLocus(locToCull);
	}//end SexLinkedDomMarkerData2::ExpungeLocus (char* )


void SexLinkedDomMarkerData2::ExpungeLocus (aString& locusToCull){
	StringList lociToCull;
	lociToCull.Append(NEW aString(locusToCull));
	ExpungeLoci(lociToCull);
	}//end SexLinkedDomMarkerData2::ExpungeLocus (aString& )


long double SexLinkedDomMarkerData2::GetExpectedHeterozygosity (int pop, int loc, int allele){
	long double freq = GetFreqDomHeterogametic(pop,loc,allele);
	return freq * ((long double)1.0 - freq);
	}//SexLinkedDomMarkerData2::GetExpectedHeterozygosity (int, int, int)
	
	
long double SexLinkedDomMarkerData2::GetExpectedHeterozygosity (int pop, int loc){
	long double freq, homosum=(long double)0.0;
	for(int allele=0;allele<allelesPresentSLDom_[loc].len();++allele){
		freq = GetFreqDomHeterogametic(pop,loc,allele);
		homosum += freq*freq;}
	return ((long double)1.0 - homosum);
	}//SexLinkedDomMarkerData2::GetExpectedHeterozygosity (int, int)




long double SexLinkedDomMarkerData2::GetFreqDom (int loc, int allele){
	long double numAlleleCopies = 0.0;
	long double numThisAllele = 0.0;
	for(int pop=0;pop<npop_;++pop){
		long double n = (long double)GetLocusSampleSizeDom(pop,loc);
		numAlleleCopies += n;
		numThisAllele += n * GetFreqDom(pop,loc,allele);
		}
	if(numAlleleCopies==0.0){return (long double)0.0;}
	return numThisAllele/numAlleleCopies;
	}//end SexLinkedDomMarkerData2::GetFreqDom


long double SexLinkedDomMarkerData2::GetFreqDom (int pop, int loc, int marker){
	if (!phenotypeFreqsCurrentSLDom_){CalculatePhenotypeFreqs();}
	return phenotypeFreqSLDom_[pop][loc][marker];
	}//end SexLinkedDomMarkerData2::GetFreqDom


long double SexLinkedDomMarkerData2::GetFreqDomHeterogametic (int pop, int loc, int marker){
	if (!phenotypeFreqsCurrentSLDom_){CalculatePhenotypeFreqs();}
	return phenotypeFreqSLHeterogametic_[pop][loc][marker];
	}//end SexLinkedDomMarkerData2::GetFreqDomHeterogametic


long double SexLinkedDomMarkerData2::GetFreqDomHomogametic (int pop, int loc, int marker){
	if (!phenotypeFreqsCurrentSLDom_){CalculatePhenotypeFreqs();}
	return phenotypeFreqSLHomogametic_[pop][loc][marker];
	}//end SexLinkedDomMarkerData2::GetFreqDomHomogametic


long double SexLinkedDomMarkerData2::GetFreqMostCommonAllele (int pop, int loc){
	long double mostCommon = 0.0;
	for(int allele=0;allele<GetNumAllelesDom(loc);++allele){
		long double freq = GetFreqDom(pop,loc,allele);
		if (freq>(long double)0.5) {return freq;}
		if (mostCommon<freq){mostCommon = freq;}
		}//and for allele
	return mostCommon;
	}//end SexLinkedDomMarkerData2::GetFreqMostCommonAllele


long SexLinkedDomMarkerData2::GetIndividualsSampledDom (int pop, int loc){
	// loc refers to sex-linked dominant loci only
	long n=0;
	for(long i=0;i<individuals(pop);++i){
		if(GetLocusSampleSizeDom (pop, i, loc)>0){
			++n;}}
	return n;
	}//end  SexLinkedDomMarkerData2::GetIndividualsSampled


long SexLinkedDomMarkerData2::GetLocusSampleSizeDom (int loc){
	if(! phenotypeFreqsCurrentSLDom_){
		CalculatePhenotypeFreqs();}//calculates twoN_
	double numMarkersFound = 0.0;
	for(int pop=0;pop<npop_;++pop){
		numMarkersFound += nByLocusSLDom_[pop][loc];
		}
	return numMarkersFound;
	}//end  SexLinkedDomMarkerData2::GetLocusSampleSize


long SexLinkedDomMarkerData2::GetLocusSampleSizeDom (int pop, int loc){
	// loc refers to sex-linkeddominant loci only
	return nByLocusSLDom_[pop][loc];
	}//end  SexLinkedDomMarkerData2::GetLocusSampleSizeDom


long SexLinkedDomMarkerData2::GetLocusSampleSizeDom (int pop, int indiv, int loc){
	// loc refers to dominant loci only
	TextDatum& score = PhenotypicVal(pop,indiv,loc);
	return score.OK();//false=0 if missing, true=1 if present
	}//end  SexLinkedDomMarkerData2::GetLocusSampleSizeDom


long SexLinkedDomMarkerData2::GetLocusSampleSizeDomHeterogametic (int pop, int loc){
	// loc refers to sex-linkeddominant loci only
	return nByLocusSLHeterogametic_[pop][loc];
	}//end  SexLinkedDomMarkerData2::GetLocusSampleSizeDomHeterogametic


long SexLinkedDomMarkerData2::GetLocusSampleSizeDomHomogametic (int pop, int loc){
	// loc refers to sex-linkeddominant loci only
	return nByLocusSLHomogametic_[pop][loc];
	}//end  SexLinkedDomMarkerData2::GetLocusSampleSizeDomHomogametic


int SexLinkedDomMarkerData2::GetNumAllelesDom (int loc){
	// loc refers to dominant loci only
	//total in data set
	if(! allelesCurrentSLDom_){CheckForNewAlleles();}
	return allelesPresentSLDom_[loc].len();
	}//end  SexLinkedDomMarkerData2::GetNumAlleles(loc)


int SexLinkedDomMarkerData2::GetNumAllelesDom (int pop, int loc){
	// loc refers to dominant loci only
	//extant alleles in population
	if(! phenotypeFreqsCurrentSLDom_){CalculatePhenotypeFreqs();}
	aList<long double>& locList = phenotypeFreqSLDom_[pop][loc];
	int count=0;
	for(int a=0;a<locList.len();++a){
		if (locList[a] >(long double) 0.0){++count;}}
	return count;
	}//end  SexLinkedDomMarkerData2::GetNumAllelesDom(pop,loc)


aString* SexLinkedDomMarkerData2::GetTraitString(int pop, int indiv, int loc){
	//loc indexed as in locusNumSLdom_ 
	aString *aStr = NEW aString();
	int tr = locusNumSLDom_[loc];
	aStr->cat(rawTraits_[pop][indiv][tr][0]);
	return aStr;
	}//SexLinkedDomMarkerData2::GetTraitString


aString* SexLinkedDomMarkerData2::GetTraitString(int pop, int indiv, int loc, int/* allele*/){
	return GetTraitString(pop, indiv, loc);
	}//HaploidMarkerData::GetTraitString


int SexLinkedDomMarkerData2::individuals(int pop, int loc){
	int indivs=0;
	for(int i=0;i<individuals(pop);++i){
		if (GetLocusSampleSizeDom ( pop, i, loc)>0){++indivs;}}
	return indivs;
	}//end  SexLinkedDomMarkerData2::individuals(int,int)
	

long SexLinkedDomMarkerData2::maxall(void){
	//maximum alleles per locus in data set
	CheckForNewAlleles();
	long maxalleles=0;
	int loc;
	for(loc=0;loc<nlociSLDom_;++loc){
		maxalleles = MAX(maxalleles,allelesPresentSLDom_[loc].len());}
	return maxalleles;
	}//SexLinkedDomMarkerData2::maxall()






/*
void  EvolutionaryGeneticsData::PrintAlleleFreqs (ostream& outFile, int ncols, char colSpacer){
	//Sends a table of allelic frequencies for each population to the output file.
	//nCols indexes the number of population columns per page
	CalculateAlleleFreqs();
	int asciiFormat = 1;//default: align columns with font of constant width
	if (colSpacer != ' '){
		asciiFormat = 0;}//separate columns using the spacer supplied


	outFile<<title<<endl<<endl<<endl;
	outFile<<"ALLELE FREQUENCY DATA"<<endl<<endl;
	outFile<<"NUMBER OF POPULATIONS SURVEYED = ";outFile.width(3);outFile<<npop<<endl;
	outFile<<"NUMBER OF LOCI SURVEYED = ";outFile.width(3);outFile<<nloci<<endl;
	outFile<<"LOCI SKIPPED : ";
	if (lociSkipped == 0){
			outFile<<"none";}
		else{
			for (int loc=0;loc< lociSkipped;++loc){
				aString& locName = skippedLocusName[loc];
				outFile<<locName;
				if (loc < lociSkipped-1){outFile<<", ";}
				}//end for loc
		}//end if lociSkipped
	outFile<<endl;

	//print the table with populations as columns, loci and alleles as rows

	//PFIT it the total number of population blocks the table is divided into
	int pFit = npop / ncols;
	int npop0 = npop;
	if (MOD(npop0,ncols) > 0){++pFit;}

	for (int block=0;block<pFit;++block){
		//M indexes the particular population block
		if (block == 0){ 
				outFile<<"Allele frequencies for each population."<<endl;
				outFile<<"Sample sizes in brackets for each locus."<<endl;
				}
			else{
				outFile<<"Allele frequency table, continued."<<endl<<endl;}
		int x =  (ncols * (block));//x is the population that starts this row
		int endPop = MIN((int)npop, (ncols * (block+1)))-1;
		outFile<<"pop. ";
		for (int pop=x;pop<=endPop;++pop){ //indexes the population number
			if (asciiFormat){outFile.width(12);} else{outFile<<colSpacer;}
			outFile<<pop+1;
			}
		outFile<<endl;

		for (int loc=0;loc<nloci;++loc) {//print the locus and locus sample size
			aString& locWord = locusName[loc];
			outFile<< locWord;
			if (asciiFormat){outFile.width(11 + (5 - locWord.len()));}else{outFile<<colSpacer;}
			for (int pop=x;pop<=endPop;++pop){//print the locus sample sizes in brackets
				int samSize = GetLocusSampleSize(pop, loc) / 2;
				outFile<<"[";if (asciiFormat){outFile.width(2);}outFile<<samSize<<"]";
				if (pop < endPop){
					if (asciiFormat){outFile.width(9);}else{outFile<<colSpacer;}
					}
				}//end for pop
			outFile<<endl;

			//print the allelic letter designation on the left side of the page
			StringList& alleleNameList = allelesPresent[loc];
			for (int allele=0; allele<alleleNameList.len();++allele){
				aString& allName=alleleNameList[allele];
				aString allNameCopy(allName);
				allNameCopy.PrependCharToLen(' ',3);
				outFile<<allNameCopy;
				// print the frequency of the allele for this locus, or
				//a blank space if the frequency is zero
				for (int pop=x;pop<=endPop;++pop){
					double freq = GetFreq(pop, loc, allele);
					aString freqStr(freq,0,4);
					if (asciiFormat){freqStr.PrependCharToLen(' ',12);}else{freqStr.prepend(colSpacer);}
					if (pop == endPop){//just write the freq if >0
							if (freq > 0.0){
									if (pop==x) {
										if (asciiFormat){freqStr.PrependCharToLen(' ',17);}
											//else{freqStr.prepend(colSpacer);}
										}
								 	outFile<<freqStr<<endl;}
								else{outFile<<endl;}
							}
						else	{//pop<endpop; include spaces if freq=0}
							if (freq == 0.0){
									if (asciiFormat){
											aString blanks(' ',12);
											if (pop==x) {
												blanks.PrependCharToLen(' ',17);}
											outFile<<blanks;
											}
										else{outFile<<colSpacer;}
									}
								else{
									if (pop==x) {
										if (asciiFormat){freqStr.PrependCharToLen(' ',17);}
											//else{freqStr.prepend(colSpacer);}
										}
									outFile<<freqStr;}
							}//end if pop...else
					}//end for pop
				}//end for allele
			}//end for loc
		outFile<<endl<<endl;
		}//end for block

	}//end EvolutionaryGeneticsData::PrintAlleleFreqs




void  EvolutionaryGeneticsData::PrintAlleleFreqsByPopList (ostream& outFile, 
											ObjList<ObjList<aList<double> > >& popFreqList, 
											ObjList<aList<double> >& popTwoNList, 
											int ncols){
	//popFreqList must contain the entire set of alleles in the data set
	//Sends a table of allelic frequencies to the output file.
	//ncols indexes the number of population columns per page

	//print the table with populations as columns, loci and alleles as rows

	//PFIT it the total number of population blocks the table is divided into
	int pFit = popFreqList.len() / ncols;
	int npop0 = popFreqList.len();
	if (MOD(npop0,ncols) > 0){++pFit;}

	for (int block=0;block<pFit;++block){
		//M indexes the particular population block
		if (block == 0){ 
				outFile<<"Sample sizes in brackets for each locus."<<endl;
				}
			else{
				outFile<<"Allele frequency table, continued."<<endl<<endl;}
		int x =  (ncols * (block));//x is the population that starts this row
		int endPop = MIN((int)popFreqList.len(), (ncols * (block+1)))-1;
		outFile<<"pop. ";
		for (int pop=x;pop<=endPop;++pop){ //indexes the population number
			outFile.width(12);outFile<<pop+1;}
		outFile<<endl;

		for (int loc=0;loc<nloci;++loc) {//print the locus and locus sample size
			aString& locWord = locusName[loc];
			outFile<< locWord;outFile.width(11 + (5 - locWord.len()));
			for (int pop=x;pop<=endPop;++pop){//print the locus sample sizes in brackets
				int samSize = popTwoNList[pop][loc] / 2;
				outFile<<"[";outFile.width(2);outFile<<samSize<<"]";
				if (pop < endPop){outFile.width(9);}
				}//end for pop
			outFile<<endl;

			//print the allelic letter designation on the left side of the page
			StringList& alleleNameList = allelesPresent[loc];
			for (int allele=0; allele<alleleNameList.len();++allele){
				aString& allName=alleleNameList[allele];
				aString allNameCopy(allName);
				allNameCopy.PrependCharToLen(' ',3);
				outFile<<allNameCopy;
				// print the frequency of the allele for this locus, or
				//a blank space if the frequency is zero
				for (int pop=x;pop<=endPop;++pop){
					double freq = popFreqList[pop][loc][allele];
					aString freqStr(freq,0,4);
					freqStr.PrependCharToLen(' ',12);
					if (pop == endPop){//just write the freq if >0
							if (freq > 0.0){
									if (pop==x) {
										freqStr.PrependCharToLen(' ',17);}
								 	outFile<<freqStr<<endl;}
								else{outFile<<endl;}
							}
						else	{//pop<endpop; include spaces if freq=0}
							if (freq == 0.0){
									aString blanks(' ',12);
									if (pop==x) {
										blanks.PrependCharToLen(' ',17);}
									outFile<<blanks;}
								else{
									if (pop==x) {
										freqStr.PrependCharToLen(' ',17);}
									outFile<<freqStr;}
							}//end if pop...else
					}//end for pop
				}//end for allele
			}//end for loc
		outFile<<endl<<endl;
		}//end for block

	}//end EvolutionaryGeneticsData::PrintAlleleFreqsByPopList
*/


void	 SexLinkedDomMarkerData2::PrintDomMarkerFile(aString& outFileName){
	fstream dataFile;
	char* fileName = outFileName.raw();
	dataFile.open(fileName, ios::out /*,filebuf::openprot*/);
	PrintDomMarkerFile(dataFile);
	dataFile.close();
	delete [] fileName;fileName=0;
	}//end SexLinkedDomMarkerData2::PrintDomMarkerFile(aString&)



void SexLinkedDomMarkerData2::PrintDomMarkerFile (ostream& outFile){
	aString dataLine = title_;
	dataLine.cat(":  skipped loci omitted");
	outFile<<dataLine<<endl;
	dataLine = "NPOP=";
	dataLine.cat(npop_);
	dataLine.cat(", NLOCI=");
	dataLine.cat(nlociSLDom_);
	long maxall_=0;
	for(int loc=0;loc<allelesPresentSLDom_.len();++loc){
		maxall_=MAX(maxall_,allelesPresentSLDom_[loc].len());}
	dataLine.cat(", MAXALL=");
	dataLine.cat(maxall_);
	dataLine.cat(", NGROUPS=");
	dataLine.cat(ngroups_);
	outFile<<dataLine<<endl;
	dataLine.clear();
	for (int loc=0;loc<nlociSLDom_;++loc){
		dataLine.cat(locusNameDom(loc));
		if( ( ((double)(loc+1)) / 5.0) - ((loc+1) / 5) == 0){//new line for every 5 loci
				outFile<<dataLine<<endl;
				dataLine.clear();}
			else if (loc+1 < nlociSLDom_){
				dataLine.cat("\t");}
			else{
				outFile<<dataLine<<endl;
				dataLine.clear();}
		}//end for loc
	dataLine = "SKIP=0";
	outFile<<dataLine<<endl;
	dataLine.clear();
	for (int pop=0;pop<npop_;++pop){
		outFile<<popName_[pop]<<endl;
		//cobble together a phenotype list for dominant markers only
		for (int i=0;i<individuals(pop);++i){
			StringList idata;
			idata.Append(NEW TextDatum(rawTraits_[pop][i][0]));
			for(int dloc=0;dloc<nlociSLDom_;++dloc){
				TextDatum& score=rawTraits_[pop][i][locusNumSLDom_[dloc]];
				if(score.OK()){
						idata.Append(NEW aString(score));}
					else{//record as missing data
						idata.Append(NEW aString(rawTraits_[pop][i].missingDataStr_));}
				}//dLoc
			aString outStr;
			for(int j=0;j<idata.len();++j){
				outStr+idata[j];
				if(j<idata.len()-1){
					outStr+" ";}}
			outFile<<outStr<<endl;
			}//end for i
		outFile<<"NEXT"<<endl;
		}//end for pop
	outFile<<"END"<<endl;
	}//end SexLinkedDomMarkerData2::PrintDomMarkerFile(ostream&)



void	 SexLinkedDomMarkerData2::PrintNEXUSFile(aString& outFileName, StringList& textToAppend){
	fstream dataFile;
	char* fileName = outFileName.raw();
	dataFile.open(fileName, ios::out /*,filebuf::openprot*/);
	PrintNEXUSFile(dataFile,textToAppend);
	dataFile.close();
	delete [] fileName;fileName=0;
	}//end SexLinkedDomMarkerData2::PrintNEXUSFile(aString&,StringList&)



void SexLinkedDomMarkerData2::PrintNEXUSFile (ostream& outFile, StringList& textToAppend){
	outFile<<"#NEXUS"<<endl;
	aString dataLine = title_;
	dataLine.prepend("[ ! ");
	outFile<<dataLine<<endl<<"]"<<endl<<endl;
	dataLine = "begin alleles;";
	outFile<<dataLine<<endl;
	dataLine = "\tdimensions newpops nloci=";
	dataLine.cat(nlociSLDom_);
	dataLine.cat(" npops=");
	dataLine.cat(npop_);
	dataLine.cat(";");
	outFile<<dataLine<<endl;
	dataLine = "\tdominant all:1;";
	outFile<<dataLine<<endl;
	dataLine = "\tformat labels missing=? ;";
	outFile<<dataLine<<endl;
	dataLine = "\tmatrix";
	outFile<<dataLine<<endl;
	dataLine.clear();
	/* need code for locus names
	for (int loc=0;loc<nlociSLDom_;++loc){
		dataLine.cat(locusNameDom_(loc));
		if( ( ((double)(loc+1)) / 5.0) - ((loc+1) / 5) == 0){//new line for every 5 loci
				outFile<<dataLine<<endl;
				dataLine.clear();}
			else if (loc+1 < nlociSLDom_){
				dataLine.cat("\t");}
			else{
				outFile<<dataLine<<endl;
				dataLine.clear();}
		}//end for loc
	*/
	aString endCharList("\t, ");
	for (int pop=0;pop<npop_;++pop){
		aString pname = popName_[pop];
		pname.replaceAll(' ','_');
		outFile<<'\t'<<pname<<":"<<endl;
		for (int i=0;i<individuals(pop);++i){
			StringList idata;
			idata.Append(NEW TextDatum(rawTraits_[pop][i][0]));
			idata[0].PrependCharToLen('0',3);//tweak the format of the ID code
			idata[0].prepend('_');
			idata[0].cat("_\t");
			for(int dloc=0;dloc<nlociSLDom_;++dloc){
				TextDatum& score=rawTraits_[pop][i][locusNumSLDom_[dloc]];
				if(score.OK()){
						idata.Append(NEW aString(score));}
					else{//record as missing data
						idata.Append(NEW aString("?"));}
				}//dLoc
			aString outStr;
			for(int j=0;j<idata.len();++j){
				outStr+idata[j];
				if(j<idata.len()-1){
					outStr+"\t";}}
			outFile<<"\t\t"<<outStr<<endl;

			}//end for i
		if(pop==npop_-1){
				outFile<<";"<<endl;}
			else{
				outFile<<","<<endl;}
		}//end for pop
	outFile<<"end;"<<endl<<endl;
	
	for(int i=0;i<textToAppend.len();++i){
		outFile<<textToAppend[i]<<endl;}
	outFile<<endl;
	}//end SexLinkedDomMarkerData2::PrintNEXUSFile(ostream&, StringList&)



void SexLinkedDomMarkerData2::PrintLociDom (ostream& outFile, int lociPerLine){//file assumed open
	int lineSpot = 0;
	for (int loc=0;loc<nlociSLDom_;++loc){ 
		aString& locName = locusNameDom(loc);
		outFile<<locName;
		++lineSpot;
		if ((loc == nlociSLDom_-1) || (lineSpot == lociPerLine)) {
				outFile<<endl;}
			else{
				outFile<<"\t";}
		}//end for loc
	outFile<<endl;
	}//end SexLinkedDomMarkerData2::PrintLociDom


void SexLinkedDomMarkerData2::PrintPhenotypeCounts(aString& outFileName, int ncols, char colSpacer){
	fstream dataFile;
	char* fileName = outFileName.raw();
	dataFile.open(fileName, ios::out /*,filebuf::openprot*/);
	PrintPhenotypeCounts(dataFile, ncols, colSpacer);
	dataFile.close();
	delete [] fileName;fileName=0;
	}//end SexLinkedDomMarkerData2::PrintPhenotypeCounts(aString&, int, char)


void SexLinkedDomMarkerData2::PrintPhenotypeCountsBySex(aString& outFileName, int ncols, char colSpacer){
	fstream dataFile;
	char* fileName = outFileName.raw();
	dataFile.open(fileName, ios::out /*,filebuf::openprot*/);
	PrintPhenotypeCountsBySex(dataFile, ncols, colSpacer);
	dataFile.close();
	delete [] fileName;fileName=0;
	}//end SexLinkedDomMarkerData2::PrintPhenotypeCountsBySex(aString&, int, char)



void  SexLinkedDomMarkerData2::PrintPhenotypeCounts (ostream& outFile, int ncols, char colSpacer){
	//Sends a table of phenotypic frequencies for each population to the output file.
	//nCols indexes the number of population columns per page
	CalculatePhenotypeFreqs();
	int asciiFormat = 1;//default: align columns with font of constant width
	if (colSpacer != ' '){
		asciiFormat = 0;}//separate columns using the spacer supplied
	int significantDigits = 4;

	outFile<<title_<<endl<<endl<<endl;
	outFile<<"PHENOTYPIC FREQUENCY DATA (COUNTS)"<<endl<<endl;
	outFile<<"NUMBER OF POPULATIONS SURVEYED = ";outFile.width(3);outFile<<npop_<<endl;
	outFile<<"NUMBER OF MARKERS SURVEYED = ";outFile.width(3);outFile<<nlociSLDom_<<endl;
	outFile<<"LOCI SKIPPED : ";
	if (skippedLocusNumSLDom_.len() == 0){
			outFile<<"none";}
		else{
			for (int loc=0;loc< skippedLocusNumSLDom_.len();++loc){
				aString& locName = traitName_[skippedLocusNumSLDom_[loc]];
				outFile<<locName;
				if(MOD(loc+1,20)==0){outFile<<endl;}
					else if (loc < skippedLocusNumSLDom_.len()-1){outFile<<"\t";}
					else{}
				}//end for loc
		}//end if lociSkippedDom
	outFile<<endl;

	//print the table with populations as columns, loci and alleles as rows

	//PFIT it the total number of population blocks the table is divided into
	int pFit = npop_ / ncols;
	int npop0 = npop_;
	if (MOD(npop0,ncols) > 0){++pFit;}

	for (int block=0;block<pFit;++block){
		//M indexes the particular population block
		if (block == 0){ 
				outFile<<"Phenotypic counts of SEX-LINKED DOMINANT markers for each population."<<endl;
				outFile<<"Sample sizes in brackets for each locus."<<endl;
				}
			else{
				outFile<<"Phenotypic counts table, continued."<<endl<<endl;}
		int x =  (ncols * (block));//x is the population that starts this row
		int endPop = MIN((int)npop_, (ncols * (block+1)))-1;
		outFile<<"pop. ";
		for (int pop=x;pop<=endPop;++pop){ //indexes the population number
			if (asciiFormat){outFile.width(12);} else{outFile<<colSpacer;}
			outFile<<pop+1;
			}
		outFile<<endl;

		for (int loc=0;loc<nlociSLDom_;++loc) {//print the locus and locus sample size
			aString& locWord = locusNameDom(loc);
			outFile<< locWord;
//			if (asciiFormat){outFile.width(11 + (5 - locWord.len()));}else{outFile<<colSpacer;}
//			for (int pop=x;pop<=endPop;++pop){//print the locus sample sizes in brackets
//				int samSize = nByLocusSLDom_[pop][loc];
//				outFile<<"[";if (asciiFormat){outFile.width(2);}outFile<<samSize<<"]";
//				if (pop < endPop){
//					if (asciiFormat){outFile.width(9);}else{outFile<<colSpacer;}
//					}
//				}//end for pop
			outFile<<endl;

			//print the allelic letter designation on the left side of the page
			StringList& markerNameList = allelesPresentSLDom_[loc];
			for (int marker=0; marker<markerNameList.len();++marker){
				aString& markerName=markerNameList[marker];
				aString markerNameCopy(markerName);
				markerNameCopy.PrependCharToLen(' ',3);
				outFile<<markerNameCopy;
				// print the frequency of the marker for this locus, or
				//a blank space if the frequency is zero
				for (int pop=x;pop<=endPop;++pop){
					int countfreq = phenotypeCountSLDom_[pop][loc][marker];
					aString freqStr(countfreq);
					if (asciiFormat){freqStr.PrependCharToLen(' ',12);}else{freqStr.prepend(colSpacer);}
					if (pop == endPop){//just write the freq if >0
							if (countfreq > 0){
									if (pop==x) {
										if (asciiFormat){freqStr.PrependCharToLen(' ',17);}
										}
								 	outFile<<freqStr<<endl;}
								else{outFile<<endl;}
							}
						else	{//pop<endpop; include spaces if freq=0}
							if (countfreq == 0){
									if (asciiFormat){
											aString blanks(' ',12);
											if (pop==x) {
												blanks.PrependCharToLen(' ',17);}
											outFile<<blanks;
											}
										else{outFile<<colSpacer;}
									}
								else{
									if (pop==x) {
										if (asciiFormat){freqStr.PrependCharToLen(' ',17);}
											//else{freqStr.prepend(colSpacer);}
										}
									outFile<<freqStr;}
							}//end if pop...else
					}//end for pop
				}//end for allele
			}//end for loc
		outFile<<endl<<endl;
		}//end for block

	}//end EvolutionaryGeneticsData::PrintPhenotypeCounts



void  SexLinkedDomMarkerData2::PrintPhenotypeCountsBySex (ostream& outFile, int ncols, char colSpacer){
	//Sends a table of phenotypic frequencies by sex for each population to the output file.
	//nCols indexes the number of population columns per page
	CalculatePhenotypeFreqs();
	int asciiFormat = 1;//default: align columns with font of constant width
	if (colSpacer != ' '){
		asciiFormat = 0;}//separate columns using the spacer supplied
	int significantDigits = 4;

	outFile<<title_<<endl<<endl<<endl;
	outFile<<"PHENOTYPIC FREQUENCY (COUNTS) DATA BY SEX"<<endl<<endl;
	outFile<<"NUMBER OF POPULATIONS SURVEYED = ";outFile.width(3);outFile<<npop_<<endl;
	outFile<<"NUMBER OF MARKERS SURVEYED = ";outFile.width(3);outFile<<nlociSLDom_<<endl;
	outFile<<"LOCI SKIPPED : ";
	if (skippedLocusNumSLDom_.len() == 0){
			outFile<<"none";}
		else{
			for (int loc=0;loc< skippedLocusNumSLDom_.len();++loc){
				aString& locName = traitName_[skippedLocusNumSLDom_[loc]];
				outFile<<locName;
				if(MOD(loc+1,20)==0){outFile<<endl;}
					else if (loc < skippedLocusNumSLDom_.len()-1){outFile<<"\t";}
					else{}
				}//end for loc
		}//end if lociSkippedDom
	outFile<<endl;

	//print the table with populations as columns, loci and alleles as rows

	//PFIT it the total number of population blocks the table is divided into
	int pFit = npop_ / ncols;
	int npop0 = npop_;
	if (MOD(npop0,ncols) > 0){++pFit;}
// 	int samSize;
	int countfreq;
	aString mWord("M"),fWord("F"), sexWord;

	for (int block=0;block<pFit;++block){
		//M indexes the particular population block
		if (block == 0){ 
				outFile<<"Phenotypic counts by sex of SEX-LINKED DOMINANT markers for each population."<<endl;
//				outFile<<"Sample sizes in brackets for each locus and sex."<<endl;
				}
			else{
				outFile<<"Phenotypic counts table, continued."<<endl<<endl;}
		int x =  (ncols * (block));//x is the population that starts this row
		int endPop = MIN((int)npop_, (ncols * (block+1)))-1;
		outFile<<"pop. ";
		for (int pop=x;pop<=endPop;++pop){ //indexes the population number
			if (asciiFormat){outFile.width(12);} else{outFile<<colSpacer;}
			outFile<<pop+1;
			}
		outFile<<endl;

		for (int loc=0;loc<nlociSLDom_;++loc) {//print the locus and locus sample size
			aString& locWord = locusNameDom(loc);
			outFile<< locWord<<endl;
			for(int sex=0;sex<2;++sex){
				if(sex==0) {sexWord=fWord;}else{sexWord=mWord;}
				outFile<<sexWord;
//				if (asciiFormat){outFile.width(11 + (5 - sexWord.len()));}else{outFile<<colSpacer;}
//				for (int pop=x;pop<=endPop;++pop){//print the locus sample sizes in brackets
//					samSize=0;
//					if(sex==0){//F
//							if(heterogameticSex()==F){
//									samSize = GetLocusSampleSizeDomHeterogametic(pop, loc);}
//								else{
//									samSize = GetLocusSampleSizeDomHomogametic(pop, loc);}
//							}
//						else{//M
//							if(heterogameticSex()==M){
//									samSize = GetLocusSampleSizeDomHeterogametic(pop, loc);}
//								else{
//									samSize = GetLocusSampleSizeDomHomogametic(pop, loc);}
//							}
//		//			samSize = nByLocusSLDom_[pop][loc];
//					outFile<<"[";if (asciiFormat){outFile.width(2);}outFile<<samSize<<"]";
//					if (pop < endPop){
//						if (asciiFormat){outFile.width(9);}else{outFile<<colSpacer;}
//						}
//					}//end for pop
				outFile<<endl;

				//print the allelic letter designation on the left side of the page
				StringList& markerNameList = allelesPresentSLDom_[loc];
				for (int marker=0; marker<markerNameList.len();++marker){
					aString& markerName=markerNameList[marker];
					aString markerNameCopy(markerName);
					markerNameCopy.PrependCharToLen(' ',3);
					outFile<<markerNameCopy;
					// print the frequency of the marker for this locus, or
					//a blank space if the frequency is zero
					for (int pop=x;pop<=endPop;++pop){
						countfreq=0;
						if(sex==0){//F
								if(heterogameticSex()==F){
										countfreq = GetCountDomHeterogametic(pop, loc, marker);}
									else{
										countfreq = GetCountDomHomogametic(pop, loc, marker);}
								}
							else{//M
								if(heterogameticSex()==M){
										countfreq = GetCountDomHeterogametic(pop, loc, marker);}
									else{
										countfreq = GetCountDomHomogametic(pop, loc, marker);}
								}
//						freq = phenotypeFreqSLDom_[pop][loc][marker];
						aString freqStr(countfreq);
						if (asciiFormat){freqStr.PrependCharToLen(' ',12);}else{freqStr.prepend(colSpacer);}
						if (pop == endPop){//just write the freq if >0
								if (countfreq > 0){
										if (pop==x) {
											if (asciiFormat){freqStr.PrependCharToLen(' ',17);}
											}
									 	outFile<<freqStr<<endl;}
									else{outFile<<endl;}
								}
							else	{//pop<endpop; include spaces if freq=0}
								if (countfreq == 0){
										if (asciiFormat){
												aString blanks(' ',12);
												if (pop==x) {
													blanks.PrependCharToLen(' ',17);}
												outFile<<blanks;
												}
											else{outFile<<colSpacer;}
										}
									else{
										if (pop==x) {
											if (asciiFormat){freqStr.PrependCharToLen(' ',17);}
												//else{freqStr.prepend(colSpacer);}
											}
										outFile<<freqStr;}
								}//end if pop...else
						}//end for pop
					}//end for allele
				}//sex
			}//end for loc
		outFile<<endl<<endl;
		}//end for block

	}//end EvolutionaryGeneticsData::PrintPhenotypeCountsBySex




void SexLinkedDomMarkerData2::PrintPhenotypeFreqs(aString& outFileName, int ncols, char colSpacer){
	fstream dataFile;
	char* fileName = outFileName.raw();
	dataFile.open(fileName, ios::out /*,filebuf::openprot*/);
	PrintPhenotypeFreqs(dataFile, ncols, colSpacer);
	dataFile.close();
	delete [] fileName;fileName=0;
	}//end SexLinkedDomMarkerData2::PrintPhenotypeFreqs(aString&, int, char)


void SexLinkedDomMarkerData2::PrintPhenotypeFreqsBySex(aString& outFileName, int ncols, char colSpacer){
	fstream dataFile;
	char* fileName = outFileName.raw();
	dataFile.open(fileName, ios::out /*,filebuf::openprot*/);
	PrintPhenotypeFreqsBySex(dataFile, ncols, colSpacer);
	dataFile.close();
	delete [] fileName;fileName=0;
	}//end SexLinkedDomMarkerData2::PrintPhenotypeFreqs(aString&, int, char)



void  SexLinkedDomMarkerData2::PrintPhenotypeFreqs (ostream& outFile, int ncols, char colSpacer){
	//Sends a table of phenotypic frequencies for each population to the output file.
	//nCols indexes the number of population columns per page
	CalculatePhenotypeFreqs();
	int asciiFormat = 1;//default: align columns with font of constant width
	if (colSpacer != ' '){
		asciiFormat = 0;}//separate columns using the spacer supplied
	int significantDigits = 4;

	outFile<<title_<<endl<<endl<<endl;
	outFile<<"PHENOTYPIC FREQUENCY DATA"<<endl<<endl;
	outFile<<"NUMBER OF POPULATIONS SURVEYED = ";outFile.width(3);outFile<<npop_<<endl;
	outFile<<"NUMBER OF MARKERS SURVEYED = ";outFile.width(3);outFile<<nlociSLDom_<<endl;
	outFile<<"LOCI SKIPPED : ";
	if (skippedLocusNumSLDom_.len() == 0){
			outFile<<colSpacer<<"none";}
		else{
			outFile<<colSpacer;
			for (int loc=0;loc< skippedLocusNumSLDom_.len();++loc){
				aString& locName = traitName_[skippedLocusNumSLDom_[loc]];
				outFile<<locName;
				if(MOD(loc+1,20)==0){outFile<<endl;}
					else if (loc < skippedLocusNumSLDom_.len()-1){outFile<<colSpacer;}
					else{}
				}//end for loc
		}//end if lociSkippedDom
	outFile<<endl;

	//print the table with populations as columns, loci and alleles as rows

	//PFIT it the total number of population blocks the table is divided into
	int pFit = npop_ / ncols;
	int npop0 = npop_;
	if (MOD(npop0,ncols) > 0){++pFit;}

	for (int block=0;block<pFit;++block){
		//M indexes the particular population block
		if (block == 0){ 
				outFile<<"Phenotypic frequencies of SEX-LINKED DOMINANT markers for each population."<<endl;
				outFile<<"Sample sizes in brackets for each locus."<<endl;
				}
			else{
				outFile<<"Phenotypic frequency table, continued."<<endl<<endl;}
		int x =  (ncols * (block));//x is the population that starts this row
		int endPop = MIN((int)npop_, (ncols * (block+1)))-1;
		outFile<<"pop. ";
		for (int pop=x;pop<=endPop;++pop){ //indexes the population number
			if (asciiFormat){outFile.width(12);} else{outFile<<colSpacer;}
			outFile<<pop+1;
			}
		outFile<<endl;

		for (int loc=0;loc<nlociSLDom_;++loc) {//print the locus and locus sample size
			aString& locWord = locusNameDom(loc);
			outFile<< locWord;
			if (asciiFormat){outFile.width(11 + (5 - locWord.len()));}else{outFile<<colSpacer;}
			for (int pop=x;pop<=endPop;++pop){//print the locus sample sizes in brackets
				int samSize = nByLocusSLDom_[pop][loc];
				outFile<<"[";if (asciiFormat){outFile.width(2);}outFile<<samSize<<"]";
				if (pop < endPop){
					if (asciiFormat){outFile.width(9);}else{outFile<<colSpacer;}
					}
				}//end for pop
			outFile<<endl;

			//print the allelic letter designation on the left side of the page
			StringList& markerNameList = allelesPresentSLDom_[loc];
			for (int marker=0; marker<markerNameList.len();++marker){
				aString& markerName=markerNameList[marker];
				aString markerNameCopy(markerName);
				markerNameCopy.PrependCharToLen(' ',3);
				outFile<<markerNameCopy;
				// print the frequency of the marker for this locus, or
				//a blank space if the frequency is zero
				for (int pop=x;pop<=endPop;++pop){
					double freq = phenotypeFreqSLDom_[pop][loc][marker];
					aString freqStr(freq,0,significantDigits);
					if (asciiFormat){freqStr.PrependCharToLen(' ',12);}else{freqStr.prepend(colSpacer);}
					if (pop == endPop){//just write the freq if >0
							if (freq > 0.0){
									if (pop==x) {
										if (asciiFormat){freqStr.PrependCharToLen(' ',17);}
										}
								 	outFile<<freqStr<<endl;}
								else{outFile<<endl;}
							}
						else	{//pop<endpop; include spaces if freq=0}
							if (freq == 0.0){
									if (asciiFormat){
											aString blanks(' ',12);
											if (pop==x) {
												blanks.PrependCharToLen(' ',17);}
											outFile<<blanks;
											}
										else{outFile<<colSpacer;}
									}
								else{
									if (pop==x) {
										if (asciiFormat){freqStr.PrependCharToLen(' ',17);}
											//else{freqStr.prepend(colSpacer);}
										}
									outFile<<freqStr;}
							}//end if pop...else
					}//end for pop
				}//end for allele
			}//end for loc
		outFile<<endl<<endl;
		}//end for block

	}//end EvolutionaryGeneticsData::PrintPhenotypeFreqs



void  SexLinkedDomMarkerData2::PrintPhenotypeFreqsBySex (ostream& outFile, int ncols, char colSpacer){
	//Sends a table of phenotypic frequencies by sex for each population to the output file.
	//nCols indexes the number of population columns per page
	CalculatePhenotypeFreqs();
	int asciiFormat = 1;//default: align columns with font of constant width
	if (colSpacer != ' '){
		asciiFormat = 0;}//separate columns using the spacer supplied
	int significantDigits = 4;

	outFile<<title_<<endl<<endl<<endl;
	outFile<<"PHENOTYPIC FREQUENCY DATA BY SEX"<<endl<<endl;
	outFile<<"NUMBER OF POPULATIONS SURVEYED = ";outFile.width(3);outFile<<npop_<<endl;
	outFile<<"NUMBER OF MARKERS SURVEYED = ";outFile.width(3);outFile<<nlociSLDom_<<endl;
	outFile<<"LOCI SKIPPED : ";
	if (skippedLocusNumSLDom_.len() == 0){
			outFile<<"none";}
		else{
			for (int loc=0;loc< skippedLocusNumSLDom_.len();++loc){
				aString& locName = traitName_[skippedLocusNumSLDom_[loc]];
				outFile<<locName;
				if(MOD(loc+1,20)==0){outFile<<endl;}
					else if (loc < skippedLocusNumSLDom_.len()-1){outFile<<"\t";}
					else{}
				}//end for loc
		}//end if lociSkippedDom
	outFile<<endl;

	//print the table with populations as columns, loci and alleles as rows

	//PFIT it the total number of population blocks the table is divided into
	int pFit = npop_ / ncols;
	int npop0 = npop_;
	if (MOD(npop0,ncols) > 0){++pFit;}
	int samSize;
	long double freq;
	aString mWord("M"),fWord("F"), sexWord;

	for (int block=0;block<pFit;++block){
		//M indexes the particular population block
		if (block == 0){ 
				outFile<<"Phenotypic frequencies by sex of SEX-LINKED DOMINANT markers for each population."<<endl;
				outFile<<"Sample sizes in brackets for each locus and sex."<<endl;
				}
			else{
				outFile<<"Phenotypic frequency table, continued."<<endl<<endl;}
		int x =  (ncols * (block));//x is the population that starts this row
		int endPop = MIN((int)npop_, (ncols * (block+1)))-1;
		outFile<<"pop. ";
		for (int pop=x;pop<=endPop;++pop){ //indexes the population number
			if (asciiFormat){outFile.width(12);} else{outFile<<colSpacer;}
			outFile<<pop+1;
			}
		outFile<<endl;

		for (int loc=0;loc<nlociSLDom_;++loc) {//print the locus and locus sample size
			aString& locWord = locusNameDom(loc);
			outFile<< locWord<<endl;
			for(int sex=0;sex<2;++sex){
				if(sex==0) {sexWord=fWord;}else{sexWord=mWord;}
				outFile<<sexWord;
				if (asciiFormat){outFile.width(11 + (5 - sexWord.len()));}else{outFile<<colSpacer;}
				for (int pop=x;pop<=endPop;++pop){//print the locus sample sizes in brackets
					samSize=0;
					if(sex==0){//F
							if(heterogameticSex()==F){
									samSize = GetLocusSampleSizeDomHeterogametic(pop, loc);}
								else{
									samSize = GetLocusSampleSizeDomHomogametic(pop, loc);}
							}
						else{//M
							if(heterogameticSex()==M){
									samSize = GetLocusSampleSizeDomHeterogametic(pop, loc);}
								else{
									samSize = GetLocusSampleSizeDomHomogametic(pop, loc);}
							}
//					samSize = nByLocusSLDom_[pop][loc];
					outFile<<"[";if (asciiFormat){outFile.width(2);}outFile<<samSize<<"]";
					if (pop < endPop){
						if (asciiFormat){outFile.width(9);}else{outFile<<colSpacer;}
						}
					}//end for pop
				outFile<<endl;

				//print the allelic letter designation on the left side of the page
				StringList& markerNameList = allelesPresentSLDom_[loc];
				for (int marker=0; marker<markerNameList.len();++marker){
					aString& markerName=markerNameList[marker];
					aString markerNameCopy(markerName);
					markerNameCopy.PrependCharToLen(' ',3);
					outFile<<markerNameCopy;
					// print the frequency of the marker for this locus, or
					//a blank space if the frequency is zero
					for (int pop=x;pop<=endPop;++pop){
						freq=(long double)0.0;
						if(sex==0){//F
								if(heterogameticSex()==F){
										freq = GetFreqDomHeterogametic(pop, loc, marker);}
									else{
										freq = GetFreqDomHomogametic(pop, loc, marker);}
								}
							else{//M
								if(heterogameticSex()==M){
										freq = GetFreqDomHeterogametic(pop, loc, marker);}
									else{
										freq = GetFreqDomHomogametic(pop, loc, marker);}
								}
//						freq = phenotypeFreqSLDom_[pop][loc][marker];
						aString freqStr(freq,0,significantDigits);
						if (asciiFormat){freqStr.PrependCharToLen(' ',12);}else{freqStr.prepend(colSpacer);}
						if (pop == endPop){//just write the freq if >0
								if (freq > 0.0){
										if (pop==x) {
											if (asciiFormat){freqStr.PrependCharToLen(' ',17);}
											}
									 	outFile<<freqStr<<endl;}
									else{outFile<<endl;}
								}
							else	{//pop<endpop; include spaces if freq=0}
								if (freq == 0.0){
										if (asciiFormat){
												aString blanks(' ',12);
												if (pop==x) {
													blanks.PrependCharToLen(' ',17);}
												outFile<<blanks;
												}
											else{outFile<<colSpacer;}
										}
									else{
										if (pop==x) {
											if (asciiFormat){freqStr.PrependCharToLen(' ',17);}
												//else{freqStr.prepend(colSpacer);}
											}
										outFile<<freqStr;}
								}//end if pop...else
						}//end for pop
					}//end for allele
				}//sex
			}//end for loc
		outFile<<endl<<endl;
		}//end for block

	}//end EvolutionaryGeneticsData::PrintPhenotypeFreqsBySex




int SexLinkedDomMarkerData2::ReadAFLPDataFile (aString& dataFileName){
	Clear();
	fstream dataFile;
	aString endCharList(" \t,\r"), missingDataListElems("?. -_");
	char endchar = '\n';	
	StringList missingDataList;
	for(int s=0;s<missingDataListElems.len();++s){
		missingDataList.Append(NEW aString(missingDataListElems[s]));}
	char *dataLine=NEW char[10001];dataLine[0]='\0';
	char* filename=dataFileName.raw();
	dataFile.open(filename,ios::in);
	int dataFileOpen = dataFile.is_open();
	if(! dataFileOpen){
		aString errstr("couldn\'t open the file ");
		errstr.cat(filename);
		aError(errstr);
		return 0;}

	dataFile.getline(dataLine, 10000,endchar);
	title_ = dataLine;

	dataFile.getline(dataLine, 10000,endchar); 
	aString parameterLine(dataLine);
	aString *paramWord = parameterLine.ChopOffFirstWord(endCharList);
	paramWord->cut(0, 5);
	npop_ = paramWord->toInt();
	delete paramWord; paramWord=0;

	paramWord = parameterLine.ChopOffFirstWord(endCharList);
	paramWord->cut(0, 6);
	nlociSLDom_ = paramWord->toInt();
	delete paramWord; paramWord=0;

	paramWord = parameterLine.ChopOffFirstWord(endCharList);
	paramWord->cut(0, 7);
	int maxall_ = paramWord->toInt();//now ignored
	delete paramWord; paramWord=0;

	paramWord = parameterLine.ChopOffFirstWord(endCharList);
	paramWord->cut(0, 8);
	ngroups_ =  paramWord->toInt();
	delete paramWord; paramWord=0;


	//get locus information
	int moreLoci = 1;//true
	long loc = 0;
	StringList rawLocusNameDom,skippedLocusNameDom;//temporary
	while (moreLoci){
		dataFile.getline(dataLine, 10000,endchar); 
		aString locusLine(dataLine);
		while (locusLine.len() > 0){
			++loc;
			aString *locName = locusLine.ChopOffFirstWord(endCharList);
			if(locName->len()>0){//there could be trailing blanks on locusLine
				aString *s = NEW aString(locName);
				rawLocusNameDom.Append(s);}//append a copy
			delete locName; locName=0;
			}//end while locusLine.len()
		if (loc >= nlociSLDom_){//data may be on more than one line
			moreLoci = 0;}//false
		}//end while moreLoci
	//check for duplicates	
	StringList uniqueNames;
	for(long i=0;i<rawLocusNameDom.len();++i){
		if(!(uniqueNames.Includes(&(rawLocusNameDom[i])))){
			uniqueNames.Append(NEW aString(rawLocusNameDom[i]));}}

	long numuni=uniqueNames.len();
	if(rawLocusNameDom.len()>numuni){
		//figure out the names and positions of duplicated loci & report
		StringList dupNames(rawLocusNameDom);
		for(loc=0;loc<uniqueNames.len();++loc){
			long uItem=dupNames.Loc(&(uniqueNames[loc]));
			dupNames.Delete(uItem);
			}//loc
		ObjList<aList<long> > dupPositions;
		for(loc=0;loc<dupNames.len();++loc){
			StringList locNamesCopy(rawLocusNameDom);//work with a copy
			dupPositions.Append(NEW aList<long>());
			long dupcount=0;
			long dupitem = locNamesCopy.Loc(&(dupNames[loc]));
			while (dupitem>=0){
				locNamesCopy.Delete(dupitem);
				dupPositions[loc].Append(dupitem+dupcount);//because the locNamesCopy list shrinks from the bottom
				++dupcount;
				dupitem = locNamesCopy.Loc(&(dupNames[loc]));
				}//while
			}//loc
		cout<<"You have duplicated locus names in your data set."<<endl;
		cout<<"Please check that these are not mistakes, and give all your loci unique names."<<endl;
		cout<<"duplicated loci:"<<endl;
		dataFile<<"You have duplicated locus names in your data set."<<endl;
		dataFile<<"Please check that these are not mistakes, and give all your loci unique names."<<endl;
		dataFile<<"duplicated loci:"<<endl;
		for(loc=0;loc<dupNames.len();++loc){
			aString dupLine(dupNames[loc]);
			dupLine.cat(" at positions ");
			for(int i=0;i<dupPositions[loc].len();++i){
				dupLine.cat(dupPositions[loc][i]+1);
				if(i<dupPositions[loc].len()-1){
					dupLine.cat(", ");}
				}//i
			cout<<dupLine<<endl;
			dataFile<<dupLine<<endl;}
		aError("The duplicated names are in your output file. Please edit your data file and start again from the beginning.");
		return 2;
		}//unique names
	//read in the number of loci to be skipped in the analyses
	dataFile.getline(dataLine, 10000,endchar); 
	aString skipLine(dataLine);
	aString *skipWord = skipLine.ChopOffFirstWord(endCharList);
	skipWord->cut(0,5);
	int lociSkippedDom = skipWord->toInt();
	delete skipWord; skipWord=0;

	//and read in the names of skipped loci, if any
	loc = 0;
	moreLoci = 0;//false
	if (lociSkippedDom > 0){
			moreLoci = 1;}//true
	while (moreLoci){
		while (skipLine.len() > 0){
			++loc;
			skipWord = skipLine.ChopOffFirstWord(endCharList);
			if (skipWord->len()>0){//there could be trailing blanks
				aString *s = NEW aString(skipWord);
				skippedLocusNameDom.Append(s);//append a copy
				}
			delete skipWord; skipWord=0;
			}//end while .len()
		if (loc >= lociSkippedDom){
				moreLoci = 0;}//false
			else	{//more loci on the next line
				dataFile.getline(dataLine, 10000,endchar); 
				skipLine = dataLine;}
		}//end while moreLoci

	traitName_=rawLocusNameDom;
	for(int tr=0;tr<traitName_.len();++tr){
		allSLDomLoci_.Append(tr);}
	locusNumSLDom_=allSLDomLoci_;
		
	//read in population data
	aString popLine;
	aString beast;
	ObjList<StringList> rawPhenotypes;
	for (int pop=0;pop<npop_;++pop){
		//skip blank lines before pops in the data file
		int blankLines = 0;
		popLine.clear();
		while (popLine.len() == 0){
			dataFile.getline(dataLine, 10000,endchar); 
			popLine = dataLine;
			++blankLines;
			if (blankLines > 20){
				cout<<"A lot of blank lines in the data set.  Did you set NPOP too high ?"<<endl;}
			}//end while .len()
		aString *s = NEW aString(popLine);
		popName_.Append(s);//append a copy

		//make a new sublist for the genotypes of this population
		rawPhenotypes.Append(NEW StringList());
		// BEAST is the string for a particular individual
		beast.clear();
		while (beast != "NEXT"){ 
			dataFile.getline(dataLine, 10000,endchar); 
			beast = dataLine;
			beast.CullTrailingChar('\t');
			beast.CullTrailingChar(' ');
			beast.CullTrailingChar(',');
			if (beast != "NEXT"){ 
					aString *s = NEW aString(beast);
					rawPhenotypes[pop].Append(s);
					s=0;}//appends a copy
			}//end while beast..else
		}//end for pop
	dataFile.close();
	delete [] dataLine;dataLine=0;
	delete [] filename;filename=0;
	//Now parse the data by trait
	for(int pop=0;pop<npop_;++pop){	
		rawTraits_.Append(NEW ObjList<TextDataList>());
		for(int i=0;i<rawPhenotypes[pop].len();++i){
			aString dataStrCopy(rawPhenotypes[pop][i]);
			if(dataStrCopy.len()==0) continue;
			rawTraits_[pop].Append(NEW TextDataList("?"));
			aString *codeWord = dataStrCopy.ChopOffFirstWord(endCharList);
			rawTraits_[pop][i].Append(NEW TextDatum(*codeWord));
			for(int loc=0;loc<nlociSLDom_;++loc){
				int posPtypeWord = 1 + ((alleleLen_+1) * loc);
				if(posPtypeWord>=dataStrCopy.len()){
						rawTraits_[pop][i].Append(NEW TextDatum("",true));
						continue;}
				aString phene = aString(dataStrCopy, posPtypeWord, posPtypeWord+alleleLen_-1);
				if(missingDataList.Includes(&phene)){
						rawTraits_[pop][i].Append(NEW TextDatum("",true));}
					else{
						rawTraits_[pop][i].Append(NEW TextDatum(phene));}
				}//loc
			delete codeWord;codeWord=0;
			}//i		
		}//pop		
	CullDomLoci(skippedLocusNameDom);
	GroupMembership();
	LocalityMembership();
	CheckForNewAlleles();
	return 1;
	}//end SexLinkedDomMarkerData2::ReadAFLPDataFile


/*

int SexLinkedDomMarkerData2::ReadAndAppendAFLPDataFile (aString& dataFileName){
	fstream dataFile;	
	char endchar = '\n';	
	char *dataLine=NEW char[10001];dataLine[0]='\0';
	aString endCharList(" \t,\r");
	char* filename=dataFileName.raw();
	dataFile.open(filename,ios::in);
	int dataFileOpen = dataFile.is_open();
	if(! dataFileOpen){
		aString errstr("couldn\'t open the file ");
		errstr.cat(filename);
		aError(errstr);
		return 0;}

	dataFile.getline(dataLine, 10000,endchar);
	title_.prepend("Combined data: [");
	title_.cat("] & [");
	title_.cat(dataLine);
	title_.cat("]");

	dataFile.getline(dataLine, 10000,endchar); 
	aString parameterLine(dataLine);
	aString *paramWord = parameterLine.ChopOffFirstWord(endCharList);
	paramWord->cut(0, 5);
	int npopThisFile = paramWord->toInt();
	delete paramWord; paramWord=0;

	paramWord = parameterLine.ChopOffFirstWord(endCharList);
	paramWord->cut(0, 6);
	int nlociDomThisFile = paramWord->toInt();
	delete paramWord; paramWord=0;

	paramWord = parameterLine.ChopOffFirstWord(endCharList);
	paramWord->cut(0, 7);
	long maxallThisFile = paramWord->toInt();
	delete paramWord; paramWord=0;
	maxall = MAX(maxall, maxallThisFile);

	paramWord = parameterLine.ChopOffFirstWord(endCharList);
	paramWord->cut(0, 8);
	int ngroupsThisFile =  paramWord->toInt();
	delete paramWord; paramWord=0;


	//get locus information
	int moreLoci = 1;//true
	int loc = 0;
	while (moreLoci){
		dataFile.getline(dataLine, 10000,endchar); 
		aString locusLine(dataLine);
		while (locusLine.len() > 0){
			++loc;
			aString *locName = locusLine.ChopOffFirstWord(endCharList);
			if(locName->len()>0){//there could be trailing blanks on locusLine
				if(!(rawLocusNameDom.Includes(locName))){//appended data can repeat loci
					aString *s = NEW aString(locName);
					rawLocusNameDom.Append(s);}//append a copy
				}
			delete locName; locName=0;
			}//end while locusLine.len()
		if (loc >= nlociDomThisFile){//data may be on more than one line
			moreLoci = 0;}//false
		}//end while moreLoci
	nlociSLDom_ = rawLocusNameDom.len();
	//read in the number of loci to be skipped in the analyses
	dataFile.getline(dataLine, 10000,endchar); 
	aString skipLine(dataLine);
	aString *skipWord = skipLine.ChopOffFirstWord(endCharList);
	skipWord->cut(0,5);
	int lociSkippedDomThisFile = skipWord->toInt();
	delete skipWord; skipWord=0;

	//and read in the names of skipped loci, if any
	loc = 0;
	moreLoci = 0;//false
	if (lociSkippedDom > 0){
			moreLoci = 1;}//true
	while (moreLoci){
		while (skipLine.len() > 0){
			++loc;
			skipWord = skipLine.ChopOffFirstWord(endCharList);
			if (skipWord->len()>0){//there could be trailing blanks
				if(!(skippedLocusNameDom.Includes(skipWord))){
					aString *s = NEW aString(skipWord);//skipped loci can be repeated
					skippedLocusNameDom.Append(s);//append a copy
					int toSkip = rawLocusNameDom.Loc(s);
					skippedLocusNumDom.Append(toSkip);}
				}
			delete skipWord; skipWord=0;
			}//end while .len()
		if (loc >= lociSkippedDom){
				moreLoci = 0;}//false
			else	{//more loci on the next line
				dataFile.getline(dataLine, 10000,endchar); 
				skipLine = dataLine;}
		}//end while moreLoci
	lociSkippedDom = skippedLocusNameDom.len();

	locusNameDom.Copy(rawLocusNameDom);
	for (loc=0;loc<skippedLocusNumDom.len();++loc){
		aString& toSkip = skippedLocusNameDom[loc];
		int location = locusNameDom.Loc(&toSkip);
		locusNameDom.Delete(location);
		}//end for loc
	nlociSLDom_ -= lociSkippedDom;

	//read in population data
	aString popLine;
	aString beast;
	for (int pop=0;pop<npopThisFile;++pop){
		//skip blank lines before pops in the data file
		int blankLines = 0;
		popLine.clear();
		while (popLine.len() == 0){
			dataFile.getline(dataLine, 10000,endchar); 
			popLine = dataLine;
			++blankLines;
			if (blankLines > 20){
				cout<<"A lot of blank lines in the data set.  Did you set NPOP too high ?"<<endl;}
			}//end while .len()
		int thepop = pop;
		if(!(popName.Includes(&popLine))){
				aString *s = NEW aString(popLine);
				popName.Append(s);//append a copy
				thepop = popName.len()-1;//the last pop in list
				//make a new sublist for the genotypes of this population
				rawPhenotypes.Append(NEW StringList());				
				}
			else{
				thepop = popName.Loc(&popLine);}


		// BEAST is the string for a particular individual
		beast.clear();
		while (beast != "NEXT"){ 
			dataFile.getline(dataLine, 10000,endchar); 
			beast = dataLine;
			beast.CullTrailingChar('\t');
			beast.CullTrailingChar(' ');
			beast.CullTrailingChar(',');
			if (beast != "NEXT"){ 
				//check to see if this individual already has data
				aString beastCopy(beast);
				aString* IDbeast = beastCopy.ChopOffFirstWord(endCharList);
				int hasData	= 0, indivNum=0;
				for(int i=0;i<rawPhenotypes[thepop].len();++i){
					aString indivData(rawPhenotypes[thepop][i]);//copies
					aString *IDindiv = indivData.ChopOffFirstWord(endCharList);
					if(*IDbeast == *IDindiv){//already in data set
						hasData = 1;//true
						indivNum = i;
						delete IDindiv;IDindiv=0;
						break;//escape for i loop
						}
					delete IDindiv;IDindiv=0;
					}//end for i
				if(hasData){//append to end of this individual -- buggy if loci repeated
						beastCopy.prepend('\t');
						rawPhenotypes[thepop][indivNum].cat(beastCopy);
						}
					else{
						aString *s = NEW aString(beast);
						rawPhenotypes[thepop].Append(s);
						s=0;}//appends a copy
				delete IDbeast; IDbeast=0;
				}//end if beast != NEXT
			}//end while beast..else


		}//end for pop
	npop_ = rawPhenotypes.len();
	dataFile.close();
	delete [] dataLine;dataLine=0;
	delete [] filename;filename=0;
	ResetFlags();
	GroupMembership();
	LocalityMembership();
	CullSkippedLociDom();
	CheckForNewAlleles();
	return 1;
	}//end SexLinkedDomMarkerData2::ReadAndAppendAFLPDataFile
*/






void SexLinkedDomMarkerData2::RestoreLociDom (aList<int>& lociToRestore){
	//This function restores the designated loci to the analysis.
	//It shifts trait numbers from from skippedTraitNums_ to the traitNums_ list
	//and keps track of the changes in the locusNumSLDom_ and skippedLocusNumSLDom_ lists
	if(lociToRestore.len()==0){return;}//none to cull
	ResetFlags();
	for(int tr=0;tr<lociToRestore.len();++tr){
		int rLoc = lociToRestore[tr];//make sure it's a valid locus to restore
		if(skippedTraitNum_.Includes(rLoc) && rLoc>=0 && rLoc<traitName_.len()){
			traitNum_.Append(rLoc);
			locusNumSLDom_.Append(rLoc);
			long item = skippedTraitNum_.Loc(rLoc);
			skippedTraitNum_.Delete(item);
			item = skippedLocusNumSLDom_.Loc(rLoc);
			skippedLocusNumSLDom_.Delete(item);
			}//if item not skipped already
		}//tr
	traitNum_.Sort();
	locusNumSLDom_.Sort();
	CheckForNewAlleles();
	}//end  SexLinkedDomMarkerData2::RestoreLociDom(aList<int>&)


void SexLinkedDomMarkerData2::RestoreLociDom (StringList& lociToRestore){
	//This function restores the designated loci to the analysis
	if(lociToRestore.len()==0){return;}//none to cull
	//convert names to numbers and cull
	aList<int> restoreListByNum;
	for(int tr=0;tr<lociToRestore.len();++tr){
		aString rTraitname = lociToRestore[tr];
		int item = traitName_.Loc(&rTraitname);
		if((item>=0)&&(!(traitNum_.Includes(item)))){
			//the trait exists in the rawlist && isn't already included
			restoreListByNum.Append(item);
			}//if item exists
		}//tr
	RestoreLociDom(restoreListByNum);
	}//end SexLinkedDomMarkerData2::RestoreLociDom(StringList&)


void SexLinkedDomMarkerData2::RestoreLocusDom (aString& locusToRestore){
	StringList lociToRestore;
	lociToRestore.Append(new aString(locusToRestore));
	RestoreLociDom(lociToRestore);
	}//end SexLinkedDomMarkerData2::RestoreLocus (aString& )




void SexLinkedDomMarkerData2::SetLoci(aList<int>& lociToInclude){
	if(lociToInclude.len()==0) return;
	SexLinkedDomMarkerData2::ResetGeneticFlags();
	allSLDomLoci_=lociToInclude;
	locusNumSLDom_=lociToInclude;
	for(int tr=0;tr<lociToInclude.len();++tr){
		int cLoc = lociToInclude[tr];
		if(skippedTraitNum_.Includes(cLoc)){
			long item = locusNumSLDom_.Loc(cLoc);
			if(item>=0){
				locusNumSLDom_.Delete(item);}
			if(! skippedLocusNumSLDom_.Includes(cLoc)){
				skippedLocusNumSLDom_.Append(cLoc);}
			}
		}//tr
	skippedLocusNumSLDom_.Sort();
	nlociSLDom_ = locusNumSLDom_.len();
	SexLinkedDomMarkerData2::CheckForNewAlleles();
	}//SexLinkedDomMarkerData2::SetLoci(aList<int>& )



void SexLinkedDomMarkerData2::UpdateVariableLociDom(void){
	if (varLociCurrentSLDom_){return;}
	CheckForNewAlleles();
	variableLocusNumSLDom_.Clear();
	for(int loc=0;loc<nlociSLDom_;++loc){
		if (allelesPresentSLDom_[loc].len()>1){
			variableLocusNumSLDom_.Append(loc);}}
	varLociCurrentSLDom_=1;
	}//end SexLinkedDomMarkerData2::UpdateVariableLociDom



#endif






