/*****
GenotypeFreqDistDom.cpp

Sex-linked dominant markers: p_ is the (dominant) allele frequency, 
beta_ is the dominant marker frequency over males and females, 
and  the class holds marker frequencies in the order {dominant,recessive}.  

The constructor should be set up like this:

GenotypeFreqDistribution someDist(dominantMarkerFreq, Fis, //SLdom=// true, //heterogameticSexIsMale=// true, 
			sexratio);

*****/

#ifndef GenotypeFreqDistDomcpp
#define GenotypeFreqDistDomcpp = 1


#include "GenotypeFreqDistDom.h"
#include "Element.cpp"
#include "aList.cpp"
#include "StatList.cpp"




void GenotypeFreqDistDom::CreateDistributionDominantMarker(void){
	//0-1 data, sampled from Fis &  marker freq
	//need to calculate allele frequency
	
	//calculate allele frequency from marker frequency
	p_ = sqrt((two-Fis_)*(two-Fis_) - four * beta_ * (one-Fis_) );
	p_ += (two-Fis_);
	p_ /= two * (one-Fis_);
	Append(beta_);
	Append(one - beta_);
	}//GenotypeFreqDistDom::CreateDistributionDominantMarker()






#endif