//GenotypeFreqDistribution.cpp


#ifndef GenotypeFreqDistributioncpp
#define GenotypeFreqDistributioncpp = 1

#include "GenotypeFreqDistribution.h"
#include "Element.cpp"
#include "aList.cpp"
#include "StatList.cpp"



long double GenotypeFreqDistribution::alleleFrequency(int alleleVal){
	if(alleleVal==0){ return p_;}
		else{ return (long double)1.0 - p_;}
	}//GenotypeFreqDistribution::alleleFrequency(int)
	
	
	
	
/*
void GenotypeFreqDistribution::CreateDistribution(void){
	Clear();
	long double HomoA = p_ * p_;
	long double Hexp = (long double)2.0 * p_ *((long double)1.0 -p_);
	long double HomoB = ((long double)1.0 -p_) * ((long double)1.0 -p_);
	if ((Fis_!=(long double)0.0) &&(p_>(long double)0.0) && (p_<(long double)1.0)){
		//since the heterozygotes are comprised of 50% of each allele, 
		//the deviation in heterozygotes described by Fis_
		//must be made up of equal parts contribituons to/from the homozygote classes
		long double Hobs = Hexp * ((long double)1.0 - Fis_);
		long double decrement = Hexp - Hobs;
//		double Aratio = HomoA/(HomoA+HomoB);
//		double Bratio = HomoB/(HomoA+HomoB);
//bug		HomoA += 0.5* decrement;
//bug		HomoB += 0.5* decrement;
		HomoA =  p_ * p_ *((long double)1.0-Fis_) + Fis_ * Hexp;
		HomoB =  ((long double)1.0 - p_) * ((long double)1.0 - p_) *((long double)1.0-Fis_) + Fis_ * Hexp;
		Hexp = Hobs;
		}//end if Fis && polymorphic
	Append(HomoA);
	Append(Hexp);
	Append(HomoB);
	float summ=sum();
	if(summ != (long double)1.0){
		aString errstr="BUG: genotype frequencies sum to ";
		errstr.cat(summ); errstr.cat("; they should sum to 1.0");
		aError(errstr);}
	}//end GenotypeFreqDistribution::CreateDistribution
*/	


void GenotypeFreqDistribution::CreateDistribution2(void){
	StringList gTypes;//code modified from GenotypeFreqMultiAlleleDist::CreateDistribution2()
	aList<long double> pp;//allele frequencies
	pp.Append(p_);
	pp.Append((long double)1.0-p_);
	int a0,a1,h,j, alleles = pp.len();//a0= rows, a1= columns
	//first sort p_ into ascending order, saving the original order of alleles
	aList<int> freqorder, currentOrder, originalOrder, sortedOrder;
	for(a0=0;a0<alleles;++a0){
		currentOrder.Append(a0);
		originalOrder.Append(a0);
		}
	aList<long double> freqs, frqcopy(pp);
	while(frqcopy.len()>0){
		long double lowFreq=(long double)2.0;
		int item;
		for(int a3=0;a3<frqcopy.len();++a3){
			if(frqcopy[a3]<lowFreq){//find lowest
				lowFreq=frqcopy[a3];
				item=a3;}
			}
		freqs.Append(lowFreq);
		freqorder.Append(currentOrder[item]);
		frqcopy.Delete(item);
		currentOrder.Delete(item);
		}//end while 
	for(a0=0;a0<alleles;++a0){
		sortedOrder.Append(freqorder.Loc(originalOrder[a0]));}
				
	//work on sorted allele frequencies
	ObjList<aList<long double> > gFreq;//notational convenience
	for(a0=0;a0<alleles;++a0){//initialize matrix  
		gFreq.Append(NEW aList<long double>());
		for(a1=0;a1<alleles;++a1){
			gFreq[a0].Append((long double)0.0);
			}}
	ObjList<aList<long double> > p, pt;//p[h][j]=pj^(h) in algebra notation, h<j
	for(a0=0;a0<alleles;++a0){
		p.Append(NEW aList<long double>());
		pt.Append(NEW aList<long double>());
		for(a1=0;a1<alleles;++a1){
			p[a0].Append((long double)0.0);
			pt[a0].Append((long double)0.0);
			}}//a0, a1
	for(h=0;h<alleles;++h){//fill in values for p
//		int& h = a0;//algebraic notation
		for(j=0;j<alleles;++j){
//			int& j=a1;//algebraic notation
			if(h==0){
					p[h][j] = freqs[j];}
				else if(j<h){
					p[h][j] = -1.0;}//error code for debugging
				else{
					p[h][j] = freqs[j];
					}
			}//a1=j
		}//a0=h
	long double Fmin, FF;
	for(a0=0;a0<alleles;++a0){
		Fmin = - p[a0][a0]/((long double)1.0 - p[a0][a0]);
		FF = MAX((long double)Fis_, Fmin);
		}//a0
	for(a0=0;a0<alleles;++a0){//cols-- fill in matrix below diagonal
		for(a1=a0;a1<alleles;++a1){//rows
			if(a1==a0){//homozygotes
					gFreq[a0][a0] = p[a0][a0]*p[a0][a0] + FF * p[a0][a0] * ((long double)1.0 - p[a0][a0]);
					}//end homozygotes
				else{//heterozygotes
					gFreq[a1][a0] = gFreq[a0][a1] = (long double)2.0 * ((long double)1.0 - FF) * p[a0][a0] * p[a0][a1];
					}//end heterozygotes
			}}//a1,a0

	//restore genotypes to original order of allele frequencies
	ObjList<aList<long double> > sortedgFreqOrder(gFreq);//copies these
	for(a0=0;a0<alleles;++a0){
		for(a1=0;a1<=a0;++a1){
			gFreq[a0][a1] = sortedgFreqOrder[sortedOrder[a0]][sortedOrder[a1]];
			}}//a0,a1
	for(a0=0;a0<alleles;++a0){
		for(a1=0;a1<=a0;++a1){
			if(ABS(gFreq[a0][a1])<10.0e-15){//chop off rounding errors near zero
				gFreq[a0][a1] = (long double)0.0;}
			}//a1
		for(a1=a0+1;a1<alleles;++a1){
			gFreq[a0][a1] = (long double)0.0;}
		}//a0

	//convert to list notation
	GenotypeFreqDistribution& gFreqList = *this;//notational convenience
	for(a0=0;a0<alleles;++a0){
		for(a1=a0;a1<alleles;++a1){
			aString* gt = NEW aString((char)(a1+'A'));
			gt->prepend((char)(a0+'A'));
			gTypes.Append(gt);
//			gFreqList.Append(gFreq[a1][a1]);			
			gFreqList.Append(gFreq[a1][a0]);			
			}
		}
	float summ = sum();
	if(summ != 1.0){
		aString errstr="BUG: genotype frequencies sum to ";
		errstr.cat(summ); errstr.cat("; they should sum to 1.0");
		aError(errstr);}
	}//end GenotypeFreqDistribution::CreateDistribution2
	



void GenotypeFreqDistribution::PrintToScreen(void){
	for (int x=0;x<len();++x){
		long double p = Nth(x);
		cout<<p<<endl;
	}//end for x
}//end GenotypeFreqDistribution::PrintToScreen


#endif

