//HarmonicMeanDiseq.cp


#include <HarmonicMeanDiseq.h>

double HarmonicDiseqMarkerVsSelLoci (double c, double r0){
	//c is the effective number of chromosomes
	//r0 is the minimum distance between loci on a chromosome
	//typically r0=1.0e-4, or 1.0e-5
	const double dy = 1.0e-5;
	//calculated as r=1/r, then take r=1/r at the end
	double r = 0;
	double bigR = c;//assumes each chromosome is 1 Morgan (map unit) long; each is
					//really bigR/c map units long
	//First the linked contribution, an integral done numerically
	double x=1/dy;
	long top = long (x)+1;
	for (long y = 1;y<= top;++y){ 
		r +=  (log((exp(2.0 * ((double) y) / ((double) top)) - 1.0) / (2.0 * r0))) * dy;}
	r *= (2.0 * c / (bigR * bigR));
	r += 2.0 * (c - 1.0) / c;	//now add in the unlinked contribution
	return (1/r);
	}//	end HarmonicDiseqMarkerVsSelLoci

