// AllozymeClineShapeData2.h

//This class calculates cline shape by fitting data in the form (x,y) to
//a 2-parameter tanh function.  The theory is in Szymura & Barton 1986.
//The program reads in a data set of allozymes and calculates the hybrid
//index and gametic disequilibria for each population.

//derived classes implement the appropriate cline shape functions
#ifndef AllozymeClineShapeData2h
#define AllozymeClineShapeData2h = 1

//#include <iostream.h>
#include <Shape2ParamRec.h>
//#include <ClinePopList.h>
//#include <AllozymeClineShapeData.h>
#include <AllozymeClineShapeOnly.h>





class AllozymeClineShapeData2: public AllozymeClineShapeOnly<Shape2ParamRec>{
		public:
			AllozymeClineShapeData2(double harmonicMeanRecomb):
				AllozymeClineShapeOnly<Shape2ParamRec>(harmonicMeanRecomb){
						harMeanRecomb = harmonicMeanRecomb;
						params = 2;}
			AllozymeClineShapeData2(aString& s, double harmonicMeanRecomb): 
				AllozymeClineShapeOnly<Shape2ParamRec>(s, harmonicMeanRecomb){
						harMeanRecomb = harmonicMeanRecomb;
						params = 2;}
			AllozymeClineShapeData2(double numChromosomes, double mapDistBetweenLoci):
				AllozymeClineShapeOnly<Shape2ParamRec>(numChromosomes, mapDistBetweenLoci){
						params = 2;}
			AllozymeClineShapeData2(aString& s, double numChromosomes, double mapDistBetweenLoci): 
				AllozymeClineShapeOnly<Shape2ParamRec>(s, numChromosomes, mapDistBetweenLoci){
						params = 2;}
			~AllozymeClineShapeData2(void){}
			
		};//end class AllozymeClineShapeData2

#endif
