// AllozymeClineShapeData4.h

//This class calculates cline shape by fitting data in the form (x,y) to
//a 4-parameter tanh function.  The theory is in Szymura & Barton 1986.
//The program reads in a data set of allozymes and calculates the hybrid
//index and gametic disequilibria for each population.

//derived classes implement the appropriate cline shape functions
#ifndef AllozymeClineShapeData4h
#define AllozymeClineShapeData4h = 1

//#include <iostream.h>
#include <Shape4ParamRec.h>
//#include <AllozymeClineShapeData2.h>
#include <AllozymeClineShapeOnly.h>


class AllozymeClineShapeData4: public AllozymeClineShapeOnly<Shape4ParamRec>{
		public:
			AllozymeClineShapeData4(double harmonicMeanRecomb):
				AllozymeClineShapeOnly<Shape4ParamRec>(harmonicMeanRecomb){
						params = 4;}
			AllozymeClineShapeData4(aString& s, double harmonicMeanRecomb): 
				AllozymeClineShapeOnly<Shape4ParamRec>(s, harmonicMeanRecomb){
						params = 4;}
			AllozymeClineShapeData4(double numChromosomes, double mapDistBetweenLoci):
				AllozymeClineShapeOnly<Shape4ParamRec>(numChromosomes, mapDistBetweenLoci){
						params = 4;}
			AllozymeClineShapeData4(aString& s, double numChromosomes, double mapDistBetweenLoci): 
				AllozymeClineShapeOnly<Shape4ParamRec>(s, numChromosomes, mapDistBetweenLoci){
						params = 4;}
			~AllozymeClineShapeData4(void){}
			
		};//end class AllozymeClineShapeData4





/*

class AllozymeClineShapeData4: virtual public AllozymeClineShapeData2{
		public:
			AllozymeClineShapeData4(void): AllozymeClineShapeData2(){
				IShapeData();}
			AllozymeClineShapeData4(String& s): AllozymeClineShapeData2(s){
				IShapeData();}
			~AllozymeClineShapeData4(void){}

	virtual void 		IShapeData(void ){
						params = 4;					
						delete bestParams; bestParams= new Shape4ParamRec();
						delete paramsInUse; paramsInUse= new Shape4ParamRec();
						delete paramDeviations; paramDeviations= new Shape4ParamRec();
						delete paramsToTry; paramsToTry= new Shape4ParamRec();
						}//end IShapeData		
	virtual void		SetCurrentAsBest(void){
						delete bestParams; bestParams = 0;
						bestParams = new Shape4ParamRec(*paramsInUse);
						}//end SetCurrentAsBest
		};//end class AllozymeClineShapeData4
*/

#endif

