// AllozymeClineShapeData5.h

//This class calculates cline shape by fitting data in the form (x,y) to
//a 5-parameter tanh function.  The theory is in Szymura & Barton 1986.
//The program reads in a data set of allozymes and calculates the hybrid
//index and gametic disequilibria for each population.

//derived classes implement the appropriate cline shape functions
#ifndef AllozymeClineShapeData5h
#define AllozymeClineShapeData5h = 1

//#include <iostream.h>
#include <Shape5ParamRec.h>
//#include <AllozymeClineShapeData3.h>
#include <AllozymeClineShapePlus.h>


class AllozymeClineShapeData5: public AllozymeClineShapePlus<Shape5ParamRec>{
		public:
			AllozymeClineShapeData5(double harmonicMeanRecomb):
				AllozymeClineShapePlus<Shape5ParamRec>(harmonicMeanRecomb){
						harMeanRecomb = harmonicMeanRecomb;
						params = 5;}
			AllozymeClineShapeData5(aString& s, double harmonicMeanRecomb): 
				AllozymeClineShapePlus<Shape5ParamRec>(s, harmonicMeanRecomb){
						harMeanRecomb = harmonicMeanRecomb;
						params = 5;}
			AllozymeClineShapeData5(double numChromosomes, double mapDistBetweenLoci):
				AllozymeClineShapePlus<Shape5ParamRec>(numChromosomes, mapDistBetweenLoci){
						params = 5;}
			AllozymeClineShapeData5(aString& s, double numChromosomes, double mapDistBetweenLoci): 
				AllozymeClineShapePlus<Shape5ParamRec>(s, numChromosomes, mapDistBetweenLoci){
						params = 5;}
			~AllozymeClineShapeData5(void){}
			
		};//end class AllozymeClineShapeData5


/*



class AllozymeClineShapeData5: virtual public AllozymeClineShapeData3{
		public:
			AllozymeClineShapeData5(void): AllozymeClineShapeData3(){
				IShapeData();}
			AllozymeClineShapeData5(String& s): AllozymeClineShapeData3(s){
				IShapeData();}
			~AllozymeClineShapeData5(void){}

	virtual void 		IShapeData(void ){
						params = 5;					
						delete bestParams; bestParams= new Shape5ParamRec();
						delete paramsInUse; paramsInUse= new Shape5ParamRec();
						delete paramDeviations; paramDeviations= new Shape5ParamRec();
						delete paramsToTry; paramsToTry= new Shape5ParamRec();
						}//end IShapeData		
	virtual void		SetCurrentAsBest(void){
						delete bestParams; bestParams = 0;
						bestParams = new Shape4ParamRec(*paramsInUse);
						}//end SetCurrentAsBest
		};//end class AllozymeClineShapeData5

*/
#endif
