// AllozymeClineShapeData6.h

//This class calculates cline shape by fitting data in the form (x,y) to
//a 6-parameter tanh function.  The theory is in Szymura & Barton 1986.
//The program reads in a data set of allozymes and calculates the hybrid
//index and gametic disequilibria for each population.

//derived classes implement the appropriate cline shape functions
#ifndef AllozymeClineShapeData6h
#define AllozymeClineShapeData6h = 1

//#include <iostream.h>
#include <Shape6ParamRec.h>
//#include <AllozymeClineShapeData2.h>
#include <AllozymeClineShapeOnly.h>



class AllozymeClineShapeData6: public AllozymeClineShapeOnly<Shape6ParamRec>{
		public:
			AllozymeClineShapeData6(double harmonicMeanRecomb):
				AllozymeClineShapeOnly<Shape6ParamRec>(harmonicMeanRecomb){
						harMeanRecomb = harmonicMeanRecomb;
						params = 6;}
			AllozymeClineShapeData6(aString& s, double harmonicMeanRecomb): 
				AllozymeClineShapeOnly<Shape6ParamRec>(s, harmonicMeanRecomb){
						harMeanRecomb = harmonicMeanRecomb;
						params = 6;}
			AllozymeClineShapeData6(double numChromosomes, double mapDistBetweenLoci):
				AllozymeClineShapeOnly<Shape6ParamRec>(numChromosomes, mapDistBetweenLoci){
						params = 6;}
			AllozymeClineShapeData6(aString& s, double numChromosomes, double mapDistBetweenLoci): 
				AllozymeClineShapeOnly<Shape6ParamRec>(s, numChromosomes, mapDistBetweenLoci){
						params = 6;}
			~AllozymeClineShapeData6(void){}
			
		};//end class AllozymeClineShapeData6



/*

class AllozymeClineShapeData6: virtual public AllozymeClineShapeData2{
		public:
			AllozymeClineShapeData6(void): AllozymeClineShapeData2(){
				IShapeData();}
			AllozymeClineShapeData6(String& s): AllozymeClineShapeData2(s){
				IShapeData();}
			~AllozymeClineShapeData6(void){}
	virtual void 		IShapeData(void ){
						params = 6;					
						delete bestParams; bestParams= new Shape6ParamRec();
						delete paramsInUse; paramsInUse= new Shape6ParamRec();
						delete paramDeviations; paramDeviations= new Shape6ParamRec();
						delete paramsToTry; paramsToTry= new Shape6ParamRec();
						}//end IShapeData		
	virtual void		SetCurrentAsBest(void){
						delete bestParams; bestParams = 0;
						bestParams = new Shape6ParamRec(*paramsInUse);
						}//end SetCurrentAsBest
		};//end class AllozymeClineShapeData6
		
		
*/
#endif
