// AllozymeClineShapeData7.h

//This class calculates cline shape by fitting data in the form (x,y) to
//a 7-parameter tanh function.  The theory is in Szymura & Barton 1986.
//The program reads in a data set of allozymes and calculates the hybrid
//index and gametic disequilibria for each population.

//derived classes implement the appropriate cline shape functions
#ifndef AllozymeClineShapeData7h
#define AllozymeClineShapeData7h = 1
//#include <iostream.h>
#include <Shape7ParamRec.h>
//#include <AllozymeClineShapeData3.h>
#include <AllozymeClineShapePlus.h>


class AllozymeClineShapeData7: public AllozymeClineShapePlus<Shape7ParamRec>{
		public:
			AllozymeClineShapeData7(double harmonicMeanRecomb):
				AllozymeClineShapePlus<Shape7ParamRec>(harmonicMeanRecomb){
						harMeanRecomb = harmonicMeanRecomb;
						params = 7;}
			AllozymeClineShapeData7(aString& s, double harmonicMeanRecomb): 
				AllozymeClineShapePlus<Shape7ParamRec>(s, harmonicMeanRecomb){
						harMeanRecomb = harmonicMeanRecomb;
						params = 7;}
			AllozymeClineShapeData7(double numChromosomes, double mapDistBetweenLoci):
				AllozymeClineShapePlus<Shape7ParamRec>(numChromosomes, mapDistBetweenLoci){
						params = 7;}
			AllozymeClineShapeData7(aString& s, double numChromosomes, double mapDistBetweenLoci): 
				AllozymeClineShapePlus<Shape7ParamRec>(s, numChromosomes, mapDistBetweenLoci){
						params = 7;}
			~AllozymeClineShapeData7(void){}
			
		};//end class AllozymeClineShapeData7



/*


class AllozymeClineShapeData7: virtual public AllozymeClineShapeData3{
		public:
			AllozymeClineShapeData7(void): AllozymeClineShapeData3(){
				IShapeData();}
			AllozymeClineShapeData7(String& s): AllozymeClineShapeData3(s){
				IShapeData();}
			~AllozymeClineShapeData7(void){}

	virtual void 		IShapeData(void ){
						params = 7;					
						delete bestParams; bestParams= new Shape7ParamRec();
						delete paramsInUse; paramsInUse= new Shape7ParamRec();
						delete paramDeviations; paramDeviations= new Shape7ParamRec();
						delete paramsToTry; paramsToTry= new Shape7ParamRec();
						}//end IShapeData		
	virtual void		SetCurrentAsBest(void){
						delete bestParams; bestParams = 0;
						bestParams = new Shape7ParamRec(*paramsInUse);
						}//end SetCurrentAsBest
		};//end class AllozymeClineShapeData7

*/
#endif

