// AllozymeClineShapeData8.h

//This class calculates cline shape by fitting data in the form (x,y) to
//an 8-parameter tanh function.  The theory is in Szymura & Barton 1986.
//The program reads in a data set of allozymes and calculates the hybrid
//index and gametic disequilibria for each population.

//derived classes implement the appropriate cline shape functions
#ifndef AllozymeClineShapeData8h
#define AllozymeClineShapeData8h = 1

//#include <iostream.h>
#include <Shape8ParamRec.h>
//#include <AllozymeClineShapeData6.h>
#include <AllozymeClineShapeOnly.h>


class AllozymeClineShapeData8: public AllozymeClineShapeOnly<Shape8ParamRec>{
		public:
			AllozymeClineShapeData8(double harmonicMeanRecomb):
				AllozymeClineShapeOnly<Shape8ParamRec>(harmonicMeanRecomb){
						harMeanRecomb = harmonicMeanRecomb;
						params = 8;}
			AllozymeClineShapeData8(aString& s, double harmonicMeanRecomb): 
				AllozymeClineShapeOnly<Shape8ParamRec>(s, harmonicMeanRecomb){
						harMeanRecomb = harmonicMeanRecomb;
						params = 8;}
			AllozymeClineShapeData8(double numChromosomes, double mapDistBetweenLoci):
				AllozymeClineShapeOnly<Shape8ParamRec>(numChromosomes, mapDistBetweenLoci){
						params = 8;}
			AllozymeClineShapeData8(aString& s, double numChromosomes, double mapDistBetweenLoci): 
				AllozymeClineShapeOnly<Shape8ParamRec>(s, numChromosomes, mapDistBetweenLoci){
						params = 8;}
			~AllozymeClineShapeData8(void){}
			
		};//end class AllozymeClineShapeData8


/*


class AllozymeClineShapeData8: virtual public AllozymeClineShapeData6{
		public:
			AllozymeClineShapeData8(void): AllozymeClineShapeData6(){
				IShapeData();}
			AllozymeClineShapeData8(String& s): AllozymeClineShapeData6(s){
				IShapeData();}
			~AllozymeClineShapeData8(void){}
			
	virtual void 		IShapeData(void ){
						params = 8;
						delete bestParams; bestParams= new Shape8ParamRec();
						delete paramsInUse; paramsInUse= new Shape8ParamRec();
						delete paramDeviations; paramDeviations= new Shape8ParamRec();
						delete paramsToTry; paramsToTry= new Shape8ParamRec();
						}//end IShapeData		
	virtual void		SetCurrentAsBest(void){
						delete bestParams; bestParams = 0;
						bestParams = new Shape8ParamRec(*paramsInUse);
						}//end SetCurrentAsBest
		};//end class AllozymeClineShapeData8

*/
#endif
