//FitMultilocusCline.cp
# pragma once
#include <FitMultilocusCline.h>



void ParamSetList::RescaleLtoLmaxRatios (int typeL){
//			oldParamSet: paramRecPtr;
//			i, j, lowLIndex: longint;
	double newL, testL;
	if (typeL == 1){//rescale based on Lcline
			testL = best.Lcline - 2.0;
			best.LtoLmaxCline = 1.0;
			best.LmaxMinusLcline = 0.0;
			newL = best.Lcline;}
		else if (typeL == 2){//rescale based on Ldiseq
			testL = best.Ldiseq - 2.0;
			best.LtoLmaxDiseq = 1.0;
			best.LmaxMinusLdiseq = 0.0;
			newL = best.Ldiseq;}
		else	{//rescale based on Ltotal
			testL = (best.Lcline + best.Ldiseq) - 2.0;
			newL = (best.Lcline + best.Ldiseq);}
	for (long i = len()-1;i>=0;--i){//go backwards because list grows shorter
		ParamRec* oldParamSet = Nth(i);
		if(typeL == 1){//rescale based on Lcline
				if (oldParamSet->Lcline >= testL){//keep this parameter set, but
						//change the LtoLmax ratio & Lmax-L difference
						oldParamSet->LtoLmaxCline = exp(oldParamSet->Lcline - newL);
						oldParamSet->LmaxMinusLcline = (newL - oldParamSet->Lcline);}
					else	{//throw away this parameter set
						Delete(i);}
				}
			else if (typeL == 2){//rescale based on Ldiseq
				if (oldParamSet->Ldiseq >= testL){//keep this parameter set, but
						//change the LtoLmax ratio & Lmax-L difference
						oldParamSet->LtoLmaxDiseq = exp(oldParamSet->Ldiseq - newL);
						oldParamSet->LmaxMinusLdiseq = (newL - oldParamSet->Ldiseq);}
					else	{//throw away this parameter set
						Delete(i);}
				}
			else	{//if typeL==3	//rescale based on Ltotal
				if ((oldParamSet->Lcline + oldParamSet->Ldiseq) < testL){
					//throw away this parameter set
					Delete(i);}
				}//end if typeL...
		}//end for i
	}//end  ParamSetList::RescaleLtoLmaxRatios


int ParamSetList::SaveParams (ParamRec* paramsToSave,int typeL){
	//returns boolean
	//returns False if space left in list, True if all done
//			newPtr: paramRecPtr;
//			lowL: extended;
//			lowLIndex, i: longint;
	int newBest=0;
	if (typeL==1){//compare using Lcline
			if(paramsToSave->Lcline > best.Lcline){
				newBest=1;}}
		else if (typeL==2){//compare using Ldiseq
			if(paramsToSave->Ldiseq > best.Ldiseq){
				newBest=1;}}
		else {//if (typeL==2) //compare using Ltotal
			double Ltotal =best.Lcline +best.Ldiseq;
			if(paramsToSave->Lcline + paramsToSave->Ldiseq > Ltotal){
				newBest=1;}}
	if (newBest) {//can save a new best param even if full
			//best parameter is first in the list
			best=*paramsToSave;
			Prepend(paramsToSave);
			if(len()>maxLen){
				DeleteLast();}
			RescaleLtoLmaxRatios(typeL);}
		else{
			if(len()<=maxLen){
				Append(paramsToSave);}
			}//end if newBest...else
	if (len()>=maxLen){
			return 1;}//sends allDone=True message
		else{
			return 0;}//list still incomplete
	}//end  ParamSetList::SaveParams



