//LikelihoodListDiseq.cp


#include <LikelihoodListDiseq.h>




template<class T> double LikelihoodListDiseq<T>::bestL(ClinePopList& popCombList){
	T* bestParam = best(popCombList);
	if (bestParam == 0){ return 0.0;}
		else{ return bestParam->Ldiseq();}
	}//end LikelihoodListDiseq<T>::bestL(ClinePopList&)




template <class T> void LikelihoodListDiseq<T>::PrintBestParameters(long& allTries,
									aList<long>& acceptedChanges, 
									aList<long>& totalTries,
									ostream& outFile){
	long sumA = 0, sumN = 0; 
	aList<double> successRate; double overallSuccessRate = 0.0;
	for (int i=0;i<totalTries.len();++i){
		successRate.Append(0.0);}
	for (i=0;i<successRate.len();++i){
		if (totalTries[i] > 0){				
			successRate.Replace((double) acceptedChanges[i] / (double) totalTries[i], i);
			sumA += acceptedChanges[i];
			sumN += totalTries[i];
			}//end if totalTries
		}//end for i
	if (sumN > 0){
		overallSuccessRate = (double) sumA / (double) sumN;}

	double diseqSuccess = overallBest.GetDiseqSuccess(successRate);
	overallBest.PrintDiseqWithCI(diseqSuccess,lowerCI, upperCI, outFile);
						
	}//end  LikelihoodListDiseq<T>::PrintBestParameters



template <class T> void LikelihoodListDiseq<T>::SetToCurrentDiseq(T& param, ClinePopList& popCombList){
	T* Dparam = current(popCombList);
	if (Dparam == 0){//new pop combination encountered
			param.D(0.0);//Idiseq
			param.Ldiseq(0.0);//default uncalculated
			param.LtoLmaxDiseq(1.0);
			param.LmaxMinusLDiseq(0.0);}
		else{//look up current value
			param.D(Dparam->D());
			param.Ldiseq(Dparam->Ldiseq());
			param.LtoLmaxDiseq(Dparam->LtoLmaxDiseq());
			param.LmaxMinusLDiseq(Dparam->LmaxMinusLDiseq());}
	}//end LikelihoodListDiseq<T>::SetCurrentDiseq







