//LikelihoodListTotal.h


#ifndef LikelihoodListTotalh
#define LikelihoodListTotalh = 1

#include <LikelihoodList.h>



 template <class T> class LikelihoodListTotal:  public LikelihoodList<T>{
	//For each set of center populations found in the cline-fitting iterations.
	//this class stores the center populations themselves, and
	//the list of acdeptable parameters for those populations.
	//The best-fitting set of parameters is always the 0th element,
	//and the current set of parameters is the last element.
	//The intervening elements in the list are unsorted.
	public:
		LikelihoodListTotal(likelihoodType z): LikelihoodList<T>(z){};
		LikelihoodListTotal(LikelihoodListTotal<T>& c): 
				LikelihoodList<T>(c) {};
		LikelihoodListTotal(LikelihoodListTotal<T>* c):  
				LikelihoodList<T>(c) {};
		~LikelihoodListTotal(void){};
		
	virtual double bestL(ClinePopList& popCombList);
	virtual void 	PrintBestParameters(long& allTries,
								aList<long>& acceptedChanges, 
								aList<long>& totalTries,
								ostream& outFile);
		};//end class LikelihoodListTotal<T>

#endif
