// Shape5ParamRec.h


#ifndef Shape5ParamRech
#define Shape5ParamRech = 1

//#include <Shape2ParamRec.h>
//#include <Shape3ParamRec.h>
//#include <Shape4ParamRec.h>
#include "AllozymeClineGlobals.h"

class ClinePopList;
class Shape5ParamRec;

class Shape5ParamRec
//			 public virtual Shape2ParamRec,
//			 public virtual Shape3ParamRec,
//			 public virtual Shape4ParamRec
			 {
				//a set of cline shape parameters and their derived parameters
		//for width, center location, bottom and top allele frequencies, and disequilibrium
	    public:
		double c_;//when fitting, these are randomly chosen
		double w_;		//width
		double bottomL_;	//average allele freq on left side
		double topR_;		//average allele freq on right side
		double Lcline_;	//likelihood of this parameter set
		double LtoLmaxCline_;
		double LmaxMinusLcline_;
		double D_;//disequilibrium
		double Ldiseq_;	//likelihood of this disequilibrium value
		double LtoLmaxDiseq_;
		double LmaxMinusLDiseq_;
		double Ltotal_;	//likelihood of this parameter set
		double LtoLmaxTotal_;
		double LmaxMinusLTotal_;
	public:
		Shape5ParamRec(void): Lcline_(0.0), LtoLmaxCline_(0.0), LmaxMinusLcline_(0.0),
			c_(0.0), w_(0.0), Ldiseq_(0.0), LtoLmaxDiseq_(0.0), LmaxMinusLDiseq_(0.0), D_(0.0),
			Ltotal_(0.0), LtoLmaxTotal_(0.0), LmaxMinusLTotal_(0.0), bottomL_(0.0), topR_(0.0)
			{}
		Shape5ParamRec(Shape5ParamRec& x):	//copy constructor
					c_(x.center()),
					w_(x.w()),
					bottomL_(x.bottomL()),
					topR_(x.topR()),
					D_(x.D()),
					Lcline_(x.Lcline()),
					LtoLmaxCline_(x.LtoLmaxCline()),
					LmaxMinusLcline_(x.LmaxMinusLcline()),
					Ldiseq_(x.Ldiseq()),
					LtoLmaxDiseq_(x.LtoLmaxDiseq()),
					LmaxMinusLDiseq_(x.LmaxMinusLDiseq()),
					Ltotal_(x.Ltotal()),
					LtoLmaxTotal_(x.LtoLmaxTotal()),
					LmaxMinusLTotal_(x.LmaxMinusLTotal())
					{}
		Shape5ParamRec(Shape5ParamRec* x):	//copy constructor
					c_(x->center()),
					w_(x->w()),
					bottomL_(x->bottomL()),
					topR_(x->topR()),
					D_(x->D()),
					Lcline_(x->Lcline()),
					LtoLmaxCline_(x->LtoLmaxCline()),
					LmaxMinusLcline_(x->LmaxMinusLcline()),
					Ldiseq_(x->Ldiseq()),
					LtoLmaxDiseq_(x->LtoLmaxDiseq()),
					LmaxMinusLDiseq_(x->LmaxMinusLDiseq()),
					Ltotal_(x->Ltotal()),
					LtoLmaxTotal_(x->LtoLmaxTotal()),
					LmaxMinusLTotal_(x->LmaxMinusLTotal())
					{}
		virtual ~Shape5ParamRec(void){}


	virtual double 	center(void){return c_;}
	virtual double 	w(void) {return w_;}	
	virtual double 	bottomL(void){return bottomL_;}//average allele freq on left side
	virtual double 	topR(void){return topR_;} //average allele freq on right side
	virtual double 	Lcline(void){return Lcline_;}
	virtual double 	LtoLmaxCline(void) {return LtoLmaxCline_;}	
	virtual double 	LmaxMinusLcline(void){return LmaxMinusLcline_;}
	virtual double 	D(void){return D_;}
	virtual double 	Ldiseq(void){return Ldiseq_;}
	virtual double 	LtoLmaxDiseq(void){return LtoLmaxDiseq_;}
	virtual double 	LmaxMinusLDiseq(void){return LmaxMinusLDiseq_;}
	virtual double 	Ltotal(void){return Ltotal_;}
	virtual double 	LtoLmaxTotal(void) {return LtoLmaxTotal_;}	
	virtual double 	LmaxMinusLTotal(void){return LmaxMinusLTotal_;}
	virtual void	 	center(double c){c_ = c;}
	virtual void	 	w(double w) {w_ = w;}	
	virtual void	 	bottomL(double b){bottomL_ = b;}
	virtual void	 	topR(double t) {topR_ = t;}	
	virtual void	 	Lcline(double L){Lcline_ = L;}
	virtual void	 	LtoLmaxCline(double ratio) {LtoLmaxCline_ = ratio;}	
	virtual void	 	LmaxMinusLcline(double diff){LmaxMinusLcline_ = diff;}
	virtual void	 	D(double d){D_ = d;}
	virtual void	 	Ldiseq(double L){Ldiseq_ = L;}
	virtual void	 	LtoLmaxDiseq(double ratio){LtoLmaxDiseq_ = ratio;}
	virtual void	 	LmaxMinusLDiseq(double diff){LmaxMinusLDiseq_ = diff;}
	virtual void	 	Ltotal(double L){Ltotal_ = L;}
	virtual void	 	LtoLmaxTotal(double ratio) {LtoLmaxTotal_ = ratio;}	
	virtual void	 	LmaxMinusLTotal(double diff){LmaxMinusLTotal_ = diff;}

	//DERIVED VARIABLES
	virtual double sigma (const double recombinationRate){		
					if (D() < 0.0) {
							return 0.0;}
						else{
							return sqrt((D() * recombinationRate * w() * w()) / (1.0 + recombinationRate));}
					}//end sigma

	virtual double sVsHets (const double recombinationRate){
						double s = sigma(recombinationRate);
						return (2.0*s / w())*(2.0*s / w());}
	virtual double sStarEcotone (const double recombinationRate){	//selection in an ecotone, =(1.732*sigma/w)^2
						double s = sigma(recombinationRate);
						return (1.732*s / w())*(1.732*s / w());}
	virtual double sStarDomEcotone (const double recombinationRate){//selection in an ecotone vs dominant locus, =(1.782*sigma/w)^2
						double s = sigma(recombinationRate);
						return (1.782*s / w())*(1.782*s / w());}



	//REGULAR FUNCTIONS
	virtual Shape5ParamRec* 	
					ChangeDiseqParam(Shape5ParamRec& paramDeviations,
						  Ran3& ran, int& thisOne, const double t);
	virtual Shape5ParamRec* 	
					ChangeParams(Shape5ParamRec& paramDeviations,
						  Ran3& ran, int& thisOne, const double t, const int annealingShape);
	virtual int		ChooseParameter(Ran3& ran, const int annealingShape=0);
	virtual void		Clear(void){
						c_=w_=Lcline_=LtoLmaxCline_=LmaxMinusLcline_=0.0;
						D_=Ldiseq_=LtoLmaxDiseq_=LmaxMinusLDiseq_=0.0;
						Ltotal_=LtoLmaxTotal_=LmaxMinusLTotal_=0.0;
						bottomL_=topR_=0.0;}
	virtual Shape5ParamRec* 	Copy(void){//must be deleted elsewhere
						return new Shape5ParamRec(*this);}
	virtual void		DerivedValues(aList<double>& derivedList, double recombinationRate);
	virtual double 	GetDiseqSuccess(aList<double>& successRate){
						return successRate[4];}//D is fifth parameter varied in ChangeParams
	virtual int 		FindCenterPopulations(ClinePopList& centerPopList, ClinePopList& popLocation);
	virtual int		HasHigherLikelihood(Shape5ParamRec& param, likelihoodType compare, const double ci = 0.0){//boolean
						//always greater if param.L == 0
						if (compare == cline){
								return ((param.Lcline() == 0.0) ||  (Lcline() > param.Lcline() - ci ));}
							else if (compare ==disequilibrium){
								return ((param.Ldiseq() == 0.0) ||  (Ldiseq() > param.Ldiseq() - ci ));}
							else {// (compare ==total)
								return ((param.Ltotal() == 0.0) ||  (Ltotal() > param.Ltotal() - ci ));}
						}//end HasHigherLikelihood
	virtual void		max(Shape5ParamRec& param){//sets parameters to the maximum of this & param
							if(param.center()>center()){c_=param.center();}
							if(param.w()>w()){w_=param.w();}
							Lcline_=LtoLmaxCline_=LmaxMinusLcline_=0.0;
							if(param.D()>D()){D_=param.D();}
							Ldiseq_=LtoLmaxDiseq_=LmaxMinusLDiseq_=0.0;
							Ltotal_=LtoLmaxTotal_=LmaxMinusLTotal_=0.0;
							if(param.bottomL()>bottomL()){bottomL_=param.bottomL();}
							if(param.topR()>topR()){topR_=param.topR();}
							}
	virtual int 		MeetsParamCriteria (void);//boolean for legal parameters
	virtual void		min(Shape5ParamRec& param){//sets parameters to the minimum of this & param
							if(param.center()<center()){c_=param.center();}
							if(param.w()<w()){w_=param.w();}
							Lcline_=LtoLmaxCline_=LmaxMinusLcline_=0.0;
							if(param.D()<D()){D_=param.D();}
							Ldiseq_=LtoLmaxDiseq_=LmaxMinusLDiseq_=0.0;
							Ltotal_=LtoLmaxTotal_=LmaxMinusLTotal_=0.0;
							if(param.bottomL()<bottomL()){bottomL_=param.bottomL();}
							if(param.topR()<topR()){topR_=param.topR();}
							}
	virtual double 	PonCline(const double x, const double score);
	virtual void 		PrintDerivedWithCI(Shape5ParamRec& lowerCI, 
							Shape5ParamRec& upperCI, 
							aList<double>& bestDerived,
							aList<double>& lowerDerivedCI, 
							aList<double>& upperDerivedCI, 
							ostream& outFile);//called by the best total parameter set only
	virtual void 		PrintDiseqWithCI(const double successRate, 
							Shape5ParamRec& lowerCI, 
							Shape5ParamRec& upperCI, 
							ostream& outFile);//called by the best parameter set only		
	virtual void 		PrintShapeWithCI(const long allTries, 
							const double overallSuccessRate, 
							aList<double>& successRate,
							Shape5ParamRec& lowerCI, 
							Shape5ParamRec& upperCI, 
							aList<double>& bestDerived, 
							aList<double>& lowerDerivedCI, 
							aList<double>& upperDerivedCI, 
							ostream& outFile);//called by the best parameter set only
	virtual void		PrintToScreen(const long tries, const double recombinationRate);
	virtual void 		SetClineLikelihoodRatios(double LmaxCline);
	virtual void		SetDeviationValues(void);
	virtual void 		SetDiseqLikelihoodRatios(const double LmaxDiseq);
	virtual void 		SetNewBest(void){LtoLmaxCline_ = 1.0; LmaxMinusLcline_ = 0.0;}
	virtual void 		SetNewBestDiseq(void){LtoLmaxDiseq_ = 1.0; LmaxMinusLDiseq_ = 0.0;}
	virtual void 		SetNewBestTotal(void){LtoLmaxTotal_ = 1.0; LmaxMinusLTotal_ = 0.0;}
	virtual int    		SetShape(void){//returns boolean false if illegal shape
						return MeetsParamCriteria();}
	virtual void		SetStartingValues(void);
	virtual void 		SetTotal(void){Ltotal_ = Lcline() + Ldiseq();}
	virtual void 		SetTotalLikelihoodRatios(const double LmaxTotal);
	virtual void 		operator=(Shape5ParamRec& x){
						c_= x.center();
						w_= x.w();
						bottomL_ = x.bottomL();
						topR_ = x.topR(); 
						D_= x.D();
						Lcline_= x.Lcline();
						LtoLmaxCline_= x.LtoLmaxCline();
						LmaxMinusLcline_= x.LmaxMinusLcline();
						Ldiseq_= x.Ldiseq();
						LtoLmaxDiseq_= x.LtoLmaxDiseq();
						LmaxMinusLDiseq_= x.LmaxMinusLDiseq();
						Ltotal_ = x.Ltotal();
						LtoLmaxTotal_ = x.LtoLmaxTotal();
						LmaxMinusLTotal_ = x.LmaxMinusLTotal();
						}

	friend int 		operator== (Shape5ParamRec& a, Shape5ParamRec& b);

	friend int 		operator!= (Shape5ParamRec& a, Shape5ParamRec& b){
	 					return (!(a==b));}

	};//end class Shape5ParamRec

#endif
