//Shape9ParamRec.cp


#ifndef Shape9ParamReccp
#define Shape9ParamReccp = 1

#include <Shape9ParamRec.h>
#include <ClinePopList.h>



void Shape9ParamRec::operator=(Shape9ParamRec& x){
						c_= x.center();
						w_= x.w();
						thetaL_ = x.thetaL();
						thetaR_ = x.thetaR();
						asymptoteL_ = x.asymptoteL();
						asymptoteR_ = x.asymptoteR();
						bottomL_ = x.bottomL();
						topR_ = x.topR(); 
						xL_ = x.xL();
						xR_ = x.xR();
						betaL_ = x.betaL();
						betaR_ = x.betaR();
						D_= x.D();
						Lcline_= x.Lcline();
						LtoLmaxCline_= x.LtoLmaxCline();
						LmaxMinusLcline_= x.LmaxMinusLcline();
						Ldiseq_= x.Ldiseq();
						LtoLmaxDiseq_= x.LtoLmaxDiseq();
						LmaxMinusLDiseq_= x.LmaxMinusLDiseq();
						Ltotal_ = x.Ltotal();
						LtoLmaxTotal_ = x.LtoLmaxTotal();
						LmaxMinusLTotal_ = x.LmaxMinusLTotal();
						}



Shape9ParamRec* Shape9ParamRec::ChangeDiseqParam (Shape9ParamRec& paramDeviations,
						  Ran3& ran, int& thisOne, const double t){
	int OK=True;
	thisOne = 9;
	Shape9ParamRec* paramToChange = new Shape9ParamRec(*this);//calls copy constructor
	do	{
		OK = True;
		//change disequilibrium by random amount
		paramToChange->D_ = ran.NormDev(D(), paramDeviations.D() * t);
		if ((D() < diseqBottom) || (D() > diseqTop)) {
			OK = False;}
		}while (! OK);
	return paramToChange;
	}//	end Shape9ParamRec::ChangeParams



Shape9ParamRec* Shape9ParamRec::ChangeParams (Shape9ParamRec& paramDeviations,
						  	     Ran3& ran, int& thisOne, const double t, const int annealingShape){
	int OK=True;
	thisOne = ChooseParameter(ran, annealingShape);
	Shape9ParamRec* paramToChange = new Shape9ParamRec(*this);//calls copy constructor
	do	{
		OK = True;
		if (thisOne == 1){//change center point by a random amount
				paramToChange->c_ = ran.NormDev(center(), paramDeviations.center() * t);}
			else if (thisOne == 2){//change width by random amount
				paramToChange->w_ = ran.NormDev(w(), paramDeviations.w() * t);}
			else if (thisOne == 3){//change bottomL by random amount
				paramToChange->bottomL_ = ran.NormDev(bottomL(), paramDeviations.bottomL() * t);}
			else if (thisOne == 4){//change topR by random amount
				paramToChange->topR_ = ran.NormDev(topR(), paramDeviations.topR() * t);}
			else if (thisOne == 5){//change thetaL by random amount
				paramToChange->thetaL_ = ran.NormDev( thetaL(), paramDeviations.thetaL() * t);}
			else if (thisOne == 6){//change thetaR by random amount
				paramToChange->thetaR_ = ran.NormDev(thetaR(), paramDeviations.thetaR() * t);}
			else if (thisOne == 7){//change asymptoteL by random amount
				paramToChange->asymptoteL_ = ran.NormDev(asymptoteL(), paramDeviations.asymptoteL() * t);}
			else if (thisOne == 8){//change asymptoteR by random amount
				paramToChange->asymptoteR_ = ran.NormDev(asymptoteR(),  paramDeviations.asymptoteR() * t);}
			else if (thisOne == 9){//change disequilibrium by random amount
				paramToChange->D_ = ran.NormDev(D(), paramDeviations.D() * t);}
		OK = paramToChange->SetShape();
		}while (! OK);
	return paramToChange;
	}//	end Shape9ParamRec::ChangeParams



int Shape9ParamRec::ChooseParameter(Ran3& ran, const int annealingShape){ 
	//randomly choose center (1), width (2), bottomL (3), topR (4), thetaL (5), thetaR(6), 
	//asymptoteL (7), asymptoteR (8), or disequilibrium (9)
	if (annealingShape){
			return ran.longBetween(1,8);}
		else {
			return ran.longBetween(1,9);}
	}//end Shape9ParamRec::ChooseParameter



Shape9ParamRec* Shape9ParamRec::Copy(void){//must be deleted elsewhere
	return new Shape9ParamRec(*this);
	}//end Shape9ParamRec::Copy



void Shape9ParamRec::DerivedValues(aList<double>& derivedList, double recombinationRate){
	Shape7ParamRec::DerivedValues(derivedList, recombinationRate);
	}//end Shape9ParamRec::DerivedValues




int Shape9ParamRec::FindCenterPopulations(ClinePopList& centerPopList, ClinePopList& popLocation){
	return centerPopList.FindCenterPopulations(*this, popLocation);}



int Shape9ParamRec:: MeetsParamCriteria (void){
	int OK = Shape7ParamRec:: MeetsParamCriteria();
	if (OK){
		if ((bottomL() < minScoreAtL) || (bottomL() > (minScoreAtL + maxScoreAtR) / 2.0)) {
				OK = False;}
			else if ((topR() > maxScoreAtR) || (topR() < (minScoreAtL + maxScoreAtR) / 2.0)) {
				OK = False;}
			else if ((D() < diseqBottom) || (D() > diseqTop)) {
				OK = False;}
		}//end if OK
	return OK;
	}//end  Shape9ParamRec:: MeetsParamCriteria




void Shape9ParamRec::PrintToScreen (const long tries, const double recombinationRate){
	Shape7ParamRec::PrintToScreen(tries, recombinationRate);
	}//end  Shape9ParamRec::PrintToScreen



void	 Shape9ParamRec::SetDeviationValues(void){
	//set initial parameter deviation values (standard deviations)
	//parameters deviated by random variables with these standard deviations
	// these are now constants defined in AllozymeClineGlobals.h
	Shape7ParamRec::SetDeviationValues();
	bottomL_ = bottomTopDev;
	topR_ = bottomTopDev;
	}//end Shape9ParamRec::SetDeviationValues




void	 Shape9ParamRec::SetStartingValues(void){
	// plausible arbitrary values that start the iteration process
	// these are now constants defined in AllozymeClineGlobals.h
	bottomL_ = minScoreAtL;
	topR_ = maxScoreAtR;
	Shape7ParamRec::SetStartingValues();
	}//end Shape9ParamRec::SetStartingValues


int operator== (Shape9ParamRec& a, Shape9ParamRec& b){
	if(	((Shape7ParamRec) a == (Shape7ParamRec) b) &&
		 (a.bottomL()==b.bottomL())  &&			
		 (a.topR()==b.topR())
	    )		 {return 1;}else{ return 0;}
	}//end operator ==


#endif

