/*******************************************************
*
*	GeneticGridCell.cpp
*
*	Superclass: GridCell
*
*	This class handles the interface for genetic individuals
*	of different species.  It adds only functions.

*******************************************************/
#ifndef GeneticGridCellcp
#define GeneticGridCellcp = 1

#include "GeneticGridCell.h"
#include "GeneticLandScape.h"
#include "Element.cpp"
#include "aList.cpp"



GridCell* GeneticGridCell::Duplicate(LandScape* r, CoordinateType coords, int habitat){
	//virtual constructor
	return NEW GeneticGridCell(r,coords,habitat);}
	
	
GridCell* GeneticGridCell::Duplicate(LandScape* r, CoordinateType coords){
		//virtual constructor
	return NEW GeneticGridCell(r,coords);}


GridCell* GeneticGridCell::Duplicate(void){
		//virtual copy constructor
	GeneticGridCell* g = NEW GeneticGridCell(*this);
	g->neighbors_ = neighbors_;
	g->region_ = region_;	
	return g;
	}//end GeneticGridCell::Duplicate()




void GeneticGridCell::CoordsOfNthLocus(int species, int nthLoc, int& onChromNum, int& locNumOnChrom){
		GeneticLandScape* region = (GeneticLandScape*) region_;
		region->CoordsOfNthLocus(species,nthLoc,onChromNum,locNumOnChrom);}


aString*	GeneticGridCell::GetPhenotypeString(int species, long indiv, char* separator){
		GeneticPopulation* pop = (GeneticPopulation*) &(pops_[species]);
		return pop->GetPhenotypeString(indiv, separator);}

int GeneticGridCell::loci(int species){
		GeneticLandScape* region = (GeneticLandScape*) region_;
		return  region->loci(species);}

int GeneticGridCell::NthLocus(int species, int chrom, int locOnChrom){
		GeneticLandScape* region = (GeneticLandScape*) region_;
		return region->NthLocus(species,chrom,locOnChrom);}

int GeneticGridCell::ploidy(int species, int locus){
		GeneticLandScape* region = (GeneticLandScape*) region_;
		return  region->ploidy(species,locus);}

//void GeneticGridCell::Reproduce (int species, long& idCount, Ran3List& ran, double mutationRate, double sigma){
//		GeneticPopulation* pop = (GeneticPopulation*) &(pops_[species]);
//		pop->Reproduce(idCount, ran,mutationRate,sigma);}

void GeneticGridCell::Reproduce (int species, long& idCount, Ran3List& ran, aList<long double>& specialInfo){
		pops_[species].Reproduce(idCount, ran, specialInfo);}

#endif
