/***************************************************
*
*	DioeciousIndividual.cpp
*
*	This class has to mate with the opposite sex  before reproducing,
*		but the genetic details are otherwise ignored.
*	All individuals are classed as males or females upon construction.
*	Genetic stuff done by derived class DioeciousGeneticIndividual.
*	Collect data (dispersal etc.) using derived classes.
*
****************************************************/

#ifndef DioeciousIndividualcp
#define DioeciousIndividualcp = 1

#include "DioeciousIndividual.h"
#include "Population.h"
#include "Element.cpp"
#include "aList.cpp"
#include "RandomList.cpp"

DioeciousIndividual::DioeciousIndividual(genderSet gender, 
								long id, Population* site){
	//uses default SexualIndividual constructor
	id_=id;
	pop_=site;
	matings_=0;
	matingsThisAgeClass_=0;
	sex_=gender;
	}//end constructor


DioeciousIndividual::DioeciousIndividual(long id, Population* site){
	//uses default SexualIndividual constructor
	//by default, all individuals are FEMALE
	id_=id;
	pop_=site;
	matings_=0;
	matingsThisAgeClass_=0;
	sex_=F;
	}//end constructor


DioeciousIndividual::DioeciousIndividual(void){
	//uses default SexualIndividual constructor
	//by default, all individuals are FEMALE
	id_=0;
	pop_=NULL;
	matings_=0;
	matingsThisAgeClass_=0;
	sex_=F;
	}//end constructor


DioeciousIndividual::DioeciousIndividual(DioeciousIndividual& indiv){
	id_=indiv.id();
	pop_=indiv.pop();
	matings_=indiv.matings();
	matingsThisAgeClass_=indiv.matingsThisAgeClass();
	sex_=indiv.sex();
	}//end constructor DioeciousIndividual::DioeciousIndividual
							
							
DioeciousIndividual::DioeciousIndividual(DioeciousIndividual* indiv){
	id_=indiv->id();
	pop_=indiv->pop();
	matings_=indiv->matings();
	matingsThisAgeClass_=indiv->matingsThisAgeClass();
	sex_=indiv->sex();
	}//end constructor DioeciousIndividual::DioeciousIndividual


Individual* DioeciousIndividual::Duplicate (genderSet gender, long id, Population* site){
	//returns a duplicate, used for virtual copy construction
	return  new DioeciousIndividual(gender, id, site);
	}//end  DioeciousIndividual::Duplicate


Individual* DioeciousIndividual::Duplicate (long id, Population* site){
	//returns a duplicate, used for virtual copy construction
	return  new DioeciousIndividual(id, site);
	}//end  DioeciousIndividual::Duplicate

Individual* DioeciousIndividual::Duplicate (void){
	//a virtual constructor
	return new DioeciousIndividual();
	}//end  DioeciousIndividual::Duplicate



		

void DioeciousIndividual::Clone (long& idCount){
	//installs a new baby in the population
	DioeciousIndividual* baby = new DioeciousIndividual(++idCount);
	baby->age_ = 1;
	baby->alive_ = 1;
	baby->lifeStage_ = zygote;
	baby->matings_=0;
	baby->matingsThisAgeClass_=0;
	baby->moveRate(moveRate());
	pop_->Install(baby);
	}//end DioeciousIndividual::Clone
	
	
void DioeciousIndividual::IIndividual (genderSet gender, lifeStageType lifeStage, 
								double rate, Ran3List& ran){
	SexualIndividual::IIndividual(gender,lifeStage,rate,ran);
	if ((sex()==B)||(sex()==A)){
		cout<<"You can't initialize a dioecious hermaphrodite or asexual.";
		cout<<"  Indiv. id: "<<id()<<endl;}
	}//end DioeciousIndividual::IIndividual
	
	

void DioeciousIndividual::IIndividual (genderSet gender, lifeStageType lifeStage, 
								double rate, Ran3List& ran, LandScapeInitializer01& init, aList<double>& extraInfo){
	SexualIndividual::IIndividual(gender,lifeStage,rate,ran,init,extraInfo);//init does things in derived classes
	if ((sex()==B)||(sex()==A)){
		cout<<"You can't initialize a dioecious hermaphrodite or asexual.";
		cout<<"  Indiv. id: "<<id()<<endl;}
	}//end DioeciousIndividual::IIndividual
	
	

void DioeciousIndividual::MakeABaby (long& idCount, Ran3List& ran){
	if(sex_==M) return;
	DioeciousIndividual* baby = (DioeciousIndividual*) Duplicate(++idCount,0);
	baby->age_ = 1;
	baby->alive_ = 1;
	baby->lifeStage_ = zygote;
	baby->matings_=0;
	baby->matingsThisAgeClass_=0;
	baby->sex_ = (ran.next()<intrinsicSexRatio()) ? F:M;
	baby->moveRate(moveRate());
	pop_->Install(baby);
	}//end DioeciousIndividual::MakeABaby

#endif
