/************************
*
*
*	Individual3.cpp
*
		****   MOVED TO Individual.cpp ************
*
*************************/

#ifndef Individual3cp
#define Individual3cp = 1

#include "Individual.h"
#include "Population.h"
#include "GridCell.h"


CoordinateType& Individual::MoveRandomlyKurtoticDiffusion (Ran3List& ran, double kurtosisFactor){
	/*movement is diffusion with random sigma
	randomly determine a new distance in cells to traverse
	travel in steps in random directions until total cells reached
	lose a step if a habitat(landscape) edge crossing is attempted*/
	double mean=0.0, stDev=0.0;
	stDev = moveRate() / gridScale();
	stDev=ran.NormDev(stDev, kurtosisFactor);
	stDev=abs(stDev);
	long dist=(long) ran.NormDev(mean, stDev);
	dist=abs(dist);
	GridCell& currentSite=site();/*current grid cell*/
	GridCell* targetSite = &currentSite;
	while (dist>0){
		int currentHabitat = targetSite->habitat();
		aList<int>* neighborHabitats = targetSite->NeighboringHabitats();
		aList<double> migrationProbs;/*probabilities of moving a given direction*/
		for (int n=0;n<neighborHabitats->len();++n){
			int potentialHabitat = neighborHabitats->Nth(n);
			double prob=0.0;
			if (potentialHabitat != -1){/*-1 indicates absolute boundary*/
				prob = MigrationProb(currentHabitat, potentialHabitat);}
			migrationProbs.Append(prob);
			}/*end for n*/
//		int direction=ran.longBetween(0,targetSite->neighbors()-1);
		int direction=ran.weighted(migrationProbs);
		GridCell* targetNeighbor = targetSite->neighbor(direction);
		if (WillEnterHabitat(targetNeighbor,dist,ran)){
//			targetSite=targetSite->neighbor(direction);
			targetSite=targetNeighbor;
			movedThisGen(1);
			//dist -=1;/*uncomment to avoid skipping a turn for non-move*/
			}/*not-skipping will run forever if no acceptable cell available*/
		dist -=1;/*uncomment to skip a turn for non-move*/
		delete neighborHabitats;neighborHabitats=0;
		}/*end while dist*/
	if(targetSite != &currentSite){
		int s=species();
		currentSite.Extract(s,this);
		targetSite->Install(s,this);
		}//end if
	return coords();/*wherever it ends up*/
	}/*end Individual::MoveRandomlyKurtoticDiffusion*/



#endif
