/***************************************************
*
*	SexualGeneticIndividual.cpp
*
*	Handles processes involving sexually reproducing genetic individuals within populations
*	Genotypes are held in a container class.
*	All are ideal hermaphrodites by default.
*
****************************************************/

#ifndef SexualGeneticIndividualcp
#define SexualGeneticIndividualcp = 1

#include "SexualGeneticIndividual.h"
#include "Element.cpp"
#include "aList.cpp"

	
	
//CONSTRUCTORS AND DESTRUCTORS

SexualGeneticIndividual::SexualGeneticIndividual(Phenotype& newGenes, long id, Population* site){
	id_=id;
	pop_=site;
	genes_= newGenes.Duplicate();
	matings_=0;
	matingsThisAgeClass_=0;
	sex_=B;
	}//end constructor SexualGeneticIndividual::SexualGeneticIndividual


SexualGeneticIndividual::SexualGeneticIndividual(long id,Population* site){
	//must add genes; called during reproduction
	id_=id;
	pop_=site;
	matings_=0;
	matingsThisAgeClass_=0;
	sex_=B;
	}//end constructor SexualGeneticIndividual::SexualGeneticIndividual
	
	
SexualGeneticIndividual::SexualGeneticIndividual(void){
	//must add genes; called during reproduction
	id_=0;
	pop_=NULL;
	matings_=0;
	matingsThisAgeClass_=0;
	sex_=B;
	}//end constructor SexualGeneticIndividual::SexualGeneticIndividual

	
SexualGeneticIndividual::~SexualGeneticIndividual(void){
	PrepareForBurial();
	}//end destructor SexualGeneticIndividual::~SexualGeneticIndividual
	


Individual* SexualGeneticIndividual::Duplicate (void){
	//returns a duplicate, used for virtual copy construction
	return  NEW SexualGeneticIndividual(*this);
	}//end  SexualGeneticIndividual::Duplicate


Individual* SexualGeneticIndividual::Duplicate (long id, Population* site){
	//returns a duplicate, used for virtual copy construction
	return  NEW SexualGeneticIndividual(id, site);
	}//end  SexualGeneticIndividual::Duplicate


GeneticIndividual* SexualGeneticIndividual::Duplicate (Phenotype& newGenes, long id, Population* site){
	//returns a duplicate, used for virtual copy construction
	SexualGeneticIndividual* sgi = NEW SexualGeneticIndividual(id, site);	
	delete sgi->genes_;sgi->genes_=NULL;
	sgi->genes_ = newGenes.Duplicate();
	sgi->sex_ = sgi->genes_->sex(sex());//genetic sex determination overrides
	return sgi;
	}//end  SexualGeneticIndividual::Duplicate






	

void SexualGeneticIndividual::IIndividual (genderSet gender, lifeStageType lifeStage, 
								long double rate, Ran3List& ran){
	Individual::IIndividual(gender,lifeStage,rate,ran);
	sex_ = genes_->sex(gender);//genetic sex determination overrides
	matings_=0; matingsThisAgeClass_=0;
	}//end SexualIndividual<T>::IIndividual


/*void SexualGeneticIndividual::IIndividual (genderSet gender, lifeStageType lifeStage, 
								double rate, Ran3List& ran,LandScapeInitializer00& init){
	GeneticIndividual::IIndividual(gender,lifeStage,rate,ran,init);
	sex_ = genes_.sex(gender);//genetic sex determination overrides
	matings_=0; matingsThisAgeClass_=0;
	}//end SexualIndividual<T>::IIndividual
*/

void SexualGeneticIndividual::IIndividual (genderSet gender, lifeStageType lifeStage, 
								long double rate, Ran3List& ran,LandScapeInitializer01& init, aList<long double>& extraInfo){
	GeneticIndividual::IIndividual(gender,lifeStage,rate,ran,init,extraInfo);
	sex_ = genes_->sex(gender);//genetic sex determination overrides
	matings_=0; matingsThisAgeClass_=0;
	SetPhenotype();
	}//end SexualIndividual<T>::IIndividual


// FUNCTIONS


void SexualGeneticIndividual::Birthday (int maxage){
	matingsThisAgeClass_=0;
	Individual::Birthday(maxage);
	}//end SexualGeneticIndividual::Birthday
	
	
int SexualGeneticIndividual::CanMate (int maxThisAgeClass){
	//override for mate-choice subclasses
	return ((alive())&&(lifeStage_==adult)&&
				(maxThisAgeClass>=matingsThisAgeClass_));
	}//end SexualGeneticIndividual::CanMate
	
	
//void SexualGeneticIndividual::Clone (long& id, Ran3& ran, double mutationRate, double sigma)	{
void SexualGeneticIndividual::Clone (long& id, Ran3List& ran, aList<long double>& specialInfo)	{
	//installs a new baby in the population
	SexualGeneticIndividual* baby = NEW SexualGeneticIndividual(id);
	baby->age_ = 1;
	baby->alive_ = 1;
	baby->lifeStage_ = zygote;
	baby->moveRate_ = moveRate();
	baby->genes_ = genes_->Duplicate();
	baby->sex_ = baby->genes_->sex(sex());
//	double mutationRate = specialInfo[0];
//	double sigma = specialInfo[1];
//	baby->genes_->Mutate(ran,mutationRate,sigma);
	baby->genes_->Mutate(ran,specialInfo);
	baby->matings_=0; 
	baby->matingsThisAgeClass_=0;
	pop_->Install(baby);
	}//end SexualGeneticIndividual::Clone
	

//void SexualGeneticIndividual::Clone (Individual* mom, Ran3& ran, double mutationRate, double sigma)	{
void SexualGeneticIndividual::Clone (Individual* mom, Ran3List& ran, aList<long double>& specialInfo)	{
	//copies mom as a new baby
	//obtain all information directly from mom
//	GeneticIndividual::Clone(mom, ran, mutationRate, sigma);// copies location etc. details
	GeneticIndividual::Clone(mom, ran, specialInfo);// copies location etc. details
	//mom must be a SexualGeneticIndividual
	matings_=0; 
	matingsThisAgeClass_=0;
	}//end SexualGeneticIndividual::Clone



void SexualGeneticIndividual::Copy (GeneticIndividual* it){
	//assumes 'it' is SexualGeneticIndividual
	SexualGeneticIndividual* it1 = (SexualGeneticIndividual*) it;
	SexualGeneticIndividual::Copy(it1);
	}//end SexualGeneticIndividual::Copy

void SexualGeneticIndividual::Copy (Individual* it){
	//assumes 'it' is SexualGeneticIndividual
	SexualGeneticIndividual* it1 = (SexualGeneticIndividual*) it;
	SexualGeneticIndividual::Copy(it1);
	}//end SexualGeneticIndividual::Copy

void SexualGeneticIndividual::Copy (SexualGeneticIndividual* it){
	GeneticIndividual::Copy((GeneticIndividual*) it);
	matings_=it->matings();
	matingsThisAgeClass_=it->matingsThisAgeClass();
	mates_.Copy(it->GetMates());
	}//end SexualGeneticIndividual::Copy


void SexualGeneticIndividual::FindMate (Ran3List& ran, aList<long double>& /*reproductionInfo*/, int tries, int /*maxThisAgeClass*/){
	//NO MAXIMUM MATINGS ENFORCED FOR DEFAULT IDEAL HERMAPHRODITES!!
	//chooses a random individual of the appropriate gender and mates with it
	//the mate must be within the present population
//	if ((tries>0)&&(maxThisAgeClass>matingsThisAgeClass())){//FOR ENF0RCING MAXIMAL MATINGS
	if (tries){
		Population* p=pop();
		StatList<long> choices;
		if (sex()==B){//can mate with males, females, or other hermaphrodites
			 	choices.Append(p->herms()); 
			 	choices.Append(p->females()); 
			 	choices.Append(p->males());}
			 else if (sex()==F){//can mate with males or hermaphrodites
			 	choices.Append(p->herms()); 
			 	choices.Append(0); 
			 	choices.Append(p->males());}
			 else {//(sex()==M)//can mate with females or hermaphrodites
			 	choices.Append(p->herms()); 
			 	choices.Append(p->females()); 
			 	choices.Append(0);}
//DERIVE FOR ENF0RCING MAXIMAL MATINGS
//		int y = (int) (maxThisAgeClass-matingsThisAgeClass_);
//		int actualTries=min(tries,y);
//		for(int t=0;t<actualTries;++t){

		if (choices.sum()>0){
			for(int t=0;t<tries;++t){
				long a=ran.weighted(choices);
				int num=ran.longBetween(0,choices[a]-1);
				Individual* mate;
				if (a==0){mate=&(p->herm(num));} 
					else if (a==1){mate=&(p->female(num));} 
					else {mate=&(p->male(num));}
				SetMate(mate,0);//0 is a dummy variable
				if (*mate != *this){
					mate->SetMate(this,0);}//0 is a dummy variable
				}//end for tries
			}//end if choices
		}//end if tries
	}//end SexualGeneticIndividual::FindMate





CoreGenome&	SexualGeneticIndividual::GetMate (Ran3List& /*ran*/){	
	//returns a genotype list of a mate
	//depends on mating system
	//default is complete LAST-MALE sperm precedence
	return GetMate(0);
		
	
		//commented code does equal sperm mixing
//	long randomDad = ran.longBetween(0,mates.len()-1);
//	Genome<T>& dadGenes = GetMate(randomDad);
//	return dadGenes;
	}//end SexualGeneticIndividual::GetMate



//void SexualGeneticIndividual::MakeABaby (long& idCount, Ran3List& ran, double mutationRate, double sigma){
void SexualGeneticIndividual::MakeABaby (long& idCount, Ran3List& ran, aList<long double>& specialInfo){
	//OVERRIDE IN SUBCLASSES FOR DIFFERENT MATING SYSTEMS
	//THIS IMPLEMENTS SEXUAL REPRODUCTION WITH COMPLETE LAST-MATE SPERM PRECEDENCE
	//does nothing if no sperm available
	//installs a new baby in the population
	if(sex_==M) return;
	if (mates()){
		SexualGeneticIndividual* baby = NEW SexualGeneticIndividual(++idCount);
		baby->age_ = 1;
		baby->alive_ = 1;
		baby->lifeStage_ = zygote;
		baby->moveRate_ = moveRate();
		baby->genes_ = genes_->Duplicate();
		//get the parents genotypes and send to Genotype for meiosis & fertilization	
		CoreGenome& momGenes = GetGenotype();
		CoreGenome& dadGenes = GetMate(ran);
		CoreGenome* g = (CoreGenome*) baby->genes_;
//		g->SetSexualZygote(&momGenes, &dadGenes, ran, mutationRate, sigma);
		g->SetSexualZygote(&momGenes, &dadGenes, ran, specialInfo);
		baby->sex_=baby->genes_->sex(sex());//sex determination overrides; derive for dioecious classes
		baby->SetPhenotype();
		pop_->Install(baby);
		}// end if mates
	}  //end GeneticIndividual.MakeABaby



void SexualGeneticIndividual::Reproduce (long& idCount, Ran3List& ran, aList<long double>& reproductionInfo)	{
	//installs new babies in the population
	//each hermaphrodite reproduces
	//according to its individual fecundity
	//derived classes handle separate genders, genetics, etc.
	//IDEAL HERMAPHRODITES, SO ALL OFFSPRING HAVE NEWLY CHOSEN FATHERS
	if(sex_==M) return;
	int b,f=Fecundity(ran);
	for (b=0;b<f;++b){
		ClearMates();
		FindMate(ran,reproductionInfo,1,1);//each offspring has newly chosen father
//		MakeABaby(idCount,ran,mutationRate,sigma);}
		MakeABaby(idCount,ran,reproductionInfo);}
	}//end SexualGeneticIndividual::Reproduce




void SexualGeneticIndividual::SetMate (Individual* sweetie, int){
	//OVERRIDE FOR OTHER MATING SYSTEM TYPES
	if ((sex()==B)||(sex()==F)){//i.e., receiver's sex
		GeneticIndividual* gSweetie = (GeneticIndividual*) sweetie;
		CoreGenome& sperm = gSweetie->GetGenotype();
//		Genome<T>* spermCopy = NEW Genome<T>();
//		spermCopy->Copy(sperm);
		CoreGenome* spermCopy = (CoreGenome*) sperm.Duplicate();
		mates_.Prepend(spermCopy);
		}//end if female or hermaphrodite
	//this data taken regardless of gender
	++matings_; ++matingsThisAgeClass_;	
	}//end SexualGeneticIndividual::SetMate

StringList* SexualGeneticIndividual::stateNames(void){
	//column heading info for states() below
	StringList* line = Individual::stateNames();
	line->Append(NEW aString("mates"));
	line->Append(NEW aString("totalMatings"));
	return line;
	}//end SexualGeneticIndividual::stateNames


StringList* SexualGeneticIndividual::states(void){
	// indiv values for stateNames() above
	StringList* line = Individual::states();
	line->Append(NEW aString(mates()));
	line->Append(NEW aString(matings())); 
	return line;
	}//end SexualGeneticIndividual::states

#endif


