/***************************************************
*
*	SexualIndividual.cpp
*
*	This class has to mate before reproducing,
*		but the genetic details are otherwise ignored.
*	All individuals are classed as hermaphrodites by default.
*	Genetic stuff done by derived class SexualGeneticIndividual.
*	Collect data (dispersal etc.) using derived classes.
*
****************************************************/

#ifndef SexualIndividualcp
#define SexualIndividualcp = 1

#include "SexualIndividual.h"
#include "Population.h"
#include "StatList.cpp"
#include "Element.cpp"
#include "aList.cpp"

SexualIndividual::SexualIndividual(long id, Population* site){
	//uses default Individual constructor
	//done this way to permit  multiply-inheritance for derived sexual individual classes
	id_=id;
	pop_=site;
	matings_=0;
	matingsThisAgeClass_=0;
	sex_=B;
	}//end constructor


SexualIndividual::SexualIndividual(void){
	//uses default Individual constructor
	//done this way to permit  multiple-inheritance for derived sexual individual classes
	id_=0;
	pop_=NULL;
	matings_=0;
	matingsThisAgeClass_=0;
	sex_=B;
	}//end constructor


SexualIndividual::SexualIndividual(SexualIndividual& indiv){
	Individual::Copy((Individual*) &indiv);
	matings_=indiv.matings();
	matingsThisAgeClass_=indiv.matingsThisAgeClass();
	}//end constructor SexualIndividual::SexualIndividual
							
							
SexualIndividual::SexualIndividual(SexualIndividual* indiv){
	Individual::Copy((Individual*) indiv);
	matings_=indiv->matings();
	matingsThisAgeClass_=indiv->matingsThisAgeClass();
	}//end constructor SexualIndividual::SexualIndividual


Individual* SexualIndividual::Duplicate (long id, Population* site){
	//returns a duplicate, used for virtual copy construction
	return  NEW SexualIndividual(id, site);
	}//end  SexualIndividual::Duplicate




		



void SexualIndividual::Birthday (int maxage){
	Individual::Birthday(maxage);
	if(! alive_) return;//leave current data as is
	matingsThisAgeClass_=0;
	}//end SexualIndividual::Birthday
	
	
int SexualIndividual::CanMate (int maxThisAgeClass){
	//override for genetic subclasses
	return ((alive())&&(lifeStage_==adult)&&
				(maxThisAgeClass>=matingsThisAgeClass_));
	}//end SexualIndividual::CanMate
	
	
void SexualIndividual::Clone (Individual* mom)	{
	//copies mom as a new baby
	Individual::Clone(mom);
	matings_=0;
	matingsThisAgeClass_=0;
	}//end Individual::Clone
	
	
void SexualIndividual::Clone (long& idCount){
	//installs a new baby in the population
	SexualIndividual* baby = new SexualIndividual(++idCount);
	baby->age_ = 1;
	baby->alive_ = 1;
	baby->lifeStage_ = zygote;
	matings_=0;
	matingsThisAgeClass_=0;
	pop_->Install(baby);
	}//end SexualIndividual::Clone
	
/*	
void SexualIndividual::Copy (Individual* it){
	Individual::Copy((Individual*) it);
	matings_=it->matings();
	matingsThisAgeClass_=it->matingsThisAgeClass();
	}//end SexualIndividual::Copy 
*/

void SexualIndividual::FindMate(Ran3List& ran, int tries, int /*maxThisAgeClass*/){
	//MAXIMAL MATINGS UNENFORCED
	//any individual of the opposite sex (or hermaphrodites) in the same grid cell
	//chooses a random individual of the appropriate gender and mates with it
	//the mate must be within the present population
//	if ((tries>0)&&(maxThisAgeClass>matingsThisAgeClass())){//FOR ENF0RCING MAXIMAL MATINGS
	if (tries){
		Population* p=pop();
		StatList<long> choices;
		if (sex()==B){//can mate with males, females, or other hermaphrodites
			 	choices.Append(p->herms()); 
			 	choices.Append(p->females()); 
			 	choices.Append(p->males());}
			 else if (sex()==F){//can mate with males or hermaphrodites
			 	choices.Append(p->herms()); 
			 	choices.Append(0); 
			 	choices.Append(p->males());}
			 else {//(sex()==M)//can mate with females or hermaphrodites
			 	choices.Append(p->herms()); 
			 	choices.Append(p->females()); 
			 	choices.Append(0);}
//DERIVE FOR ENF0RCING MAXIMAL MATINGS
//		int y = (int) (maxThisAgeClass-matingsThisAgeClass_);
//		int actualTries=min(tries,y);
//		for(int t=0;t<actualTries;++t){
		if (choices.sum()>0){
			for(int t=0;t<tries;++t){
				long a=ran.weighted(choices);
				int num=ran.longBetween(0,choices[a]-1);
				Individual* mate;
				if (a==0){mate=&(p->herm(num));} 
					else if (a==1){mate=&(p->female(num));} 
					else {mate=&(p->male(num));}
				SetMate(mate,0);
				if (mate!=this){
					mate->SetMate(this,0);}
				}//end for tries
			}//end if choices
		}//end if tries
	}//end SexualIndividual::FindMate

	

void SexualIndividual::IIndividual (genderSet gender, lifeStageType lifeStage, 
								double rate, Ran3List& ran){
	Individual::IIndividual(gender,lifeStage,rate,ran);
	matings_=0; matingsThisAgeClass_=0;
	}//end SexualIndividual::IIndividual
	
	

void SexualIndividual::IIndividual (genderSet gender, lifeStageType lifeStage, 
								double rate, Ran3List& ran, LandScapeInitializer01& init, aList<double>& extraInfo){
	IIndividual(gender,lifeStage,rate,ran,init, extraInfo);//init does things in derived classes
	}//end SexualIndividual::IIndividual
	
	

void SexualIndividual::MakeABaby (long& idCount, Ran3List&){
	//since selfing is permitted in this class, we need only copy the mother
	if(sex_==M) return;
	Clone(idCount);
	}//end SexualIndividual::MakeABaby 


StringList* SexualIndividual::stateNames(void){
	//column heading info for states() below
	StringList* line = Individual::stateNames();
	line->Append(NEW aString("matings"));
	return line;
	}//end Individual::stateNames


StringList* SexualIndividual::states(void){
	// indiv values for stateNames() above
	StringList* line = Individual::states();
	line->Append(NEW aString(matings())); 
	return line;
	}//end Individual::states




#endif
