/*************************************
*
*	MatrixFunctions.cpp
*
*	functions that return matrices
*
***************************************/

#ifndef MatrixFunctionscpp
#define MatrixFunctionscpp = 1

#include "aMatrix.cpp"
#include "InlineTemplates.h"


aMatrix<long double>* 	CMatrix(unsigned long len){
	aMatrix<long double> *imat = IdentityMatrix(zero, len);
	aMatrix<long double> *jbmat = JbarMatrix(len);
	jbmat->Multiply(-one);
	aMatrix<long double> *cmat = imat->Add(*jbmat);
	delete imat; delete jbmat; imat=jbmat=NULL;
	cmat->nullity_=1;
	return cmat;
	}//end template JbarMatrix


template<class T > aMatrix<T>* IdentityMatrix (T x, unsigned long len){
	aMatrix<T> *imat = ZeroMatrix(x,len,len);
	for(long i=0;i<len;++i){(*imat)[i][i]=(T)1.0;}
	imat->nullity_=0;
	return imat;
}//end IdentityMatrix


aMatrix<long double>* 	JbarMatrix(unsigned long len){
	aMatrix<long double> *jbmat = JMatrix(zero, len);
	jbmat->Multiply(one/(long double)len);
	jbmat->nullity_=len-1;
	return jbmat;
	}//end template JbarMatrix


template <class T> aMatrix<T>* JMatrix(T x, unsigned long len){
	//x is a dummy that gives the return type
	return OneMatrix(x, len,len);}

template <class T> aMatrix<T>* JMatrix(T x, unsigned long rows, unsigned long cols){
	//x is a dummy that gives the return type
	return OneMatrix(x,rows,cols);}

template <class T> aMatrix<T>* OneMatrix(T x, unsigned long rows, unsigned long cols){
	//x is a dummy that gives the return type
	T a = x;//dummy to fool compiler
	aMatrix<T> *omat=NEW aMatrix<T>((T)1.0,rows,cols);
	omat->nullity_=MIN(rows,cols)-1;
	return omat;}

template <class T> aMatrix<T>* ZeroMatrix(T x, unsigned long rows, unsigned long cols){
	//x is a dummy that gives the return type
	T a=x;//dummy to fool debugger
	aMatrix<T> *zmat=NEW aMatrix<T>((T)0.0,rows,cols);
//	zmat->nullity_=min(rows,cols);
	return zmat;}


#endif
