/*******************************************
*
*
*	PartitionedMatrix.cpp
*
*	A class that implements a matrix of matrices of doubles
*
*
*
************************************************/

#ifndef PartitionedMatrixcp
#define PartitionedMatrixcp = 1

#include "PartitionedMatrix.h"
#include "Element.cpp"
#include "aList.cpp"
#include "aVector.cpp"
#include "aMatrix.cpp"
//#include "MatrixList.cpp"



aMatrix<long double>* PartitionedMatrix::Flatten(void){
	aMatrix<long double>* flatmat = NULL;
	PartitionedMatrix& x = *this;
	long nrows=0, ncols=0;
	//check for compatibility
	for(int pmrow1=0;pmrow1<len_;++pmrow1){
		nrows += x[pmrow1][0].rows();
		for (int pmcol1=1;pmcol1<x[pmrow1].len();++pmcol1){
			if(x[pmrow1][0].rows() != x[pmrow1][pmcol1].rows()){
				aString err(" PartitionedMatrix::Flatten; elements with unmatched row numbers!");
				BadOperation(err);
				return flatmat;}}}
	for(int pmcol2=0;pmcol2<x[0].len();++pmcol2){
		ncols += x[0][pmcol2].cols();
		for (int pmrow2=1;pmrow2<len();++pmrow2){
			if(x[0][pmcol2].cols() != x[pmrow2][pmcol2].cols()){
				aString err(" PartitionedMatrix::Flatten; elements with unmatched column numbers!");
				BadOperation(err);
				return flatmat;}}}
	//so far, so good.  make and fill matrix
	flatmat = NEW aMatrix<long double>(zero, nrows, ncols);
	aMatrix<long double>& f = *flatmat;
	long rBasis=0;
	for(int pmrow3=0; pmrow3<len();++pmrow3){
		long cBasis=0;
		for(int pmcol3=0;pmcol3<x[0].len();++pmcol3){
			for(int r=0;r<x[pmrow3][pmcol3].rows();++r){
				for(int c=0;c<x[pmrow3][pmcol3].cols();++c){
					f[r+rBasis][c+cBasis] = x[pmrow3][pmcol3][r][c];
				}}
			cBasis += x[pmrow3][pmcol3].cols();
			}
		rBasis += x[pmrow3][0].rows();
		}
	return flatmat;
	}//end PartitionedMatrix::Flatten()


aMatrix<long double>* PartitionedMatrix::sForm(aMatrix<long double>& m, int index, int size){
	//returns a flattened matrix A with elements a11=ai1=a1i=aii=m, others zero
	Clear();//only start with empty partitioned matrices
	if(index<1){
		aString e="PartitionedMatrix::sForm requires index>0. NULL matrix returned";
		return NULL;}
	for(int pr=0;pr<size;++pr){
		MatrixList* prow=NEW MatrixList();
		Append(prow);
		for(int pc=0;pc<size;++pc){
			aMatrix<long double>* aprpc=NULL;
			if(((pr==0)&&(pc==0)) || (pr==0)&&(pc==index) || (pr==index)&&(pc==0) ||(pr==index)&&(pc==index) ){
					aprpc = NEW aMatrix<long double>(m);}
				else{
					aprpc = ZeroMatrix(zero,m.rows(),m.cols());}
			prow->Append(aprpc);
			}//end for pc
		}//end for pr
	return Flatten();
	}//end PartitionedMatrix::sForm




#endif
