/***************************************************************
*
*
*	StatList.cpp
*
*	superclass aList<T>
*
*	Does basic statistics on lists of numbers
*
***************************************************************/

#ifndef StatListcpp

#define StatListcpp = 1

#include "StatList.h"
#include "Element.cpp"
#include "aList.cpp"





template<class T > StatList< T >::StatList(void): 
		aList<T>() {
			ResetFlags();
			}//empty list



template<class T > StatList< T >::StatList (StatList< T >& toCopy):
		aList< T >() {//constucts a new copy
	for(long i=0;i<toCopy.len();++i){
		T x=toCopy[i];
		aList< T >::Append(x);
		}
	flagsFlag_=toCopy.flagsFlag_;
	kurtosisFlag_=toCopy.kurtosisFlag_;
	harmonicMeanFlag_=toCopy.harmonicMeanFlag_;
	maxFlag_=toCopy.maxFlag_;
	meanFlag_=toCopy.meanFlag_;
	medianFlag_=toCopy.medianFlag_;
	minFlag_=toCopy.minFlag_;
	stdevFlag_=toCopy.stdevFlag_;
	stdevPFlag_=toCopy.stdevPFlag_;
	sumFlag_=toCopy.sumFlag_;
	sumSqdFlag_=toCopy.sumSqdFlag_;
	sumCubedFlag_=toCopy.sumCubedFlag_;
	sum4thedFlag_=toCopy.sum4thedFlag_;
	sqdSumFlag_=toCopy.sqdSumFlag_;
	varFlag_=toCopy.varFlag_;
	varPFlag_=toCopy.varPFlag_;
	kurtosis_=toCopy.kurtosis_;
	harmonicMean_=toCopy.harmonicMean_;
	max_=toCopy.max_;
	mean_=toCopy.mean_;
	min_=toCopy.min_;
	stdev_=toCopy.stdev_;
	stdevP_=toCopy.stdevP_;
	sum_=toCopy.sum_;
	sumSqdVals_=toCopy.sumSqdVals_;
	sumCubedVals_=toCopy.sumCubedVals_;
	sum4thedVals_=toCopy.sum4thedVals_;
	sqdSum_=toCopy.sqdSum_;
	var_=toCopy.var_;
	varP_=toCopy.varP_;
	}//end copy constructor &


template<class T > StatList< T >::StatList (StatList< T >* toCopy):
		aList< T >() {//constucts a new copy
	for(long i=0;i<toCopy->len();++i){
		T x=toCopy->Nth(i);
		aList< T >::Append(x);
		}
	flagsFlag_=toCopy->flagsFlag_;
	kurtosisFlag_=toCopy->kurtosisFlag_;
	harmonicMeanFlag_=toCopy->harmonicMeanFlag_;
	maxFlag_=toCopy->maxFlag_;
	meanFlag_=toCopy->meanFlag_;
	medianFlag_=toCopy->medianFlag_;
	minFlag_=toCopy->minFlag_;
	stdevFlag_=toCopy->stdevFlag_;
	stdevPFlag_=toCopy->stdevPFlag_;
	sumFlag_=toCopy->sumFlag_;
	sumSqdFlag_=toCopy->sumSqdFlag_;
	sumCubedFlag_=toCopy->sumCubedFlag_;
	sum4thedFlag_=toCopy->sum4thedFlag_;
	sqdSumFlag_=toCopy->sqdSumFlag_;
	varFlag_=toCopy->varFlag_;
	varPFlag_=toCopy->varPFlag_;
	harmonicMean_=toCopy->harmonicMean_;
	kurtosis_=toCopy->kurtosis_;
	max_=toCopy->max_;
	mean_=toCopy->mean_;
	min_=toCopy->min_;
	stdev_=toCopy->stdev_;
	stdevP_=toCopy->stdevP_;
	sum_=toCopy->sum_;
	sumSqdVals_=toCopy->sumSqdVals_;
	sumCubedVals_=toCopy->sumCubedVals_;
	sum4thedVals_=toCopy->sum4thedVals_;
	sqdSum_=toCopy->sqdSum_;
	var_=toCopy->var_;
	varP_=toCopy->varP_;
	}//end copy constructor *


template<class T > StatList< T >& StatList< T >::operator= (StatList< T >& z){
    	//copies list z element by element
    	Clear();
   	for (long i=0;i<z.len_;++i){
    		Append(z[i]);}
	flagsFlag_=z.flagsFlag_;
	kurtosisFlag_=z.kurtosisFlag_;
	harmonicMeanFlag_=z.harmonicMeanFlag_;
	maxFlag_=z.maxFlag_;
	meanFlag_=z.meanFlag_;
	medianFlag_=z.medianFlag_;
	minFlag_=z.minFlag_;
	stdevFlag_=z.stdevFlag_;
	stdevPFlag_=z.stdevPFlag_;
	sumFlag_=z.sumFlag_;
	sumSqdFlag_=z.sumSqdFlag_;
	sumCubedFlag_=z.sumCubedFlag_;
	sum4thedFlag_=z.sum4thedFlag_;
	sqdSumFlag_=z.sqdSumFlag_;
	varFlag_=z.varFlag_;
	varPFlag_=z.varPFlag_;
	kurtosis_=z.kurtosis_;
	harmonicMean_=z.harmonicMean_;
	max_=z.max_;
	mean_=z.mean_;
	min_=z.min_;
	stdev_=z.stdev_;
	stdevP_=z.stdevP_;
	sum_=z.sum_;
	sumSqdVals_=z.sumSqdVals_;
	sumCubedVals_=z.sumCubedVals_;
	sum4thedVals_=z.sum4thedVals_;
	sqdSum_=z.sqdSum_;
	var_=z.var_;
	varP_=z.varP_;
    return *this;
    }// StatList< T >::operator=



template<class T> void StatList<T>::CullMissingData(T missingDataVal){
	if(len()>0){
		ResetFlags();
		long i;
		for(i=len_-1;i>=0;--i){
			if(Nth(i)==missingDataVal){
				Delete(i);}
			}//i
		}
	}//StatList<T>::CullMissingData(T )


template<class T > long double StatList< T >::kurtosis(void){
	//also calculates sums, means and variances
	if (kurtosisFlag_) {return kurtosis_;}
	kurtosis_=zero;
	if (var() > zero){
		long double mu4 = (sum4thedVals() - 
					  four * mean() * sumCubedVals() + 
					  six * mean() * mean() * sumSqdVals() - 
					  three * mean() * mean() * mean() * sum()) / n();
		kurtosis_ = (mu4 - three * var() * var()) / (var() * var());
		}
	kurtosisFlag_=flagsFlag_=1;
	return kurtosis_;
	}//end StatList< T >::kurtosis(void)



template<class T > long double StatList< T >::harmonicMean(void){
	if (harmonicMeanFlag_) {return harmonicMean_;}
	if (n() > 0)  {
			long i;
			long double summ = zero, val = zero;
			int undefinedFlag = 0;
			NumElem<T> *elem = first;
			for(i=0;i<len();++i) {
				long double val = (long double)elem->data();				
				if (val!=zero){summ += one/(val);}
					else{undefinedFlag=1;}
				elem = elem->nextElem();
				}
			if (undefinedFlag){harmonicMean_=zero;}
				else{
					summ /= (long double) n();
					harmonicMean_=1/summ;}
			} 
		 else {harmonicMean_=zero;}//end if n()>0
	harmonicMeanFlag_=flagsFlag_=1;
	return harmonicMean_;
	}//end StatList< T >::harmonicMean


template<class T > T StatList< T >::max(void){
	if (maxFlag_) {return max_;}	
	if (n()>0){
		long i;
		max_=First();
		for(i=1;i<n();++i){
			T& y=Nth(i);
			max_=MAX(max_,y);}
		}
		else {max_=zero;}
	maxFlag_=flagsFlag_=1;
	return max_;
	}//end StatList< T >::max



template<class T > long double StatList< T >::mean(void){
	if (meanFlag_) {return mean_;}
	if (n()>0){
			mean_=sum()/(long double)n();} 
		else {
			mean_=zero;}
	meanFlag_=flagsFlag_=1;
	return mean_;
	}//end StatList< T >::mean



template<class T > long double StatList< T >::median(void){
	if (medianFlag_) {return median_;}
	Sort();
	if (len_==0){
			median_=zero;} 
		else if (len_==1){
			median_=Nth(0);}
		else if (odd(len_)){
			median_=Nth(len_/2);}
		else{//even
//			median_ = (long double)(Nth(len_/2) + Nth(len_/2+1))/two;}
			median_ = (long double)(Nth(len_/2-1) + Nth(len_/2))/two;}
	medianFlag_=flagsFlag_=1;
	return median_;
	}//end StatList< T >::mean



template<class T > T StatList< T >::min(void){
	if (minFlag_) {return min_;}	
	if (n()>0){
		min_=First();
		long i;
		for(i=1;i<n();++i){
			T& y=Nth(i);
			min_=MIN(min_,y);}
		}
		else {min_=zero;}
	minFlag_=flagsFlag_=1;
	return min_;
	}//end StatList< T >::min



template<class T > long double StatList< T >::stdErrMean(void){
	//standard deviaiton of the mean, using stdev/sqrt(n)
	long double N = (long double) n();
	long double sqrtN= sqrt(N);
	return stdev()/sqrtN;
	}//end StatList< T >::stdErrMean
	


template<class T > long double StatList< T >::stdev(void){
	//sample standard deviation using (n-1)
	if (stdevFlag_) {return stdev_;}
	stdev_=sqrt(var());
	stdevFlag_=flagsFlag_=1;
	return stdev_;
	}//end StatList< T >::stdev
	


template<class T > long double StatList< T >::stdevP(void){
	//total population standard deviation using (n)
	if (stdevPFlag_) {return stdevP_;}
	stdevP_=sqrt(varP());
	stdevPFlag_=flagsFlag_=1;
	return stdevP_;
	}//end StatList< T >::stdevP
	


template<class T > long double StatList< T >::sum(void){
	//returns the sum of the numbers in the list
	if (sumFlag_) {return sum_;}
	sum_=zero;
	if (n() > 0) {
		NumElem<T> *elem = first;
		long i;
		for(i=0;i<len();++i) {
			sum_ += (long double) elem->data();
			elem = elem->nextElem();
			}
		} //end if len()>0
	sumFlag_=flagsFlag_=1;
	return sum_;
	}	//end StatList< T >::sum



template<class T > long double StatList< T >::sumSqdVals(void){
	//=sum (x^2)
	//returns the sum of the squared numbers in the list
	//also calculates the sum, sum of cubes, and sum of 4th powers
	if (sumSqdFlag_) {return sumSqdVals_;}
	sumSqdVals_=sum_=sumCubedVals_=sum4thedVals_=zero;
	long double x;
	if (n() > 0) {
		long i;
		NumElem<T> *elem = first;
		for(i=0;i<len();++i) {
			x = (long double)elem->data();
			sum_          += x;
			sumSqdVals_   += x * x;
			sumCubedVals_ += x * x * x;
			sum4thedVals_ += x * x * x * x;
			elem = elem->nextElem();
			}
		} //end if len()>0
	sumFlag_=sumSqdFlag_=sumCubedFlag_=sum4thedFlag_=flagsFlag_=1;
	return sumSqdVals_;
	}	//end StatList< T >::sumSqdVals
	
	
	
template<class T > long double StatList< T >::sumCubedVals(void){
	//=sum (x^3)
	//returns the sum of the cubed numbers in the list
	//also calculates the sum, sum of squared vals, and sum of 4th powers
	if (sumCubedFlag_) {return sumCubedVals_;}
	long double x=sumSqdVals();//does the calculations
	return sumCubedVals_;
	}//end StatList< T >::sumCubedVals(void)


template<class T > long double StatList< T >::sum4thedVals(void){
	//=sum (x^4)
	//also calculates the sum, sum of cubes, and sum of squared vals
	if (sum4thedFlag_) {return sum4thedVals_;}
	long double x=sumSqdVals();//does the calculations
	return sum4thedVals_;
	}//end StatList< T >::sum4thedVals(void)




template<class T > long double StatList< T >::sqdSum(void){
	//(sum x)^2
	if (sumSqdFlag_) {return sqdSum_;}
	sqdSum_=sum() * sum();
	sumSqdFlag_=flagsFlag_=1;
	return sqdSum_;
	}//end StatList< T >::sqdSum


template<class T > long double StatList< T >::t(long double givenMean){
	//one-sample t-test statistic
	if (stdev()==zero) {return zero;}
	return givenMean/stdev();
	}//end StatList< T >::t


template<class T > long double StatList< T >::var(void){
	//returns the sample variance using (n-1)
	//also calculates the total population variance 
	if (varFlag_) {return var_;}
	varP_=var_=zero;
	long double sqdev=zero, dev=zero;
	if ((n()-1) > 0) {//otherwise var_=0 or is undefined
		NumElem<T> *elem = first;
		long i;
		for(i=0;i<len();++i) {
			dev=((long double)elem->data() - mean());
			sqdev += (dev * dev);
			elem = elem->nextElem();
			}
		var_ = 	sqdev / (long double)(n()-1);
		varP_ = sqdev / (long double)n();
		} //end if n()>0
	varFlag_=varPFlag_=flagsFlag_=1;
	return var_;
	}	//end StatList< T >::var



template<class T > long double StatList< T >::varP(void){
	//returns the total population variance using (n)
	//also calculates the sample variance 
	if (varPFlag_) {return varP_;}
	varP_=var_=zero;
	long double sqdev=zero, dev=zero;
	if ((n()-1) > 0) {//otherwise varP_=0 or is undefined
		NumElem<T> *elem = first;
	long i;
		for(i=0;i<len();++i) {
			dev=((long double)elem->data() - mean());
			sqdev += (dev * dev);
			elem = elem->nextElem();
			}
		var_ = 	sqdev / (long double)(n()-1);
		varP_ = sqdev / (lolng double) n();
		} //end if n()>0
	varFlag_=varPFlag_=flagsFlag_=1;
	return varP_;
	}	//end StatList< T >::varP




#endif



