/******************************************
*
*
*
*	CommonMathFunctions.cpp
*
*	solves Quadratic; add others as needed
*
*
*****************************************/



#ifndef CommonMathFunctionscpp
#define CommonMathFunctionscpp

#include "CommonMathFunctions.h"
#include "Element.cpp"
#include "aList.cpp"
#include "StatList.cpp"



typedef long double (*General_1D_Function)(aList<long double>& /*all parameters & variables*/);
	//use this for any genralized function

long double SomeFunction(aList<long double>& /*dummy*/){
		 return zero;}	//default function



long double Integrate(General_1D_Function func, aList<long double>& variables){// lowEnd, long double highEnd, long double tolerance){//StatList<long double>& points);//, aList<long double>& parameters){
	//in this function, the last three varibles must be, in sequence, lowEnd, highEnd, tolerance
	int i;
	long double trapezoidArea, xdist,f0,f1,x1,x2,integral1,integral2;
	StatList<long double> *integralCurrent, *integralNew, points;
	integralCurrent= NEW StatList<long double>();
	integralNew = NEW StatList<long double>();
	bool done=false;
	
	long double tolerance = variables.Last();
	variables.DeleteLast();
	long double highEnd = variables.Last();
	variables.DeleteLast();
	long double lowEnd = variables.Last();

	long double midpoint = (lowEnd+highEnd)/two;

	points.Append(lowEnd);
	points.Append(midpoint);
	points.Append(highEnd);

	for(i=0;i<points.len()-1;++i){
		variables.Last() = points[i];//replaces lowEnd on first call
		f0 = func(variables);
		variables.Last() = points[i+1];
		f1 = func(variables);
		xdist = points[i+1]-points[i];
		trapezoidArea = xdist*(f0+f1)/two;
		integralCurrent->Append(trapezoidArea);
		}
	cout<<"progress = "<<integralCurrent->sum()<<endl;

	while (! done){
		integralNew->Clear();
		for(i=points.len()-2;i>=0;--i){
			x1=points[i];
			x2=points[i+1];
			points.Append((x1+x2)/two);
			}
		points.Sort();
		for(i=0;i<points.len()-1;++i){
			variables.Last()=points[i];
			f0 = func(variables);
			variables.Last()=points[i+1];
			f1 = func(variables);
			xdist = points[i+1]-points[i];
			trapezoidArea = xdist*(f0+f1)/two;
			integralNew->Append(trapezoidArea);
			}
		integral1=integralCurrent->sum();
		integral2=integralNew->sum();
		cout<<"progress = "<<integral2<<endl;
		if(ABS(integral1-integral2)<=tolerance){
				done=true;}
			else{
				SWAP(integralCurrent, integralNew);}
		}//! done
	cout<<"answer = "<<integral2<<endl;

	delete integralCurrent;
	delete integralNew;
	integralCurrent = integralNew = NULL;
	variables.Append(lowEnd);//restore
	variables.Append(highEnd);
	variables.Append(tolerance);	
	return integral2;
	}//function Integrate
	



void SolveQuadratic(aList<long double>& abc, aList<long double>& quadraticSolutions){
	quadraticSolutions.Clear();
	if(abc.len()>=3 && abc[0] != zero){
		long double val, a=abc[0], b=abc[1], c=abc[2];
		val = (-b + sqrt(b*b -four*a*c))/(two*a);
		quadraticSolutions.Append(val);
		val = (-b - sqrt(b*b -four*a*c))/(two*a);
		quadraticSolutions.Append(val);
		}
	}//end SolveQuadratic(aList<long double>& , aList<long double>& )




#endif
