/***********************************************************************************
*
*	CoordinateClass.cpp
*
*	Template class holding coordinates in Cartesian space
*
************************************************************************************/

#ifndef CoordinateClasscpp
#define CoordinateClasscpp = 1

#include "CoordinateClass.h"
//#include "Element.cpp"
//#include "aList.cpp"


template <class T> CoordinateClass<T>::CoordinateClass(void) {
 		data_[0] = (T)0.0; data_[1] = (T)0.0; data_[2] = (T)0.0;}
 		
 		
template <class T> CoordinateClass<T>::CoordinateClass(T x, T y, T z) {
 		data_[0] = x; data_[1] = y; data_[2] = z;}
 		
 		
template <class T> CoordinateClass<T>::CoordinateClass(CoordinateClass<T>& c) {
 		data_[0] = c[0]; data_[1] = c[1]; data_[2] = c[2];}
 		
 		
template <class T> CoordinateClass<T>::CoordinateClass(CoordinateClass<T>* c) {
 		data_[0] = (*c)[0]; data_[1] = (*c)[1]; data_[2] = (*c)[2];}
 		
 		
template <class T>   	CoordinateClass<T>* CoordinateClass<T>::Duplicate(void){
		return NEW CoordinateClass<T>(*this);
		}



template <class T> T& CoordinateClass<T>::operator[] (int i) {return data_[i];}


template <class T> void CoordinateClass<T>::set (T x, T y, T z) {
		data_[0]=x; data_[1]=y; data_[2]=z;}


template <class T> void CoordinateClass<T>::set_x (T x) {
		data_[0]=x;}


template <class T> void CoordinateClass<T>::set_y (T y) {
		data_[1]=y;}


template <class T> void CoordinateClass<T>::set_z (T z) {
		data_[2]=z;}


template <class T> void CoordinateClass<T>::RandomLoc(T minX, T maxX, T minY, T maxY, Ran3& ran){
  			data_[0]=ran.longBetween (minX,maxX);
   			data_[1]=ran.longBetween (minY,maxY);
   			}


template <class T> void CoordinateClass<T>::RandomLoc(T minX, T maxX, T minY, T maxY, T minZ, T maxZ, Ran3& ran){
  			data_[0]=ran.longBetween (minX,maxX);
   			data_[1]=ran.longBetween (minY,maxY);
   			data_[1]=ran.longBetween (minZ,maxZ);
   			}


template <class T> int operator== (CoordinateClass<T>& a, CoordinateClass<T>& b){
			return ((a.data_[0]==b.data_[0])&&(a.data_[1]==b.data_[1])&&(a.data_[2]==b.data_[2]));}
			
			
template <class T> int operator!= (CoordinateClass<T>& a, CoordinateClass<T>& b){
			return !(a==b);}
  	

#endif
