/**************************************************
*
*	Correlation.cpp
*
*	This class computes correlation coefficients on pairs of numbers.
*
**************************************************/

#ifndef Correlationcpp
#define Correlationcpp = 1



#include "Correlation.h"
#include "Element.cpp"
#include "aList.cpp"
#include "StatList.cpp"


Correlation::Correlation(void):rFlag_(0){}
Correlation::Correlation(StatList<long double> a, StatList<long double> b):
   			rFlag_(0), x_(a), y_(b) { 
   				CalcrPearson();}
Correlation::Correlation(Correlation& c):
   			rFlag_(c.rFlag_), x_(c.x_), y_(c.y_),
   			rPearson_(c.rPearson_){}
Correlation::Correlation(Correlation* c):
  			rFlag_(c->rFlag_), x_(c->x_), y_(c->y_),
  			rPearson_(c->rPearson_){}
Correlation::~Correlation(void){
	x_.Clear();
	y_.Clear();}


   	
void Correlation::Append(long double x, long double y){
	x_.Append(x);y_.Append(y);}


    	
void Correlation::CalcrPearson(void){//sets rPearson_=2.0 if r is undefined
	if(x_.len() != y_.len()){
		cout<<"The lists must be of the same length to do a correlation"<<endl; return;}
	long double sum = zero;
	for (int i=0;i<x_.len();++i){
		sum += (x_[i] - x_.mean() ) * (y_[i] - y_.mean() );
		}//end for i
	rPearson_ = two;
	if (x_.stdev() !=zero && y_.stdev() != zero ){//whereupon r is undefined
		rPearson_ = sum/(x_.stdev() * y_.stdev() );}
	rFlag_ = 1;
	}//end Correlation::CalcrPearson

   	
long double Correlation::rPearson(void){
	if (rFlag_==0){CalcrPearson();}
	return rPearson_;
	}//end Correlation::rPearson






#endif



