/***********************************************
*
*	LogLikelihoodFunctions.cpp
*
*	this holds commonly used log-likelihood functions,
*	useful for maximizing likelihoods and comparing them
*
************************************************/


#ifndef LogLikelihoodFunctionscpp
#define LogLikelihoodFunctionscpp = 1


#include "LogLikelihoodFunctions.h"
#include "Element.cpp"
#include "aList.cpp"


long double BinomialLnLikelihood(long n, long r, long double p){
	long double lnL=one;//impossible value
	if(n > 0 && r<=n && r>=0){
		if((p==zero && r==0) || (p==one && r==n)){
				lnL=zero;}//100% true
			else if(p>zero && p<one){
				long double nn = (long double)n, rr = (long double) r;
				lnL = nn*log(p) + (nn-rr)*log(one - p);
				}
			else{}
		}
	return lnL;
	}










long double NormalLnLikelihood(aList<long double>& x, long double mu, long double sigma){
	long double lnL=zero;
	if(x.len()>0 && sigma>zero){
		long double n = x.len(), ssq=zero;
		long i;
		for(i=0;i<x.len();++i){
			ssq += (x[i] - mu)*(x[i]-mu);
			}
		lnL = - n*log(sigma) - ssq/(two * sigma * sigma);
		}
	return lnL;
	}
	


#endif

