/*********************************************
*
*
*		NormalDistrib.cpp
*
*
*		Functions for calculating Normal-distribution statistics
*
*
**********************************************/


#ifndef NormalDistributioncp
#define NormalDistributioncp = 1

#include "NormalDistrib.h"
#include "Element.cpp"
#include "aList.cpp"


long double NormalDistrib(	const long double x, 
							const long double mu, 
							const long double sigma){
		//calculates the height of N(mu,sigma) at point x
//		const long double pi = 3.141592653589793238462643383;
		long double sqrt2pi = sigma * sqrt( two * PI());
		if(x == mu){return one/sqrt2pi;}
		long double dev = (x - mu) / sigma;
		if(dev*dev/two==zero){return one/sqrt2pi;}
		long double exponent = - (dev * dev / two);
		long double f = exp(exponent);
//		long double s = (sigma * sqrt2pi);
		long double s = sqrt2pi;
		return f/s;
		}
		
long double NormalDistrib(aList<long double>& mu_sigma_x){
		//calculates the height of N(mu,sigma) at point x
		long double mu = mu_sigma_x[0];
		long double sigma = mu_sigma_x[1];
		long double x = mu_sigma_x[2];
		return NormalDistrib(x,mu,sigma);
		}
		

#endif

