/*******************************************************
*
*	SexualPopulation.cpp															
*
*	Superclass:  Population																							
*
*	This class handles processes within sexual (but not genetic) populations					
********************************************************/

#ifndef SexualPopulationcpp
#define SexualPopulationcpp = 1


#include "SexualPopulation.h"
#include "Element.cpp"
#include "aList.cpp"
#include "RandomList.cpp"


void SexualPopulation::AssignMates (Ran3List& ran, int tries, 
									 int maxThisAgeClass){
	long i;
	for (i=0;i<herms();++i){
		herm(i).FindMate(ran,tries,maxThisAgeClass);
		}//end for i
	for (i=0;i<females();++i){
		female(i).FindMate(ran,tries,maxThisAgeClass);
		}//end for i
	}//end SexualPopulation::AssignMates



void SexualPopulation::Reproduce (long& idCount, Ran3List& ran){
	//clones randomly chosen hermaphroditic adults in the population
	//according to their individual fecundities
	//cloning ok here because genetics not specified
	//derived classes handle separate genders, genetics, etc.
	Population::Reproduce(idCount,ran);//also do any asexuals
	long i;
	for (i=0;i<herms();++i){
		herm(i).Reproduce(idCount,ran);}
	} //end SexualPopulation::Reproduce 

#endif


