/******************************************
*
*	RandomList.cp
*
*	handles random number classes
*
******************************************/

#ifndef RandomListcp
#define RandomListcp = 1


#include "RandomList.h"
#include "Element.cpp"
#include "aList.cpp"
#include "aVector.cpp"



long Ran3List::weighted(aList<int>& weights){
	//returns an index of a place in the list 
	long sum=0;
	long i;
	for (i=0;i<weights.len();++i){
		sum+=weights[i];}
	long x=longBetween(1,sum);
	long cum=0;
	for (i=0;i<weights.len();++i){
		cum+=weights[i];
		if((x<cum)||((x==cum)&&(cum==sum))){
			return i;}
		}
	return weights.len();
	}//end Ran3List::weighted<int>



long Ran3List::weighted(aList<long>& weights){
	//returns an index of a place in the list 
	long i, sum=0;
	for (i=0;i<weights.len();++i){
		sum+=weights[i];}
	long x=longBetween(1,sum);
	long cum=0;
	for (i=0;i<weights.len();++i){
		cum+=weights[i];
		if((x<cum)||((x==cum)&&(cum==sum))){
			return i;}
		}
	return weights.len();
	}//end Ran3List::weighted<long>


long Ran3List::weighted(aList<float>& weights){
	//returns an index of a place in the list 
	double sum=0.0;
	long i;
	for (i=0;i<weights.len();++i){
		sum+=weights[i];}
	float x=doubleBetween(0,sum);
	double cum=0;
	for (i=0;i<weights.len();++i){
		cum+=weights[i];
		if((x<cum)||((x==cum)&&(cum==sum))){
			return i;}
		}
	return weights.len();
	}//end Ran3List::weighted<float>


long Ran3List::weighted(aList<double>& weights){
	//returns an index of a place in the list 
	double sum=0.0;
	long i;
	for (i=0;i<weights.len();++i){
		sum+=weights[i];}
	double x=doubleBetween(0,sum);
	double cum=0.0;
	for (i=0;i<weights.len();++i){
		cum+=weights[i];
		if((x<cum)||((x==cum)&&(cum==sum))){
			return i;}
		}
	return weights.len();
	}//end Ran3List::weighted<double>


long Ran3List::weighted(aList<long double>& weights){
	//returns an index of a place in the list 
	long double sum=zero;
	long i;
	for (i=0;i<weights.len();++i){
		sum+=weights[i];}
	long double x=longdoubleBetween(0,sum);
	long double cum=zero;
	for (i=0;i<weights.len();++i){
		cum+=weights[i];
		if((x<cum)||((x==cum)&&(cum==sum))){
			return i;}
		}
	return weights.len();
	}//end Ran3List::weighted<long double>








long Ran3List::weighted(aVector<int>& weights){
	//returns an index of a place in the list 
	long sum=weights.Sum();
	long i;
	long x=longBetween(1,sum);
	long cum=0;
	for (i=0;i<weights.len();++i){
		cum+=weights[i];
		if((x<cum)||((x==cum)&&(cum==sum))){
			return i;}
		}
	return weights.len();
	}//end Ran3List::weighted<int>



long Ran3List::weighted(aVector<long>& weights){
	//returns an index of a place in the list 
	long i, sum=weights.Sum();
	long x=longBetween(1,sum);
	long cum=0;
	for (i=0;i<weights.len();++i){
		cum+=weights[i];
		if((x<cum)||((x==cum)&&(cum==sum))){
			return i;}
		}
	return weights.len();
	}//end Ran3List::weighted<long>


long Ran3List::weighted(aVector<float>& weights){
	//returns an index of a place in the list 
	double sum=weights.Sum();
	long i;
	float x=doubleBetween(0,sum);
	double cum=0;
	for (i=0;i<weights.len();++i){
		cum+=weights[i];
		if((x<cum)||((x==cum)&&(cum==sum))){
			return i;}
		}
	return weights.len();
	}//end Ran3List::weighted<float>


long Ran3List::weighted(aVector<double>& weights){
	//returns an index of a place in the list 
	double sum=weights.Sum();
	long i;
	double x=doubleBetween(0,sum);
	double cum=0.0;
	for (i=0;i<weights.len();++i){
		cum+=weights[i];
		if((x<cum)||((x==cum)&&(cum==sum))){
			return i;}
		}
	return weights.len();
	}//end Ran3List::weighted<double>


long Ran3List::weighted(aVector<long double>& weights){
	//returns an index of a place in the list 
	long double sum=weights.Sum();
	long i;
	long double x=longdoubleBetween(0,sum);
	long double cum=zero;
	for (i=0;i<weights.len();++i){
		cum+=weights[i];
		if((x<cum)||((x==cum)&&(cum==sum))){
			return i;}
		}
	return weights.len();
	}//end Ran3List::weighted<long double>



#endif
