/******************************************
*
*	Randomness2bit.cpp
*
*	handles random number classes
*
******************************************/

#ifndef Randomness2bitcp
#define Randomness2bit = 1

#include "Randomness2bit.h"


void Ran3::IRan3(void){
	//initializes 
	float mj = mseed_ + idum_;
	if (mj !< 0.0) {
			mj -= mbig_ * long(mj / mbig_);}
		else {
			mj = mbig_ - abs(mj) + mbig_ * long(abs(mj) / mbig_);}
	ran3ma_[54] = mj;
	float mk = 1.0;
	int ii;
	for (int i=1;i<55;++i){// 1 to 54 in pascal
//		ii =  mod(21 *(i), 55);//fix operator mod long( i - j * long(i/j))
		int temp = 21*(i);
		ii =  long( temp - 55 * long(temp/55));//same without mod call 
		ran3ma_[ii-1] = mk;
		mk = mj - mk;
		if (mk < mz_) {mk += mbig_;}
		mj = ran3ma_[ii-1];
		}//	end for i
	for (int k=0;k<4;++k){
		for (int i=0;i<55;++i){ 
//			ii=(1 + mod((i + 30), 55))-1;
			long temp = (i + 30);
			ii=1+long( temp - 55 * long(temp/55))-1;//same without mod call 
			ran3ma_[i] -= ran3ma_[ii];
			if (ran3ma_[i] < mz_) {ran3ma_[i] += mbig_;}
			}
		}
	ran3Inext_ = 0;
	ran3Inextp_ = 31;
	idum_ = 1;
	}//end IRan3
	
float Ran3::next(void){
	//returns a random number
	++ran3Inext_;
	if (ran3Inext_ == 56) {ran3Inext_ = 1;}
	++ran3Inextp_;
	if (ran3Inextp_ == 56) {ran3Inextp_ = 1;}
	float mj = ran3ma_[ran3Inext_-1] - ran3ma_[ran3Inextp_-1];
	if (mj < mz_){
			mj += mbig_;}
	ran3ma_[ran3Inext_-1] = mj;
	return mj * fac_;
	}// end Ran3::next
	
	
float Ran3::GasDev (void) {
	//returns a random deviate from a standard normal distribution
	//adapted from Pascal Recipes p 225
	float f, r, v1, v2;
	if (gasdevIset_ == 0){
			do{
				v1 = 2.0 * next() - 1.0;
				v2 = 2.0 * next() - 1.0;
				r = (v1*v1) + (v2*v2);
				}while ((r <= 0.0) || (r >= 1.0));
			f = sqrt(-2.0 * log(r) / r);
			gasdevGset_ = v1 * f;
			gasdevIset_ = 1;
			return (v2 * f);
			}
		else{
			gasdevIset_ = 0;
			return gasdevGset_;
			}
	}//end Ran3::GasDev


long Ran3::longBetween (long bottom, long top){
	long range = top - bottom + 1;
	return  long((next() * range) + bottom);
	}//end Ran3::longBetween


float Ran3::floatBetween (float bottom, float top){
	float range = top - bottom;
	return  (next() * range) + bottom;
	}//end Ran3::longBetween



float Ran3::NormDev (float mu, float sigma){
	//returns a random normal deviate 
	//from dist. of mean=mu and st.dev=sigma}
	return (sigma * GasDev() + mu);}







#endif
