/******************************************************
*
*	StringClass.cpp
*
*	Implements a string class, from C++ FAQs book, FAQ#459
*	Additional functions added.
*
*
********************************************************/

//20020906 modified numerical constructors to return 'undefined' for NAN errors

#ifndef StringClasscp
#define StringClasscp = 1

#include "StringClass.h"
#include "Element.cpp"
#include "aList.cpp"

int Digits (long i){
	//counts digits in a long integer
	//negative sign counts as a digit
	int digit = 0;
	if (i < 0){++digit;i= (-i);}
	do{
		++digit;
		i = (long)(i / 10);
		}while (i > 0);
	return digit;
	} //end function Digits




aString::aString(const aString& s): 
		len_(s.len_), data_(NEW char[s.len_+1]){
  		memcpy(data_, s.data_, len_+1);}
  		
aString::aString(const aString* s): 
		len_(s->len_), data_(NEW char[s->len_+1]){
  		memcpy(data_, s->data_, len_+1);}




aString::aString (int n):len_(0),data_(NEW char[1]){
			data_[0]='\0';
			char newChar;
			long lastNumeral, remains = ABS(n);
			for (int i= Digits(ABS(n));i>=1;--i){
				lastNumeral = long( remains - (long)10 * long(remains/(long)10));
				remains = (int)((remains - lastNumeral) / 10);
				newChar = (char)(lastNumeral + '0');
				prepend(newChar);
				}//end for i
			if (n<0) {prepend('-');}
	}//end constructor aString(int)



aString::aString (long n):len_(0),data_(NEW char[1]){
			data_[0]='\0';
			char newChar;
			long lastNumeral, remains = ABS(n);
			for (int i= Digits(ABS(n));i>=1;--i){
				lastNumeral = long( remains - (long)10 * long(remains/(long)10));
				remains = (int)((remains - lastNumeral) / 10);
				newChar = (char)(lastNumeral + '0');
				prepend(newChar);
				}//end for i
			if (n<0) {prepend('-');}
	}//end constructor aString(long)


aString::aString (const float n, int /*preDecPlaces*/, int decPlaces):
		len_(0),data_(NULL){
	float nn = ROUND(n,decPlaces);
	bool neg=false;
	if(nn<0){
		neg=true;
		nn*=-1.0;}
	std::stringstream ss;
	ss<<nn;
	std::string s = ss.str();
	int nnn=s.length();
	int i, decloc=-1, postDecLen,moreDecPlacesNeeded;
	data_=NEW char[nnn+1];
	for(i=0;i<nnn;++i){
		data_[i] = (char)(s[i]);
		if(data_[i]=='.'){
			decloc=i;}
		}
	data_[nnn]='\0';
	len_=nnn;
	if(decloc== -1){
			postDecLen=0;}
		else{
			postDecLen=nnn-(decloc+1);}
	moreDecPlacesNeeded=decPlaces-postDecLen;
	if(moreDecPlacesNeeded>0){
			if(decloc==-1){
				cat('.');}
			AppendCharToLen('0',len_ + moreDecPlacesNeeded);}
	if(decloc==0){
		prepend(0);}
	if(neg && nn!=0){
		prepend('-');}
	}//end constructor aString(const float,int,int)
	
	
	

/*
aString::aString (const float n, int preDecPlaces, int decPlaces):
		len_(0),data_(NEW char[1]){
			data_[0]='\0';
			int places=0;
			float remains=ABS(n);
			long preDecimal=(long)(remains);
			remains -= preDecimal;
			long postDecimal=0;
			int leadingZeros=0,countingLeadingZeros=1;
			while(remains>0){//take care of floating-point inaccuracies
				int m = (int)(10*remains);
				if (countingLeadingZeros && m==0) 
						{++leadingZeros;} 
					else{
						countingLeadingZeros=0;
						postDecimal=10*postDecimal+m;}
				++places;
				if (places>=decPlaces+1) {break;}
				remains = 10*remains - m;
				}//end while
			if (places>=decPlaces+1){//round off 
				double x=(double)(postDecimal)/10.0 - ((long)(postDecimal/10));
				postDecimal=(long)(postDecimal/10);
				if (x>=0.5) {
					int preincrementDigits = Digits(postDecimal);
					++postDecimal;
					int postincrementDigits = Digits(postDecimal);
					if(preincrementDigits<postincrementDigits){
						--leadingZeros;}
					}
				--places;
				if(Digits(postDecimal)>places){
					++preDecimal;
					postDecimal=0;
					places=1;}
				}//end if places
			cat(preDecimal);
			if((data_[0]==',' && data_[1]=='(')||(data_[1]==',' && data_[2]=='(')){
				*this = "undefined";//reading in a NAN error
				return;}		
			if (preDecPlaces>0){
				PrependCharToLen (' ',preDecPlaces);}
			cat('.');
			for(int i=0;i<leadingZeros; ++i){cat('0');}
			cat(postDecimal);
			for(int i=places;i<decPlaces;++i){cat('0');}
	}//end constructor aString(float)
*/


aString::aString (const double n, int /*preDecPlaces*/, int decPlaces):
		len_(0),data_(NULL){
	double nn = ROUND(n,decPlaces);
	bool neg=false;
	if(nn<0){
		neg=true;
		nn*=-1.0;}
	std::stringstream ss;
	ss<<nn;
	std::string s = ss.str();
	int nnn=s.length();
	int i, decloc=-1, postDecLen,moreDecPlacesNeeded;
	data_=NEW char[nnn+1];
	for(i=0;i<nnn;++i){
		data_[i] = (char)(s[i]);
		if(data_[i]=='.'){
			decloc=i;}
		}
	data_[nnn]='\0';
	len_=nnn;
	if(decloc== -1){
			postDecLen=0;}
		else{
			postDecLen=nnn-(decloc+1);}
	moreDecPlacesNeeded=decPlaces-postDecLen;
	if(moreDecPlacesNeeded>0){
			if(decloc==-1){
				cat('.');}
			AppendCharToLen('0',len_ + moreDecPlacesNeeded);}
	if(decloc==0){
		prepend(0);}
	if(neg && nn!=0){
		prepend('-');}
	}//end constructor aString(const float,int,int)
	
	
/*
aString::aString (const double n,int preDecPlaces, int decPlaces):
		len_(0),data_(NEW char[1]){
			data_[0]='\0';
			int places=0;
			int internalDecPlaces = MIN(decPlaces, 8);
			double remains=ABS(n);
			long preDecimal=(long)(remains);
			remains -= preDecimal;
			long postDecimal=0;
			int leadingZeros=0,countingLeadingZeros=1;
			while(remains>0){//take care of floating-point inaccuracies
				int m = (int)(10*remains);
				if (countingLeadingZeros && m==0) 
						{++leadingZeros;} 
					else{
						countingLeadingZeros=0;
						postDecimal=10*postDecimal+m;}
				++places;
				if (places>=internalDecPlaces+1) {break;}
				remains = 10*remains - m;
				}//end while
			if (places>=internalDecPlaces+1){//round off 
				double x=(double)(postDecimal)/10.0 - ((long)(postDecimal/10));
				postDecimal=(long)(postDecimal/10);
				if (x>=0.5) {
					int preincrementDigits = Digits(postDecimal);
					++postDecimal;
					int postincrementDigits = Digits(postDecimal);
					if(preincrementDigits<postincrementDigits){
						--leadingZeros;}
					}
				--places;
				if(Digits(postDecimal)>places){
					++preDecimal;
					postDecimal=0;
					places=1;}
				}//end if places
			cat(preDecimal);
			if (n<0) {prepend('-');}
			if(data_[0]=='-' && data_[1]==',' && data_[2]=='('){
				*this = "undefined";//reading in a NAN error
				return;}		
			if (preDecPlaces>0){
				PrependCharToLen (' ',preDecPlaces);}
			cat('.');
			for(int i=0;i<leadingZeros;++i){cat('0');}
			cat(postDecimal);
			for(int i=places;i<internalDecPlaces-1;++i){cat('0');}
	}//end constructor aString(double)
*/

aString::aString (const long double n, int /*preDecPlaces*/, int decPlaces):
		len_(0),data_(NULL){
	long double nn = ROUND(n,decPlaces);
	bool neg=false;
	if(nn<0){
		neg=true;
		nn*=-1.0;}
	std::stringstream ss;
	ss<<nn;
	std::string s = ss.str();
	int nnn=s.length();
	int i, decloc=-1, postDecLen,moreDecPlacesNeeded;
	data_=NEW char[nnn+1];
	for(i=0;i<nnn;++i){
		data_[i] = (char)(s[i]);
		if(data_[i]=='.'){
			decloc=i;}
		}
	data_[nnn]='\0';
	len_=nnn;
	if(decloc== -1){
			postDecLen=0;}
		else{
			postDecLen=nnn-(decloc+1);}
	moreDecPlacesNeeded=decPlaces-postDecLen;
	if(moreDecPlacesNeeded>0){
			if(decloc==-1){
				cat('.');}
			AppendCharToLen('0',len_ + moreDecPlacesNeeded);}
	if(decloc==0){
		prepend(0);}
	if(neg && nn!=0){
		prepend('-');}
	}//end constructor aString(const long double,int,int)
	
	


/*
	aString::aString (long double n,int preDecPlaces, int decPlaces)://decPlaces to print
		len_(0),data_(NEW char[1]){
			data_[0]='\0';
			decPlaces=MAX(decPlaces,0);//no negatives
			int internalDecPlaces = MIN(decPlaces, 16);
			n = ROUND(n,-internalDecPlaces);
			long double remains=ABS(n);
//			fesetround(3);//function round() now truncates to integer value below
			long preDecimal_=(long)(remains);//handles floating-point inaccuracies properly?
			aString predec(preDecimal_);
			cat(predec);
			if(n<(long double)0.0){
				prepend('-');}
			PrependCharToLen(' ',preDecPlaces);
			if(decPlaces<=0) {
//				fesetround(1);//restores default round to nearest value
				return;}
			remains -= preDecimal_;
			long double remainsPt1 = remains*(long double)1.0e8;
			long postDecimal0=(long)(remainsPt1);
			aString postDec(postDecimal0);
			postDec.PrependCharToLen('0',8);
			if(decPlaces>8){
				long double remainsPt2 = (remainsPt1 - postDecimal0);
				remainsPt2 *= (long double)(1.0e7);//2-step conversion handles floating-point inaccuracies
//				remainsPt2 *= (long double)(10.0);
				long postDecimal1=(long)round(remainsPt2);
				postDecimal1 *= 10;
				aString postDec1(postDecimal1);
				postDec1.AppendCharToLen('0',8);
				postDec.cat(postDec1);
				}
//			fesetround(1);//restores default round to nearest value
			postDec.cut(decPlaces+1,postDec.len());//check this
			cat('.');
			cat(postDec);
			return;
	}//end constructor aString(long double)
*/



  	
  	
aString::aString(const aString& s, const int len){
  		//use for trunctation or elongation
  		if(len>s.len_)
  				{len_=s.len_;}
  			else
  				{len_=len;}
  		data_=NEW char[len_+1];
  		if (len_==0){data_[0]='\0';}
  			else {
  				memcpy(data_, s.data_, len_+1);
  				data_[len_]='\0';}
  		}//end constructor for known-size aString
  	

aString::aString(aString* s, const int len){
  		//use for trunctation or elongation
  		if(len>s->len_)
  				{len_=s->len_;}
  			else
  				{len_=len;}
  		data_=NEW char[len_+1];
  		if (len_==0){data_[0]='\0';}
  			else {
  				memcpy(data_, s->data_, len_+1);
  				data_[len_]='\0';}
  		}//end constructor for known-size aString
  	

	
	
aString::aString(aString& s, const int start, const int fin): 
  			len_(0), data_(NULL){
   		//use to copy out a part of a string
//   		if(s.len()<=start || fin<=start){
//   		if(s.len()<=start || fin<start){
   		if(s.len()<start || fin<start || fin>s.len()){
				data_ = NEW char[1];}
			else{
				data_ = NEW char[fin-start+2];
				len_= fin-start+1;
				int i;
				for (i=0;i<len_;++i){
					data_[i]=s.data_[start+i-1];}
				}
		data_[len_]='\0';
  		}//end constructor for aString

aString::aString(aString* s, const int start, const int fin): 
  			len_(0), data_(NULL){
   		//use to copy out a part of a string
//   		if(s->len()<=start || fin<=start){
   		if(s->len()<start || fin<start || fin>s->len()){
				data_ = NEW char[1];}
			else{
				data_ = NEW char[fin-start+2];
				len_= fin-start+1;
				int i;
				for (i=0;i<len_;++i){
					data_[i]=s->data_[start+i-1];}
				}
		data_[len_]='\0';
  		}//end constructor for aString

aString::aString(const char c, const int len): 
  			len_(len), data_(NEW char[len+1]){
  		//use to make a string repeating character c to length len 
 		for (int i=0;i<len_;++i){
  			data_[i]= c;}
  		data_[len_]='\0';
  		}//end constructor for aString



void aString::cat(const aString& s){//concatenate
  	char *tempData = NEW char[len_ + 1];
  	strcpy(tempData, data_);
  	delete [] data_;
  	data_ = NEW char[len_ + s.len_ + 1];
  	strcpy(data_, tempData);
  	strcat(data_, s.data_);
  	delete [] tempData;
  	len_ += s.len_;
  	}//end cat
  	
  	
int aString::pos(const aString& s){
	//returns the position of aString s within the calling string
	int i,j,answer=0;
	if (len_<s.len_){return answer;}
		else{
			for(i=0;i<len_;++i){
				if(i>len_-s.len_){return answer;}
				if(data_[i] == s.data_[0]){
					answer=i+1;
					for(j=1;j<s.len_;++j){
						if(data_[i+j]!=s.data_[j]){answer=0;break;}
						}
					if (answer>0) {return answer;}
					}
				}
			}
	return answer;				
	}//end aString::pos



void aString::prepend(const aString& insertedStr){
	aString old = *this;
	trunc(0);
	cat(insertedStr);
	cat(old);
	}//end aString::prepend
  	

void aString::replace (aString& insertedStr, int start, int fin){
	aString old=*this;
	trunc(start-1);
	cat(insertedStr);
	if (fin < old.len_) {
		aString right(old, fin + 1, (int) old.len_);
		cat(right);}
	}//end aString::replace
	

void aString::replaceAll(const char oldChar, const char newChar){
	for(int i=0;i<len_;++i){
		if(data_[i]==oldChar){
			data_[i]=newChar;}
		}
	}//end aString::replaceAll(const char, const char)
	
	
void aString::trunc (int newLen){
  		if(len_ != newLen){//no change done quickly
  			if (newLen<0) {newLen=0;}
  			aString newData(*this,newLen);
  			delete [] data_;data_=0;
  			data_ = newData.data_;newData.data_=0;
  			len_ = newData.len_;newData.len_=0;
  			}//end if
  		}//end aString::trunc
  	
	
void aString::PrependCharToLen (char c, int newLen){
	//characters before strings
	//until they reach a final specified length
	while(len_<newLen){
		prepend(c);}
	}//end aString::PrependCharToLen 


void aString::AppendCharToLen (char c, int newLen){
	//adds characters at end of strings
	//until they reach a final specified length
	while(len_<newLen){
		cat(c);}
	}//end aString::PrependCharToLen 



void aString::CullChar (char c){
	//culls all cases of the char from a string
	aString nullStr();
	int x=pos(c);
	while(x>0){
		cut(x, x);
		x=pos(c);
		}
	} //end aString::CullChar

void aString::CullLeadingChar (char c){
	while(data_[0] == c){
		cut(1);}
	} //end aString::CullLeadingChar

	
void aString::CullTrailingChar (char c){
	if (len_ == 0) return;
	while(data_[len_-1] == c){
		cut(len_);}
	} //end aString::CullTrailingChar
	

void aString::CullLeadingWhiteSpace (void){
	while((data_[0] == ' ') ||(data_[0] == '\t')){
		cut(1);}
	} //end aString::CullLeadingWhiteSpace
	
void aString::CullTrailingWhiteSpace (void){
	if (len_ == 0) return;
	while((data_[len_-1] == ' ')||(data_[len_-1] == '\t')){
		cut(len_);}
	} //end aString::CullTrailingWhiteSpace
	


void aString::cut(int start, int fin){
	//cut chars from start to fin from current string
	if(start>fin){return;}
	if(fin > len_) {
		fin = len_;}
	aString last(*this,fin+1,len_);
	if (start>0) {trunc(start-1);} else {trunc(0);}
	cat(last);
	}//end aString::cut



aString::aString(int len, Ran3& ran): len_(0), data_(NEW char[1]){
	//makes a string of random characters
	// the word is 'len' characters long
	char c;
	while(len_<len){
		c = (char)(ran.longBetween(0,93) + 33);
		cat(c);
		}//end while
	}//end random constructor



aString& aString::operator= (const aString& s){
  		if(len_ != s.len_){//makes self-assignment harmless
  			char* newData = NEW char[s.len_+1];
  			delete [] data_;data_=0;
  			data_ = newData;
  			len_ = s.len_;
  			}//end if
  		memcpy(data_,s.data_,len_+1);
  		return *this;
  		}//end operator=
  	
aString& aString::operator= (const char* c){
		aString s(c);
		*this=s;
 		return *this;
  		}//end operator=
  	
aString& aString::operator= (const char c){
		aString s(c);
		*this=s;
 		return *this;
  		}//end operator=
  	

aString& aString::operator= (const int c){
		aString s(c);
		*this=s;
 		return *this;
  		}//end operator=
  	

aString& aString::operator= (const long c){
		aString s(c);
		*this=s;
 		return *this;
  		}//end operator=
  	

aString& aString::operator= (const float c){
		aString s(c);
		*this=s;
 		return *this;
  		}//end operator=
  	

aString& aString::operator= (const double c){
		aString s(c);
		*this=s;
 		return *this;
  		}//end operator=
  	

aString& aString::operator= (const long double c){
		aString s(c);
		*this=s;
 		return *this;
  		}//end operator=
  	



aString* aString::ChopOffFirstWord (void){
		//returns the position in the string where the first word ends
		//returns 0 if empty string, returns len() if only 1 word
		aString endCharList(" \t,.;:\"(){}[]!?");
		return ChopOffFirstWord(endCharList);
		}//end aString::ChopOffFirstWord(void)



aString* aString::ChopOffFirstWord (aString& endCharList){
		// returns a new string pointer which must be deleted elsewhere		
		aString *firstWord = NULL;		
		if (len_==0){//return empty aString
				firstWord=NEW aString();
				}
			else{		
				int sepLoc = posEndFirstWord(endCharList);
				while (sepLoc == 1) {//removes initial commas & blanks
					cut(1, 1);//removes 1st character
					sepLoc = posEndFirstWord(endCharList);
					}	//end while sepLoc==1
				//the string could now be zero length}
				if (len_==0){//return empty aString
						firstWord=NEW aString();}
					else if (sepLoc == 0) {//only one word left in string
						firstWord=NEW aString(*this);
						clear();//this := "";
						}
					else {//probably more than one word remains if 
						//only terminal end-characters remain, they would be handled on the next call
						firstWord = NEW aString(*this,1,sepLoc-1);
					 	cut(0, sepLoc);
						}	
				}	
		return firstWord;
		}	//end aString::ChopOffFirstWord(aString&)



aString* aString::ChopOffLastWord (void){
		//returns the position in the string where the first word ends
		//returns 0 if empty string, returns len() if only 1 word
		aString endCharList(" \t,.;:\"(){}[]!?");
		return ChopOffLastWord(endCharList);
		}//end aString::ChopOffLastWord(void)


aString* aString::ChopOffLastWord (aString& endCharList){				
		// returns a new string pointer which must be deleted elsewhere				
		aString *lastWord = NULL;
		if (len_==0){//return empty aString
			lastWord=NEW aString();
			}
		invert();
		int sepLoc = posEndFirstWord(endCharList);
		while (sepLoc == 1) {//removes initial commas & blanks
			cut(1, 1);//removes 1st character
			sepLoc = posEndFirstWord(endCharList);
			}	//end while sepLoc==1
		//the string could now be zero length}
		if (len_==0){//return empty aString
			lastWord=NEW aString();
			//no need to invert back
			}
		if (sepLoc == 0) {//only one word left in string
				invert();//put in proper order
				lastWord=NEW aString(*this);
				clear();//this := "";
				}
			else {//probably more than one word remains if 
				//only terminal end-characters remain, they would be handled on the next call
				lastWord = NEW aString(this,1,sepLoc-1);
				lastWord->invert();
				cut(0, sepLoc);
				invert();
				}
		return lastWord;		
		}	//end aString::ChopOffLastWord(aString&)


void aString::invert (void){	
	//inverts the sequence of characters in the string
	if (len_ < 2) {return;}
	aString a;
	for(int i=0;i<len_;++i){
		a.prepend(data_[i]);}
	delete [] data_;data_=0;
	data_=a.raw();
	}//end aString::invert



int aString::isNumber(void){
	if(len_==0){return 0;}
	aString dup(this);//work on a copy
	int mult=1;
	while ((dup[0]==' ') || (dup[0]=='-')){
		if (dup[0]=='-'){mult*= (-1);}
		//trims leading negative signs and holds them
		dup.cut(1,1);}//trims initial blanks
	int decCount=0;
	for(int i=0;i<dup.len_;++i){
		if (dup[i]=='.'){
				++decCount;
				if (decCount>1){
					return 0;}
				}
			else if((dup[i]<'0') || (dup[i]>'9')){
					return 0;}			
			else{}
		}
	return 1;
	}//end aString::isNumber



int aString::isDecimal(void){
	if (!isNumber()){return 0;}
	aString dup(this);//work on a copy
	int mult=1;
	while ((dup[0]==' ') | (dup[0]=='-')){
		if (dup[0]=='-'){mult*= (-1);}
		//trims leading negative signs and holds them
		dup.cut(0,0);}//trims initial blanks
	if (dup[0]=='.'){return 1;}
	return dup.pos('.') ? 1:0;
	}//end aString::isDecimal



int aString::posEndFirstWord(void){
		//returns the position in the string where the first word ends
		//returns 0 if empty string, returns len() if only 1 word
		if(len()==0){return 0;}
		aString endCharList(" \t,.;:\"(){}[]!?");
		return posEndFirstWord(endCharList);
		}//end aString::posEndFirstWord(aString&)




int aString::posEndFirstWord(aString& endCharList){
		//returns the position in the string where the first word ends
		//returns 0 if empty string or if only 1 word
		if(len()==0){return 0;}
		aList<int> charPosList;
		for(int p=0;p<endCharList.len();++p){
			const char c = endCharList[p];
			charPosList.Append(pos(c));
			}//end for p
		charPosList.Sort();
		if(charPosList.len()==0){return 0;}
		for(int p=0;p<charPosList.len();++p){
			if(charPosList[p] >0){return charPosList[p];}
			}
		return 0;
		}//end aString::posEndFirstWord(aString&)

		

void aString::separator(const int numSpaces, char sepChar){
	if (sepChar != '\0'){
			cat(sepChar);}
		else{
			for(int i=0;i<numSpaces;++i){
				cat(' ');}}
	}//end aString::separator



double aString::toDouble(void){//converts string to double
	if (!isNumber()){return 0.0;}//should throw error instead
	aString dup(this);//work on a copy
	aString preDecimal, postDecimal;
	int sign=1;
	while ((dup[0]==' ') || (dup[0]=='-')){
		if (dup[0]=='-'){sign*= (-1);}
		//trims leading negative signs and holds them
		dup.cut(1,1);}//trims initial blanks
	if (dup.len() < 32) {
			int pointLoc = dup.pos('.');
			if (pointLoc > 0){
					preDecimal = dup; postDecimal = dup;
					preDecimal.cut(pointLoc,preDecimal.len());
					postDecimal.cut(0,pointLoc);
					}
				else{
					preDecimal = dup;
					postDecimal.clear();
					}//end if pointLoc>0
			double newDouble = 0.0;
			for (int i=0;i<preDecimal.len();++i){
				aString newPreChar=preDecimal[i];
				char* newChar1 = newPreChar.raw();
				newDouble *= 10.0;
				int nextNumeral = CharToInteger(*newChar1);
				newDouble += nextNumeral;
				delete [] newChar1;newChar1=0;
				}//end for i
			double tempDecDouble = 0.0;
			double tenPower = 1.0;
			for (int i=0;i<postDecimal.len();++i){
				aString newPostChar = postDecimal[i];
				char* newChar2 = newPostChar.raw();
				tenPower *= 10.0;
				tempDecDouble *= 10.0;
				int nextNumeral = CharToInteger(*newChar2);
				tempDecDouble += nextNumeral;
				delete [] newChar2;newChar2=0;
				}//end for i
			tempDecDouble /= tenPower;
			return (sign * (newDouble + tempDecDouble));
			}	
		else{
			return 0.0;}
	}//end aString::toDouble 



long double aString::toLongDouble(void){//converts string to double
	if (!isNumber()){return 0.0;}//should throw error instead
	aString dup(this);//work on a copy
	aString preDecimal, postDecimal;
	int sign=1;
	while ((dup[0]==' ') || (dup[0]=='-')){
		if (dup[0]=='-'){sign*= (-1);}
		//trims leading negative signs and holds them
		dup.cut(1,1);}//trims initial blanks
	if (dup.len() < 32) {
			int pointLoc = dup.pos('.');
			if (pointLoc > 0){
					preDecimal = dup; postDecimal = dup;
					preDecimal.cut(pointLoc,preDecimal.len());
					postDecimal.cut(0,pointLoc);
					}
				else{
					preDecimal = dup;
					postDecimal.clear();
					}//end if pointLoc>0
			long double newDouble = 0.0;
			for (int i=0;i<preDecimal.len();++i){
				aString newPreChar=preDecimal[i];
				char* newChar1 = newPreChar.raw();
				newDouble *= 10.0;
				int nextNumeral = CharToInteger(*newChar1);
				newDouble += nextNumeral;
				delete [] newChar1;newChar1=0;
				}//end for i
			long double tempDecDouble = 0.0;
			long double tenPower = 1.0;
			for (int i=0;i<postDecimal.len();++i){
				aString newPostChar = postDecimal[i];
				char* newChar2 = newPostChar.raw();
				tenPower *= 10.0;
				tempDecDouble *= 10.0;
				int nextNumeral = CharToInteger(*newChar2);
				tempDecDouble += nextNumeral;
				delete [] newChar2;newChar2=0;
				}//end for i
			tempDecDouble /= tenPower;
			return (sign * (newDouble + tempDecDouble));
			}	
		else{
			return 0.0;}
	}//end aString::toLongDouble 




long aString::toLong(void){//converts string to long integer
	if (!isNumber()){return 0;}//should throw error instead
	aString dup(this);//work on a copy
	int sign=1;
	while ((dup[0]==' ') | (dup[0]=='-')){
		if (dup[0]=='-'){sign *= (-1);}
		//trims leading negative signs and holds them
		dup.cut(1,1);}//trims initial blanks
	if (dup.len() < 32) {
			long newLong = 0;
			for (int i=0;i<dup.len();++i){
				aString newChar = dup[i];
				char* newCharacter = newChar.raw();
				newLong *= 10;
				long nextNumeral = CharToInteger(*newCharacter);
				newLong += nextNumeral;
				delete [] newCharacter;newCharacter=0;
				}//end for i
			return newLong;
			}
		else{
			return 0;}//should throw error instead			
	}//end aString::toLong




aString& aString::operator+(const aString& a){
	cat(a);
	return *this;
	}//end aString::operator+(const aString&)
	
	
aString& aString::operator+(const char* a){
	cat(a);
	return *this;
	}//end aString::operator+(const char*)
	
	
aString& aString::operator+(const char a){
	cat(a);
	return *this;
	}//end aString::operator+(const char)
	
	


#endif
