/***********************************
*
*
*	StringList.cpp
*
*	Implements a variable-length list of aString objects
*
******************************************/


#ifndef StringListcpp
#define StringListcpp = 1

#include "StringList.h"
#include "Element.cpp"
#include "aList.cpp"





StringList::StringList (StringList& toCopy):
		ObjList<aString>(){//constucts a new copy
try{
	long a=toCopy.len();
	for(long i=0;i<a;++i){
		const aString& x=toCopy[i];
		aString* y=NEW aString(x);//copies the string
		Append(y);
		}
	}catch(std::bad_alloc){
		CatchBadAlloc("StringList::Stringlist(StringList& )");}
	}//end copy constructor &


StringList::StringList(StringList* toCopy):
		ObjList<aString>(){//constucts a new copy
try{
	long a=toCopy->len();
	for(long i=0;i<a;++i){
		const aString& x=toCopy->Nth(i);
		aString* y=NEW aString(x);//copies the string
		Append(y);
		}
	}catch(std::bad_alloc){
		CatchBadAlloc("StringList::StringList(StringList* )");}
	}//end copy constructor *



ObjList<aString>* StringList::Duplicate(void){
		//returns list as a base-class object
		ObjList<aString>* nStrList = NULL;
		try{
			nStrList = NEW StringList(*this);
			}catch(std::bad_alloc){
				CatchBadAlloc("StringList::Duplicate()");}
		return nStrList;
		}


void StringList::Print(ostream& outFile){//file assumed open
	//primitive debugging output, one string per line
	if (len() > 0)  {
		for (long i=0;i<len();++i) {
			aString& x = Nth(i);
			outFile<<x<<endl;
			}
		}
	else {outFile<<"empty list"<<endl;}
	outFile<<endl;
	}//end StringList::Print
		


void StringList::Sort(long start, long finish){
	//implements QuickSort
	//patched to accomodate 0-indexing
	if (len()<2) {return;}
	long left=start+1, right=finish+1;
	aString& startValue = Nth(DIV((left + right),(long) 2)-1);
	aString startStr(startValue);
	do{
			while (Nth(left-1) < startStr) {
				++left;}
			while (startStr < Nth(right-1)) {
				--right;}
			if (left <= right) {
				aString* temp = &(Nth(left-1));
				Replace(&(Nth(right-1)),left-1);
				Replace(temp,right-1);
				++left;
				--right;
				}//end if
		}while(right > left);
	if (start < right-1) {
		Sort(start, right-1);}
	if (left-1 < finish) {
		Sort(left-1, finish);}
	}//end StringList::Sort

#endif

