/***********************************
*
*
*	TextDataList.cpp
*
*	Implements a variable-length list of TextDatum objects
*
******************************************/


#ifndef TextDataListcpp
#define TextDataListcpp = 1

#include "TextDataList.h"
#include "Element.cpp"
#include "aList.cpp"




TextDataList::TextDataList (TextDataList& toCopy){//constucts a new copy
	try{
		long a=toCopy.len();
		for(long i=0;i<a;++i){
			TextDatum* x=(TextDatum*) &(toCopy[i]);
			TextDatum* y=NEW TextDatum(*x);//copies the datum
			Append(y);
			}
		}catch(std::bad_alloc){
			CatchBadAlloc("TextDataList::TextDataList(TextDataList& )");}
	missingDataStr_ = toCopy.missingDataStr_;
	}//end copy constructor &


TextDataList::TextDataList(TextDataList* toCopy){//constucts a new copy
	try{
		long a=toCopy->len();
		for(long i=0;i<a;++i){
			TextDatum* x=(TextDatum*) &(toCopy->Nth(i));
			TextDatum* y=NEW TextDatum(*x);//copies the string
			Append(y);
			}
		}catch(std::bad_alloc){
			CatchBadAlloc("TextDataList::TextDataList(TextDataList* )");}
	missingDataStr_=toCopy->missingDataStr_;
	}//end copy constructor *



ObjList<aString>* TextDataList::Duplicate(void){
		//returns list as a base-class object
		ObjList<aString>* nStrList = NULL;
		try{
			nStrList = NEW TextDataList(*this);
			}catch(std::bad_alloc){
				CatchBadAlloc("TextDataList::Duplicate()");}
		return nStrList;
		}


void TextDataList::Print(ostream& outFile){//file assumed open
	//primitive debugging output, one string per line
	if (len() > 0)  {
		for (long i=0;i<len();++i) {
			TextDatum* x = (TextDatum*) &(Nth(i));
			if(x->OK()){
					outFile<<*x<<endl;}
				else{
					outFile<<missingDataStr_<<endl;}
			}
		}
	else {outFile<<"empty list"<<endl;}
	outFile<<endl;
	}//end TextDataList::Print
		


void TextDataList::Sort(long start, long finish){
	//implements QuickSort
	//patched to accomodate 0-indexing
	if (len()<2) {return;}
	long left=start+1, right=finish+1;
	TextDatum* startValue = (TextDatum*) &(Nth(DIV((left + right),(long) 2)-1));
	TextDatum startStr(startValue);
	do{
			while (Nth(left-1) < startStr) {
				++left;}
			while (startStr < Nth(right-1)) {
				--right;}
			if (left <= right) {
				aString* temp = &(Nth(left-1));
				Replace(&(Nth(right-1)),left-1);
				Replace(temp,right-1);
				++left;
				--right;
				}//end if
		}while(right > left);
	if (start < right-1) {
		Sort(start, right-1);}
	if (left-1 < finish) {
		Sort(left-1, finish);}
	}//end TextDataList::Sort

#endif

