/******************


aTime.cpp

This class handles time calculations

*******************/


#ifndef aTimecp
#define aTimecp = 1

#include "aTime.h"

aTime::aTime(void){
	time(&firstTime_);//sets to current time
	mostRecentTime_=firstTime_;
	elapsedSinceLast_=0;
	}//end constructor
		
aTime::aTime(aTime& t):firstTime_(t.firstTime_),
						mostRecentTime_(t.mostRecentTime_),
						elapsedSinceLast_(t.elapsedSinceLast_){}

aTime* aTime::Duplicate(void){
			return NEW aTime(*this);}
		
time_t aTime::first(){return firstTime_;}


time_t aTime::recent(){return mostRecentTime_;}


int aTime::daysInMonth(int m, int yr){//4-digit years only; months 1-12 not 0-11
	if(m==2){
		if(yr==2000){return 28;}
		if(MOD(yr,4)==0){return 29;}
		return 28;
		}
	switch (m){
		case 1: return 31;
		case 3: return 31;
		case 5: return 31;
		case 7: return 31;
		case 8: return 31;
		case 10: return 31;
		case 12: return 31;
		default: return 30;
		}
	return 30;
	}//end daysInMonth


time_t aTime::elapsedSinceLast(){return elapsedSinceLast_;}


long double aTime::elapsed(){
			time_t now;
			time(&now);
			return difftime(now,mostRecentTime_);}
		
void aTime::mark(void){//sets new most recent time
			time_t temp = mostRecentTime_;
			time(&mostRecentTime_);
			elapsedSinceLast_ = mostRecentTime_ - temp;
			}

aString* aTime::HMS(long double timediff){//returns a string with hours:mins:secs only
			//used mostly to display differences in time
			long hours = timediff/3600;
			long double td = timediff - (hours*(long double)3600);
			int mins = td/60;
			td = td-(mins*(long double)60);
			aString* hms = NEW aString(hours);
			hms->cat(":");
			aString minstr(mins);
			if(Digits(mins)==1){minstr.prepend('0');}
			hms->cat(minstr);
			hms->cat(":");
			int secs = td;
			td = secs-td;//leaves decimal
			aString secstr(secs);
			if(Digits(secs)==1){secstr.prepend('0');}
			hms->cat(secstr);
			if(td >zero){
				aString tdStr(td);
				tdStr.CullLeadingChar('0');
				hms->cat(tdStr);}
			return hms;
			}//end HMS
		

aString* aTime::HMS_elapsed(void){
		return HMS(elapsed());}//returns a string with hours:mins:secs only


aString* aTime::HMS_totalElapsed(void){
		return HMS(totalElapsed());}//returns a string with hours:mins:secs only



long double aTime::totalElapsed(void){//firstTime_ to now, in seconds
			time_t now;
			time(&now);
			return difftime(now,firstTime_);
	}





int operator==(aTime& t1, aTime& t2){
				return ((t1.firstTime_==t2.firstTime_)&&
						(t1.mostRecentTime_==t2.mostRecentTime_)&&
						(t1.elapsedSinceLast_==t2.elapsedSinceLast_) );}
		
int operator!=(aTime& t1, aTime& t2){
				return (! (t1==t2) );}
		


















#endif













