/******************************************************
*
*	AdditiveGenotype.h
*
*	This class implements a phenotype that is the sum of the genotypic values
*
*	Base class:  Genotype
*
*******************************************************/

#ifndef AdditiveGenotypeh
#define AdditiveGenotypeh = 1

#include <iostream.h>
#include "Element.h"
#include "aList.h"
#include "Randomness.h"
#include "Genotype.h"

class AdditiveGenotype: public Genotype {
  protected:
  	int traitMeasured_;
  public:
  	AdditiveGenotype(void):Genotype(),traitMeasured_(0) {}//creates empty list
  	AdditiveGenotype(int numLoci, int ploidy, int  ): 
  			Genotype(numLoci,ploidy,ploidy),traitMeasured_(0){}
  			//creates a 'null' homozygous individual at all loci
	AdditiveGenotype(AdditiveGenotype& gen)://copies the AdditiveGenotype during construction
			Genotype(gen),traitMeasured_(gen.traitMeasured_){}
	AdditiveGenotype(AdditiveGenotype* gen)://copies the AdditiveGenotype during construction
			Genotype(gen),traitMeasured_(gen->traitMeasured_){}
virtual ~AdditiveGenotype(void){}
  	
//virtual void	Print(ostream& outFile, int alleleLen=4);

  	virtual void SetTrait(float, int){}//can't change a trait unless the genotype is changed

	double trait(void);
 
 	};//end class AdditiveGenotype


#endif
