/*****************************************************
*
*
*	Allele.h
*
*	Holds the value of an individual allele
*
******************************************************/
#ifndef alleleh
#define alleleh = 1
#include "StringClass.h"
#include "Randomness.h"
#include "MemoryManager.h"

template <class T> class Allele {
  protected:
  	T data_;
  public:
  	Allele(T x): data_(x){
			}
	Allele(Allele<T>& a): data_(a.val() ){
			}
	Allele(Allele<T>* a): data_(a->val() ){
			}
	Allele<T>& operator= (Allele& a);
virtual ~Allele(void){
			}
virtual Allele<T>* Duplicate(void);
  	T val(void) {return data_;}
virtual aString* GenotypeString(char* /*separator*/);
virtual void mutateTo(T x);
virtual void Mutate(Ran3& ran, double sigma);
  	
  	friend int operator== (Allele<T>& a, Allele<T>& b);
  	friend int operator!= (Allele<T>& a, Allele<T>& b);
  	friend int operator> (Allele<T>& a, Allele<T>& b);
  	friend int operator< (Allele<T>& a, Allele<T>& b);
  	friend int operator>= (Allele<T>& a, Allele<T>& b);
  	friend int operator<= (Allele<T>& a, Allele<T>& b);
  	};//end Allele


template<class T> int operator== (Allele<T>& a, Allele<T>& b){
	return (a.data_==b.data_);}

template<class T> int operator!= (Allele<T>& a, Allele<T>& b){
	return !(a==b);}

template<class T> int operator< (Allele<T>& a, Allele<T>& b){
	return (a.data_ < b.data_);}

template<class T> int operator> (Allele<T>& a, Allele<T>& b){
	return (a.data_ > b.data_);}

template<class T> int operator<= (Allele<T>& a, Allele<T>& b){
	return (a.data_ <= b.data_);}

template<class T> int operator>= (Allele<T>& a, Allele<T>& b){
	return (a.data_ >= b.data_);}



#endif
