
	//GeneContainerCore.h

	//Use these classes to swap data between specialized simulation and data-analysis classes
	//that may store data in arbitrary ways


#ifndef GeneContainerCoreh
#define GeneContainerCoreh = 1

#include <iostream.h>
#include "MemoryManager.h"

//use derived classes based on this class 
class GeneContainerCore{
	public:
		long id_;
	public:
		GeneContainerCore(void):id_(-1){}
		GeneContainerCore(long IDval):id_(IDval){}
		GeneContainerCore(GeneContainerCore& gc):id_(gc.id_){}
		GeneContainerCore(GeneContainerCore* gc):id_(gc->id_){}
		~GeneContainerCore(void){}
		
		virtual GeneContainerCore* Duplicate(void){//virtual copy
					return NEW GeneContainerCore(*this);}
		virtual long GetPointerToDerivedSelf(void){
					return (long) this;}
		
		virtual void Clear(void){
					id_= -1;}
					
		virtual int EqualQ(GeneContainerCore& gc2){//virtual operator==
					return id_==gc2.id_;
					}
		
		long ID(void){return id_;}
		
		virtual void Print(ostream& output, char /*sepChar*/){
					output<<"ID="<<id_<<endl;}
		
		virtual void SetID(long IDval){
					id_=IDval;}
		
		GeneContainerCore& operator=(GeneContainerCore& gc){
				id_=gc.id_;
				return *this;}

		
		friend int operator==(GeneContainerCore& hc1, GeneContainerCore& hc2);
		friend int operator!=(GeneContainerCore& hc1, GeneContainerCore& hc2);
		};//end class GeneContainerCore

int operator==(GeneContainerCore& hc1, GeneContainerCore& hc2);
int operator!=(GeneContainerCore& hc1, GeneContainerCore& hc2);



#endif

