/*****************************************************
*
*
*	RegulatedAllele1.h
*
*	Holds an allele with a promoter & product, each with 2 states
*	No recombination occurs within an allele.
*
******************************************************/
#ifndef RegulatedAllele1h
#define RegulatedAllele1h = 1

#include "StringClass.h"
#include "Element.h"
#include "aList.h"
#include "Randomness.h"
#include "RandomList.h"
#include <iostream.h>
#include "aError.h"
#include "MemoryManager.h"


class RegulatedAllele1 {
  private:
  	float promoter_;//value that upregulates
  	float product_;//the coding site
  public:
  	RegulatedAllele1(float prom, float prod){
  		promoter_=prom;
  		product_=prod;
			}
	RegulatedAllele1(RegulatedAllele1& a){
 			promoter_ = a.promoter();
			product_ = a.product();		
			}
	RegulatedAllele1(RegulatedAllele1* a){
 			promoter_ = a->promoter();
			product_ = a->product();		
			}
virtual ~RegulatedAllele1(void){
			}

virtual RegulatedAllele1& operator= (RegulatedAllele1& a){
  	promoter_ = a.promoter(); 
  	product_ = a.product(); 
  	return *this;
  	}//end RegulatedAllele1::operator=
  	
virtual RegulatedAllele1* 	Duplicate(void);
  		float 		promoter() {return promoter_;}
  		float 		product() {return product_;}
virtual void 		Mutate(Ran3& ran, double sigma);
virtual void 		MutateTo(float newValue, int allelePart);
virtual void 		set(float newValue, int allelePart);
virtual aString* 	GenotypeString(char* sepChar=" ");
virtual aString* 	GenotypeString(int allelePart, char* /*sepChar=" "*/);
virtual int			InRange(int allelePart);//boolean; checks to see if allelePart is in range
virtual int			OutOfRange(int allelePart);//boolean; checks to see if allelePart is in range
		
  	
  	friend int operator== (RegulatedAllele1& a, RegulatedAllele1& b);
  	friend int operator!= (RegulatedAllele1& a, RegulatedAllele1& b);


  	};//end RegulatedAllele1




#endif
