/*****************************************************
*
*
*	RegulatedAllele2.h
*
*	Holds an allele with a promoter & product, each with 2 states
*	No recombination occurs within an allele.
*
******************************************************/
#ifndef RegulatedAllele2h
#define RegulatedAllele2h = 1

#include <iostream.h>
#include "StringClass.h"
#include "Element.cpp"
#include "aList.cpp"
#include "Randomness.h"
#include "RandomList.h"
#include "MemoryManager.h"


class RegulatedAllele2 {
  private:
  	float promoter_[2];//value that upregulates
  	float product_[2];//the coding site
  public:
  	RegulatedAllele2(float xProm, float yProm, float xProd, float yProd){
  		promoter_[0]=xProm;
  		promoter_[1]=yProm;
  		product_[0]=xProd;
  		product_[1]=yProd;
			}
	RegulatedAllele2(RegulatedAllele2& a){
 			promoter_[0] = a.promoter(0);
			product_[0] = a.product(0);		
 			promoter_[1] = a.promoter(1);
			product_[1] = a.product(1);		
			}
	RegulatedAllele2(RegulatedAllele2* a){
 			promoter_[0] = a->promoter(0);
			product_[0] = a->product(0);		
 			promoter_[1] = a->promoter(1);
			product_[1] = a->product(1);		
			}
virtual ~RegulatedAllele2(void){
			}

virtual RegulatedAllele2& operator= (RegulatedAllele2& a){
  	promoter_[0] = a.promoter(0); 
  	product_[0] = a.product(0); 
  	promoter_[1]=a.promoter(1); 
  	product_[1]=a.product(1); 
  	return *this;
  	}//end RegulatedAllele2::operator=
  	
virtual RegulatedAllele2* 	Duplicate(void);
  		float 		promoter(int i) {return promoter_[i];}
  		float 		product(int i) {return product_[i];}
virtual void 		Mutate(Ran3& ran, double sigma);
virtual void 		MutateTo(float newValue, int allelePart);
virtual void 		set(float newValue, int allelePart);
virtual aString* 	GenotypeString(char* sepChar=" ");
virtual aString* 	GenotypeString(int allelePart, char* /*sepChar=" "*/);
virtual int			InRange(int allelePart);//boolean; checks to see if allelePart is in range
virtual int			OutOfRange(int allelePart);//boolean; checks to see if allelePart is in range
		
  	
  	friend int operator== (RegulatedAllele2& a, RegulatedAllele2& b);
  	friend int operator!= (RegulatedAllele2& a, RegulatedAllele2& b);


  	};//end RegulatedAllele2




#endif
