/******************************************************
*
*	SexChromosome.h
*
*	This Chromosome is either X or Y
*
*	Base class:  Chromosome<T> 
*
*******************************************************/

#ifndef SexChromosomeh
#define SexChromosomeh = 1

#include <iostream.h>
#include "Randomness.h"
#include "StringClass.h"
#include "Element.h"
#include "aList.h"
#include "Allele.h"
#include "Chromosome.h"
#include "MemoryManager.h"

template <class T> class SexChromosome: public Chromosome<T> {
  protected:
  	const int XorY_;//X=0 or Y=1 chromosome
  public:
  	SexChromosome(int XorY):XorY_(XorY){
		}/*creates empty list*/
  	SexChromosome(int numLoci, T alleleVal, float mapDist, int XorY);
  			/*creates a 'null' chromosome with same allele value at all loci,
  			and same map distance between loci
  			 mapDist*(numLoci-1) must be 100*/
  	SexChromosome(int numLoci, Allele<T>& alleleVal, float mapDist, int XorY);
  			/*creates a 'null' chromosome with same allele at all loci,
  			and same map distance between loci
  			 mapDist*(numLoci-1) must be 100*/
  	SexChromosome( aList<T>& alleleVal, aList<float>& mapDist, int XorY);
  	SexChromosome( ObjList<Allele<T> >& alleleVal, aList<float>& mapDist, int XorY);
	SexChromosome(SexChromosome<T>& old);/*copies the Chromosome during construction*/
	SexChromosome(SexChromosome<T>* old);/*copies the Chromosome during construction*/
virtual ~SexChromosome(void){
		}/*destroys the list*/
  	



virtual void	Copy (SexChromosome<T>&);/*copies to an existing SexChromosome*/
virtual void	Copy (SexChromosome<T>*);/*copies to an existing SexChromosome*/
	

virtual int 	IsX(void);//is X chromosome
virtual int 	IsY(void);//is X chromosome

virtual void	Recombine(SexChromosome<T>& c1, SexChromosome<T>& c2, Ran3& ran);
				/*makes a recombinant SexChromosome from c1 & c2 
				based on map distances among loci */

virtual void	Recombine(SexChromosome<T>* c1, SexChromosome<T>* c2, Ran3& ran){
					Recombine(*c1, *c2, ran);}

virtual void	RecombineWith(SexChromosome<T>& c2, Ran3& ran);
				/*makes 2 recombinant SexChromosomes from this & c2 
				based on map distances among loci */

virtual void	RecombineWith(SexChromosome<T>* c2, Ran3& ran){
					RecombineWith(*c2, ran);}

int				XorY(void){
					return XorY_;}

SexChromosome<T>& operator= (SexChromosome<T>& c2){
					XorY_ = c2.XorY();
					Chromosome<T>::operator= (c2);
					}//end operator=
	
SexChromosome<T>& operator= (SexChromosome<T>* c2){
					return operator= (*c2);
					}//end operator=
	
friend int operator== (SexChromosome<T>& c1, SexChromosome<T>& c2);
		
friend int operator!= (SexChromosome<T>& c1, SexChromosome<T>& c2);
  	
  	};/*end class SexChromosome<T>*/
  	
  	
template <class T> int operator== (SexChromosome<T>& g1, SexChromosome<T>& g2);
		
template <class T> int operator!= (SexChromosome<T>& g1, SexChromosome<T>& g2);


#endif
