/*****************************************************
*
*
*	TwoStateAllele.h
*
*	Holds an allele with 2 states, 1 & 0
*	Mutation switches states.
*
******************************************************/
#ifndef TwoStateAlleleh
#define TwoStateAlleleh = 1

#include "StringClass.h"
#include "Element.h"
#include "aList.h"
#include <iostream.h>
#include "aError.h"
#include "Randomness.h"
#include "RandomList.h"
#include "MemoryManager.h"


class TwoStateAllele {
  private:
  	short int value_;
  public:
  	TwoStateAllele(void):value_(0){
			}
  	TwoStateAllele(int value):value_(value){
			}
	TwoStateAllele(TwoStateAllele& a):value_(a.value_){
			}
	TwoStateAllele(TwoStateAllele* a):value_(a->value_){
			}
virtual ~TwoStateAllele(void){
			}

virtual TwoStateAllele& operator= (TwoStateAllele& a){
  	value_ = a.value_; 
  	return *this;
  	}//end TwoStateAllele::operator=
  	
virtual TwoStateAllele* 	Duplicate(void);
  		int 		product() {return value_;}
virtual void 		Mutate();
virtual void 		MutateTo(int newValue);
virtual void 		set(int newValue);
virtual aString* 	GenotypeString(char* sepChar=" ");		
virtual int 		InRange(int value);
virtual int 		OutOfRange(int value);

  	
  	friend int operator== (TwoStateAllele& a, TwoStateAllele& b);
  	friend int operator!= (TwoStateAllele& a, TwoStateAllele& b);
  	};//end TwoStateAllele




#endif
