/*
*
*	Chromosome<double>.cpp  instantiations
*
*	Metrowerks compiler needs these patches
*/

#ifndef ChromosomeDblcpp
#define ChromosomeDblcpp = 1

#include "Chromosome.h"

int operator== (Chromosome<double>& a, Chromosome<double>& b);
int operator!= (Chromosome<double>& a, Chromosome<double>& b);
int operator< (Chromosome<double>& a, Chromosome<double>& b);
int operator> (Chromosome<double>& a, Chromosome<double>& b);
int operator<= (Chromosome<double>& a, Chromosome<double>& b);
int operator>= (Chromosome<double>& a, Chromosome<double>& b);


int operator== (Chromosome<double>& c1, Chromosome<double>& c2){
	if(c1.loci()!=c2.loci()){return 0;}
	for (int j=0;j<c1.loci();++j){
		Allele<double>& a1=c1[j];
		Allele<double>& a2=c2[j];
		if(a1 != a2){return 0;}}
	for (int j=0;j<c1.loci()-1;++j){
		float d1=c1.mapDist(j);
		float d2=c2.mapDist(j);
		if(d1!=d2){return 0;}}
	return 1;
	}//end friend operator==
		
int operator!= (Chromosome<double>& g1, Chromosome<double>& g2){
  	return !(g1==g2);}
  	

int operator< (Chromosome<double>& c1, Chromosome<double>& c2){//compares by allele value, for sorting
	int shortLen = min(c1.loci(), c2.loci() );
	for (int j=0;j<shortLen;++j){
		Allele<double>& a1=c1[j];
		Allele<double>& a2=c2[j];
		if(a1 < a2){return 1;}}
	if(c1.loci() < c2.loci()){return 1;}
	return 0;//default returns false
	}//end friend operator<
  	

int operator> (Chromosome<double>& c1, Chromosome<double>& c2){//compares by allele value, for sorting
	int shortLen = min(c1.loci(), c2.loci() );
	for (int j=0;j<shortLen;++j){
		Allele<double>& a1=c1[j];
		Allele<double>& a2=c2[j];
		if(a1 > a2){return 1;}}
	if(c1.loci() > c2.loci()){return 1;}
	return 0;//default returns false
	}//end friend operator>
  	
int operator<= (Chromosome<double>& c1, Chromosome<double>& c2){//compares by allele value, for sorting
	return !(c1 > c2);}
  	
int operator>= (Chromosome<double>& c1, Chromosome<double>& c2){//compares by allele value, for sorting
	return !(c1 < c2);}
  	









#endif
