/*
*
*	Chromosome<int>.cpp  instantiations
*
*	Metrowerks compiler needs these patches
*/

#ifndef ChromosomeIntcpp
#define ChromosomeIntcpp = 1

#include "Chromosome.h"

int operator== (Chromosome<int>& a, Chromosome<int>& b);
int operator!= (Chromosome<int>& a, Chromosome<int>& b);
int operator< (Chromosome<int>& a, Chromosome<int>& b);
int operator> (Chromosome<int>& a, Chromosome<int>& b);
int operator<= (Chromosome<int>& a, Chromosome<int>& b);
int operator>= (Chromosome<int>& a, Chromosome<int>& b);

#ifdef MemoryLeakDebug
void  Chromosome<int>::PrintIDList(ostream& outFile){
	memIDList_.Print(outFile);}
void  Chromosome<int>::PrintIDListLen(ostream& outFile){
	memIDList_.PrintLen(outFile);}
#endif


int operator== (Chromosome<int>& c1, Chromosome<int>& c2){
	if(c1.loci()!=c2.loci()){return 0;}
	for (int j=0;j<c1.loci();++j){
		Allele<int>& a1=c1[j];
		Allele<int>& a2=c2[j];
		if(a1 != a2){return 0;}}
	for (int j=0;j<c1.loci()-1;++j){
		float d1=c1.mapDist(j);
		float d2=c2.mapDist(j);
		if(d1!=d2){return 0;}}
	return 1;
	}//end friend operator==
		
int operator!= (Chromosome<int>& g1, Chromosome<int>& g2){
  	return !(g1==g2);}
  	

int operator< (Chromosome<int>& c1, Chromosome<int>& c2){//compares by allele value, for sorting
	int shortLen = min(c1.loci(), c2.loci() );
	for (int j=0;j<shortLen;++j){
		Allele<int>& a1=c1[j];
		Allele<int>& a2=c2[j];
		if(a1 < a2){return 1;}}
	if(c1.loci() < c2.loci()){return 1;}
	return 0;//default returns false
	}//end friend operator<
  	

int operator> (Chromosome<int>& c1, Chromosome<int>& c2){//compares by allele value, for sorting
	int shortLen = min(c1.loci(), c2.loci() );
	for (int j=0;j<shortLen;++j){
		Allele<int>& a1=c1[j];
		Allele<int>& a2=c2[j];
		if(a1 > a2){return 1;}}
	if(c1.loci() > c2.loci()){return 1;}
	return 0;//default returns false
	}//end friend operator>
  	
int operator<= (Chromosome<int>& c1, Chromosome<int>& c2){//compares by allele value, for sorting
	return !(c1 > c2);}
  	
int operator>= (Chromosome<int>& c1, Chromosome<int>& c2){//compares by allele value, for sorting
	return !(c1 < c2);}
  	









#endif
