/********************************************
*
*
*		Phenotype.cpp
*
*		This is the base class for phenotypic scores
*
*********************************************/

#ifndef Phenotypecp
#define Phenotypecp = 1

#include "Phenotype.h"
#include "Element.cpp"
#include "aList.cpp"
//#include "GeneContainers.cpp"



void Phenotype::Copy(Phenotype& p){
	selectionFunc = p.selectionFunc;
	trait_.Clear();
	int i;
	for (i=0;i<p.trait_.len();++i){
		trait_.Append(p.trait(i));}
	}//end Phenotype::Copy(Phenotype&)


void Phenotype::MakeNull(void){
	SetSelectionFunction(NeutralToSelection);
	int i;
	for (i=0;i<trait_.len();++i){
		trait_[i] = zero;}
	}//end Phenotype::MakeNull()


//void 	Phenotype::Mutate(Ran3& ran, double mutationRate, double sigma){
void 	Phenotype::Mutate(Ran3& ran, aList<long double>& mutationInfo){
	long double mutationRate = mutationInfo[0];
	if (mutationRate<=zero){return;}
	long double sigma = mutationInfo[1];
	int t;
	for(t=0;t<trait_.len();++t){
		long double rannum = ran();
		if(rannum<mutationRate){
			trait_[t] = ran.NormDev(trait_[t],sigma);
			}
		}
	}//end Phenotype::Mutate(Ran3&, aList<double>&)


long double Phenotype::trait(int i){
	return trait_[i];}

long double Phenotype::trait(void){
	return trait_[0];}


aString* Phenotype::GetPhenotypeString(char* separator){
	aString* phenotype = NEW aString();
	int tr;
	for(tr=0;tr<traits()-1;++tr){
		phenotype->cat(trait(tr));
		phenotype->cat(separator);
		}
	phenotype->cat(trait_.Last());		
	return phenotype;
	}//end Phenotype::GetPhenotypeString



void Phenotype::SetSelectionParams(aList<long double>& selParams){
	int i;
	long double t;
	for(i = 0;i<trait_.len();++i){
		t = zero + trait_[i];
		selParams.Append(t);}
	}//end Phenotype::SetSelectionParams(aList<double>&)


void Phenotype::SetTrait(long double z, int i){
	if(i>=trait_.len()){
		trait_.Append(z);
		return;}
	trait_.Replace(z,i);
	}//end Phenotype::SetTrait
	
  		
  		
int operator== (Phenotype& p1, Phenotype& p2){
	if(p1.trait_.len() != p2.trait_.len() ){return 0;}
	int i;
	for (i=0;i<p1.trait_.len();++i){
		if (p1.trait(i) != p2.trait(i) ){return 0;}}
	return 1;//default returns true
	}//end operator== (Phenotype&, Phenotype&)


		
int operator!= (Phenotype& p1, Phenotype& p2){
	return !(p1 == p2);}


#endif

