/*****************************************************
*
*
*	RegulatedAllele1.cpp
*
*	Holds the cis-regulatory sites of an allele
*
******************************************************/
#ifndef RegulatedAllele1cp
#define RegulatedAllele1cp = 1


#include "RegulatedAllele1.h"
//#include <iostream.h>
//#include "aError.h"
#include "Element.cpp"
#include "aList.cpp"



RegulatedAllele1* RegulatedAllele1::Duplicate(void){
	return NEW RegulatedAllele1(*this);
	}//end RegulatedAllele1::Duplicate()


aString* RegulatedAllele1::GenotypeString(char* sepChar) {
  	aString* g;
  	g = NEW aString(promoter());
  	g->cat(sepChar);
  	g->cat(product());
  	return g;
  	}//end RegulatedAllele1::GenotypeString(char)


aString* RegulatedAllele1::GenotypeString(int allelePart, char* /*sepChar*/) {
	if(OutOfRange(allelePart)){return NEW aString();}
  	aString* g;
  	if(allelePart==0){//hits promoter
  			g = NEW aString(promoter());}
  		else{//hits product
  			g = NEW aString(product());}
  	return g;
  	}//end RegulatedAllele1::GenotypeString(int)




void RegulatedAllele1::Mutate(Ran3& ran, double sigma){
	//pick the part that mutates
  	if(ran()<0.5){//hits promoter
  			promoter_ = ran.NormDev(promoter_, sigma);}
  		else{//hits product
  			product_ = ran.NormDev(product_, sigma);}
  	}//end RegulatedAllele1::Mutate(Ran3&,double)



void RegulatedAllele1::MutateTo(float newValue, int allelePart){
	if(OutOfRange(allelePart)){return;}
  	if(allelePart==0){//hits promoter
  			promoter_ =newValue;}
  		else{//hits product
  			product_ = newValue;}
  	}//end RegulatedAllele1::MutateTo(float, int)


void RegulatedAllele1::set(float newValue, int allelePart){
	MutateTo(newValue, allelePart);
  	}//end RegulatedAllele1::set(float, int)


int RegulatedAllele1::InRange(int allelePart){
	if( ( allelePart<0) || (allelePart>1) ){
		aString mess("ERROR:  allelePart ");mess.cat(allelePart);
		mess.cat(" out of range");
		aError(mess);
		return 0;}
	return 1;
	}//end RegulatedAllele1::InRange(int)


int RegulatedAllele1::OutOfRange(int allelePart){
	return ! InRange(allelePart);
	}//end RegulatedAllele1::OutOfRange(int)


int operator== (RegulatedAllele1& a, RegulatedAllele1& b){
	return ( (a.promoter()==b.promoter() ) && 
			 (a.product()==b.product() ) );
			 }

int operator!= (RegulatedAllele1& a, RegulatedAllele1& b){
	return !(a==b);}




#endif
