/*****************************************************
*
*
*	TwoStateAllele.cpp
*
*	Holds the cis-regulatory sites of an allele
*
******************************************************/
#ifndef TwoStateAllelecp
#define TwoStateAllelecp = 1



#include "TwoStateAllele.h"
//#include <iostream.h>
//#include "aError.h"
#include "Element.cpp"
#include "aList.cpp"



TwoStateAllele* TwoStateAllele::Duplicate(void){
	return NEW TwoStateAllele(*this);
	}//end TwoStateAllele::Duplicate()


aString* TwoStateAllele::GenotypeString(char* ) {
  	aString* g = NEW aString(product());
  	return g;
  	}//end TwoStateAllele::GenotypeString()



void TwoStateAllele::Mutate(void){
	//switch states
  	if(value_==0){
  			value_=1;}
  		else{//value_==1
  			value_=0;}
  	}//end TwoStateAllele::Mutate()



void TwoStateAllele::MutateTo(int newValue){
	if(OutOfRange(newValue)){return;}
	value_ = newValue;
  	}//end TwoStateAllele::MutateTo(int)


void TwoStateAllele::set(int newValue){
	MutateTo(newValue);
  	}//end TwoStateAllele::set(int)


int TwoStateAllele::InRange(int value){
	if( ( value<0) || (value>1) ){
		aString mess("ERROR:  allele value ");mess.cat(value);
		mess.cat(" out of range");
		aError(mess);
		return 0;}
	return 1;
	}//end TwoStateAllele::InRange(int)


int TwoStateAllele::OutOfRange(int value){
	return ! InRange(value);
	}//end TwoStateAllele::OutOfRange(int)


int operator== (TwoStateAllele& a, TwoStateAllele& b){
	return ( a.product()==b.product() );
			 }

int operator!= (TwoStateAllele& a, TwoStateAllele& b){
	return !(a==b);}




#endif
